
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "screendef.h"
#include "fft1def.h"
#include "blnkdef.h"
#include "fft2def.h"



void show_timf2(void)
{
#define TIMF2_YSCALE 0.3      
float stg, wkg;
int ia, ib, ka, kb;
int mm,k,m,p0;
wkg=hg.timf2_display_wk_gain;
stg=hg.timf2_display_st_gain;

// Show timf2 on the left half of the screen (using WIDTH/2 pixels)
// Place the strongest peak at 25% of the x-axis.
mm=4*ui.rx_channels;
ia=0;
ib=1;
m=mm+1;
ka=0;
kb=m;

if(  (hg.timf2_display_hold&1) != 0)
  {
  if(  (hg.timf2_display_lines&1) != 0)
    {
errno=400015;
    while( ib<WIDTH/2)
      {
      ck_line(ia,timf2pix[ka   ],ib,timf2pix[kb   ],0);
      ck_line(ia,timf2pix[ka+1 ],ib,timf2pix[kb+1  ],0);
      ck_line(ia,timf2pix[ka+2 ],ib,timf2pix[kb+2  ],0);
      ck_line(ia,timf2pix[ka+3 ],ib,timf2pix[kb+3  ],0);
      ck_line(ia,timf2pix[ka+mm],ib,timf2pix[kb+mm ],0);
      if(ui.rx_channels==2)
        {
        ck_line(ia,timf2pix[ka+4],ib,timf2pix[kb+4],0);
        ck_line(ia,timf2pix[ka+5],ib,timf2pix[kb+5],0);
        ck_line(ia,timf2pix[ka+6],ib,timf2pix[kb+6],0);
        ck_line(ia,timf2pix[ka+7],ib,timf2pix[kb+7],0);
        }
      ia=ib;
      ib++;
      ka=kb;
      kb+=m;
      }
    }
  else
    {
errno=400016;
    for(ia=0; ia<WIDTH/2; ia++)
      {
      ck_setpixel(ia,timf2pix[ka   ],0);
      ck_setpixel(ia,timf2pix[ka+1 ],0);
      ck_setpixel(ia,timf2pix[ka+2 ],0);
      ck_setpixel(ia,timf2pix[ka+3 ],0);
      ck_setpixel(ia,timf2pix[ka+mm],0);
      if(ui.rx_channels==2)
        {
        ck_setpixel(ia,timf2pix[ka+4],0);
        ck_setpixel(ia,timf2pix[ka+5],0);
        ck_setpixel(ia,timf2pix[ka+6],0);
        ck_setpixel(ia,timf2pix[ka+7],0);


        }
      ka+=m;
      }
    }      
  }      
k=0;
ia=0;
ka=0;
kb=m*WIDTH/2;
p0=(mm*(timf2_show_pointer-WIDTH/8)+timf2_mask+1)&timf2_mask;
while( ka<kb)
  {
  timf2pix[ka+mm]=timf2_y0[mm]-sqrt((float)(timf2_pwr[p0/mm]))*wkg;
  if(timf2pix[ka+mm]<timf2_ymin[mm])timf2pix[ka+mm]=timf2_ymin[mm];
  if(timf2pix[ka+mm]>timf2_ymax[mm])timf2pix[ka+mm]=timf2_ymax[mm];
  if(ui.rx_channels==1)
    {
    timf2pix[ka   ]=timf2_y0[3]-timf2[p0  ]*wkg;
    if(timf2pix[ka]<timf2_ymin[3])timf2pix[ka]=timf2_ymin[3];
    if(timf2pix[ka]>timf2_ymax[3])timf2pix[ka]=timf2_ymax[3];
    timf2pix[ka+1 ]=timf2_y0[2]-timf2[p0+1]*wkg;
    if(timf2pix[ka+1]<timf2_ymin[2])timf2pix[ka+1]=timf2_ymin[2];
    if(timf2pix[ka+1]>timf2_ymax[2])timf2pix[ka+1]=timf2_ymax[2];
    timf2pix[ka+2 ]=timf2_y0[1]-timf2[p0+2]*stg;
    if(timf2pix[ka+2]<timf2_ymin[1])timf2pix[ka+2]=timf2_ymin[1];
    if(timf2pix[ka+2]>timf2_ymax[1])timf2pix[ka+2]=timf2_ymax[1];
    timf2pix[ka+3 ]=timf2_y0[0]-timf2[p0+3]*stg;
    if(timf2pix[ka+3]<timf2_ymin[0])timf2pix[ka+3]=timf2_ymin[0];
    if(timf2pix[ka+3]>timf2_ymax[0])timf2pix[ka+3]=timf2_ymax[0];
    }
  else
    {  
    timf2pix[ka   ]=timf2_y0[7]-timf2[p0  ]*wkg;
    if(timf2pix[ka]<timf2_ymin[7])timf2pix[ka]=timf2_ymin[7];
    if(timf2pix[ka]>timf2_ymax[7])timf2pix[ka]=timf2_ymax[7];
    timf2pix[ka+1 ]=timf2_y0[6]-timf2[p0+1]*wkg;
    if(timf2pix[ka+1]<timf2_ymin[6])timf2pix[ka+1]=timf2_ymin[6];
    if(timf2pix[ka+1]>timf2_ymax[6])timf2pix[ka+1]=timf2_ymax[6];
    timf2pix[ka+2 ]=timf2_y0[5]-timf2[p0+2]*wkg;
    if(timf2pix[ka+2]<timf2_ymin[5])timf2pix[ka+2]=timf2_ymin[5];
    if(timf2pix[ka+2]>timf2_ymax[5])timf2pix[ka+2]=timf2_ymax[5];
    timf2pix[ka+3 ]=timf2_y0[4]-timf2[p0+3]*wkg;
    if(timf2pix[ka+3]<timf2_ymin[4])timf2pix[ka+3]=timf2_ymin[4];
    if(timf2pix[ka+3]>timf2_ymax[4])timf2pix[ka+3]=timf2_ymax[4];
    timf2pix[ka+4]=timf2_y0[3]-timf2[p0+4]*stg;
    if(timf2pix[ka+4]<timf2_ymin[3])timf2pix[ka+4]=timf2_ymin[3];
    if(timf2pix[ka+4]>timf2_ymax[3])timf2pix[ka+4]=timf2_ymax[3];
    timf2pix[ka+5]=timf2_y0[2]-timf2[p0+5]*stg;
    if(timf2pix[ka+5]<timf2_ymin[2])timf2pix[ka+5]=timf2_ymin[2];
    if(timf2pix[ka+5]>timf2_ymax[2])timf2pix[ka+5]=timf2_ymax[2];
    timf2pix[ka+6]=timf2_y0[1]-timf2[p0+6]*stg;
    if(timf2pix[ka+6]<timf2_ymin[1])timf2pix[ka+6]=timf2_ymin[1];
    if(timf2pix[ka+6]>timf2_ymax[1])timf2pix[ka+6]=timf2_ymax[1];
    timf2pix[ka+7]=timf2_y0[0]-timf2[p0+7]*stg;
    if(timf2pix[ka+7]<timf2_ymin[0])timf2pix[ka+7]=timf2_ymin[0];
    if(timf2pix[ka+7]>timf2_ymax[0])timf2pix[ka+7]=timf2_ymax[0];
    }
  p0=(p0+mm)&timf2_mask;  
  ka+=m;
  }      
ia=0;
ib=1;
m=mm+1;
ka=0;
kb=m;
if(  (hg.timf2_display_lines&1) != 0)
  {
errno=400017;
  while( ib<WIDTH/2)
    {
    ck_line(ia,timf2pix[ka  ],ib,timf2pix[kb  ],14);
    ck_line(ia,timf2pix[ka+1],ib,timf2pix[kb+1],13);
    ck_line(ia,timf2pix[ka+2],ib,timf2pix[kb+2],12);
    ck_line(ia,timf2pix[ka+3],ib,timf2pix[kb+3],11);
    ck_line(ia,timf2pix[ka+mm],ib,timf2pix[kb+mm],15);
    if(ui.rx_channels==2)
      {
      ck_line(ia,timf2pix[ka+4],ib,timf2pix[kb+4],14);
      ck_line(ia,timf2pix[ka+5],ib,timf2pix[kb+5],13);
      ck_line(ia,timf2pix[ka+6],ib,timf2pix[kb+6],12);
      ck_line(ia,timf2pix[ka+7],ib,timf2pix[kb+7],11);
      }
    ia=ib;
    ib++;
    ka=kb;
    kb+=m;
    }      
  }
else
  {
errno=400018;
  for(ia=0; ia<WIDTH/2; ia++)
    {
    ck_setpixel(ia,timf2pix[ka  ],14);
    ck_setpixel(ia,timf2pix[ka+1],13);
    ck_setpixel(ia,timf2pix[ka+2],12);
    ck_setpixel(ia,timf2pix[ka+3],11);
    ck_setpixel(ia,timf2pix[ka+mm],15);
    if(ui.rx_channels==2)
      {
      ck_setpixel(ia,timf2pix[ka+4],14);
      ck_setpixel(ia,timf2pix[ka+5],13);
      ck_setpixel(ia,timf2pix[ka+6],12);
      ck_setpixel(ia,timf2pix[ka+7],11);
      }
    ka+=m;
    }      
  }
errno=400019;

if(timf2_display_maxval < 32700)return;
timf2_ovfl++;
}

float subtract_onechan_pulse(int p_max, int sub_size)
{
int pa,pb,p0,mask;
int i, j, k, m, wid, imax;
float t1,t2,t3,t4,t5,t6;
float blanker_phase_c1,blanker_phase_c2;
int re_x,im_x;
// **************************
// Max amplitude is at p_max in timf2 
// Use blanker_phasefunc to compensate for the phase
// rotation of the strongest part of the pulse.
k=refpul_size-2*blanker_pulsewidth;
mask=timf2_mask;
pa=(4*(p_max-blanker_pulsewidth)+mask)&mask;
pb=(4*(p_max+blanker_pulsewidth) )&mask;
i=0;
while(pa != pb)
  {
  pa=(pa+4)&mask;
  t1=timf2[pa  ];
  t2=timf2[pa+1];
  t3=blanker_phasefunc[k  ];
  t4=blanker_phasefunc[k+1];
  t5=t1*t3+t2*t4;
  k+=2;
  t6=t2*t3-t1*t4;
  blanker_input[i  ]=t5;
  blanker_input[i+1]=t6;
  i+=2;
  }
// Collect the power averaged phase of the 3 center points.
imax=blanker_pulsewidth;
blanker_phase_c1=0;
blanker_phase_c2=0;
t4=0;
for(i=imax-1; i<=imax+1; i++)
  {
  t1=blanker_input[2*i  ];
  t2=blanker_input[2*i+1];
  t3=sqrt(t1*t1+t2*t2);
  blanker_phase_c1+=t3*t1;
  blanker_phase_c2+=t3*t2;
  }
t1=blanker_phase_c1*blanker_phase_c1+blanker_phase_c2*blanker_phase_c2;
// Return if the pulse is extremely small (should never happen)
if(t1 < 32)return -1;  
t1=sqrt(t1);
blanker_phase_c1/=t1;
blanker_phase_c2/=t1;
// Rotate the phase of the input pulse for zero average phase.
// Collect the I and Q powers 
wid=2*blanker_pulsewidth;
t3=0;
t4=0;
for(i=0; i<=wid; i++)
  {
  t1=blanker_input[2*i  ];
  t2=blanker_input[2*i+1];
  blanker_input[2*i  ]=blanker_phase_c1*t1+blanker_phase_c2*t2;
  blanker_input[2*i+1]=blanker_phase_c1*t2-blanker_phase_c2*t1;
  t3+=blanker_input[2*i  ]*blanker_input[2*i  ];
  t4+=blanker_input[2*i+1]*blanker_input[2*i+1];
  }
if(t4>0.25*t3)return -1.;
// Now imax points to the maximum value for the current pulse.
// Find the decimals of the position by a parabolic fit.
// Check blanker_init (buf.c) for details.
// Use decimals of position to get index to standard pulses
t4=blanker_input[2*imax-2]-blanker_input[2*imax+2];
t3=2*(blanker_input[2*imax-2]+blanker_input[2*imax+2]-2*blanker_input[2*imax]);
if(t3 == 0)return -2.;
j=MAX_REFPULSES*(t4/t3+0.5)+0.5;
if(j<0)j=0;
if(j>=MAX_REFPULSES)j=MAX_REFPULSES-1;
m=2*blanker_pulindex[j]*refpul_sizeplus+8;
mask=timf2_mask;
p0=(4*(p_max-sub_size/2)+mask)&mask;
pb=(4*(p_max+sub_size/2) )&mask;
k=refpul_size-sub_size;
// scale phase coefficients so we get the total pulse
// from a multiplication of two coefficients.
blanker_phase_c1*=blanker_input[2*imax]*liminfo_amplitude_factor;
blanker_phase_c2*=blanker_input[2*imax]*liminfo_amplitude_factor;
// Subtract the standard pulse and make a new power function.
// Collect new and old total power.
t3=0;
t4=0;
while(p0 != pb)
  {
  p0=(p0+4)&mask;
  t1=blanker_refpulse[m+k];
  t2=blanker_refpulse[m+k+1];
  re_x=timf2[p0  ]-blanker_phase_c1*t1+blanker_phase_c2*t2;
  im_x=timf2[p0+1]-blanker_phase_c1*t2-blanker_phase_c2*t1;
  timf2[p0  ]=re_x;
  timf2[p0+1]=im_x;
  t1=re_x*re_x+im_x*im_x;
  t3+=timf2_pwr[p0>>2];
  timf2_pwr[p0>>2]=t1;
  k+=2;
  t4+=t1;
  }
return t4/t3;
}

float subtract_twochan_pulse(int p_max, int sub_size)
{
int pb,p0,mask;
int i, j, k, m, wid, imax, ipw;
float t1,t2,t3,t4,t5,t6;
float blanker_phase_c1,blanker_phase_c2;
int re_x,im_x,re_y,im_y,re_a,im_a;
// **************************
// Max amplitude is at p_max in timf2 which corresponds to 
// blanker_pulsewidth/2 in blanker_input.
// Use blanker_phasefunc to compensate for the phase
// rotation of the strongest part of the pulse
// and collect the average phase.
k=refpul_size-2*blanker_pulsewidth;
wid=2*blanker_pulsewidth;
for(i=0; i<=wid; i++)
  {
  t1=blanker_input[2*i  ];
  t2=blanker_input[2*i+1];
  t3=blanker_phasefunc[k  ];
  t4=blanker_phasefunc[k+1];
  t5=t1*t3+t2*t4;
  t6=t2*t3-t1*t4;
  blanker_input[2*i  ]=t5;
  blanker_input[2*i+1]=t6;
  k+=2;
  }
// Collect the power averaged phase of the 3 center points.
imax=blanker_pulsewidth;
blanker_phase_c1=0;
blanker_phase_c2=0;
t4=0;
for(i=imax-1; i<=imax+1; i++)
  {
  t1=blanker_input[2*i  ];
  t2=blanker_input[2*i+1];
  t3=sqrt(t1*t1+t2*t2);
  blanker_phase_c1+=t3*t1;
  blanker_phase_c2+=t3*t2;
  }
t1=sqrt(blanker_phase_c1*blanker_phase_c1+blanker_phase_c2*blanker_phase_c2);
if(t1 < 4)return -1;
blanker_phase_c1/=t1;
blanker_phase_c2/=t1;
// Rotate the phase of the input pulse for zero average phase.
// Collect the I and Q powers 
t3=0;
t4=0;
for(i=0; i<=wid; i++)
  {
  t1=blanker_input[2*i  ];
  t2=blanker_input[2*i+1];
  blanker_input[2*i  ]=blanker_phase_c1*t1+blanker_phase_c2*t2;
  blanker_input[2*i+1]=blanker_phase_c1*t2-blanker_phase_c2*t1;
  t3+=blanker_input[2*i  ]*blanker_input[2*i  ];
  t4+=blanker_input[2*i+1]*blanker_input[2*i+1];
  }
if(t4>0.25*t3)return -1.;
// Now imax points to the maximum value for the current pulse.
// Find the decimals of the position by a parabolic fit.
// Check blanker_init (buf.c) for details.
// Use decimals of position to get index to standard pulses
t4=blanker_input[2*imax-2]-blanker_input[2*imax+2];
t3=2*(blanker_input[2*imax-2]+blanker_input[2*imax+2]-2*blanker_input[2*imax]);
if(t3 == 0)return -2.;
j=MAX_REFPULSES*(t4/t3+0.5)+0.5;
if(j<0)j=0;
if(j>=MAX_REFPULSES)j=MAX_REFPULSES-1;
m=2*blanker_pulindex[j]*refpul_sizeplus+8;
mask=timf2_mask;
p0=(8*(p_max-sub_size/2)+mask)&mask;
pb=(8*(p_max+sub_size/2) )&mask;
k=refpul_size-sub_size;
// scale phase coefficients so we get the total pulse
// from a multiplication of two coefficients.
blanker_phase_c1*=blanker_input[2*imax]*liminfo_amplitude_factor;
blanker_phase_c2*=blanker_input[2*imax]*liminfo_amplitude_factor;
t3=0;
t4=0;
while(p0 != pb)
  {
  p0=(p0+8)&mask;
  t1=blanker_refpulse[m+k];
  t2=blanker_refpulse[m+k+1];
  re_a=blanker_phase_c1*t1-blanker_phase_c2*t2;
  im_a=blanker_phase_c1*t2+blanker_phase_c2*t1;
  re_x=timf2[p0  ]-blanker_pol_c1*re_a;
  im_x=timf2[p0+1]-blanker_pol_c1*im_a;
  re_y=timf2[p0+2]-(blanker_pol_c2*re_a+blanker_pol_c3*im_a);
  im_y=timf2[p0+3]-(blanker_pol_c2*im_a-blanker_pol_c3*re_a);
  timf2[p0  ]=re_x;
  timf2[p0+1]=im_x;
  timf2[p0+2]=re_y;
  timf2[p0+3]=im_y;
  ipw=((re_x*re_x+im_x*im_x)>>1)+((re_y*re_y+im_y*im_y)>>1);
  t3+=timf2_pwr[p0>>3];
  timf2_pwr[p0>>3]=ipw;
  k+=2;
  t4+=ipw;
  }
return t4/t3;
}


int get_pulse_pol(int p_max)
{
int pa,pb,mask;
float t1,t2,re_x,im_x,re_y,im_y,x2,y2,sina,noi2,x2s,y2s;
float re_xy,im_xy;
// *********************************
//Assume that everything in timf2 (weak signal part) is interference
//from a common origin.
//We have 2 complex arrays X and Y.
//(  /X  is the complex conjugate of X  )
//Find the total signals, X2=(X * /X) and (Y * /Y).
//Get the total sum of squares, norm=X2+Y2
//Get the normalised signals squared x2 = (X * /X) / norm
//                               and y2 = (Y * /Y) / norm
//Get the normalised 'overlap'       xy = (X * /Y) / norm
// ******************************
mask=timf2_mask;
pa=(8*(p_max-blanker_pulsewidth)+mask)&mask;
pb=(8*(p_max+blanker_pulsewidth) )&mask;
x2=0;
y2=0;
re_xy=0;
im_xy=0;
while(pa != pb)
  {
  pa=(pa+8)&mask;
  re_x=timf2[pa  ];
  im_x=timf2[pa+1];
  re_y=timf2[pa+2];
  im_y=timf2[pa+3];
  x2+=re_x*re_x+im_x*im_x;
  y2+=re_y*re_y+im_y*im_y;
  re_xy+=re_x*re_y+im_x*im_y;
  im_xy+=im_x*re_y-re_x*im_y;
  }
t1=x2+y2;
x2/=t1;
y2/=t1;
re_xy/=t1;
im_xy/=t1;
// *****************************************
//Now we have x2,y2 (real values) and xy (complex).
//For explanation purposes, assume im_xy == 0, which corresponds to linear
//polarization. The signal vill then be polarised in a plane.
//a = angle between polarisation plane and the horisontal antenna.
//Assume that the noise level n is the same in the two antennas, and that
//the noise is uncorrelated.
//We then find:
//            x2 = cos(a)**2 + n**2
//            y2 = sin(a)**2 + n**2
//            xy = sin(a)*cos(a)
//From this we find: x2 * y2 - xy*xy = n**2 + n**4
//Neglect n**4:
//cos(a)=sqr( x2 - ( x2 * y2 - xy*xy) )
//sin(a)=sqr( y2 - ( x2 * y2 - xy*xy) )
//The transformation formula to use for rotating the polarization
//plane to produce new signals A and B, where A has all the signal and B
//only noise, will then be:
// A = X * cos(a) + Y * sin(a)
// B = Y * cos(a) - X * sin(a)
//Extending to im_xy != 0 the transformation becomes
//re_A=C1*re_X+C2*re_Y-C3*im_Y
//im_A=C1*im_X+C2*im_Y+C3*re_Y
//re_B=C1*re_Y-C2*re_X-C3*im_X
//im_B=C1*im_Y-C2*im_X+C3*re_X
//C1 = cos(a)
//C2 = sin(a) * re_xy / sqr( re_xy**2 + im_xy**2)
//C3 = sin(a) * im_xy / sqr( re_xy**2 + im_xy**2)
// **************************************
t2=re_xy*re_xy+im_xy*im_xy;
noi2=x2*y2-t2;
if(noi2 > 0.15)return -1;
x2s=x2-noi2;
y2s=y2-noi2;
if(x2s > 0)
  {
  blanker_pol_c1=sqrt(x2s);
  if(y2s > 0 && t2 > 0)
    {
    sina=sqrt(y2s);
    blanker_pol_c2=sina*re_xy/sqrt(t2);
    blanker_pol_c3=sina*im_xy/sqrt(t2);
    t1=sqrt(blanker_pol_c1*blanker_pol_c1+
            blanker_pol_c2*blanker_pol_c2+
            blanker_pol_c3*blanker_pol_c3);
    blanker_pol_c1/=t1;
    blanker_pol_c2/=t1;
    blanker_pol_c3/=t1;
    }
  else
    {
    blanker_pol_c1=1;
    blanker_pol_c2=0;
    blanker_pol_c3=0;
    }
  }
else
  {
  blanker_pol_c1=0;
  blanker_pol_c2=1;
  blanker_pol_c3=0;
  }
return 1;
}


void transform_timf2_pol(int p_max) 
{
int i,pa,pb,mask;
float re_x,im_x,re_y,im_y;
mask=timf2_mask;
pa=(8*(p_max-blanker_pulsewidth)+mask)&mask;
pb=(8*(p_max+blanker_pulsewidth) )&mask;
i=0;
while(pa != pb)
  {
  pa=(pa+8)&mask;
  re_x=timf2[pa  ];
  im_x=timf2[pa+1];
  re_y=timf2[pa+2];
  im_y=timf2[pa+3];
  blanker_input[i  ]= blanker_pol_c1*re_x
                     +blanker_pol_c2*re_y
                     -blanker_pol_c3*im_y;
  blanker_input[i+1]= blanker_pol_c1*im_x
                     +blanker_pol_c2*im_y
                     +blanker_pol_c3*re_y;
  i+=2;
  }
}


void first_noise_blanker(void)
{
int i,j,k,m,sizeflag,ifirst;
int stupid_clr1, stupid_clr2, mm;
int bln_no, p0, pa, pb, p_first, pf, p_last;
int cleared_points, total_points; 
int fitted_pulses, p_max;
float t1,t2,t3,t4;
float avgpwr[BLN_INFO_SIZE];
unsigned int nfl;
int sizlim;
unsigned int powermax, pwrlim;
int power_mask;
int timf2_findmax;
int *clrint;
newdat_flag&=-1-ND_TIMF2RAW;
// timf2_pa is the latest point in timf2 containing valid data. 
// timf2p_fit is the latest point for which the blanker has been 
// run already.
mm=4*ui.rx_channels;
power_mask=timf2_mask/mm;
p_first=timf2p_fit;
pf=p_first;
// Leave blnfit_range+1 points for next time. (step size=mm=4*ui.rx_channels)  
p_last=(timf2_pa/mm-blnfit_range+power_mask)&power_mask;
p_last&=0xfffffffc;
total_points=(p_last-p_first+1+power_mask)&power_mask;
// Do not run this routine more often than 25 times per second.
if(total_points < ui.input_speed/25)
  {
  timf2_pn1=timf2_pa;
  return;
  }
if(ampinfo_flag != 0)
  {
  p0=p_first;
  if(sw_onechan)
    {
    while(p0 != p_last )
      {
      p0=(p0+1)&power_mask;
      k=p0<<2;
      i=abs(timf2[k  ]);
      if(timf1_maxamp[0]<i)timf1_maxamp[0]=i;
      i=abs(timf2[k+1]);
      if(timf1_maxamp[0]<i)timf1_maxamp[0]=i;
      i=abs(timf2[k+2]);
      if(timf1_maxamp[2]<i)timf1_maxamp[2]=i;
      i=abs(timf2[k+3]);
      if(timf1_maxamp[2]<i)timf1_maxamp[2]=i;
      }
    }  
  else
    {
    while(p0 != p_last )
      {
      p0=(p0+1)&power_mask;
      k=p0<<3;
      i=abs(timf2[k  ]);
      if(timf1_maxamp[0]<i)timf1_maxamp[0]=i;
      i=abs(timf2[k+1]);
      if(timf1_maxamp[0]<i)timf1_maxamp[0]=i;
      i=abs(timf2[k+2]);
      if(timf1_maxamp[1]<i)timf1_maxamp[1]=i;
      i=abs(timf2[k+3]);
      if(timf1_maxamp[1]<i)timf1_maxamp[1]=i;
      i=abs(timf2[k+4]);
      if(timf1_maxamp[2]<i)timf1_maxamp[2]=i;
      i=abs(timf2[k+5]);
      if(timf1_maxamp[2]<i)timf1_maxamp[2]=i;
      i=abs(timf2[k+6]);
      if(timf1_maxamp[3]<i)timf1_maxamp[3]=i;
      i=abs(timf2[k+7]);
      if(timf1_maxamp[3]<i)timf1_maxamp[3]=i;
      }
    }
  }
  
  
fitted_pulses=0;
cleared_points=0;
timf2_findmax = 0;
if(hg.clever_bln_mode == 0)
  {
  goto skip_fit;
  }
// Clear blanker_flag. This is a cyclic buffer char variable
// Clear 4-byte wide unless the limit is crossed.
if(p_last > p_first)
  {
  k=(p_last-p_first)*sizeof(char)/sizeof(int);
  clrint=(void*)(&blanker_flag[p_first]);
  for(i=0; i<k; i++)clrint[i]=0;
  }
else
  {
  p0=p_first;
  blanker_flag[p0]=0;
  while(p0 != p_last)
    {
    p0=(p0+1)&power_mask;
    blanker_flag[p0]=0;
    }     
  }
// Set the limit well below the noise floor in case the noise floor
// is raised because we used too few points before.
nfl=hg.clever_bln_limit;
sizlim=timf2_noise_floor/30;
fitted_pulses=0;
find_pulse:;
// Step until we find power above the limit.
while( (timf2_pwr[pf] <= nfl || blanker_flag[pf]>64)
                                    && pf != p_last)pf=(pf+1)&power_mask;
if(pf == p_last)goto clever_x;
p0=pf-1;
p_max=pf;
// Anything below 10 in summed power is irrelevant.
powermax=10;
m=blnfit_range;
// ****************************************************
// blanker_flag bit 0 is set each time a value is found
// that is larger than preceding points in current range.
// Values above 64 indicate point is already very much changed.
while(p0 != p_last && m>0)
  {
  p0=(p0+1)&power_mask;
  if(timf2_pwr[p0] > powermax && blanker_flag[p0]<64)
    {
    blanker_flag[p0]=1;
    powermax=timf2_pwr[p0];
    p_max=p0;
    m=blnfit_range;
    }
  m--;
  }
if(m>0)
  {
  goto clever_x;
  }  
if(timf2_findmax == 0)
  {
  if(timf2_display_powermax < powermax)
    {
    timf2_display_powermax=powermax;
    timf2_display_maxpoint=p_max;
    }
  i=timf2_display_maxval;
  if(sw_onechan)
    {
    k=p_max<<2;
    if(i<abs(timf2[k  ]))i=abs(timf2[k  ]);
    if(i<abs(timf2[k+1]))i=abs(timf2[k+1]);
    }
  else
    {
    k=p_max<<3;
    if(i<abs(timf2[k  ]))i=abs(timf2[k  ]);
    if(i<abs(timf2[k+1]))i=abs(timf2[k+1]);
    if(i<abs(timf2[k+2]))i=abs(timf2[k+2]);
    if(i<abs(timf2[k+3]))i=abs(timf2[k+3]);
    }
  if(timf2_display_maxval<(unsigned int)(i))
    {
    timf2_display_maxval=i;
    }
  }
// We do not want to handle unresolved multiple pulses with
// this rather slow method. Check the average power over bln.size points
// for the widths that may be useful.
pulse:;
bln_no=0;
pa=(p_max+1)&power_mask;
pb=(p_max+power_mask)&power_mask;
k=2;
check_avgpwr:;
m=powermax*bln[bln_no].rest;
if(m < sizlim)goto get_fit_size;
t1=0;
while(k < bln[bln_no].size)
  {
  t1+=(float)(timf2_pwr[pa])+(float)(timf2_pwr[pb]); 
  pa=(pa+1)&power_mask;
  pb=(pb+power_mask)&power_mask;
  k+=2;
  }
avgpwr[bln_no]=t1/powermax;  
bln_no++;
if(bln_no <=largest_blnfit)goto check_avgpwr; 
bln_no--;
get_fit_size:;
// Remember how strong the pulse is by setting sizeflag.
// Skip the use of large fit sizes in case the pulse is ugly.
sizeflag=bln_no;
while(avgpwr[bln_no] > bln[bln_no].avgmax && bln_no>=0)bln_no--;
if(bln_no < 0)
  {
// This pulse can not be fitted.
// Set flag to 65 over +/- blanker pulsewidth and for as long power decreases.
bad_pulse:;
  blanker_flag[p_max]=65;
  pa=p_max;
  pb=p_max;
  for(i=0; i<blanker_pulsewidth; i++)
    {
    pb=(pb+power_mask)&power_mask;
    pa=(pa+1)&power_mask;
    blanker_flag[pa]=65;
    blanker_flag[pb]=65;
    }
  p0=pb;
  pb=(pb+power_mask)&power_mask;
  if( ((pb-p_first+power_mask)&power_mask) > power_mask/2)goto find_pulse;
  while( timf2_pwr[pb] < timf2_pwr[p0] && pb!=p_first)
    {
    blanker_flag[pb]=65;
    p0=pb;
    pb=(pb+power_mask)&power_mask;
    }     
  if(pb == p_first)goto find_pulse;      
  p0=pa;
  pa=(pa+1)&power_mask;
  if( ((p_last-pa+power_mask)&power_mask) > power_mask/2)goto find_pulse;
  while( timf2_pwr[pa] < timf2_pwr[p0] && pa!=p_last)
    {
    p0=pa;
    blanker_flag[pa]=65;
    pa=(pa+power_mask)&power_mask;
    }     
  if(pa == p_last)goto find_pulse;      
// Step backwards until flag is zero across blanker_pulsewidth points    
  pb=p_max;
nofit_a:;  
  while(pb != p_first && blanker_flag[pb] != 0)
    {
    pb=(pb+power_mask)&power_mask;
    }
  if(pb == p_first)goto find_pulse;      
  for(i=0; i<blanker_pulsewidth; i++)
    {
    pb=(pb+power_mask)&power_mask;
    if(pb == p_first)goto find_pulse;      
    if(blanker_flag[pb] != 0)goto nofit_a;
    }
  while(pb != p_first && blanker_flag[pb] == 0)
    {
    pb=(pb+power_mask)&power_mask;
    }
  if(pb == p_first)goto find_pulse;      
  p_max=pb;
  powermax=timf2_pwr[p_max]; 
  goto pulse; 
  }
if(ui.rx_channels == 2)
  {
  t1=get_pulse_pol(p_max);
  if(t1 >=0)
    {
    transform_timf2_pol(p_max); 
    t1=subtract_twochan_pulse(p_max,bln[bln_no].size);
    }  
  }
else
  {
  t1=subtract_onechan_pulse(p_max, bln[bln_no].size);
  }
if(t1 < 0)goto bad_pulse;
fitted_pulses++;
blanker_flag[p_max]=66;
pa=p_max;
pb=p_max;
for(i=0; i<blanker_pulsewidth; i++)
  {
  pb=(pb+power_mask)&power_mask;
  pa=(pa+1)&power_mask;
  blanker_flag[pa]=66;
  blanker_flag[pb]=66;
  }
goto find_pulse;
clever_x:;
if(fitted_pulses > 0)timf2_findmax=1;
skip_fit:;
if(hg.stupid_bln_mode == 0)
  {
  goto skip_stupid;
  }
nfl=hg.stupid_bln_limit;
p0=p_first;
i=timf2_display_maxval;
ifirst=0;
stupid_clr1=(blanker_pulsewidth+1)>>1;
stupid_clr2=blanker_pulsewidth+1;
if(ui.rx_channels==1)
  {
  while(p0!=p_last)
    {
    p0=(p0+1)&power_mask;
    if(timf2_pwr[p0]>nfl)
      {
      ifirst++;
      k=p0<<2;
      if(timf2_findmax == 0)
        {
        if(timf2_display_powermax < timf2_pwr[p0])
          {
          timf2_display_powermax=timf2_pwr[p0];
          timf2_display_maxpoint=p0;
          }
        if(i<abs(timf2[k  ]))i=abs(timf2[k  ]);
        if(i<abs(timf2[k+1]))i=abs(timf2[k+1]);
        }
      cleared_points++;
      timf2_pwr[p0]=0;
      timf2[k  ]=0;    
      timf2[k+1]=0;    
      if(ifirst == 1)
        {
// Clear some points before the first cleared.
        pa=p0;
        for(j=0; j<stupid_clr1; j++)
          {
          pa=(pa+power_mask)&power_mask;
          k=pa<<2;
          timf2_pwr[pa]=0;
          timf2[k  ]=0;    
          timf2[k+1]=0;    
          cleared_points++;
          }
        }
      }
    else
      {
      if(ifirst != 0)
        {
        ifirst=0;
// Clear some points after the last cleared.
        pa=p0;
        for(j=0; j<stupid_clr2; j++)
          {
          k=pa<<2;
          timf2_pwr[pa]=0;
          timf2[k  ]=0;    
          timf2[k+1]=0;    
          pa=(pa+1)&power_mask;
          cleared_points++;
          }
        }
      }
    }
  }
else
  {
  while(p0!=p_last)
    {
    p0=(p0+1)&power_mask;
    if(timf2_pwr[p0]>nfl)
      {
      ifirst++;
      k=p0<<3;
      if(timf2_findmax == 0)
        {
        if(timf2_display_powermax < timf2_pwr[p0])
          {
          timf2_display_powermax=timf2_pwr[p0];
          timf2_display_maxpoint=p0;
          }
        if(i<abs(timf2[k  ]))i=abs(timf2[k  ]);
        if(i<abs(timf2[k+1]))i=abs(timf2[k+1]);
        if(i<abs(timf2[k+2]))i=abs(timf2[k+2]);
        if(i<abs(timf2[k+3]))i=abs(timf2[k+3]);
        }
      cleared_points++;
      timf2_pwr[p0]=0;
      timf2[k  ]=0;    
      timf2[k+1]=0;    
      timf2[k+2]=0;    
      timf2[k+3]=0;    
      if(ifirst == 1)
        {
// Clear some points before the first cleared.
        pa=p0;
        for(j=0; j<stupid_clr1; j++)
          {
          pa=(pa+power_mask)&power_mask;
          k=pa<<3;
          timf2_pwr[pa]=0;
          timf2[k  ]=0;    
          timf2[k+1]=0;    
          timf2[k+2]=0;    
          timf2[k+3]=0;    
          cleared_points++;
          }
        }
      }
    else
      {
      if(ifirst != 0)
        {
        ifirst=0;
// Clear some points after the last cleared.
        pa=p0;
        for(j=0; j<stupid_clr2; j++)
          {
          k=pa<<3;
          timf2_pwr[pa]=0;
          timf2[k  ]=0;    
          timf2[k+1]=0;    
          timf2[k+2]=0;    
          timf2[k+3]=0;    
          pa=(pa+1)&power_mask;
          cleared_points++;
          }
        }
      }
    }
  }
if(cleared_points > 0)
  {
  if(timf2_findmax == 0)
    {
    timf2_findmax =1;
    if(timf2_display_maxval<(unsigned int)(i))
      {
      timf2_display_maxval=i;
      }
    }
  }    
skip_stupid:;
// In case we did not remove any interference, check every fourth
// point for a maximum value.
// Note that pointers are multiples of four.
if(timf2_findmax == 0)
  {
  p0=p_first;
  pwrlim=timf2_display_powermax/3;
  i=timf2_display_maxval;
  while(p0 != p_last )
    {
    p0=(p0+4)&power_mask;
    if(timf2_pwr[p0] > pwrlim)
      {
      if(sw_onechan)
        {
        k=p0<<2;
        if(i<abs(timf2[k  ]))i=abs(timf2[k  ]);
        if(i<abs(timf2[k+1]))i=abs(timf2[k+1]);
        }
      else
        {
        k=p0<<3;
        if(i<abs(timf2[k  ]))i=abs(timf2[k  ]);
        if(i<abs(timf2[k+1]))i=abs(timf2[k+1]);
        if(i<abs(timf2[k+2]))i=abs(timf2[k+2]);
        if(i<abs(timf2[k+3]))i=abs(timf2[k+3]);
        }
      if(timf2_display_powermax < timf2_pwr[p0])
        {
        timf2_display_powermax=timf2_pwr[p0];
        pwrlim=timf2_display_powermax/3;
        timf2_display_maxpoint=p0;
        }
      }
    }
  if(timf2_display_maxval<(unsigned int)(i))
    {
    timf2_display_maxval=i;
    }
  }    
if(hg.timf2_display == 1)
  {
  timf2_display_counter++;
  if(timf2_display_counter == 2 && timf2_show_pointer >=0) show_timf2();
  if(timf2_display_counter >= timf2_display_interval)
    {
    if(timf2_display_powermax > 0)
      {
      timf2_show_pointer=timf2_display_maxpoint;
      }
    else
      {
      timf2_show_pointer =-1;
      }
    timf2_display_powermax=0;
    timf2_display_counter=0;
    timf2_display_maxval=0;
    }        
  }
if(hg.clever_bln_mode != 0)
  {
  timf2p_fit=(pf-16+power_mask)&(power_mask&0xfffffffc);
  }
else
  {
  timf2p_fit=p_last;
  }
timf2_pn1=timf2_pa;
timf2_pn2=mm*p_last;
if( ((timf2_pn2-timf2_px+timf2_totbytes)&timf2_mask) >=
                                          4*ui.rx_channels*fft2_size )
  {
  newdat_flag |= ND_TIMF2BLN;
  }
// Update timf2_noise_floor and timf2_despiked_pwr[]
// This is statistics and we do not have to use all the points.
// some time can be saved without significant loss of information.
// collect every 4th point. 
t1=0;
p0=p_first;
m=((timf2p_fit-p_first+1+power_mask)&power_mask);
timf2_fitted_pulses+=fitted_pulses;
timf2_cleared_points+=cleared_points;
timf2_blanker_points+=m;
// In case we cleared many points the number of points used for
// calculating average noise will be incorrect.
// Change k so it corresponds to the number of untouched points.
// but do not allow division by small numbers.
k=m-cleared_points-fitted_pulses;
if( k < m/25 )k=m/25;
k=(k+2)/4;
if(k<1)k=1;  
if(sw_onechan)
  {
  while(p0 != p_last)
    {
    p0=(p0+4)&power_mask;
    t1+=timf2_pwr[p0];
    }
  t1/=k;
  if(t1<10)t1=10;
  timf2_despiked_pwrinc[0]+=t1;
  }
else
  {
  t2=0;
  while(p0 != p_last)
    {
    p0=(p0+4)&power_mask;
    pa=p0<<3;
    t3=(float)(timf2[pa  ]);
    t4=(float)(timf2[pa+1]);
    t1+=t3*t3+t4*t4;
    t3=(float)(timf2[pa+2]);
    t4=(float)(timf2[pa+3]);
    t2+=t3*t3+t4*t4;
    }
  t1/=k;
  t2/=k;
  if(t1<10)t1=10;
  if(t2<10)t2=10;
  timf2_despiked_pwrinc[0]+=t1;
  timf2_despiked_pwrinc[1]+=t2;
  t1+=t2;
  }
blanker_info_update_counter++;
if(blanker_info_update_counter>=blanker_info_update_interval)
  { 
  if(fft1_lowlevel_fraction < 0.1)
    {
    blanker_info_update_counter--;
errno=20134;
    ck_write(hg.xleft+5*text_width,hg.ybottom-text_height-1,
                                         "SELLIM ERROR");
    }
  else
    {
  
    timf2_despiked_pwr[0]=timf2_despiked_pwrinc[0]/
                        (blanker_info_update_interval*fft1_lowlevel_fraction);
    timf2_despiked_pwr[1]=timf2_despiked_pwrinc[1]/
                        (blanker_info_update_interval*fft1_lowlevel_fraction);
    clever_blanker_rate=100*timf2_fitted_pulses/timf2_blanker_points;
    if(clever_blanker_rate > 99)clever_blanker_rate = 99;
    stupid_blanker_rate=100*timf2_cleared_points/timf2_blanker_points;
    if(stupid_blanker_rate > 99)stupid_blanker_rate = 99;
    timf2_noise_floor=(timf2_despiked_pwr[0]+timf2_despiked_pwr[1])/
                                                     ui.rx_channels;
    if( hg.stupid_bln_mode == 1)
      {
      if(stupid_blanker_rate > 20)
        {
        if(timf2_noise_floor<30)timf2_noise_floor=30; 
        t1=0.01*pow((float)(stupid_blanker_rate-20),2);
        if(t1>30)t1=30;
        timf2_noise_floor*=1+t1;
        }
      else
        {  
        timf2_noise_floor=((timf2_noise_floor_avgnum-1)*timf2_noise_floor+t1)/
                                                   timf2_noise_floor_avgnum;
        }
      hg.stupid_bln_limit=timf2_noise_floor*hg.stupid_bln_factor;
      }
    if( hg.clever_bln_mode == 1)
      {
      hg.clever_bln_limit=timf2_noise_floor*hg.clever_bln_factor;
      }
    show_blanker_info(1);
    blanker_info_update_counter=0;
// Set start value to 1 to avoid problems with log function in hires_graph.
    timf2_despiked_pwrinc[0]=1;
    timf2_despiked_pwrinc[1]=1;
    timf2_fitted_pulses=0;
    timf2_cleared_points=0;
    timf2_blanker_points=0;
    }
  }
}
