

#include <vga.h>
#include <vgagl.h>
#include <unistd.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "caldef.h"

#define MAX_SEG 256
#define BAL_AVGNUM 6


void expand_foldcorr(float *x)
{
int i, j, k, n, mm, mx;
mm=twice_rxchan;
if(bal_segments < fft1_size)
  {
  mx=bal_segments;
  }
else
  {
  mx=fft1_size;
  }
mx*=2;    
for(j=0; j<mm; j+=2)
  {
  k=fft1_size;
  n=4*bal_segments;
  i=0;
  while(i<mx && i<=k) 
    {
    k--;
    n--;
    fft1_tmp[2*i  ]=contracted_iq_foldcorr[mm*i+j  ];
    fft1_tmp[2*i+1]=contracted_iq_foldcorr[mm*i+j+1];
    fft1_tmp[2*k  ]=contracted_iq_foldcorr[mm*n+j  ];
    fft1_tmp[2*k+1]=contracted_iq_foldcorr[mm*n+j+1];
    i++;
    }
  for(i=2*bal_segments; i<fft1_size-2*bal_segments; i++)
    {
    fft1_tmp[2*i  ]=0;
    fft1_tmp[2*i+1]=0;
    }
  fftback(fft1_size, fft1_n, fft1_tmp, cal_table, cal_permute);
  for(i=0; i<fft1_size; i++)
    {
    x[mm*i+j  ]=fft1_tmp[2*i  ];
    x[mm*i+j+1]=fft1_tmp[2*i+1];
    }
  }  
}


void contract_foldcorr(float *x)
{
int i, j, k, n, m, mm;
float t1,t2;
mm=twice_rxchan;
m=fft1_size/bal_segments;
for(j=0; j<mm; j+=2)
  {
  for(i=0; i<fft1_size; i++)
    {
    fft1_tmp[2*i  ]=x[mm*i+j  ]/fft1_size;
    fft1_tmp[2*i+1]=x[mm*i+j+1]/fft1_size;
    }
  for(n=0; n<2; n++)
    {
    for(i=0; i<m; i++)
      {
      k=fft1_size-i-1;
      t1=fft1_tmp[2*i+n];
      t2=fft1_tmp[2*k+n];
      fft1_tmp[2*i+n]=((m+i)*t1+(m-i)*t2)/(2*m);
      fft1_tmp[2*k+n]=((m+i)*t2+(m-i)*t1)/(2*m);
      }
    }  
  fftforward(fft1_size, fft1_n, fft1_tmp, cal_table, cal_permute);
  t1=0.5*PI_L/bal_segments;
  t2=0;
  for(i=bal_segments; i<2*bal_segments; i++)
    {
    k=fft1_size-i;
    fft1_tmp[2*i  ]*=cos(t2);
    fft1_tmp[2*i+1]*=cos(t2);
    fft1_tmp[2*k  ]*=cos(t2);
    fft1_tmp[2*k+1]*=cos(t2);
    t2+=t1;
    }
  for(i=0; i<2*bal_segments; i++) 
    {
    k=fft1_size-i-1;
    n=4*bal_segments-i-1;
    contracted_iq_foldcorr[mm*i+j  ]=fft1_tmp[2*i  ];
    contracted_iq_foldcorr[mm*i+j+1]=fft1_tmp[2*i+1];
    contracted_iq_foldcorr[mm*n+j  ]=fft1_tmp[2*k  ];
    contracted_iq_foldcorr[mm*n+j+1]=fft1_tmp[2*k+1];
    }
  }
}

void write_iq_foldcorr()
{
FILE *file;
int i;
int wrbuf[20];
char s[80];
if(bal_updflag!=0)
  {
  cal_initscreen();
  if(bal_updflag==-1)
    {
    xytext(0,5,"Nothing to write to disk.");
    xytext(0,6,"Update RAM first");
    xytext(0,8,"Press any key");
    await_keyboard();
    return;
    }
if(bal_updflag==1)
    {
    xytext(0,5,"RAM cleared.");
    xytext(0,6,"Do you really want to write cleared data to file to");
    xytext(0,7,"use as I/Q balancing (Y/N)");
kbdinp:;
    await_keyboard();
    clean_vga_inkey();
    if(vga_inkey == 'N')return;
    if(vga_inkey != 'Y')goto kbdinp;
    }
  }
contract_foldcorr(fft1_foldcorr);
make_iqcorr_filename(s);
file = fopen(s, "wb");
if (file == NULL)end_program(7690);
wrbuf[0]=bal_segments;
wrbuf[1]=ui.input_mode&IQ_DATA;
wrbuf[2]=ui.input_speed;
wrbuf[3]=ui.rx_channels;
wrbuf[4]=FOLDCORR_VERNR;
for(i=5; i<10; i++)wrbuf[i]=0;
fwrite(wrbuf, sizeof(int),10,file);
fwrite(contracted_iq_foldcorr, twice_rxchan*sizeof(float),
                                                      4*bal_segments, file);  
fwrite(wrbuf, sizeof(int),10,file);
fclose(file);
bal_updflag=-1;
}

void update_iq_foldcorr(void)
{
int i, j, k, m, mm;
int ia,ib;
int seg;
float scale,t1,t2,r1,r2,ta,tb,ra,rb;
float z[2*MAX_ADCHAN];
mm=twice_rxchan;
cal_initscreen();
// Find average values for amplitude ratio and phase sum.
for(seg=0; seg<bal_segments; seg++)
  {
  if(bal_flag[seg] == BAL_AVGNUM)
    {
    for(j=0; j<4*ui.rx_channels; j++)z[j]=0;
    for(m=0; m<BAL_AVGNUM; m++)
      {
      k=(m*bal_segments+seg)*ui.rx_channels;  
      for(j=0; j<ui.rx_channels; j++)
        {
        z[4*j  ]+=bal_pos[k+j];
        t1=cos(bal_phsum[k+j]);
        t2=sin(bal_phsum[k+j]);
        z[4*j+1]+=t1;
        z[4*j+2]+=t2;
        z[4*j+3]+=bal_amprat[k+j];
        }
      }
    for(j=0; j<ui.rx_channels; j++)
      {
      bal_pos[seg*ui.rx_channels+j]=z[4*j  ]/BAL_AVGNUM;  
      bal_phsum[seg*ui.rx_channels+j]=atan2(z[4*j+2],z[4*j+1]);
      bal_amprat[seg*ui.rx_channels+j]=z[4*j+3]/BAL_AVGNUM;
      }
    }
  }  
// Expand to fft1_size and draw straight lines between the points we have.
for(j=0; j<ui.rx_channels; j++)
  {
// The center point is incorrect since the spur and the signal are not
// enough separated. Replace with average from surroundings.  
  k=bal_segments*ui.rx_channels/2+j;
  bal_phsum[k]=(bal_phsum[k+ui.rx_channels]+bal_phsum[k-ui.rx_channels])/2;
  bal_amprat[k]=(bal_amprat[k+ui.rx_channels]+bal_amprat[k-ui.rx_channels])/2;
  bal_pos[k]=(bal_pos[k+ui.rx_channels]+bal_pos[k-ui.rx_channels])/2;

  seg=0;
  while(bal_flag[seg] != BAL_AVGNUM  && seg < bal_segments) seg++;
  if(seg == bal_segments)return;
  ia=0;
  t1=bal_phsum[seg*ui.rx_channels+j];
  t2=bal_amprat[seg*ui.rx_channels+j];
  ta=t2*cos(t1);
  ra=t2*sin(t1);
fillbuf:;
  ib=bal_pos[seg*ui.rx_channels+j];
  t1=bal_phsum[seg*ui.rx_channels+j];
  t2=bal_amprat[seg*ui.rx_channels+j];
  tb=t2*cos(t1);
  rb=t2*sin(t1);
fillbuf1:;
  if(ia<0)ia=0;
  if(ib>fft1_size)ib=fft1_size;
  for(i=ia; i<ib; i++)
    {
    t1=(i-ia);
    t1/=(ib-ia);
    t2=1-t1;
    r1=t2*ta+t1*tb;
    r2=t2*ra+t1*rb;
    buf5[mm*i+2*j  ]=r1;
    buf5[mm*i+2*j+1]=r2;
    }    
  ia=ib;
  ta=tb;
  ra=rb;
  seg++;
  if(seg <= bal_segments)
    {
    while(seg < bal_segments)
      {
      if(bal_flag[seg] == BAL_AVGNUM)goto fillbuf;
      seg++;
      }
    seg++;  
    ib=fft1_size-1;
    goto fillbuf1;
    }  
  }
// Make the new correction curve smoother.
contract_foldcorr(buf5);
expand_foldcorr(buf5);
for(j=0; j<mm; j+=2)
  {
  for(i=0; i<fft1_size/2; i++)
    {
    r1=buf5[mm*i+j  ];
    r2=buf5[mm*i+j+1];
    fft1_foldcorr[mm*i+j  ]+=r1;
    fft1_foldcorr[mm*i+j+1]-=r2;
    }
  for(i=fft1_size/2+1; i<fft1_size; i++)
    {
    r1=buf5[mm*i+j  ];
    r2=buf5[mm*i+j+1];
    fft1_foldcorr[mm*i+j  ]+=r1;
    fft1_foldcorr[mm*i+j+1]+=r2;
    }
  }  
scale=5;
redraw:;
for(j=0; j<mm; j+=2)
  {
  for(i=0; i<WIDTH; i++)
    {
    k=i*fft1_size/(WIDTH-1);
    if(k>fft1_size-1)k=fft1_size-1;
errno=10210;
    ck_setpixel(i, cal_graph[WIDTH*j+i], 0);  
    t2=scale*buf5[mm*k+j];   
    if(t2 <-cal_ymax)t2=-cal_ymax;
    if(t2 >cal_ymax)t2=cal_ymax;
    if(j > 1)t2-=0.32;
    cal_graph[WIDTH*j+i]=HEIGHT*(cal_yzer-t2);
errno=10211;
    ck_setpixel(i, cal_graph[WIDTH*j+i], 13);  
errno=10212;
    ck_setpixel(i, cal_graph[WIDTH*(j+1)+i], 0);  
    t2=scale*buf5[mm*k+j+1];   
    if(t2 <-cal_ymax)t2=-cal_ymax;
    if(t2 >cal_ymax)t2=cal_ymax;
    if(j > 1)t2-=0.32;
    cal_graph[WIDTH*(j+1)+i]=HEIGHT*(0.5-t2);
errno=10213;
    ck_setpixel(i, cal_graph[WIDTH*(j+1)+i], 10);  
    }
  }
xytext(0,3,"Complex amplitude of spur frequency to add to signal.");
xytext(0,4,"If amplitudes are large, run the routine once more");
xytext(0,5,"to make sure second order effects are eliminated.");
xytext(7,7,"Press + or - to change scale, any other key to exit.)");
await_keyboard();
clean_vga_inkey();
if(vga_inkey == '+')
  {
  scale*=3.13;
  goto redraw;
  }
if(vga_inkey == '-')
  {
  scale/=3.13;
  goto redraw;
  }
bal_updflag=0;
}





int balance_spurs(void)
{
char s[80];
int seg,color;
int ia,ib;
int maxval[MAX_ADCHAN],minval[MAX_ADCHAN];
int i,j,k,m,n,mm,errskip;
float t1,t2,t3;
float z[2*MAX_ADCHAN];
bal_flag=chk_malloc((MAX_SEG+1)*sizeof(short int),1049);
bal_pos=chk_malloc(BAL_AVGNUM*(MAX_SEG+1)*ui.rx_channels*
                                                   sizeof(short int),1049);
bal_phsum=chk_malloc(BAL_AVGNUM*(MAX_SEG+1)*ui.rx_channels*
                                                       sizeof(float),1049);
bal_amprat=chk_malloc(BAL_AVGNUM*(MAX_SEG+1)*ui.rx_channels*
                                                       sizeof(float),1049);
contracted_iq_foldcorr=chk_malloc(8*(MAX_SEG+1)*ui.rx_channels*
                                                       sizeof(float),1049);
bal_updflag=-1;
bal_segments=32;
mm=twice_rxchan;
start_balcal:;
if(bal_segments > MAX_SEG)bal_segments = MAX_SEG;
if(bal_segments > fft1_size/4)bal_segments = fft1_size/4;
if(bal_segments < 8)bal_segments = 8;
for(i=0; i<=bal_segments; i++)bal_flag[i]=0;
clear_fft1_filtercorr();
cal_initscreen();
xytext(0,1,"Connect signal generator to antenna input.");
sprintf(s,"The frequency range is split in %d segments.",bal_segments);
xytext(0,2,s);
xytext(0,3,"Tune and wait for each segment to become green.");
settextcolor(14);
xytext(5,4,"+/- to change no of segments");
xytext(5,5,"S => Save correction in ram to disk");
xytext(5,6,"Z => Clear old data");
xytext(5,7,"U => Update correction in ram");
settextcolor(7);
get_baldat:;
open_audio_input();
vga_inkey=vga_getkey();
if(vga_inkey != 0)goto kbd_chk1;
// Start by reading one block of data.
// Check the raw A/D data for signal level.
// We want the signal to be high but not too close to saturation.
// Waist 1/25 seconds here.
n=2*ui.input_speed*ui.ad_channels/25;
if(  (ui.input_mode&DWORD_INPUT) != 0)n*=2;
read(audio_in, timf1_short_int, n);
for(j=0; j<ui.ad_channels; j++)
  {
  maxval[j]=0x80000000; 
  minval[j]=0x7fffffff;
  }
if(  (ui.input_mode&DWORD_INPUT) == 0)
  {  
  n/=sizeof(short int);
  for(i=0; i<n; i+=ui.ad_channels)
    {
    for(j=0; j<ui.ad_channels; j++)
      {
      k=i+j;
      if(minval[j]>timf1_short_int[k])minval[j]=timf1_short_int[k];
      if(maxval[j]<timf1_short_int[k])maxval[j]=timf1_short_int[k];
      }
    }  
  for(j=0; j<ui.ad_channels; j++)
    {
    maxval[j]<<=16; 
    minval[j]<<=16;
    }
  }
else  
  {  
  n/=sizeof(int);
  for(i=0; i<n; i+=ui.ad_channels)
    {
    for(j=0; j<ui.ad_channels; j++)
      {
      k=i+j;
      if(minval[j]>timf1_int[k])minval[j]=timf1_int[k];
      if(maxval[j]<timf1_int[k])maxval[j]=timf1_int[k];
      }
    }  
  }
clear_lines(8,9);
errskip=0;
for(j=0; j<ui.ad_channels; j++)
  {
  t1=maxval[j];
  t1-=minval[j];
  t1=(50*t1)/0x80000000;
  if(t1>90)
    {
    settextcolor(12);
    xytext(10,8,"O V E R L O A D");
    errskip=1;
    }
  if(t1<5)
    {
    settextcolor(12);
    xytext(10,8,"Signal too weak");
    errskip=1; 
    }
  sprintf(s,"A/D(%d) %.2f%%",j,t1);
  xytext(20*j,9,s);
  settextcolor(7);
  }
// Read data the normal way as fourier transforms.
fft1_pa=0;
fft1_pb=0;
fft1_nb=0;
fft1_na=0;
fft1_px=0;
fft1_nx=0;
timf1p_pa=0;
timf1p_px=0;
kbd_chk:;
vga_inkey=vga_getkey();
if(vga_inkey != 0)
  {
kbd_chk1:;
  close_audio_input();
  clean_vga_inkey();
  if(vga_inkey == 'X')
    {
    free(bal_flag);
    free(bal_pos);
    free(bal_phsum);
    free(bal_amprat);
    free(contracted_iq_foldcorr);
    init_fft1_filtercorr();
    return 0;
    }
  if(vga_inkey == '+')bal_segments*=2;
  if(vga_inkey == '-')bal_segments/=2;
  if(vga_inkey == 'S')write_iq_foldcorr();
  if(vga_inkey == 'U')update_iq_foldcorr();
  if(vga_inkey == 'Z')clear_iq_foldcorr();
  goto start_balcal;
  }
make_fft1(0);
if( fft1_pa < 3*fft1_block)goto kbd_chk;

// Using a window function we have to get 2 buffers, only buf1 has valid
// data - buf0 has partial data only.
// We are stopping the A/D after each collect cycle to avoid overruns
// so some extra time is lost here.
close_audio_input();
// Convert complex amplitudes to power and phase, store in buf3.
// Get the point of maximum. 
t2=0;
k=0;
for(i=0; i<fft1_size; i++)
  {
  t1=0;
  for(j=0; j<mm; j+=2)
    {
    buf3[mm*i+j]=pow(buf2[mm*i+j  ],2.0)+
                 pow(buf2[mm*i+j+1],2.0);
    t1+=buf3[mm*i+j];
    buf3[mm*i+j+1]=atan2(buf1[mm*i+j+1],buf1[mm*i+j  ]);
    }
  if(t2<t1)
    {
    t2=t1;
    k=i;
    }
  }
if(errskip==1) goto skipdat; 
if(k<2)k=2;
if(k>fft1_size-3)k=fft1_size-3;
// Since we use a sin power 4 window a peak will be a few points wide.
// collect the average amplitude ratio and average phase sum 
// Use power as weight factor in averaging.
clear_lines(10,10);
for(j=0; j<mm; j+=2)
  {
  z[2*j]=z[2*j+1]=z[2*j+2]=z[2*j+3]=0;
  for(i=k-2; i<=k+2; i++)
    {
    m=fft1_size-i;
    t1=buf3[mm*m+j+1]+buf3[mm*i+j+1];
    if(t1<-PI_L)t1+=2*PI_L;
    if(t1>PI_L)t1-=2*PI_L;
    t3=buf3[mm*i+j];
    t2=sqrt(buf3[mm*m+j]/buf3[mm*i+j]);
    z[2*j]+=t3;
    z[2*j+1]+=t3*t2;
    z[2*j+2]+=t3*t1;
    z[2*j+3]+=t3*i;
    }
  z[2*j+1]/=z[2*j];
  z[2*j+2]/=z[2*j];
  z[2*j+3]/=z[2*j];
  ia=z[2*j+3]+0.5;
  ib=ia+4;
  ia=ia-4;
  if(ia<0)ia=0;
  if(ib>fft1_size)ib=fft1_size;
  if(buf3[mm*ia+j]+buf3[mm*ib+j]>0.02*buf3[mm*k+j])
    {
    xytext(0,10,"Signal too unstable");
    goto skipdat;
    }
  }
clear_lines(10,10);
seg=(bal_segments*z[3])/fft1_size+0.5;
if(seg > bal_segments)seg=bal_segments;
for(j=2; j<mm; j+=2)
  {
  k=(bal_segments*z[2*j+3])/fft1_size+0.5;
  if(seg != k )
    {
    xytext(0,10,"Channels differ");
    goto skipdat;
    }
  }    
if(bal_flag[seg]==BAL_AVGNUM)
  {
  sprintf(s,"Segment %d ok",seg);
  xytext(0,10,s);
  goto skipdat_a;
  }
k=(bal_flag[seg]*bal_segments+seg)*ui.rx_channels;  
for(j=0; j<ui.rx_channels; j++)
  {
  bal_pos[k+j]=z[4*j+3]+0.5;
  bal_phsum[k+j]=z[4*j+2];
  bal_amprat[k+j]=z[4*j+1];
  }
bal_flag[seg]++;
skipdat_a:;
for(j=0; j<ui.rx_channels; j++)
  {
  sprintf(s,"Ch(%d) A=%f ph=%f",j,z[4*j+1],z[4*j+2]);
  xytext(30*j,11,s);
  }
skipdat:;


m=fft1_size/(WIDTH-1);  
for(j=0; j<mm; j+=2)
  {
  for(i=0; i<WIDTH; i++)
    {
errno=10214;
    ck_setpixel(i, cal_graph[WIDTH*j+i], 0);  
    k=i*m;
    if(k>fft1_size-m)k=fft1_size-m;
    t2=0;
    for(n=0;n<m;n++)t2+=buf3[mm*(k+n-m/2)+j];
    t2/=m;
    t2=0.03*log10(t2)-0.05;   
    if(t2 <-0.28)t2=-0.28;
    if(t2 > 0.28)t2= 0.28;
    if(j>0)t2-=.2;
    cal_graph[WIDTH*j+i]=HEIGHT*(0.5-t2);
    seg=(float)(bal_segments*k)/fft1_size+0.5;    
    color=13;
    if(bal_flag[seg]==0) color=15;
    if(bal_flag[seg]==BAL_AVGNUM)color=10;
errno=10215;
    ck_setpixel(i, cal_graph[WIDTH*j+i], color);  
    }
  }
goto get_baldat;  
}
