
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "sigdef.h"
#include "screendef.h"
#include "fft1def.h"

#define COH_GRAPH_ACTIVE -1000

void make_cg_trace(int mode,char *trtext,float *x,int trlevel,int txtlevel)
{
int i,j,k,m,oscw,ia,yzer,txty,osc_ptr,sizhalf; 
float t1,ampfac;
short int *x_short;
unsigned char *x_char;
char s[80];
x_short=(void*)x;
x_char=(void*)x;
txty=50;
if(cg_oscill_on == 0)return;
if(cg_oscill_on == 1)
  {
  if(trlevel > cg_max_trlevel)cg_max_trlevel=trlevel;
  return;
  }
sizhalf=mix2_size/2;
oscw=WIDTH/2;
osc_ptr=cg_osc_ptr;
ia=(baseb_pa-cg_osc_offset+baseband_size)&baseband_mask;
yzer=cg_lsep/2+trlevel*cg_lsep;
if(cg_osc_shift_flag == 0)
  {
  txty=txtlevel+yzer+2-text_height;
  settextcolor(7);
  gl_write(0,txty,trtext);
  i=(ia+sizhalf-oscw+baseband_size)&baseband_mask;
  j=(ia+sizhalf)&baseband_mask;
  sprintf(s,"%6d to %6d  inc=%d  ",i,j,cg_osc_offset_inc);
  xytext(33,HEIGHT/text_height-1,s);
  }
switch (mode)
  {
  case 1:
// Amplitude and phase.  
  ampfac=daout_gain/bg_amplimit;
  if(cg_no_of_traces+2 > CG_MAXTRACE)end_program(887722);
  if(cg_osc_shift_flag == 0)
    {
    settextcolor(4);
    gl_write(0,txty+text_height,"pha");
    settextcolor(7);
    gl_write(0,txty+2*text_height,"amp");
    }
  for(i=0; i<sizhalf; i++)
    {
    t1=CG_A*ampfac*sqrt(x[2*ia]*x[2*ia]+x[2*ia+1]*x[2*ia+1]);
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces]=yzer-t1;
    t1=0.5*CG_AMAX*atan2(x[2*ia+1],x[2*ia])/PI_L;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces+1]=yzer-t1;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=15;
  cg_color[cg_no_of_traces+1]=12;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_yzer[cg_no_of_traces+1]=yzer;
  cg_no_of_traces+=2;
  break;

  case 2:
// Power or threshold   
  ampfac=daout_gain/bg_amplimit;
  if(cg_no_of_traces+1 > CG_MAXTRACE)end_program(887722);
  for(i=0; i<sizhalf; i++)
    {
    t1=CG_A*ampfac*sqrt(x[ia]);
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces]=yzer-t1;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=10;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_no_of_traces++;
  break;

  case 3:
// Ramp   
  if(cg_no_of_traces+1 > CG_MAXTRACE)end_program(887722);
  for(i=0; i<sizhalf; i++)
    {
    k=x_short[ia];
    if(k>CG_AMAX)k=CG_AMAX;
    if(k<-CG_AMAX)k=-CG_AMAX;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces]=yzer-k;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=10;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_no_of_traces++;
  break;

  case 4:
  ampfac=daout_gain/bg_amplimit;
  goto cmplx;
  case 7:
  ampfac=0.009*CG_AMAX;
  
cmplx:;
  if(cg_no_of_traces+2 > CG_MAXTRACE)end_program(887722);
// Complex amplitude.  
  if(cg_osc_shift_flag == 0)
    {
    settextcolor(10);
    gl_write(0,txty+text_height,"Re");
    settextcolor(13);
    gl_write(0,txty+2*text_height,"Im");
    }
  for(i=0; i<sizhalf; i++)
    {
    t1=CG_A*ampfac*x[2*ia];
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces]=yzer-t1;
    t1=CG_A*ampfac*x[2*ia+1];
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces+1]=yzer-t1;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=10;
  cg_color[cg_no_of_traces+1]=13;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_yzer[cg_no_of_traces+1]=yzer;
  cg_no_of_traces+=2;
  break;
  
  
  case 5:
  ampfac=daout_gain/bg_amplimit;
  if(cg_no_of_traces+2 > CG_MAXTRACE)end_program(887722);
// show cwlong_buffer.
  m=0;
  while(m < oscw/4)
    {
    cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces]=yzer;
    cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces+1]=yzer;
    m++; 
    }
  for(j=0; j<CWLONG_MAXBUF; j++)
    {
    if(cwlong_no_of_traces[j]>0)
      {
      for(i=0; i<cwlong_store_points; i++)
        {
        if(m>=oscw)goto filled_5;
        t1=CG_A*ampfac*x[2*i+2*j*cwlong_store_points  ]/cwlong_no_of_traces[j];
        if(t1>CG_AMAX)t1=CG_AMAX;
        if(t1<-CG_AMAX)t1=-CG_AMAX;
        cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces]=yzer-t1;
        t1=CG_A*ampfac*x[2*i+2*j*cwlong_store_points+1]/cwlong_no_of_traces[j];
        if(t1>CG_AMAX)t1=CG_AMAX;
        if(t1<-CG_AMAX)t1=-CG_AMAX;
        cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces+1]=yzer-t1;
        m++; 
        }
      k=2*cg_code_unit;  
      for(i=0; i<k; i++)
        {
        if(m>=oscw)goto filled_5;
        cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces]=yzer;
        cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces+1]=yzer;
        m++;
        } 
      }  
    }
  while(m < oscw)
    {
    cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces]=yzer;
    cg_traces[CG_MAXTRACE*(m)+cg_no_of_traces+1]=yzer;
    m++; 
    }
filled_5:;    
  cg_color[cg_no_of_traces]=11;
  cg_color[cg_no_of_traces+1]=12;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_yzer[cg_no_of_traces+1]=yzer;
  cg_no_of_traces+=2;
  break;

  case 6:
  ampfac=0.9*CG_AMAX;
  for(i=0; i<oscw; i++)
    {
    t1=ampfac*x[2*i];
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*i+cg_no_of_traces]=yzer-t1;
    t1=ampfac*x[2*i+1];
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*i+cg_no_of_traces+1]=yzer-t1;
    }
  cg_color[cg_no_of_traces]=10;
  cg_color[cg_no_of_traces+1]=13;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_yzer[cg_no_of_traces+1]=yzer;
  cg_no_of_traces+=2;
  break;

  case 8:
  for(i=0; i<sizhalf; i++)
    {
    t1=0.5*CG_AMAX*atan2(x[2*ia+1],x[2*ia])/PI_L;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces]=yzer-t1;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=12;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_no_of_traces++;
  break;

  case 9:
// Amplitude
  if(cg_no_of_traces+1 > CG_MAXTRACE)end_program(887722);

  ampfac=daout_gain/bg_amplimit;
  for(i=0; i<sizhalf; i++)
    {
    t1=CG_A*ampfac*x[ia];
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces]=yzer-t1;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=15;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_no_of_traces++;
  break;

  case 10:
// Flags  
  if(cg_no_of_traces+1 > CG_MAXTRACE)end_program(887722);
  for(i=0; i<sizhalf; i++)
    {
    t1=-CG_AMAX;
    j=x_char[ia];
    if(j==0)
      {
      t1=0;
      }
    else
      {  
      t1=.25*CG_AMAX;
      }
    cg_traces[CG_MAXTRACE*(i+osc_ptr)+cg_no_of_traces]=yzer-t1;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=15;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_no_of_traces++;
  break;

  case 11:
// Amplitude and phase.  
// Compute all the points. These arrays are detect output data
// and we may have changed them...
  ampfac=daout_gain/bg_amplimit;
  if(cg_no_of_traces+2 > CG_MAXTRACE)end_program(887722);
  if(cg_osc_shift_flag == 0)
    {
    settextcolor(4);
    gl_write(0,txty+text_height,"pha");
    settextcolor(7);
    gl_write(0,txty+2*text_height,"amp");
    }
  ia=(ia-osc_ptr+baseband_size)&baseband_mask;
  for(i=0; i<sizhalf+osc_ptr; i++)
    {
    t1=CG_A*ampfac*sqrt(x[2*ia]*x[2*ia]+x[2*ia+1]*x[2*ia+1]);
    if(t1>CG_AMAX)t1=CG_AMAX;
    if(t1<-CG_AMAX)t1=-CG_AMAX;
    cg_traces[CG_MAXTRACE*i+cg_no_of_traces]=yzer-t1;
    t1=0.5*CG_AMAX*atan2(x[2*ia+1],x[2*ia])/PI_L;
    cg_traces[CG_MAXTRACE*i+cg_no_of_traces+1]=yzer-t1;
    ia=(ia+1)&baseband_mask;
    }
  cg_color[cg_no_of_traces]=15;
  cg_color[cg_no_of_traces+1]=12;
  cg_yzer[cg_no_of_traces]=yzer;
  cg_yzer[cg_no_of_traces+1]=yzer;
  cg_no_of_traces+=2;
  break;

  
  }
if(cg_osc_shift_flag == 0)settextcolor(7);
}  




void clear_cg_traces(void)
{
int i,j,oscw,osc_ptr,sizhalf;
oscw=WIDTH/2;
sizhalf=mix2_size/2;
osc_ptr=oscw-sizhalf;
if(osc_ptr < 0)osc_ptr=0;
cg_lsep=HEIGHT/(cg_max_trlevel+1);
if( (cg_oscill_on&2) != 0 )
  {
  if(cg_osc_shift_flag<=1)
    {
  for(j=0; j<cg_no_of_traces; j++)
    {
    for(i=1; i<oscw; i++)
      {
      gl_line(i-1,cg_traces[CG_MAXTRACE*(i-1)+j],
               i,cg_traces[CG_MAXTRACE*i+j],0);
      }
    check_fft1_timing();
    }
    }
// Move all data points backwards by sizhalf points and set pointer.
  for(i=0; i<osc_ptr; i++)
    {
    for(j=0; j<cg_no_of_traces; j++)
      {
      cg_traces[CG_MAXTRACE*i+j]=cg_traces[CG_MAXTRACE*(i+sizhalf)+j];
      }
    }
  }
cg_osc_ptr=osc_ptr;
cg_no_of_traces=0;
}



void cg_show_traces(void)
{
int i, j, yzer, oscw, sizhalf;
sizhalf=mix2_size/2;
oscw=WIDTH/2;
if( (cg_oscill_on&6) == 4)
  {
  cg_oscill_on|=2;
  for(j=0; j<cg_no_of_traces; j++)
    {
    yzer=cg_yzer[j];
    for(i=0; i<oscw; i++)
      {
      cg_traces[CG_MAXTRACE*i+j]=yzer;
      }
    }  
  }
else
  {
  hide_mouse();    
  i=cg_lsep/2;
  while(i<HEIGHT)
    {
    gl_hline(0,i,oscw,8);  
    i+=cg_lsep;
    }
  for(j=0; j<cg_no_of_traces; j++)
    {
    for(i=1; i<oscw; i++)
      {      
      gl_line(i-1,cg_traces[CG_MAXTRACE*(i-1)+j],
                i,cg_traces[CG_MAXTRACE*i+j],cg_color[j]);
      }
    check_fft1_timing();
    }  
  show_mouse();
  }
}


void shift_cg_osc_track(int shift)
{
int i,j,oscw,sizhalf;
oscw=WIDTH/2;
sizhalf=mix2_size/2;
j=oscw/sizhalf;
if(j*sizhalf < oscw)j++;
cg_osc_offset+=shift;
baseb_pa=(baseb_pa-j*sizhalf+baseband_size)&baseband_mask;
if( (cg_oscill_on&1) !=0 )cg_osc_shift_flag=1;
for(i=1; i<j; i++)
  {
  update_cg_traces();
  baseb_pa=(baseb_pa+sizhalf)&baseband_mask;
  cg_osc_shift_flag++;
  }
cg_osc_shift_flag=0;
update_cg_traces();
baseb_pa=(baseb_pa+sizhalf)&baseband_mask;
}


void update_cg_traces(void)
{
clear_cg_traces();
make_cg_trace(1,"Raw",baseb_raw,0,0);
make_cg_trace(2,"",baseb_threshold,0,0);
make_cg_trace(4,"Raw",baseb_raw,1,0);
make_cg_trace(1,"Coh1",baseb,2,0);
make_cg_trace(3,"",(float*)(baseb_ramp),2,0);
make_cg_trace(4,"Coh1",baseb,3,0);
if(genparm[CW_DECODE_ENABLE] != 0)
  {
  make_cg_trace(11,"Det",baseb_fit,4,-text_height);
  make_cg_trace(11,"Env",baseb_envelope,5,0);
  make_cg_trace(10,"Flag",(float*)baseb_detect_flag,6,0);
  make_cg_trace(6,"Avg",cg_tmpbuf,7,2*text_height);
  make_cg_trace(5,"",cwlong_buffer,7,0);
  }
make_cg_trace(8,"Carr",baseb_carrier,8,0);
make_cg_trace(9,"",baseb_carrier_ampl,8,0);
if( (cg_oscill_on&1) !=0 )
  {
  if(cg_osc_shift_flag==0)
    {
    if(cg_oscill_on > 1)cg_show_traces();
    cg_oscill_on |= 4;
    }
  }
}


