
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "sigdef.h"
#include "screendef.h"

#define ZZ 0.00000001


void skip_old_dashes(void)
{
// In trying to establish the keying speed on pure noise
// we may go on for ever without sucess. 
// The cw structure could overflow and there is no reason to
// keep very old data so this routine is called to make sure
// the oldest dash_midpoint is not older than half the
// size of the baseband buffers.
int j,k;
float t1,t2,t3;
j=no_of_cwdat-1;
t2=cw[j].midpoint;
k=j-10;
t3=baseband_size>>1;
if(k<0)goto old_dash_2;
old_dash_1:;
t1=t2-cw[k].midpoint;
if(t1 < 0)t1+=baseband_size;
if( t1 > t3)
  {
  goto old_dash_4;  
  }
k-=10;
if(k > 0 )goto old_dash_1;  
old_dash_2:;
k=0;
old_dash_3:;
t1=t2-cw[k].midpoint;
if(t1 < 0)t1+=baseband_size;
if( t1 < t3)goto old_dash_5;  
old_dash_4:;
k++;
goto old_dash_3;  
old_dash_5:;  
if(k == 0)return;
j=0;
while(k < no_of_cwdat)
  {
  cw[j]=cw[k];
  j++;
  k++;
  }
no_of_cwdat=j;
}


void fit_dot(void)
{
int i,k,m,ss,pp,n1,n2,n3,trials;
float t1,t2,t3,r1,r2;
float im_1,im_2,im_3;
float re_1,re_2,re_3;
float p1,p2,p3,old_re,old_im;
float midpoint[4],offset[4],ampl[4];
int ref[4],shift[4];
// Compare the current waveform to the waveform of a dot.
// Set cg_wave_start to the position giving the best fit.
// Set cg_wave_midpoint to the center of the waveform.
// Return similarity of waveforms.
trials=0;
old_re=0;
old_im=0;
try_fit:;
pp=cg_wave_start;
ref[trials]=pp;
ss=(cg_wave_start+dot_pts)&baseband_mask;
re_1=0;
re_2=0;
re_3=0;
im_1=0;
im_2=0;
im_3=0;
p2=0;
n2=pp;
k=dot_pts/6;
if(k<1)k=1;
n1=(pp-k+baseband_size)&baseband_mask;
n3=(pp+k)&baseband_mask;
i=0;
while(n2 != ss)
  {
  p2+=baseb_totpwr[n2];
  re_1+=baseb[2*n1  ]*dot_waveform[2*i  ]+
      baseb[2*n1+1]*dot_waveform[2*i+1];
  im_1+=baseb[2*n1  ]*dot_waveform[2*i+1]-
      baseb[2*n1+1]*dot_waveform[2*i  ];
  re_2+=baseb[2*n2  ]*dot_waveform[2*i  ]+
      baseb[2*n2+1]*dot_waveform[2*i+1];
  im_2+=baseb[2*n2  ]*dot_waveform[2*i+1]-
      baseb[2*n2+1]*dot_waveform[2*i  ];
  re_3+=baseb[2*n3  ]*dot_waveform[2*i  ]+
      baseb[2*n3+1]*dot_waveform[2*i+1];
  im_3+=baseb[2*n3  ]*dot_waveform[2*i+1]-
      baseb[2*n3+1]*dot_waveform[2*i  ];
  i++;
  n1=(n1+1)&baseband_mask;
  n2=(n2+1)&baseband_mask;
  n3=(n3+1)&baseband_mask;
  }
p1=p2;
p3=p2;
n1=(pp-k+baseband_size)&baseband_mask;
n3=(pp+k)&baseband_mask;
while(n1 != pp)
  {
  p1+=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
while(n1 != n3)
  {
  p3-=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
n1=(ss-k+baseband_size)&baseband_mask;
n3=(ss+k)&baseband_mask;
while(n1 != ss)
  {
  p1-=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
while(n1 != n3)
  {
  p3+=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
t1=sqrt((re_1*re_1+im_1*im_1)/(p1*dot_sumsq));
t2=sqrt((re_2*re_2+im_2*im_2)/(p2*dot_sumsq));
t3=sqrt((re_3*re_3+im_3*im_3)/(p3*dot_sumsq));
r2=2*(t1+t3-2*t2);
r1=(t1-t3);
// t1,t2 and t3 reflect how well the current waveform fits to the reference
// when shifted by -k,0 and +k.
// These points should have a maximum close to t2.
if(r2 >= 0)
  {
// If the three points are on a straight line or a concave one
// we have a bad fit. Skip by returning zero.
  goto skip;
  }
if( (t1<0.33 && t2<0.33 && t3<0.33) )
  {
// If all points are really small, return zero to indicate an error.  
skip:;
  cg_wave_fit=0;
  return;
  }
// Fit a parabola to the 3 points and get shift and best fit.
m=0;
r1=r1/r2;
if(fabs(r1) > 2)r1=2*r1/fabs(r1);
r1*=k;
offset[trials]=r1;
ampl[trials]=t2-r2*r1*r1*0.25;
cg_wave_midpoint=cg_wave_start+0.5*dot_pts+r1;
if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
midpoint[trials]=cg_wave_midpoint;
if(fabs(r1) <= 0.5)goto pos_ok;
if(trials >= 3)goto skip;  
m=(fabs(r1)+0.5)*r1/fabs(r1);
cg_wave_start=(cg_wave_start+m)&baseband_mask;
shift[trials]=m;
if(trials != 0)
  {
  if(m*shift[trials-1] <0)
    {
    m=(m-shift[trials-1])/2;
    cg_wave_start=(cg_wave_start+m)&baseband_mask;
    shift[trials]=m;
    if(abs(m) <= 1)goto pos_ok;
    }
  for(i=0; i<=trials; i++)
    {
    if(ref[i] == cg_wave_start)goto pos_ok;
    }
  }  
trials++;
old_re=re_2;
old_im=im_2;
goto try_fit;
pos_ok:;
cg_wave_re=re_2;
cg_wave_im=im_2;
if(trials != 0)
  {
  if(shift[trials]*shift[trials-1] < 0)
    {
    if(fabs(offset[trials]) > 2*fabs(offset[trials-1]) )
      {
      if(fabs(offset[trials]) > 0.5*fabs(offset[trials-1]) )
        {
// The previous fit was much better. Use it !!
        cg_wave_re=old_re;
        cg_wave_im=old_im;
        trials--;
        }
      else
        {
// We have two results, one from each side. 
// None is much better than the other.
// Use the weighted average.        
        t1=midpoint[trials];
        t2=midpoint[trials-1];
        if(t1-t2 >  (baseband_size >>1))t1=t1-baseband_size;                    
        if(t1-t2 < -(baseband_size >>1))t1=t1+baseband_size;                    
        p1=offset[trials];
        p2=offset[trials-1];
        p1=1/(0.2+fabs(p1));
        p2=1/(0.2+fabs(p2));
        p1=p1*p1;
        p2=p2*p2;
        t1=(p1*t1+p2*t2)/(p1+p2);
        if(t1 >= baseband_size)t1-=baseband_size;
        if(t1<0)t1+=baseband_size;
        midpoint[trials]=t1;
        t1=ampl[trials];
        t2=ampl[trials-1];
        ampl[trials]=(p1*t1+p2*t2)/(p1+p2);
        cg_wave_re=(p1*re_2+p2*old_re)/(p1+p2);
        cg_wave_im=(p1*im_2+p2*old_im)/(p1+p2);
        }
      }
    }
  }  
cg_wave_midpoint=midpoint[trials];
cg_wave_fit=ampl[trials];
cg_wave_re/=dot_sumsq;
cg_wave_im/=dot_sumsq;
}

void fit_dash(void)
{
int i,k,m,ss,pp,n1,n2,n3,trials;
float t1,t2,t3,r1,r2;
float im_1,im_2,im_3;
float re_1,re_2,re_3;
float p1,p2,p3,old_re,old_im;
float midpoint[4],offset[4],ampl[4];
int ref[4],shift[4];
// Compare the current waveform to the waveform of a dash.
// Set cg_wave_start to the position giving the best fit.
// Set cg_wave_midpoint to the center of the waveform.
// Return similarity of waveforms.
trials=0;
old_re=0;
old_im=0;
try_fit:;
pp=cg_wave_start;
ref[trials]=pp;
ss=(cg_wave_start+dash_pts)&baseband_mask;
re_1=0;
re_2=0;
re_3=0;
im_1=0;
im_2=0;
im_3=0;
p2=0;
n2=pp;
k=dot_pts/6;
if(k<1)k=1;
n1=(pp-k+baseband_size)&baseband_mask;
n3=(pp+k)&baseband_mask;
i=0;
while(n2 != ss)
  {
  p2+=baseb_totpwr[n2];
  re_1+=baseb[2*n1  ]*dash_waveform[2*i  ]+
      baseb[2*n1+1]*dash_waveform[2*i+1];
  im_1+=baseb[2*n1  ]*dash_waveform[2*i+1]-
      baseb[2*n1+1]*dash_waveform[2*i  ];
  re_2+=baseb[2*n2  ]*dash_waveform[2*i  ]+
      baseb[2*n2+1]*dash_waveform[2*i+1];
  im_2+=baseb[2*n2  ]*dash_waveform[2*i+1]-
      baseb[2*n2+1]*dash_waveform[2*i  ];
  re_3+=baseb[2*n3  ]*dash_waveform[2*i  ]+
      baseb[2*n3+1]*dash_waveform[2*i+1];
  im_3+=baseb[2*n3  ]*dash_waveform[2*i+1]-
      baseb[2*n3+1]*dash_waveform[2*i  ];
  i++;
  n1=(n1+1)&baseband_mask;
  n2=(n2+1)&baseband_mask;
  n3=(n3+1)&baseband_mask;
  }
p1=p2;
p3=p2;
n1=(pp-k+baseband_size)&baseband_mask;
n3=(pp+k)&baseband_mask;
while(n1 != pp)
  {
  p1+=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
while(n1 != n3)
  {
  p3-=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
n1=(ss-k+baseband_size)&baseband_mask;
n3=(ss+k)&baseband_mask;
while(n1 != ss)
  {
  p1-=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
while(n1 != n3)
  {
  p3+=baseb_totpwr[n1];
  n1=(n1+1)&baseband_mask;
  }
t1=sqrt((re_1*re_1+im_1*im_1)/(p1*dash_sumsq));
t2=sqrt((re_2*re_2+im_2*im_2)/(p2*dash_sumsq));
t3=sqrt((re_3*re_3+im_3*im_3)/(p3*dash_sumsq));
r2=2*(t1+t3-2*t2);
r1=(t1-t3);
// t1,t2 and t3 reflect how well the current waveform fits to the reference
// when shifted by -k,0 and +k.
// These points should have a maximum close to t2.
if(r2 >= 0)
  {
// If the three points are on a straight line or a concave one
// we have a bad fit. Skip by returning zero.
  goto skip;
  }
if( (t1<0.33 && t2<0.33 && t3<0.33) )
  {
// If all points are really small, return zero to indicate an error.  
skip:;
  cg_wave_fit=0;
  return;
  }
// Fit a parabola to the 3 points and get shift and best fit.
m=0;
r1=r1/r2;
if(fabs(r1) > 2)r1=2*r1/fabs(r1);
r1*=k;
offset[trials]=r1;
ampl[trials]=t2-r2*r1*r1*0.25;
cg_wave_midpoint=cg_wave_start+0.5*dash_pts+r1;
if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
midpoint[trials]=cg_wave_midpoint;
if(fabs(r1) <= 0.5)
  { 
  goto pos_ok;
  }
if(trials >= 3)goto skip;  
m=(fabs(r1)+0.5)*r1/fabs(r1);
cg_wave_start=(cg_wave_start+m)&baseband_mask;
shift[trials]=m;
if(trials != 0)
  {
  if(m*shift[trials-1] <0)
    {
    m=(m-shift[trials-1])/2;
    cg_wave_start=(cg_wave_start+m)&baseband_mask;
    shift[trials]=m;
    if(abs(m) <= 1)goto pos_ok;
    }
  for(i=0; i<=trials; i++)
    {
    if(ref[i] == cg_wave_start)m/=2;
    }
  }  
trials++;
old_re=re_2;
old_im=im_2;
goto try_fit;
pos_ok:;
cg_wave_re=re_2;
cg_wave_im=im_2;
if(trials != 0)
  {
  if(shift[trials]*shift[trials-1] < 0)
    {
    if(fabs(offset[trials]) > 2*fabs(offset[trials-1]) )
      {
      if(fabs(offset[trials]) > 0.5*fabs(offset[trials-1]) )
        {
// The previous fit was much better. Use it !!
        cg_wave_re=old_re;
        cg_wave_im=old_im;
        trials--;
        }
      else
        {
// We have two results, one from each side. 
// None is much better than the other.
// Use the weighted average.        
        t1=midpoint[trials];
        t2=midpoint[trials-1];
        if(t1-t2 >  (baseband_size >>1))t1=t1-baseband_size;                    
        if(t1-t2 < -(baseband_size >>1))t1=t1+baseband_size;                    
        p1=offset[trials];
        p2=offset[trials-1];
        p1=1/(0.2+fabs(p1));
        p2=1/(0.2+fabs(p2));
        p1=p1*p1;
        p2=p2*p2;
        t1=(p1*t1+p2*t2)/(p1+p2);
        if(t1 >= baseband_size)t1-=baseband_size;
        if(t1<0)t1+=baseband_size;
        midpoint[trials]=t1;
        t1=ampl[trials];
        t2=ampl[trials-1];
        ampl[trials]=(p1*t1+p2*t2)/(p1+p2);
        cg_wave_re=(p1*re_2+p2*old_re)/(p1+p2);
        cg_wave_im=(p1*im_2+p2*old_im)/(p1+p2);
        }
      }
    }
  }  
cg_wave_midpoint=midpoint[trials];
cg_wave_fit=ampl[trials];
cg_wave_re/=dash_sumsq;
cg_wave_im/=dash_sumsq;
}

void make_waveform_guess(void)
{
int i, j, k, ib;
float t1, t2;
// If the optimum filter is selected a Morse code dot will
// have a width at the 6dB points of cwbit units.
// The square wave (a row of dots) is turned into a sine wave
// by a matched filter.
// Make the rising edge of dash_waveform a cosine wave that
// rises from 0 to 1 in cg_code_unit points while the angle
// goes from 0 to PI if a rectangular window is used (bg_curvpoints==0)
// For a maximum soft filter function, make risetime twice as long.
t2=2.2*bg_curvpoints/(bg_flatpoints+2*bg_curvpoints);
t1=PI_L/((1+t2)*cg_code_unit);
t2=0;
i=0;
while(t2<PI_L)
  {
  dash_waveform[2*i]=0.5*(1-cos(t2));
  if(dash_waveform[2*i]<0.1)dash_waveform[2*i]=0;
  dash_waveform[2*i+1]=0;
  t2+=t1;
  i++;
  }
// Continue at amplitude = 1 so the length to the midpoint from the 6dB
// point becomes 1.5*cwbit_pts.
// In case the filter is soft and narrow, the dash waveform will
// not have reached 1.0 at the midpoint. If it has not, normalise the
// rising edge.
// This code is inefficient but we use it seldomly, so no worry.
ib=1.5*cwbit_pts+0.5*cg_code_unit+0.5;
if(ib < i)
  {
  k=i-ib;
  for(i=0; i<ib; i++)
    {
    dash_waveform[2*i]=dash_waveform[2*(i+k)];
    }
  dash_waveform[2*ib]=1;
  t1=dash_waveform[0];
  for(i=0; i<=ib; i++)
    {
    dash_waveform[2*i]-=t1;
    }
  t1=1/dash_waveform[2*ib];
  for(i=0; i<=ib; i++)
    {
    dash_waveform[2*i]*=t1;
    if(dash_waveform[2*i]<0.1)dash_waveform[2*i]=0;
    }
  }  
else
  {
  while(i<=ib)
    {
    dash_waveform[2*i]=1;  
    dash_waveform[2*i+1]=0;
    i++;
    }
  }
// Make the waveform symmetric around the midpoint.
j=ib+1;
k=ib;
while(k>=0)
  {
  dash_waveform[2*j]=dash_waveform[2*k];
  dash_waveform[2*j+1]=0;
  j++;
  k--;
  }
dash_pts=j;
}


void store_symmetry_adapted_dashdot(int itot)
{
int i,j,k,m,ia,ib,ic,ih;
float t1,t2,t3,r1,r2,r3,phmax,phslope;
float maxpow;
// Knowing that the curve shape should be symmetrical around it's
// midpoint, fold the signal over and form sums and differences.
phslope=0;
if(itot == 0)
  {
  goto guess_shape;
  }
if(itot > 0)
  {
  ib=cwlong_store_points;
  ia=0;
  }
else
  {
  ib=cwspeed_store_points;
  ia=cwspeed_store_points-cwlong_store_points;
  }  
m=2*ib-ia;
for(i=ia; i<ib; i+=2)
  {
  m-=2;
  t1=fft1_tmp[i  ];
  t2=fft1_tmp[m  ];
  fft1_tmp[i]=t1+t2;
  fft1_tmp[m]=t1-t2;
  t1=fft1_tmp[i+1];
  t2=fft1_tmp[m+1];
  fft1_tmp[i+1]=t1-t2;
  fft1_tmp[m+1]=t1+t2;
  }
// Step from the center until we reach the 6dB point.
// Get it as the sum of the symmetric real part and 
// the antisymmetric imaginary part.
// Collect the total power.
// Also collect the noise as the deviation from symmetry.
maxpow=0;
r1=0;
r2=0;
r3=0;
m=ib;
ic=ib;
t1=0;
t3=0;
while(ic > ia)
  {
  ic-=2;
  t1=fft1_tmp[ic]*fft1_tmp[ic]+fft1_tmp[ic+1]*fft1_tmp[ic+1];
  if(maxpow < t1)maxpow=t1;
  if(maxpow > 4*t1)goto collect_power_x;
  t3=t1;
  r1+=t1;
  r2+=fft1_tmp[m  ]*fft1_tmp[m  ];
  r3+=fft1_tmp[m+1]*fft1_tmp[m+1];
  m+=2;
  }
collect_power_x:;
if(r1 == 0 || ic == ib-2 || ic < ia+4)
  {
  goto guess_shape;
  }
r2/=r1;
r3/=r1;
if(r2 > 0.05 || r3>0.03)
  {
  goto guess_shape;
  }
ih=ic;
t2=0.05*maxpow;
while(ic > ia && t1 < t3 && t1 > t2)
  {
  t3=t1;
  ic-=2;
  t1=fft1_tmp[ic]*fft1_tmp[ic]+fft1_tmp[ic+1]*fft1_tmp[ic+1];
  }
// The phase angle should vary linearly with time and go
// through zero at the midpoint.
// Normalize for a peak amplitude=1
// Store the power and the phase angle.
t1=1/sqrt(maxpow);
k=ib+2;
for(i=ic; i<ib; i+=2)
  {
  fft1_tmp[i]*=t1;
  fft1_tmp[i+1]*=t1;
  fft1_tmp[k+i  ]=fft1_tmp[i]*fft1_tmp[i]+fft1_tmp[i+1]*fft1_tmp[i+1];
  fft1_tmp[k+i+1]=atan2(fft1_tmp[i+1],fft1_tmp[i]);
  }
// The phase angle has to be zero halfway between ib and the next
// point ib+2 since we work in the symmetry adapted function.
// Collect the power weighted average slope.
r1=0;
phslope=0;
for(i=ic; i<ib; i+=2)
  {
  r1+=fft1_tmp[k+i];
  phslope+=fft1_tmp[k+i]*fft1_tmp[k+i+1]/(ib-i-1);
  }
phslope/=r1;
// Use the average slope to construct the phase function 
// The real part is cos(x), make the imaginary part sin(x) 
// while collecting the rms error and total power.
t1=0;
t2=0;
for(i=ic; i<ib; i+=2)
  {
  t1+=fft1_tmp[i]*fft1_tmp[i];
  r1=fft1_tmp[i]*tan((ib-i-1)*phslope);
  t2+=(fft1_tmp[i+1]-r1)*(fft1_tmp[i+1]-r1);
  fft1_tmp[i+1]=r1;
  }
if(t2/t1 > 0.05)
  {
  goto guess_shape;
  }
phmax=phslope*(ib-ih+1);
cg_chirpx=cg_x0-1.5*cg_size*cos(phmax);
cg_chirpy=cg_y0-1.5*cg_size*sin(phmax);
// ih is the point of half amplitude or nearest below.
// Our data may be corrupted by noise so it is perhaps not
// very reliable at low amplitudes.
// Replace the first part of the rising edge by
// the guessed waveform.
ic=0;
while(dash_waveform[ic]<fft1_tmp[ih])
  {
  ic+=2;
  }
if(ic==0)
  {
  goto guess_shape;
  }
ih-=2;
t3=1;
while(ic != 0 && ih >= ia)
  {
  t1=dash_waveform[ic]-dash_waveform[ic-2];
  t2=fft1_tmp[ih];
  fft1_tmp[ih]=fft1_tmp[ih+2]-t1;
  if(fft1_tmp[ih]<0.1)
    {
    goto risex;
    }
  if(t2>0.1)t3=fft1_tmp[ih]/t2;  
  fft1_tmp[ih+1]*=t3;
  ic-=2;
  ih-=2;
  }
risex:;
while(ih >= ia)
  {
  fft1_tmp[ih  ]=0;
  fft1_tmp[ih+1]=0;
  ih-=2;
  }
// Unfold the waveform to get the symmetry adapted original waveform back.
// (we could save some time by writing directly into dash_waveform)
j=ib-2;
k=ib;
while(j >= ia)
  {
  fft1_tmp[k  ]=fft1_tmp[j];
  fft1_tmp[k+1]=-fft1_tmp[j+1];
  j-=2;
  k+=2;
  }
fft1_tmp[k  ]=0;
fft1_tmp[k+1]=0;
ic+=ia;
while(fft1_tmp[ic]>0 && ic>ia)ic-=2;
while(fft1_tmp[ic]==0)ic+=2;
dash_pts=1;
dash_waveform[0]=0;
dash_waveform[1]=0;
while(fft1_tmp[ic] != 0)
  {
  dash_waveform[2*dash_pts  ]=fft1_tmp[ic  ];
  dash_waveform[2*dash_pts+1]=fft1_tmp[ic+1];
  ic+=2;
  dash_pts++;
  }    
dash_waveform[2*dash_pts  ]=0;
dash_waveform[2*dash_pts+1]=0;
dash_pts++;
if(itot == -1)dash_waveform_established=no_of_cwdat;
guess_shape:;
if(dash_pts >= cwlong_store_points)
  {
  dash_pts=cwlong_store_points-1;
  }
if(dash_pts < 5)make_waveform_guess();
if(dash_pts >=WIDTH)dash_pts=WIDTH;
t1=0;
for(i=0; i<2*WIDTH; i++)cg_tmpbuf[i]=0;
for(i=0; i<2*dash_pts; i++)
  {
  cg_tmpbuf[i]=dash_waveform[i];
  }
// Make a guess for the dot waveform.
// Assume the amplitude rises and falls as for a dash, but that
// the flat region in the center is shorter.
// The separation between the 6dB points should be 3 and 1 code
// units respectively. Including the full rise and fall, 
// the total lengths should be 4 and 2 units respectively.
// Take the leading and ending zeroes into consideration and
// construct the real part of the dot waveform from the real part
// of the dashes. 
// Use the same phase slope to construct the imaginary part.
ic=0;
while(dash_waveform[2*ic]==0 && ic < (cwlong_store_points>>1))
  {
  dot_waveform[2*ic]=0;
  ic++;
  }
k=dash_pts-2*ic;  
ib=ic+k/2;
if(ib >  (cwlong_store_points>>1))
  {
  ib= (cwlong_store_points>>1)-1;
  ic=ib-k/2;
  if(ic < 0)ic=0;
  }    
j=ic;
k=ib;
while(ib>=ic)
  {
  dot_waveform[2*ic]=dash_waveform[2*ic];
  dot_waveform[2*ib]=dash_waveform[2*ic];
  r1=dash_waveform[2*ic]*tan((ib-ic)*phslope);
  dot_waveform[2*ic+1]=r1;
  dot_waveform[2*ib+1]=-r1;
  ic++;
  ib--;
  }
j--;
k++;
while(j >=0 && k<(cwlong_store_points>>1))
  {
  dot_waveform[2*k]=0;
  dot_waveform[2*k+1]=0;
  j--;
  k++;
  }
dot_pts=k;
k=2*dash_pts+2*dot_pts;
for(i=0; i<2*dot_pts; i++)
  {
  cg_tmpbuf[k+i]=dot_waveform[i];
  }
dash_sumsq=0;
t1=0;
for(i=0; i<dash_pts; i++)
  {
  t2=dash_waveform[2*i  ]*dash_waveform[2*i  ]+
     dash_waveform[2*i+1]*dash_waveform[2*i+1];
  dash_sumsq+=t2;
  if(t1<t2)t1=t2;
  }
t1/=6;
cwbit_pts=0;
for(i=0; i<dash_pts; i++)
  {
  t2=dash_waveform[2*i  ]*dash_waveform[2*i  ]+
     dash_waveform[2*i+1]*dash_waveform[2*i+1];
  if(t2>t1)cwbit_pts++;
  }
cwbit_pts/=3;
dot_pwrmax=0;
dot_sumsq=0;
for(i=0; i<dot_pts; i++)
  {
  t1=dot_waveform[2*i  ]*dot_waveform[2*i  ]+
     dot_waveform[2*i+1]*dot_waveform[2*i+1];
  dot_sumsq+=t1;
  if(dot_pwrmax < t1)dot_pwrmax=t1;
  }
}

void get_average_shapes(void)
{
int i,j,k,m,itot;
int ia,ib;
float t1,t2,t3;
// Make a guess for the current shape of a Morse code dash.
// The length should be about 3*cg_code_unit.
// Look at cg_statistics to see if there is a maximum that we
// should use. 3*cg_code_unit corresponds to cg_size/2.
// Dots should be at cg_size/6.
// In case there is no signal, only noise, we should expect to
// find a maximum near cg_size/6. The random output of a filter
// is most likely to be the 1/bandwidth in a linear time scale.
// First locate the dot/noise peak.
ib=0.4*cg_size;
t1=0;
k=0;
for(i=0; i<ib; i++)
  {
  if(t1<cg_statistics[i])
    {
    t1=cg_statistics[i];
    k=i;
    }
  }
t1*=0.75;
ia=k;
ib=k;
while(ia>0 && t1<cg_statistics[ia-1])ia--;
while(ib<cg_size-1 && t1<cg_statistics[ib+1])ib++;
if(ib-ia > (cg_size>>2))goto bad_statistics;
t1=0;
t2=0;
for(i=ia; i<=ib; i++)
  {
  t1+=cg_statistics[i];
  t2+=i*cg_statistics[i];
  } 
if(t1<5)goto bad_statistics;  
t2/=t1;  
// There is a maximum at t2 in cg_statistics.
// This should be dots, but it could be just noise.
// There is also a small chance it is dashes because
// we may listen to a series of "O", (typical in EME)
// Decide t2 is dashes if there is enough signal at three times 
// lower position and t2 has a large value.
ia=t2/3; 
ib=t2/2+1;
if(ib > (cg_size>>2) )
  {
  t3=0;
  for(i=ia; i<=ib; i++)
    {
    t3+=cg_statistics[i];
    } 
  if(t2 > 0.35*cg_size && t1/t3 < 3)goto dashmax_found;
  }
// Assuming t2 is dots we should expect dashes at 3*t2
ia=2.2*t2;
ib=4*t2;
if(ib >= cg_size)ib=cg_size-1;
t3=0;
k=0;
for(i=ia; i<ib; i++)
  {
  if(t3<=cg_statistics[i])
    {
    t3=cg_statistics[i];
    k=i;
    }
  }
t3*=0.75;
ia=k;
ib=k;
while(ia>0 && t3<cg_statistics[ia-1])ia--;
while(ib<cg_size-1 && t3<cg_statistics[ib+1])ib++;
if(ib-ia > (cg_size>>2))goto bad_statistics;
if(ia < 2*t2)goto bad_statistics;
t3=0;
t2=0;
for(i=ia; i<=ib; i++)
  {
  t3+=cg_statistics[i];
  t2+=i*cg_statistics[i];
  } 
if(t3<5)
  {
bad_statistics:;  
  cwbit_pts=cg_code_unit;
  goto cwbit_established;
  }
if(t3 < 0.5*t1)goto bad_statistics;  
t2/=t3;  
dashmax_found:;
cwbit_pts=2*cg_code_unit*t2/cg_size;
cwbit_established:;
make_waveform_guess();
// If the curve shape really is the average of long Morse code parts,
// it should be symmetric around it's center.
// The real part should be equal on both sides while the imaginary
// part should have opposite sign on both sides reflecting the coherent
// detect trying to lock on a chirpy signal.
// We have taken all the trouble of this routine to evaluate the magnitude
// of this chirp.
// Start by collecting the average of all buffers.
k=2*cwlong_store_points;
for(i=0; i<k; i++)fft1_tmp[i]=0;
itot=0;
for(j=0; j<CWLONG_MAXBUF; j++)
  {
  if(cwlong_no_of_traces[j]>0)
    {
    itot++;
    m=2*j*cwlong_store_points;
    for(i=0; i<k; i++)
      {
      fft1_tmp[i]+=cwlong_buffer[i+m];
      }
    } 
  }
store_symmetry_adapted_dashdot(itot);
}

void add_cwlong(int mid)
{
int i, k, ia, ib, ka,kb,last_point, first_point;
float t1,t2,t3,r1,r2;
float *z;
// mid is the midpoint of a region with amplitude above the threshold.
// Accumulate the complex amplitude from baseb in cwlong_buffer.
// First rotate the phase. In case the operator selected a too narrow
// filter for the carrier the coherent procedure may have failed.
first_point=(mid-cwlong_store_points/2+baseband_size)&baseband_mask;
last_point=(first_point+cwlong_store_points)&baseband_mask;
t1=0;
t2=0;
ia=mid;
ka=0;
while(ia != last_point && baseb_ramp[ia] > 0)
  {
  ka++;
  t1+=baseb[2*ia  ];
  t2+=baseb[2*ia+1];
  ia=(ia+1)&baseband_mask;
  }
ib=mid;
k=baseb_ramp[mid]-1;
for(i=0; i<k; i++)
  {  
  ib=(ib+baseband_mask)&baseband_mask;
  t1+=baseb[2*ib  ];
  t2+=baseb[2*ib+1];
  ka++;
  }
t3=sqrt(t1*t1+t2*t2);
t1/=t3;
t2/=t3;
// Collect the in-phase and the out-of-phase energy outside the
// region that is above the threshold.
r1=0;
r2=0;
kb=0;
while(ia != last_point)
  {
  kb++;
  r1+=baseb[2*ia  ]*t1+baseb[2*ia+1]*t2;
  r2+=baseb[2*ia+1]*t1-baseb[2*ia  ]*t2;
  ia=(ia+1)&baseband_mask;
  }
while(ib != first_point)
  {
  kb++;
  ib=(ib+baseband_mask)&baseband_mask;
  r1+=baseb[2*ia  ]*t1+baseb[2*ia+1]*t2;
  r2+=baseb[2*ia+1]*t1-baseb[2*ia  ]*t2;
  }
r1/=ka*t3/kb;
r2/=ka*t3/kb;
// If the signal level is larger (on the average) outside the 
// current region above threshold, skip this one.
// Also skip in case the imaginary component is above 50%
// outside.

if(r1*r1+r2*r2 > 1 || r2 > 0.5)return;
ia=first_point;
z=&cwlong_buffer[2*cwlong_store_points*cg_shape_bufno];
for(i=0; i<cwlong_store_points; i++)
  {
  z[2*i  ]+=baseb[2*ia  ]*t1+baseb[2*ia+1]*t2; 
  z[2*i+1]+=baseb[2*ia+1]*t1-baseb[2*ia  ]*t2; 
  ia=(ia+1)&baseband_mask;
  }
cwlong_no_of_traces[cg_shape_bufno]++;
}

void clear_coherent(void)
{
int i,n,nn,pp;
clear_cg_traces();
// ********   Clear graphics data *********
n=cg_size*cg_size;
for(i=0; i<n; i++)cg_map[i]=0;
for(i=0; i<cg_size; i++)cg_statistics[i]=0;
cg_statistics_sum=0;
// *********** Clear data for cw speed determination *********
cg_collect_points=0;
cg_shape_bufno=0;
for(i=0; i<2*cwlong_store_points*CWLONG_MAXBUF; i++)cwlong_buffer[i]=0;
for(i=0; i<CWLONG_MAXBUF; i++)cwlong_no_of_traces[i]=0;
no_of_dots=0;
no_of_spaces=0;
no_of_trispaces=0;
no_of_cwdat=0;
dash_waveform_established=0;
cw_detect_flag=0;
// ***********  Clear threshold  **************
i=(baseb_pa+baseband_mask)&baseband_mask;
baseb_upthreshold[i]=0;
// ********* Clear old data so the oscilloscope will not 
// display incorrect information. *********
// With sine squared windows we have 50% overlap of transforms.
nn=(baseb_pa-cg_osc_offset+baseband_size)&baseband_mask;
pp=(baseb_pa+mix2_size/2)&baseband_mask;
while(nn != pp)
  {
  baseb_ramp[nn]=-cg_code_unit;
  baseb_threshold[nn]=0;
  baseb_upthreshold[nn]=0;
  baseb_raw[2*nn]=0;
  baseb_raw[2*nn+1]=0;
  baseb_raw_orthog[2*nn]=0;
  baseb_raw_orthog[2*nn+1]=0;
  baseb[2*nn]=0;
  baseb[2*nn+1]=0;
  baseb_carrier[2*nn]=0;
  baseb_carrier[2*nn+1]=0;
  baseb_carrier_ampl[nn]=0;
  baseb_totpwr[nn]=0;
  if(genparm[CW_DECODE_ENABLE] != 0)
    {
    baseb_fit[2*nn]=0;
    baseb_fit[2*nn+1]=0;
    baseb_tmp[2*nn]=0;
    baseb_tmp[2*nn+1]=0;
    baseb_envelope[2*nn]=0;
    baseb_envelope[2*nn+1]=0;
    baseb_detect_flag[nn]=0;
    baseb_errpwr[nn]=0;
    }
  nn=(nn+1)&baseband_mask;
  }
// ***********  Clear all the baseb pointers ********
baseb_pb=baseb_pa;
baseb_pc=baseb_pa;
baseb_pd=baseb_pa;
baseb_pe=baseb_pa;
baseb_pf=baseb_pa;
baseb_px=baseb_pa;
// *********** Clear basblock. Used for S-meter averaging ************ 
basblock_pa=2*baseb_pa/mix2_size;
nn=basblock_pa;
for(i=0; i<basblock_hold_points; i++)
  {
  basblock_maxpower[nn]=0;
  basblock_avgpower[nn]=0;
  nn=(nn+basblock_mask)&basblock_mask;
  }
cg_chirpx=cg_x0;
cg_chirpy=cg_y0;
cg_maxmax=0;
cg_maxavg=0;
if(s_meter_avgnum > 0)
  {
  s_meter_avg=0;
  s_meter_avgnum=0;
  }
}

