
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "sigdef.h"
#include "screendef.h"
#include "fft1def.h"
#define ZZ 0.000000001
//int no_of_cwdat;
/*
// Structure for Morse decoding data.
typedef struct {
unsigned char type;    // Part type (CW_DASH,CW_DOT,CW_SPACE,....A,B,C,...)
unsigned char unkn;    // Number of unknown states before this part
unsigned char down;    // Number of states to lower character boundary
unsigned char len;     // Length of character in states if type < CW_DASH
float midpoint;
float re;
float im;
}MORSE_DECODE_DATA;
// Defines for MORSE_DECODE_DATA.type (cw.type)
// Note that CW_DASH must have the lowest value.
#define CW_WORD_SEPARATOR 255
#define CW_TRISPACE 254
#define CW_SPACE 253
#define CW_DOT 252
#define CW_DASH 251


*/
//   name     data    length
// CW_DASH    |---_|     4
// CW_DOT     |-_|       2 
// CW_SPACE   |__|       2
// CW_WORDSEP |____|     4 


void check_cw(int num,int type);
float dash_average_noise;


// *********************************************************
// *********************************************************
// These defines allow a lot of information to be written to dmp
// define DUMPFILE 1 in main.c to use this.
#define PR00 0
#define PR01 0
#define PR02 0
#define PR03 0
#define PR04 0
#define PR05 0
#define PR06 0
#define PR07 0
#define PR08 1

#define PRT00 if(dmp != NULL && PR00 != 0)PERMDEB
#define PRT01 if(dmp != NULL && PR01 != 0)PERMDEB
#define PRT02 if(dmp != NULL && PR02 != 0)PERMDEB
#define PRT03 if(dmp != NULL && PR03 != 0)PERMDEB
#define PRT04 if(dmp != NULL && PR04 != 0)PERMDEB
#define PRT05 if(dmp != NULL && PR05 != 0)PERMDEB
#define PRT06 if(dmp != NULL && PR06 != 0)PERMDEB
#define PRT07 if(dmp != NULL && PR07 != 0)PERMDEB
#define PRT08 if(dmp != NULL && PR08 != 0)PERMDEB
// *********************************************************
// *********************************************************


// float[2] baseb_out=data to send to loudspeaker
// float[2] baseb=complex amplitude of first level coherent data.
// float[2] baseb_raw=complex amplitude of baseband signal. Raw data, pol. adapted.
// float[2] baseb_raw_orthog=complex amplitude of pol. orthog signal. Raw data.
// float[2] baseb_carrier=phase of carrier. Complex data, cosines and sines.
// float[1] baseb_carrier_ampl=amplitude of carrier
// float[1] baseb_totpwr=total power of baseb_raw
// float[2] baseb_envelope=complex amplitude from fitted dots and dashes.
// float[1] baseb_upthreshold=forward peak detector for power
// float[1] baseb_threshold=combined forward and backward peak detector at -6dB
// float[2] baseb_fit=fitted dots and dashes.
// float[1] baseb_errpwr=power of difference between baseb and baseb_fit
// float[1] baseb_agc_level=used only when AGC is enabled.
// char[1] baseb_detect_flag=status of a point, useful for debug.
// short int[1] baseb_ramp=indicator for time of power above/below threshold.
// short_int[1] baseb_clock=CW code clock
// float[2] baseb_tmp=for debug during development

// baseb_pa  The starting point of the latest mix2_size/2 points.
// baseb_pb  The point up to which thresholds exist.
// baseb_pc  The point up to which cw speed statistics and ramp is collected.
// baseb_pd  A key up region close before baseb_pc
// baseb_pe  The point up to which we have run first detect. 
// baseb_pf
// baseb_px  The oldest point that contains valid data.

void store_pattern(void)
{
int i;
for(i=0; i<(baseband_size<<1); i++)baseb_fit[i]=0;
for(i=0; i<no_of_cwdat; i++)
  {
  cg_wave_midpoint=cw[i].midpoint;
  cg_wave_re=cw[i].re;
  cg_wave_im=cw[i].im;
  switch (cw[i].type)
    {
    case CW_DOT:
    store_dot();
    break;

    case CW_DASH:
    accurate_store_dash();
    break;
    }
  }
}

void insert_item(int type)
{
int i;
float r1,r2;
check_cw(4001,1);
r2=cw[cw_ptr].midpoint-cg_wave_midpoint;
if(r2 < 0)r2+=baseband_size;
r1=cg_wave_midpoint-cw[cw_ptr-1].midpoint;
if(r1 < 0)r1+=baseband_size;
i=no_of_cwdat;
while(i > cw_ptr)
  {
  cw[i]=cw[i-1];
  i--;
  }
cw[cw_ptr].midpoint=cg_wave_midpoint;
cw[cw_ptr].type=type;
cw[cw_ptr].re=cg_wave_re;
cw[cw_ptr].im=cg_wave_im;
cw[cw_ptr].len=cw_item_len[255-type];
fprintf(dmp,"\n[%f] type %d  len %d",cg_wave_midpoint,type,cw_item_len[255-type]);
cw[cw_ptr].sep=r1;
cw[cw_ptr+1].sep=r2;
no_of_cwdat++;
if(no_of_cwdat > max_cwdat)end_program(1171);
accurate_store_dash();  
}


void second_detect(void)
{
int sizhalf;
int k, ia;
int ity, item, unkn;
float dotpos1_nom, dotpos2_nom, dotpos3_nom, dotpos4_nom;
float dashpos1_nom, dashpos2_nom;
float dot1_chk, dot2_chk, dot3_chk, dot4_chk, dash1_chk, dash2_chk;
float dashpos1, dashpos2, dotpos1, dotpos2, dotpos3, dotpos4;
float dashpos1_err, dashpos2_err;
float dotpos1_err, dotpos2_err, dotpos3_err, dotpos4_err;
float dash_fit1, dash_fit2, dot_fit1, dot_fit2, dot_fit3, dot_fit4;
float r1, t1, t2, t3;
float dash1_re, dash1_im, dash2_re, dash2_im;
float dot1_re, dot1_im, dot2_re, dot2_im;
// **************************************************************
// **************************************************************
// ****    This routine is called to initiate a recently     ****
// ***     collected data area for which dashes have been    ****
// **** fitted but for which nothing else has yet been done. ****
// **************************************************************
// **************************************************************
sizhalf=baseband_size>>1;
// Initiate with stupid values. This avoids compiler complaints.
dot1_chk=-BIG;
dotpos1=BIG;
dotpos1_err=BIG;
dot1_re=BIG;
dot1_im=BIG;
dot_fit1=-BIG;
dot2_chk=-BIG;
dotpos2=BIG;
dotpos2_err=BIG;
dot2_re=BIG;
dot2_im=BIG; 
dot_fit2=-BIG;
dotpos1_nom=BIG;
dotpos2_nom=BIG;
dash_fit2=-BIG;
dot_fit4=-BIG;
// *****************************************************
// *****************************************************
// *****  Fit key up or key down patterns to short *****
// *****  regions that are surrounded by dashes    *****
// *****    Initiate cw[].unkn with the number of  *****
// ***** unknown "Morse code clock" states between *****
// *****  the current item and the preceding one.  *****
// *****************************************************
// *****************************************************
// Look for the following cases:
//    Code       Unkn
//  |__|          2
//  |-_|          2
//  |____|        4
//  |-___|        4
//  |__-_|        4
//  |-_-_|        4
//  |---_|        4
//  |______|      6
//  |-_____|      6
//  |__-___|      6


PRT02"\nCWBIT PTS %f",cwbit_pts);
// Store the most probable signal in each case.
//   name     data    length
// CW_DASH    |---_|     4
// CW_DOT     |-_|       2 
// CW_SPACE   |__|       2
// CW_WORDSEP |____|     4 
// The item starts (length/2 + 0.5) below cw[].midpoint because
// midpoint is the center of a key down period while the item
// midpoint is 0.5 above that because one space is always
// included in an item.   
fprintf(dmp,"\n [%7.1f]  (S+N)/N  %f ",
                cw[0].midpoint,
                (cw[0].re*cw[0].re+
                cw[0].im*cw[0].im)/dash_average_noise);
cw_ptr=1;
while(cw_ptr < no_of_cwdat)
  {
  r1=cw[cw_ptr].sep/cwbit_pts;
  k=(int)(r1)&0xfffffffe;
  if(r1-k > 1)k+=2;

fprintf(dmp,"\nk=3%d [%7.1f]  unkn=%d    (S+N)/N  %f ",
                k,cw[cw_ptr].midpoint,cw[cw_ptr].unkn,
                (cw[cw_ptr].re*cw[cw_ptr].re+
                cw[cw_ptr].im*cw[cw_ptr].im)/dash_average_noise);

goto zzx;
  PRT02"\n%d PRT02> %d unkn%d %f  [%f]",cw_ptr,k,
                          cw[cw_ptr].unkn,r1,cw[cw_ptr].midpoint);
  switch (k)
    {
    case 2:
    case 4:
// We have two close spaced dashes.
// There can be nothing in between.
    cw[cw_ptr].unkn=0;
    cw[cw_ptr].down=2;
    break;
    
    case 6:
//  ---_-_---     6
//  ---___---     6
// Base the decision on the probability that there is a dot
// right between the two dashes.
    set_region_envelope();
    dotpos1_nom=cw[cw_ptr].midpoint-0.5*cw[cw_ptr].sep;
    if(dotpos1_nom < 0)dotpos1_nom+=baseband_size;
    dot1_chk=check_dot(dotpos1_nom);
    PRT03"\n{6}CHK DOT %f (%f)",dot1_chk,dotpos1_nom);
// If dot1_chk in negative, the fit is better for a space than for a dot.
// Be careful and check if a dot would fit even for dot1_chk a little below zero.
    if(dot1_chk > -0.25)
      {
      cg_wave_start=dotpos1_nom-(dot_pts>>1)+baseband_size;
      cg_wave_start&=baseband_mask;
      fit_dot();
      PRT03" [%f]", cg_wave_midpoint);
      dotpos1_err=dotpos1_nom-cg_wave_midpoint;
      if(dotpos1_err < -sizhalf)dotpos1_err+=baseband_size;
      PRT03"  poserr %f  fit %f",dotpos1_err/cwbit_pts,cg_wave_fit);
      t3=-1;
// Use t3 as an indicator. 
// t3 < 0 => store space.
// t3 > 0 => store dot using t3 as the weight on fit_dot data.      
      if(cg_wave_fit > DASH_DETECT_LIMIT && fabs(dotpos1_err) < 0.25*cwbit_pts)
        {
        if(dot1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      if(cg_wave_fit > DASH_MISFIT_LIMIT && 
                       fabs(dotpos1_err) < 0.5*cwbit_pts && dot1_chk > 0.5)t3=0.5;
      if(t3 < 0 && dot1_chk > 0.7)t3=0;
      if(t3 >= 0)
        {
        t2=1-t3; 
        cg_wave_midpoint+=t2*dotpos1_err;
        if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
        if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
        ia=cg_wave_midpoint;
        cg_wave_re=t3*cg_wave_re+t2*baseb_envelope[2*ia  ]; 
        cg_wave_im=t3*cg_wave_im+t2*baseb_envelope[2*ia+1]; 
        clear_region();
        PRT03"\nstore dot %f",cg_wave_midpoint);
        item=CW_DOT;
        }
      else
        {
        cg_wave_midpoint=dotpos1_nom;
        clear_region();
        PRT03"\nstore space %f",cg_wave_midpoint);
        item=CW_SPACE;
        }
      }
    else
      {
      cg_wave_midpoint=dotpos1_nom;
      clear_region();
      PRT03"\nstore space %f",cg_wave_midpoint);
      item=CW_SPACE;
      }
    insert_item(item);
    break;

    case 8:
//  ---_-_-_---   8  ity=4
//  ---_---_---   8  ity=1
//  ---___-_---   8  ity=3
//  ---_-___---   8  ity=2
//  ---_____---   8  ity=5
    set_region_envelope();
    ity=0;
// See if a dash will fit well.
    dashpos1_nom=cw[cw_ptr].midpoint-0.5*cw[cw_ptr].sep;
    if(dashpos1_nom < 0)dashpos1_nom+=baseband_size;
    dash1_chk=check_dash(dashpos1_nom);
    cg_wave_start=dashpos1_nom-(dash_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dash();
    dash1_re=cg_wave_re;
    dash1_im=cg_wave_im;
    dashpos1=cg_wave_midpoint;
    dashpos1_err=dashpos1_nom-cg_wave_midpoint;
    if(dashpos1_err < -sizhalf)dashpos1_err+=baseband_size;
    dash_fit1=cg_wave_fit; 
    if( dash_fit1 > DASH_DETECT_LIMIT && 
                   dash1_chk > 0.5 &&  fabs(dashpos1_err) < 0.5*cwbit_pts)
      {
      ity=1;
      PRT04"\n{8}GOOD DASH %f fit= %f  (%f) [%f]",
                        dash1_chk,cg_wave_fit,dashpos1_nom,cg_wave_midpoint);      
      goto store8;
      }
    PRT04"\n{8}CHK DASH %f fit= %f  (%f) [%f]",
                         dash1_chk,cg_wave_fit,dashpos1_nom,cg_wave_midpoint);
    dotpos1_nom=cw[cw_ptr].midpoint-0.625*cw[cw_ptr].sep;
    if(dotpos1_nom < 0)dotpos1_nom+=baseband_size;
    dot1_chk=check_dot(dotpos1_nom);
    dotpos2_nom=cw[cw_ptr].midpoint-0.375*cw[cw_ptr].sep;
    if(dotpos2_nom < 0)dotpos2_nom+=baseband_size;
    dot2_chk=check_dot(dotpos2_nom);
    if(dash1_chk < -0.25 && dot1_chk < -0.25 && dot2_chk < -0.25)
      {
      PRT04"\nALL chk NEG (< -0.25)");
      ity=5;
      goto store8;
      }
    cg_wave_start=dotpos1_nom-(dot_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dot();
    dot1_re=cg_wave_re;
    dot1_im=cg_wave_im;
    dotpos1=cg_wave_midpoint;
    dotpos1_err=dotpos1_nom-cg_wave_midpoint;
    if(dotpos1_err < -sizhalf)dotpos1_err+=baseband_size;
    dot_fit1=cg_wave_fit; 
    PRT04"\n{8}CHK DOT1 %f fit=%f  (%f)  [%f]",
                          dot1_chk,cg_wave_fit,dotpos1_nom,cg_wave_midpoint);
    cg_wave_start=dotpos2_nom-(dot_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dot();
    dot2_re=cg_wave_re;
    dot2_im=cg_wave_im;
    dotpos2=cg_wave_midpoint;
    dotpos2_err=dotpos2_nom-cg_wave_midpoint;
    if(dotpos2_err < -sizhalf)dotpos2_err+=baseband_size;
    dot_fit2=cg_wave_fit; 
    PRT04"\n{8}CHK DOT2 %f fit=%f  (%f)  [%f]",
                         dot2_chk,cg_wave_fit,dotpos2_nom,cg_wave_midpoint);
    if( dash_fit1 < DASH_MISFIT_LIMIT || 
             ( (dash1_chk < -0.25 && fabs(dashpos1_err) < 0.5*cwbit_pts) ||
                ( dash1_chk < 0.25 && fabs(dashpos1_err) < cwbit_pts ) ) ) 
      {
// The fit to a dash is very poor. 
// Set ity to 5 (word separator), then check whether dot or space will fit.     
      ity=5;
      PRT04"\nset ity=5");
      PRT04"\ndot1 fit %f    chk %f    poserr %f ",dot_fit1,dot1_chk,dotpos1_err);
      if( dot_fit1 > DOT_MISFIT_LIMIT &&
                      dot1_chk > 0.25 && fabs(dotpos1_err) < 0.5*cwbit_pts ) 
        {
        ity=2;
        PRT04"\nset ity=2");
        } 
      PRT04"\ndot2 fit %f    chk %f    poserr %f ",dot_fit2,dot2_chk,dotpos2_err);
      if( dot_fit2 > DOT_MISFIT_LIMIT &&
                      dot2_chk > 0.25 && fabs(dotpos2_err) < 0.5*cwbit_pts ) 
        {
        if(ity == 2)
          {
          ity=4;
          PRT04"\nset ity=4");
          }
        else
          {
          ity=3;
          PRT04"\nset ity=3");
          }
        }    
      goto store8;
      }
    PRT04"\nUnclear");
// The situation is unclear. Nothing fits well...........
    if(dash1_chk < 0 && dot1_chk < 0 && dot2_chk < 0)
      {
      ity=5;
      PRT04"\nset ity=5  (all neg)");
      goto store8;
      }
    t1=dot1_chk*dot2_chk;
    if( fabs(t1) > dash1_chk*fabs(dash1_chk) )
      {
// The fit to a dash is worse than dots and/or spaces.
      PRT04"\nset ity=5  (dash worse than dots)");
      ity=5;
      if( dot_fit1 > DOT_MISFIT_LIMIT &&
                         dot1_chk > 0 && fabs(dotpos1_err) < 0.7*cwbit_pts ) 
        {
        ity=2;
        PRT04"\nset ity=2");
        } 
      if( dot_fit2 > DOT_MISFIT_LIMIT &&
                            dot2_chk > 0 && fabs(dotpos2_err) < 0.7*cwbit_pts ) 
        {
        if(ity == 2)
          {
          ity=4;
          PRT04"\nset ity=4");
          }
        else
          {
          ity=3;
          PRT04"\nset ity=3");
          }
        }    
      goto store8;
      }
    if( dash_fit1 > DASH_MISFIT_LIMIT && 
                (dash1_chk > 0 || fabs(dashpos1_err) < cwbit_pts ) )
      {
      ity=1;
      PRT04"\nset ity=1");
      }
store8:;
    clear_region();
    PRT04"\nity=%d",ity);
    switch (ity)
      {
      case 1:
// Store a dash
//  ---_---_---   8  ity=1
      t3=0;
      if(dash_fit1 > DASH_DETECT_LIMIT && fabs(dashpos1_err) < 0.25*cwbit_pts)
        {
        if(dash1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dashpos1+t2*dashpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dash1_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dash1_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dash %f",cg_wave_midpoint);
      insert_item(CW_DASH);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;

      case 2:
// Store dot1 and space
//  ---_-___---   8  ity=2
//  ---___-_---   8  ity=3
//  ---_____---   8  ity=5
//  ---_-_-_---   8  ity=4
      t3=0;
      if(dot_fit1 > DOT_DETECT_LIMIT && fabs(dotpos1_err) < 0.25*cwbit_pts)
        {
        if(dot1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos1+t2*dotpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot1_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot1_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cg_wave_midpoint=dotpos2_nom;
      PRT04"\nstore_space %f",cg_wave_midpoint);
      insert_item(CW_SPACE);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;

      case 3:
// Store space and dot2 
//  ---___-_---   8  ity=3
      cg_wave_midpoint=dotpos1_nom;
      PRT04"\nstore_space %f",cg_wave_midpoint);
      insert_item(CW_SPACE);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      t3=0;
      if(dot_fit2 > DOT_DETECT_LIMIT && fabs(dotpos2_err) < 0.25*cwbit_pts)
        {
        if(dot2_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos2+t2*dotpos2_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot2_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot2_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;

      case 4:
// Store dot1 and dot2 
//  ---_-_-_---   8  ity=4
      t3=0;
      if(dot_fit1 > DOT_DETECT_LIMIT && fabs(dotpos1_err) < 0.25*cwbit_pts)
        {
        if(dot1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos1+t2*dotpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot1_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot1_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      t3=0;
      if(dot_fit2 > DOT_DETECT_LIMIT && fabs(dotpos2_err) < 0.25*cwbit_pts)
        {
        if(dot2_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos2+t2*dotpos2_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot2_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot2_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;


      case 5:
// Store word separator
//  ---_____---   8  ity=5
      cg_wave_midpoint=dashpos1_nom;
      PRT04"\nstore word sep %f",cg_wave_midpoint);
      insert_item(CW_WORDSEP);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      cw_ptr++;
      break;
      }
    break;

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    default:
    if(k==10)
      {    
      set_region_envelope();
      }
    else
      {    
      set_long_region_envelope();
      }
// See if a dash will fit in the first position.
    dashpos1_nom=cw[cw_ptr].midpoint-0.6*cw[cw_ptr].sep;
    if(dashpos1_nom < 0)dashpos1_nom+=baseband_size;
    dash1_chk=check_dash(dashpos1_nom);
    cg_wave_start=dashpos1_nom-(dash_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dash();
    dash1_re=cg_wave_re;
    dash1_im=cg_wave_im;
    dashpos1=cg_wave_midpoint;
    dashpos1_err=dashpos1_nom-cg_wave_midpoint;
    if(dashpos1_err < -sizhalf)dashpos1_err+=baseband_size;
    dash_fit1=cg_wave_fit; 
    PRT05"\n{def.l}CHK DASH %f fit= %f  (%f) [%f]",
                            dash1_chk,cg_wave_fit,dashpos1_nom,cg_wave_midpoint);
    ity=0;
    unkn=k-4;
    if(  (dash_fit1 > DASH_DETECT_LIMIT && 
          fabs(dashpos1_err) < 0.7*cwbit_pts &&
          dash_fit1-dash_fit2 >0.05 &&
          dash1_chk > 0)    ||
               (dash_fit1 > DASH_MISFIT_LIMIT && 
                fabs(dashpos1_err) < 0.5*cwbit_pts &&
                dash_fit1-dash_fit2 >0.05 &&
                dash1_chk > 0.5)  ) 
      {
// A dash fits reasonably well in the lower position.
      ity=1;
// Check how well dots would fit at the beginning or end of the dash position.        
      dotpos1_nom=dashpos1_nom-cwbit_pts;
      if(dotpos1_nom < 0)dotpos1_nom+=baseband_size;
      dot1_chk=check_dot(dotpos1_nom);
      cg_wave_start=dotpos1_nom-(dot_pts>>1)+baseband_size;
      cg_wave_start&=baseband_mask;
      fit_dot();
      dotpos1=cg_wave_midpoint;
      dotpos1_err=dotpos1_nom-cg_wave_midpoint;
      if(dotpos1_err < -sizhalf)dotpos1_err+=baseband_size;
      dot_fit1=cg_wave_fit; 
      PRT05"\n{def.l}CHK DOT1 %f fit=%f  (%f)  [%f]",
                          dot1_chk,cg_wave_fit,dotpos1_nom,cg_wave_midpoint);
      if(fabs(dotpos1_err) < 0.5 * cwbit_pts && 
         dash_fit1 < dot_fit1+0.05 &&
         dot1_chk > 0.25)
        {
        PRT05"\ndot1.l good");     
        ity=0;
        }
      else
        {
        dotpos2_nom=dashpos1_nom+cwbit_pts;
        if(dotpos2_nom >= baseband_size)dotpos2_nom-=baseband_size;
        dot2_chk=check_dot(dotpos2_nom);
        cg_wave_start=dotpos2_nom-(dot_pts>>1)+baseband_size;
        cg_wave_start&=baseband_mask;
        fit_dot();
        dotpos2=cg_wave_midpoint;
        dotpos2_err=dotpos2_nom-cg_wave_midpoint;
        if(dotpos2_err < -sizhalf)dotpos2_err+=baseband_size;
        dot_fit2=cg_wave_fit; 
        PRT05"\n{def.l}CHK DOT2 %f fit=%f  (%f)  [%f]",
                          dot2_chk,cg_wave_fit,dotpos2_nom,cg_wave_midpoint);
        if(fabs(dotpos2_err) < 0.5 * cwbit_pts && 
           dash_fit1 < dot_fit2+0.05 &&
           dot2_chk > 0.25)
          {
          PRT05"\ndot2.h good");     
        ity=0;
          }
        }
      }
// See if a dash will fit in the upper position.
    dashpos2_nom=cw[cw_ptr].midpoint-0.4*cw[cw_ptr].sep;
    if(dashpos2_nom < 0)dashpos2_nom+=baseband_size;
    dash2_chk=check_dash(dashpos2_nom);
    cg_wave_start=dashpos2_nom-(dash_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dash();
    dash2_re=cg_wave_re;
    dash2_im=cg_wave_im;
    dashpos2=cg_wave_midpoint;
    dashpos2_err=dashpos2_nom-cg_wave_midpoint;
    if(dashpos2_err < -sizhalf)dashpos2_err+=baseband_size;
    dash_fit2=cg_wave_fit; 
    PRT05"\n{def.u}CHK DASH %f fit= %f  (%f) [%f]",
                         dash2_chk,cg_wave_fit,dashpos2_nom,cg_wave_midpoint);
    if(  (dash_fit2 > DASH_DETECT_LIMIT && 
          fabs(dashpos2_err) < 0.7*cwbit_pts &&
          dash_fit2-dash_fit1 >0.05 &&
          dash2_chk > 0)  ||
                (dash_fit2 > DASH_MISFIT_LIMIT && 
                 fabs(dashpos2_err) < 0.5*cwbit_pts &&
                 dash_fit2-dash_fit1 >0.05 &&
                 dash2_chk > 0.5)  )
      {
// A dash fits reasonably well in the upper position.
      ity|=2;
// Check how well dots would fit at the beginning or end of the dash position.        
      dotpos3_nom=dashpos2_nom-cwbit_pts;
      if(dotpos3_nom < 0)dotpos3_nom+=baseband_size;
      dot3_chk=check_dot(dotpos3_nom);
      cg_wave_start=dotpos3_nom-(dot_pts>>1)+baseband_size;
      cg_wave_start&=baseband_mask;
      fit_dot();
      dotpos3=cg_wave_midpoint;
      dotpos3_err=dotpos3_nom-cg_wave_midpoint;
      if(dotpos3_err < -sizhalf)dotpos3_err+=baseband_size;
      dot_fit3=cg_wave_fit; 
      PRT05"\n{def.h}CHK DOT3 %f fit=%f  (%f)  [%f]",
                          dot3_chk,cg_wave_fit,dotpos3_nom,cg_wave_midpoint);

      if(fabs(dotpos3_err) < 0.5 * cwbit_pts && 
         dash_fit2 < dot_fit3+0.05 &&
         dot3_chk > 0.25)
        {
        PRT05"\ndot3.h good");     
        ity&=1;
        }
      else
        {
        dotpos4_nom=dashpos2_nom+cwbit_pts;
        if(dotpos4_nom >= baseband_size)dotpos4_nom-=baseband_size;
        dot4_chk=check_dot(dotpos4_nom);
        cg_wave_start=dotpos4_nom-(dot_pts>>1)+baseband_size;
        cg_wave_start&=baseband_mask;
        fit_dot();
        dotpos4=cg_wave_midpoint;
        dotpos4_err=dotpos4_nom-cg_wave_midpoint;
        if(dotpos4_err < -sizhalf)dotpos4_err+=baseband_size;
        dot_fit4=cg_wave_fit; 
        PRT05"\n{def.h}CHK DOT4 %f fit=%f  (%f)  [%f]",
                          dot4_chk,cg_wave_fit,dotpos4_nom,cg_wave_midpoint);
        if(fabs(dotpos4_err) < 0.5 * cwbit_pts && 
           dash_fit2 < dot_fit4+0.05 &&
           dot4_chk > 0.25)
          {
          PRT05"\ndot2.h good");     
          ity&=1;
          }

        }  
      if( (ity & 3) == 3 && k < 12)
        {         
// We can not have one dash at each side in a short region. 
// choose the best one.

        if( fabs(dash_fit1-dash_fit2) > 0.05)
          {

          if(dash_fit1 > dash_fit2)
            {
            ity=1;
            }
          else
            {
            ity=2;
            }
          }
        else
          {  
          t1=2*dash_fit1-dot_fit1-dot_fit2-2*dash_fit2+dot_fit3+dot_fit4;
          if(fabs(t1) < 0.05)
            {
            ity=0;
            }
          else
            {
            if(t1>0)ity=1; else ity=2;
            }
          }
        } 
      }
    if( (ity&1) != 0)
      {
      cg_wave_midpoint=dashpos1+0.5*dashpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=0.5*dash1_re+0.5*baseb_envelope[2*ia  ]; 
      cg_wave_im=0.5*dash1_im+0.5*baseb_envelope[2*ia+1];     
      PRT05"\nstore_dash.l  %f",cg_wave_midpoint);
      insert_item(CW_DASH);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      cw_ptr++;
      unkn-=4;
      }
    if( (ity&2) != 0)
      {
      cg_wave_midpoint=dashpos2+0.5*dashpos2_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=0.5*dash2_re+0.5*baseb_envelope[2*ia  ]; 
      cg_wave_im=0.5*dash2_im+0.5*baseb_envelope[2*ia+1];     
      PRT05"\nstore_dash.h  %f",cg_wave_midpoint);
      insert_item(CW_DASH);
      unkn-=4;
      cw[cw_ptr].unkn=unkn;
      cw[cw_ptr].down=2;
      cw_ptr++;
      }
    else
      {
      cw[cw_ptr].unkn=unkn;
      cw[cw_ptr].down=2;
      }
    break;
    }
zzx:;    
  cw_ptr++;
  }
}


void get_old_dashes(void)
{
int i, j;
int lmin, lmax, old_no_of_cwdat;
int ia, ib;
float t1,t2;
MORSE_DECODE_DATA *tmpcw;
tmpcw=(void *)fft1_tmp;
// Speed and wave forms are known.
// Look for new dashes, in the range cw[0].midpoint
// to baseb_pc.
ia=baseb_px;
while(baseb_ramp[ia] < 0)ia=(ia+1)&baseband_mask;
while(baseb_ramp[ia] > 0)ia=(ia+1)&baseband_mask;
while(baseb_ramp[ia] < 0)ia=(ia+1)&baseband_mask;
ia=(ia+baseband_mask)&baseband_mask;
ib=cw[0].midpoint;
ib=(ib-abs(baseb_ramp[ib])+baseband_size)&baseband_mask;
if(baseb_ramp[ib] > 0)ib=(ib-baseb_ramp[ib]+baseband_size)&baseband_mask;
if( ((ib-ia+baseband_size)&baseband_mask) > baseband_neg)return;
old_no_of_cwdat=no_of_cwdat;
lmax=4.5*cwbit_pts;
lmin=1.5*cwbit_pts;
 check_cw(30010,0);

while( ib != ia)
  {
// Step downwards by the (negative) ramp length.
// We should always be on a negative ramp here.
  ib=(ib+baseb_ramp[ib]+baseband_size)&baseband_mask;
  if( ((ib-baseb_pe+baseband_size)&baseband_mask) > 
                                              baseband_neg)goto good_dash_x;
// Now we must be on a positive ramp.
  if(baseb_ramp[ib] >= lmin && baseb_ramp[ib] <= lmax)
    {
    cg_wave_start=
           (ib-((baseb_ramp[ib]+dot_pts)>>1)+baseband_size)&baseband_mask;
    fit_dot();
    t2=cg_wave_fit;
    cg_wave_start=
           (ib-((baseb_ramp[ib]+dash_pts)>>1)+baseband_size)&baseband_mask;
    fit_dash();
    PRT00"\n%f  %f  [%f]",cg_wave_fit, t2, cg_wave_midpoint);
    if(cg_wave_fit >DASH_DETECT_LIMIT && cg_wave_fit-t2 > 0.05 )
      {
      PRT00"\n  store dash %f   (get_old_dashes)", cg_wave_midpoint);
      accurate_store_dash();  
      tmpcw[no_of_cwdat].type=CW_DASH;
      tmpcw[no_of_cwdat].midpoint=cg_wave_midpoint;
      tmpcw[no_of_cwdat].re=cg_wave_re;
      tmpcw[no_of_cwdat].im=cg_wave_im;
      no_of_cwdat++;
      if(no_of_cwdat > max_cwdat)end_program(1171);
      }
    }  
  ib=(ib-baseb_ramp[ib]+baseband_size)&baseband_mask;
  }
good_dash_x:;

// Reorder cw data.
if(no_of_cwdat != old_no_of_cwdat)
  {
  i=no_of_cwdat-1;
  j=i-no_of_cwdat-old_no_of_cwdat;
  while(j >= 0)
    {
    cw[i]=cw[j];
    j--;
    i--;
    }    
  j=0;
  while(i >= 0)
    {
    cw[i]=tmpcw[j];
    t1=cw[i+1].midpoint-cw[i].midpoint;
    if(t1 < 0)t1+=baseband_size;
    cw[i+1].sep=t1;
    i--;
    j++;
    }
  }
check_cw(31001,0);
}

void get_recent_dashes(void)
{
char s[80];
int i, j;
int lmin, lmax, old_no_of_dashes;
int ia, ib;
float t1,t2;
MORSE_DECODE_DATA *tmpcw;
tmpcw=(void *)fft1_tmp;
// Speed and wave forms are known.
// Look for new dashes, in the range cw[no_of_cwdat-1].midpoint
// to baseb_pc.
ia=cw[no_of_cwdat-1].midpoint;
while(baseb_ramp[ia] > 0)ia=(ia+1)&baseband_mask;
while(baseb_ramp[ia] < 0)ia=(ia+1)&baseband_mask;
ia=(ia+baseband_mask)&baseband_mask;
// ia now points to the last point of the first negative ramp
// after the most recent cw[].midpoint.
ib=baseb_pc;
if(baseb_ramp[ib] > 0)ib=(ib-baseb_ramp[ib]+baseband_size)&baseband_mask;
if( ((ib-ia+baseband_size)&baseband_mask) > baseband_neg)return;
old_no_of_dashes=no_of_cwdat;
lmax=4.5*cwbit_pts;
lmin=1.5*cwbit_pts;
check_cw(30032,0);
while( ib != ia)
  {
// Step downwards by the (negative) ramp length.
// We should always be on a negative ramp here.
  ib=(ib+baseb_ramp[ib]+baseband_size)&baseband_mask;
  if( ((ib-baseb_pe+baseband_size)&baseband_mask) > 
                                              baseband_neg)goto good_dash_x;
// Now we must be on a positive ramp.
  if(baseb_ramp[ib] >= lmin && baseb_ramp[ib] <= lmax)
    {
    cg_wave_start=
           (ib-((baseb_ramp[ib]+dot_pts)>>1)+baseband_size)&baseband_mask;
    fit_dot();
    t2=cg_wave_fit;
    cg_wave_start=
           (ib-((baseb_ramp[ib]+dash_pts)>>1)+baseband_size)&baseband_mask;
    fit_dash();
    PRT00"\n%f  %f  [%f]",cg_wave_fit, t2, cg_wave_midpoint);
    if(cg_wave_fit >DASH_DETECT_LIMIT && cg_wave_fit-t2 > 0.05 )
      {
 check_cw(3002,0);

      PRT00"\nstore dash %f   (get_recent_dashes)", cg_wave_midpoint);
      accurate_store_dash();  
      cw[no_of_cwdat].type=CW_DASH;
      cw[no_of_cwdat].midpoint=cg_wave_midpoint;
      cw[no_of_cwdat].re=cg_wave_re;
      cw[no_of_cwdat].im=cg_wave_im;
      no_of_cwdat++;
      if(no_of_cwdat > max_cwdat)end_program(1171);
 check_cw(3003,0);
      }
    }  
  ib=(ib-baseb_ramp[ib]+baseband_size)&baseband_mask;
  }
good_dash_x:;
check_cw(30031,0);
settextcolor(15);
sprintf(s,"%4d                                                 ",no_of_cwdat);
xytext(70,0,s);
settextcolor(7);
// We stepped backwards using the ramps when collecting dash midpoints.
// Reorder dash midpoints
if(no_of_cwdat - old_no_of_dashes > 1)
  {
  i=no_of_cwdat-1;
  j=old_no_of_dashes;
  while(j < i)
    {
    tmpcw[0]=cw[i];
    cw[i]=cw[j];
    cw[j]=tmpcw[0];
    j++;
    i--;
    }
  }
// Collect dash separations
for(i=old_no_of_dashes; i<no_of_cwdat; i++)
  {
  t1=cw[i].midpoint-cw[i-1].midpoint;
  if(t1 < 0)t1+=baseband_size;
  cw[i].sep=t1;
  }
 check_cw(30030,1);
}

void show_cw(void)
{
int i;
char s[80];
fprintf(dmp,"\n******************* show_cw **********************");
for(i=0; i<no_of_cwdat; i++)
  {
  switch (cw[i].type)
    {
    case CW_DASH:
    sprintf(s,"dash   ");
    break;
    
    case CW_DOT:
    sprintf(s,"dot    ");
    break;
    
    case CW_SPACE:
    sprintf(s,"space  ");
    break;
    
    case CW_WORDSEP:
    sprintf(s,"wordsep");
    break;
    
    default:
    end_program(889988);
    break;
    }
  PERMDEB"\n%s %5d [%8.3f]%8.3f %2d %2d (%f  %f)",
                     s,i,cw[i].midpoint,cw[i].sep,cw[i].len,cw[i].unkn,
                    ZZ*cw[i].re,ZZ*cw[i].im);
  }
  PERMDEB"\n");
}  


void first_detect(int first_item)
{
int sizhalf;
int k, ia;
int ity, item, unkn;
float dotpos1_nom, dotpos2_nom, dotpos3_nom, dotpos4_nom;
float dashpos1_nom, dashpos2_nom;
float dot1_chk, dot2_chk, dot3_chk, dot4_chk, dash1_chk, dash2_chk;
float dashpos1, dashpos2, dotpos1, dotpos2, dotpos3, dotpos4;
float dashpos1_err, dashpos2_err;
float dotpos1_err, dotpos2_err, dotpos3_err, dotpos4_err;
float dash_fit1, dash_fit2, dot_fit1, dot_fit2, dot_fit3, dot_fit4;
float r1, t1, t2, t3;
float dash1_re, dash1_im, dash2_re, dash2_im;
float dot1_re, dot1_im, dot2_re, dot2_im;
// **************************************************************
// **************************************************************
// ****    This routine is called to initiate a recently     ****
// ***     collected data area for which dashes have been    ****
// **** fitted but for which nothing else has yet been done. ****
// **************************************************************
// **************************************************************
sizhalf=baseband_size>>1;
// Initiate with stupid values. This avoids compiler complaints.
dot1_chk=-BIG;
dotpos1=BIG;
dotpos1_err=BIG;
dot1_re=BIG;
dot1_im=BIG;
dot_fit1=-BIG;
dot2_chk=-BIG;
dotpos2=BIG;
dotpos2_err=BIG;
dot2_re=BIG;
dot2_im=BIG; 
dot_fit2=-BIG;
dotpos1_nom=BIG;
dotpos2_nom=BIG;
dash_fit2=-BIG;
dot_fit4=-BIG;
// *****************************************************
// *****************************************************
// *****  Fit key up or key down patterns to short *****
// *****  regions that are surrounded by dashes    *****
// *****    Initiate cw[].unkn with the number of  *****
// ***** unknown "Morse code clock" states between *****
// *****  the current item and the preceding one.  *****
// *****************************************************
// *****************************************************
// Look for the following cases:
//    Code       Sep
//  ---_---       4
//  ---_-_---     6
//  ---___---     6
//  ---_-_-_---   8
//  ---_---_---   8
//  ---___-_---   8
//  ---_-___---   8
//  ---_____---   8
//  ---_---_?_---   10
//  ---_?_---_---   10
//  ---_---_????....  default
//  ....????_---_---  default
PRT02"\nCWBIT PTS %f",cwbit_pts);
// Store the most probable signal in each case.
//   name     data    length
// CW_DASH    |---_|     4
// CW_DOT     |-_|       2 
// CW_SPACE   |__|       2
// CW_WORDSEP |____|     4 
// The item starts (length/2 + 0.5) below cw[].midpoint because
// midpoint is the center of a key down period while the item
// midpoint is 0.5 above that because one space is always
// included in an item.   
cw_ptr=first_item;
while(cw_ptr < no_of_cwdat)
  {
  r1=cw[cw_ptr].sep/cwbit_pts;
  k=(int)(r1)&0xfffffffe;
  if(r1-k > 1)k+=2;
  PRT02"\n%d PRT02> %d unkn%d %f  [%f]",cw_ptr,k,
                          cw[cw_ptr].unkn,r1,cw[cw_ptr].midpoint);
  switch (k)
    {
    case 2:
    case 4:
// We have two close spaced dashes.
// There can be nothing in between.
    cw[cw_ptr].unkn=0;
    cw[cw_ptr].down=2;
    break;
    
    case 6:
//  ---_-_---     6
//  ---___---     6
// Base the decision on the probability that there is a dot
// right between the two dashes.
    set_region_envelope();
    dotpos1_nom=cw[cw_ptr].midpoint-0.5*cw[cw_ptr].sep;
    if(dotpos1_nom < 0)dotpos1_nom+=baseband_size;
    dot1_chk=check_dot(dotpos1_nom);
    PRT03"\n{6}CHK DOT %f (%f)",dot1_chk,dotpos1_nom);
// If dot1_chk in negative, the fit is better for a space than for a dot.
// Be careful and check if a dot would fit even for dot1_chk a little below zero.
    if(dot1_chk > -0.25)
      {
      cg_wave_start=dotpos1_nom-(dot_pts>>1)+baseband_size;
      cg_wave_start&=baseband_mask;
      fit_dot();
      PRT03" [%f]", cg_wave_midpoint);
      dotpos1_err=dotpos1_nom-cg_wave_midpoint;
      if(dotpos1_err < -sizhalf)dotpos1_err+=baseband_size;
      PRT03"  poserr %f  fit %f",dotpos1_err/cwbit_pts,cg_wave_fit);
      t3=-1;
// Use t3 as an indicator. 
// t3 < 0 => store space.
// t3 > 0 => store dot using t3 as the weight on fit_dot data.      
      if(cg_wave_fit > DASH_DETECT_LIMIT && fabs(dotpos1_err) < 0.25*cwbit_pts)
        {
        if(dot1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      if(cg_wave_fit > DASH_MISFIT_LIMIT && 
                       fabs(dotpos1_err) < 0.5*cwbit_pts && dot1_chk > 0.5)t3=0.5;
      if(t3 < 0 && dot1_chk > 0.7)t3=0;
      if(t3 >= 0)
        {
        t2=1-t3; 
        cg_wave_midpoint+=t2*dotpos1_err;
        if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
        if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
        ia=cg_wave_midpoint;
        cg_wave_re=t3*cg_wave_re+t2*baseb_envelope[2*ia  ]; 
        cg_wave_im=t3*cg_wave_im+t2*baseb_envelope[2*ia+1]; 
        clear_region();
        PRT03"\nstore dot %f",cg_wave_midpoint);
        item=CW_DOT;
        }
      else
        {
        cg_wave_midpoint=dotpos1_nom;
        clear_region();
        PRT03"\nstore space %f",cg_wave_midpoint);
        item=CW_SPACE;
        }
      }
    else
      {
      cg_wave_midpoint=dotpos1_nom;
      clear_region();
      PRT03"\nstore space %f",cg_wave_midpoint);
      item=CW_SPACE;
      }
    insert_item(item);
    break;

    case 8:
//  ---_-_-_---   8  ity=4
//  ---_---_---   8  ity=1
//  ---___-_---   8  ity=3
//  ---_-___---   8  ity=2
//  ---_____---   8  ity=5
    set_region_envelope();
    ity=0;
// See if a dash will fit well.
    dashpos1_nom=cw[cw_ptr].midpoint-0.5*cw[cw_ptr].sep;
    if(dashpos1_nom < 0)dashpos1_nom+=baseband_size;
    dash1_chk=check_dash(dashpos1_nom);
    cg_wave_start=dashpos1_nom-(dash_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dash();
    dash1_re=cg_wave_re;
    dash1_im=cg_wave_im;
    dashpos1=cg_wave_midpoint;
    dashpos1_err=dashpos1_nom-cg_wave_midpoint;
    if(dashpos1_err < -sizhalf)dashpos1_err+=baseband_size;
    dash_fit1=cg_wave_fit; 
    if( dash_fit1 > DASH_DETECT_LIMIT && 
                   dash1_chk > 0.5 &&  fabs(dashpos1_err) < 0.5*cwbit_pts)
      {
      ity=1;
      PRT04"\n{8}GOOD DASH %f fit= %f  (%f) [%f]",
                        dash1_chk,cg_wave_fit,dashpos1_nom,cg_wave_midpoint);      
      goto store8;
      }
    PRT04"\n{8}CHK DASH %f fit= %f  (%f) [%f]",
                         dash1_chk,cg_wave_fit,dashpos1_nom,cg_wave_midpoint);
    dotpos1_nom=cw[cw_ptr].midpoint-0.625*cw[cw_ptr].sep;
    if(dotpos1_nom < 0)dotpos1_nom+=baseband_size;
    dot1_chk=check_dot(dotpos1_nom);
    dotpos2_nom=cw[cw_ptr].midpoint-0.375*cw[cw_ptr].sep;
    if(dotpos2_nom < 0)dotpos2_nom+=baseband_size;
    dot2_chk=check_dot(dotpos2_nom);
    if(dash1_chk < -0.25 && dot1_chk < -0.25 && dot2_chk < -0.25)
      {
      PRT04"\nALL chk NEG (< -0.25)");
      ity=5;
      goto store8;
      }
    cg_wave_start=dotpos1_nom-(dot_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dot();
    dot1_re=cg_wave_re;
    dot1_im=cg_wave_im;
    dotpos1=cg_wave_midpoint;
    dotpos1_err=dotpos1_nom-cg_wave_midpoint;
    if(dotpos1_err < -sizhalf)dotpos1_err+=baseband_size;
    dot_fit1=cg_wave_fit; 
    PRT04"\n{8}CHK DOT1 %f fit=%f  (%f)  [%f]",
                          dot1_chk,cg_wave_fit,dotpos1_nom,cg_wave_midpoint);
    cg_wave_start=dotpos2_nom-(dot_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dot();
    dot2_re=cg_wave_re;
    dot2_im=cg_wave_im;
    dotpos2=cg_wave_midpoint;
    dotpos2_err=dotpos2_nom-cg_wave_midpoint;
    if(dotpos2_err < -sizhalf)dotpos2_err+=baseband_size;
    dot_fit2=cg_wave_fit; 
    PRT04"\n{8}CHK DOT2 %f fit=%f  (%f)  [%f]",
                         dot2_chk,cg_wave_fit,dotpos2_nom,cg_wave_midpoint);
    if( dash_fit1 < DASH_MISFIT_LIMIT || 
             ( (dash1_chk < -0.25 && fabs(dashpos1_err) < 0.5*cwbit_pts) ||
                ( dash1_chk < 0.25 && fabs(dashpos1_err) < cwbit_pts ) ) ) 
      {
// The fit to a dash is very poor. 
// Set ity to 5 (word separator), then check whether dot or space will fit.     
      ity=5;
      PRT04"\nset ity=5");
      PRT04"\ndot1 fit %f    chk %f    poserr %f ",dot_fit1,dot1_chk,dotpos1_err);
      if( dot_fit1 > DOT_MISFIT_LIMIT &&
                      dot1_chk > 0.25 && fabs(dotpos1_err) < 0.5*cwbit_pts ) 
        {
        ity=2;
        PRT04"\nset ity=2");
        } 
      PRT04"\ndot2 fit %f    chk %f    poserr %f ",dot_fit2,dot2_chk,dotpos2_err);
      if( dot_fit2 > DOT_MISFIT_LIMIT &&
                      dot2_chk > 0.25 && fabs(dotpos2_err) < 0.5*cwbit_pts ) 
        {
        if(ity == 2)
          {
          ity=4;
          PRT04"\nset ity=4");
          }
        else
          {
          ity=3;
          PRT04"\nset ity=3");
          }
        }    
      goto store8;
      }
    PRT04"\nUnclear");
// The situation is unclear. Nothing fits well...........
    if(dash1_chk < 0 && dot1_chk < 0 && dot2_chk < 0)
      {
      ity=5;
      PRT04"\nset ity=5  (all neg)");
      goto store8;
      }
    t1=dot1_chk*dot2_chk;
    if( fabs(t1) > dash1_chk*fabs(dash1_chk) )
      {
// The fit to a dash is worse than dots and/or spaces.
      PRT04"\nset ity=5  (dash worse than dots)");
      ity=5;
      if( dot_fit1 > DOT_MISFIT_LIMIT &&
                         dot1_chk > 0 && fabs(dotpos1_err) < 0.7*cwbit_pts ) 
        {
        ity=2;
        PRT04"\nset ity=2");
        } 
      if( dot_fit2 > DOT_MISFIT_LIMIT &&
                            dot2_chk > 0 && fabs(dotpos2_err) < 0.7*cwbit_pts ) 
        {
        if(ity == 2)
          {
          ity=4;
          PRT04"\nset ity=4");
          }
        else
          {
          ity=3;
          PRT04"\nset ity=3");
          }
        }    
      goto store8;
      }
    if( dash_fit1 > DASH_MISFIT_LIMIT && 
                (dash1_chk > 0 || fabs(dashpos1_err) < cwbit_pts ) )
      {
      ity=1;
      PRT04"\nset ity=1");
      }
store8:;
    clear_region();
    PRT04"\nity=%d",ity);
    switch (ity)
      {
      case 1:
// Store a dash
//  ---_---_---   8  ity=1
      t3=0;
      if(dash_fit1 > DASH_DETECT_LIMIT && fabs(dashpos1_err) < 0.25*cwbit_pts)
        {
        if(dash1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dashpos1+t2*dashpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dash1_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dash1_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dash %f",cg_wave_midpoint);
      insert_item(CW_DASH);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;

      case 2:
// Store dot1 and space
//  ---_-___---   8  ity=2
//  ---___-_---   8  ity=3
//  ---_____---   8  ity=5
//  ---_-_-_---   8  ity=4
      t3=0;
      if(dot_fit1 > DOT_DETECT_LIMIT && fabs(dotpos1_err) < 0.25*cwbit_pts)
        {
        if(dot1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos1+t2*dotpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot1_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot1_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cg_wave_midpoint=dotpos2_nom;
      PRT04"\nstore_space %f",cg_wave_midpoint);
      insert_item(CW_SPACE);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;

      case 3:
// Store space and dot2 
//  ---___-_---   8  ity=3
      cg_wave_midpoint=dotpos1_nom;
      PRT04"\nstore_space %f",cg_wave_midpoint);
      insert_item(CW_SPACE);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      t3=0;
      if(dot_fit2 > DOT_DETECT_LIMIT && fabs(dotpos2_err) < 0.25*cwbit_pts)
        {
        if(dot2_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos2+t2*dotpos2_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot2_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot2_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;

      case 4:
// Store dot1 and dot2 
//  ---_-_-_---   8  ity=4
      t3=0;
      if(dot_fit1 > DOT_DETECT_LIMIT && fabs(dotpos1_err) < 0.25*cwbit_pts)
        {
        if(dot1_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos1+t2*dotpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot1_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot1_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      t3=0;
      if(dot_fit2 > DOT_DETECT_LIMIT && fabs(dotpos2_err) < 0.25*cwbit_pts)
        {
        if(dot2_chk < 0.25)
          {
          t3=0.75;
          }
        else
          {
          t3=0.5;
          }
        }  
      t2=1-t3; 
      cg_wave_midpoint=dotpos2+t2*dotpos2_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=t3*dot2_re+t2*baseb_envelope[2*ia  ]; 
      cg_wave_im=t3*dot2_im+t2*baseb_envelope[2*ia+1]; 
      PRT04"\nstore_dot %f",cg_wave_midpoint);
      insert_item(CW_DOT);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=1;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;


      case 5:
// Store word separator
//  ---_____---   8  ity=5
      cg_wave_midpoint=dashpos1_nom;
      PRT04"\nstore word sep %f",cg_wave_midpoint);
      insert_item(CW_WORDSEP);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      cw_ptr++;
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      break;
      }
    break;

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    default:
    if(k==10)
      {    
      set_region_envelope();
      }
    else
      {    
      set_long_region_envelope();
      }
// See if a dash will fit in the first position.
    dashpos1_nom=cw[cw_ptr].midpoint-0.6*cw[cw_ptr].sep;
    if(dashpos1_nom < 0)dashpos1_nom+=baseband_size;
    dash1_chk=check_dash(dashpos1_nom);
    cg_wave_start=dashpos1_nom-(dash_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dash();
    dash1_re=cg_wave_re;
    dash1_im=cg_wave_im;
    dashpos1=cg_wave_midpoint;
    dashpos1_err=dashpos1_nom-cg_wave_midpoint;
    if(dashpos1_err < -sizhalf)dashpos1_err+=baseband_size;
    dash_fit1=cg_wave_fit; 
    PRT05"\n{def.l}CHK DASH %f fit= %f  (%f) [%f]",
                            dash1_chk,cg_wave_fit,dashpos1_nom,cg_wave_midpoint);
    ity=0;
    unkn=k-4;
    if(  (dash_fit1 > DASH_DETECT_LIMIT && 
          fabs(dashpos1_err) < 0.7*cwbit_pts &&
          dash_fit1-dash_fit2 >0.05 &&
          dash1_chk > 0)    ||
               (dash_fit1 > DASH_MISFIT_LIMIT && 
                fabs(dashpos1_err) < 0.5*cwbit_pts &&
                dash_fit1-dash_fit2 >0.05 &&
                dash1_chk > 0.5)  ) 
      {
// A dash fits reasonably well in the lower position.
      ity=1;
// Check how well dots would fit at the beginning or end of the dash position.        
      dotpos1_nom=dashpos1_nom-cwbit_pts;
      if(dotpos1_nom < 0)dotpos1_nom+=baseband_size;
      dot1_chk=check_dot(dotpos1_nom);
      cg_wave_start=dotpos1_nom-(dot_pts>>1)+baseband_size;
      cg_wave_start&=baseband_mask;
      fit_dot();
      dotpos1=cg_wave_midpoint;
      dotpos1_err=dotpos1_nom-cg_wave_midpoint;
      if(dotpos1_err < -sizhalf)dotpos1_err+=baseband_size;
      dot_fit1=cg_wave_fit; 
      PRT05"\n{def.l}CHK DOT1 %f fit=%f  (%f)  [%f]",
                          dot1_chk,cg_wave_fit,dotpos1_nom,cg_wave_midpoint);
      if(fabs(dotpos1_err) < 0.5 * cwbit_pts && 
         dash_fit1 < dot_fit1+0.05 &&
         dot1_chk > 0.25)
        {
        PRT05"\ndot1.l good");     
        ity=0;
        }
      else
        {
        dotpos2_nom=dashpos1_nom+cwbit_pts;
        if(dotpos2_nom >= baseband_size)dotpos2_nom-=baseband_size;
        dot2_chk=check_dot(dotpos2_nom);
        cg_wave_start=dotpos2_nom-(dot_pts>>1)+baseband_size;
        cg_wave_start&=baseband_mask;
        fit_dot();
        dotpos2=cg_wave_midpoint;
        dotpos2_err=dotpos2_nom-cg_wave_midpoint;
        if(dotpos2_err < -sizhalf)dotpos2_err+=baseband_size;
        dot_fit2=cg_wave_fit; 
        PRT05"\n{def.l}CHK DOT2 %f fit=%f  (%f)  [%f]",
                          dot2_chk,cg_wave_fit,dotpos2_nom,cg_wave_midpoint);
        if(fabs(dotpos2_err) < 0.5 * cwbit_pts && 
           dash_fit1 < dot_fit2+0.05 &&
           dot2_chk > 0.25)
          {
          PRT05"\ndot2.h good");     
        ity=0;
          }
        }
      }
// See if a dash will fit in the upper position.
    dashpos2_nom=cw[cw_ptr].midpoint-0.4*cw[cw_ptr].sep;
    if(dashpos2_nom < 0)dashpos2_nom+=baseband_size;
    dash2_chk=check_dash(dashpos2_nom);
    cg_wave_start=dashpos2_nom-(dash_pts>>1)+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dash();
    dash2_re=cg_wave_re;
    dash2_im=cg_wave_im;
    dashpos2=cg_wave_midpoint;
    dashpos2_err=dashpos2_nom-cg_wave_midpoint;
    if(dashpos2_err < -sizhalf)dashpos2_err+=baseband_size;
    dash_fit2=cg_wave_fit; 
    PRT05"\n{def.u}CHK DASH %f fit= %f  (%f) [%f]",
                         dash2_chk,cg_wave_fit,dashpos2_nom,cg_wave_midpoint);
    if(  (dash_fit2 > DASH_DETECT_LIMIT && 
          fabs(dashpos2_err) < 0.7*cwbit_pts &&
          dash_fit2-dash_fit1 >0.05 &&
          dash2_chk > 0)  ||
                (dash_fit2 > DASH_MISFIT_LIMIT && 
                 fabs(dashpos2_err) < 0.5*cwbit_pts &&
                 dash_fit2-dash_fit1 >0.05 &&
                 dash2_chk > 0.5)  )
      {
// A dash fits reasonably well in the upper position.
      ity|=2;
// Check how well dots would fit at the beginning or end of the dash position.        
      dotpos3_nom=dashpos2_nom-cwbit_pts;
      if(dotpos3_nom < 0)dotpos3_nom+=baseband_size;
      dot3_chk=check_dot(dotpos3_nom);
      cg_wave_start=dotpos3_nom-(dot_pts>>1)+baseband_size;
      cg_wave_start&=baseband_mask;
      fit_dot();
      dotpos3=cg_wave_midpoint;
      dotpos3_err=dotpos3_nom-cg_wave_midpoint;
      if(dotpos3_err < -sizhalf)dotpos3_err+=baseband_size;
      dot_fit3=cg_wave_fit; 
      PRT05"\n{def.h}CHK DOT3 %f fit=%f  (%f)  [%f]",
                          dot3_chk,cg_wave_fit,dotpos3_nom,cg_wave_midpoint);

      if(fabs(dotpos3_err) < 0.5 * cwbit_pts && 
         dash_fit2 < dot_fit3+0.05 &&
         dot3_chk > 0.25)
        {
        PRT05"\ndot3.h good");     
        ity&=1;
        }
      else
        {
        dotpos4_nom=dashpos2_nom+cwbit_pts;
        if(dotpos4_nom >= baseband_size)dotpos4_nom-=baseband_size;
        dot4_chk=check_dot(dotpos4_nom);
        cg_wave_start=dotpos4_nom-(dot_pts>>1)+baseband_size;
        cg_wave_start&=baseband_mask;
        fit_dot();
        dotpos4=cg_wave_midpoint;
        dotpos4_err=dotpos4_nom-cg_wave_midpoint;
        if(dotpos4_err < -sizhalf)dotpos4_err+=baseband_size;
        dot_fit4=cg_wave_fit; 
        PRT05"\n{def.h}CHK DOT4 %f fit=%f  (%f)  [%f]",
                          dot4_chk,cg_wave_fit,dotpos4_nom,cg_wave_midpoint);
        if(fabs(dotpos4_err) < 0.5 * cwbit_pts && 
           dash_fit2 < dot_fit4+0.05 &&
           dot4_chk > 0.25)
          {
          PRT05"\ndot2.h good");     
          ity&=1;
          }

        }  
      if( (ity & 3) == 3 && k < 12)
        {         
// We can not have one dash at each side in a short region. 
// choose the best one.

        if( fabs(dash_fit1-dash_fit2) > 0.05)
          {

          if(dash_fit1 > dash_fit2)
            {
            ity=1;
            }
          else
            {
            ity=2;
            }
          }
        else
          {  
          t1=2*dash_fit1-dot_fit1-dot_fit2-2*dash_fit2+dot_fit3+dot_fit4;
          if(fabs(t1) < 0.05)
            {
            ity=0;
            }
          else
            {
            if(t1>0)ity=1; else ity=2;
            }
          }
        } 
      }
    if( (ity&1) != 0)
      {
      cg_wave_midpoint=dashpos1+0.5*dashpos1_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=0.5*dash1_re+0.5*baseb_envelope[2*ia  ]; 
      cg_wave_im=0.5*dash1_im+0.5*baseb_envelope[2*ia+1];     
      PRT05"\nstore_dash.l  %f",cg_wave_midpoint);
      insert_item(CW_DASH);
      cw[cw_ptr].unkn=0;
      cw[cw_ptr].down=2;
      cw_ptr++;
      unkn-=4;
      }
    if( (ity&2) != 0)
      {
      cg_wave_midpoint=dashpos2+0.5*dashpos2_err;
      if(cg_wave_midpoint < 0)cg_wave_midpoint+=baseband_size;
      if(cg_wave_midpoint >= baseband_size)cg_wave_midpoint-=baseband_size;
      ia=cg_wave_midpoint;
      cg_wave_re=0.5*dash2_re+0.5*baseb_envelope[2*ia  ]; 
      cg_wave_im=0.5*dash2_im+0.5*baseb_envelope[2*ia+1];     
      PRT05"\nstore_dash.h  %f",cg_wave_midpoint);
      insert_item(CW_DASH);
      unkn-=4;
      cw[cw_ptr].unkn=unkn;
      cw[cw_ptr].down=2;
      cw_ptr++;
      }
    else
      {
      cw[cw_ptr].unkn=unkn;
      cw[cw_ptr].down=2;
      }
    break;
    }
  cw_ptr++;
  }
}



void improve_cwspeed(void)
{
int i, k;
float r1, r2, r3;
// Collect the average waveform again.
// We probably have some more dashes now and their position is better
// known as compared to the previous speed determination.
// Then remove dashes that do not fit well any more.
seldash_cwspeed(0, no_of_cwdat);
r1=0;
r2=0;
cw_ptr=0;
check_cw(2003,1);
while(cw_ptr<no_of_cwdat)
  {
  if(cw[cw_ptr].type == CW_DASH)
    {
    cg_wave_start=cw[cw_ptr].midpoint-0.5*dash_pts+baseband_size;
    cg_wave_start&=baseband_mask;
    fit_dash();
    PRT01"\nrefine carr.  [%f] %f fit=%f",cw[cw_ptr].midpoint, 
                                                cg_wave_midpoint,cg_wave_fit);
    if(cg_wave_fit < DASH_MISFIT_LIMIT)
      {
      PRT01" removed");
      remove_dash();
      }
    else
      {  
      accurate_store_dash();  
      cw[cw_ptr].re=cg_wave_re;
      cw[cw_ptr].im=cg_wave_im;
      r1+=cg_wave_dat;
      r2+=cg_wave_err;
      fft1_tmp[cw_ptr]=r2/r1; 
      }
    }
  cw_ptr++;
  }
check_cw(2005,1);
// Use the data in fft1_tmp and cw_stoninv to decide if the new data
// as worsened the S/N ratio significantly.
// If it has, the cw speed has changed. 
// Here is where we might insert new baseb pointers and
// split the data in two regions to process independently.
// FUTURE PROJECT!!!
// ö ö ö ö ö ö ö ö ö
PRT01"\ncw_stoninv %f",cw_stoninv);
for(i=0; i<no_of_cwdat; i++)
  {
  PRT01"\n%d  N/(S+N)  %f",i,fft1_tmp[i]);
  }
PRT01"\n 1/(S/N)  %f    old %f)",fft1_tmp[no_of_cwdat-1],cw_stoninv);  
dash_average_noise=r2/no_of_cwdat;
// Update dash separations  
for(cw_ptr=1; cw_ptr<no_of_cwdat; cw_ptr++)
  {
  r3=cw[cw_ptr].midpoint-cw[cw_ptr-1].midpoint;
  if(r3 < 0)r3+=baseband_size;
  cw[cw_ptr].sep=r3;
  r3/=cwbit_pts;
  k=(int)(r3)&0xfffffffe;
  if(r3-k > 1)k+=2;
  PRT01"\ncarr. new fit %3d %3d %6.3f  [%11.4f]",
                                       cw_ptr,k,r3,cw[cw_ptr].midpoint);
  }
check_cw(2007,1);
}


void first_refine_carrier(void)
{
int sizhalf, old_no_of_dashes;
int k, ia, ib, lmax, lmin;
float r1, t2;
sizhalf=baseband_size>>1;
// When we arrive here the keying speed and the waveforms are well known.
// We have detected no_of_cwdat waveforms that fit to a dash, the center
// of the dashes are pointed to by cw[].midpoint and cw[].sep contains
// the separation between detected dashes.
// First look for recent dashes.
old_no_of_dashes=no_of_cwdat;
get_recent_dashes();
// Then collect old ones (if there are any)
get_old_dashes();
if(old_no_of_dashes != no_of_cwdat)
  {
  improve_cwspeed();
  old_no_of_dashes=no_of_cwdat;
  }
// **********************************************************
// **********************************************************
// ******  Use the (hopefully) improved dash waveform *******
// ****   and search the entire region for good matches  ****
// **********************************************************
// **********************************************************
cw_ptr=1;
lmax=4.5*cwbit_pts;
lmin=1.5*cwbit_pts;
while(cw_ptr < no_of_cwdat)
  {
  r1=cw[cw_ptr].sep/cwbit_pts;
  k=(int)(r1)&0xfffffffe;
  if(r1-k > 1)k+=2;
  PRT07"\n%d second search> %d %f  [%f]",cw_ptr,k,r1,cw[cw_ptr].midpoint);
  if(k > 8)
    {
    ib=cw[cw_ptr].midpoint-2.5*cwbit_pts;
    ia=cw[cw_ptr-1].midpoint+2.5*cwbit_pts;
    if(ib < 0)ib+=baseband_size;
    if(ia >= baseband_size)ia-=baseband_size;
    while(baseb_ramp[ia] > 0)ia=(ia+1)&baseband_mask;
    while(baseb_ramp[ia] < 0)ia=(ia+1)&baseband_mask;
    ia=(ia+baseband_mask)&baseband_mask;
    if(baseb_ramp[ib] > 0)ib=(ib-baseb_ramp[ib]+baseband_size)&baseband_mask;
    while( ib != ia)
      {
// Step downwards by the (negative) ramp length.
// We should always be on a negative ramp here.
      ib=(ib+baseb_ramp[ib]+baseband_size)&baseband_mask;
      if( ((ib-baseb_pe+baseband_size)&baseband_mask) > 
                                        baseband_neg)goto second_dashfind_x;
// Now we must be on a positive ramp.
      if(baseb_ramp[ib] >= lmin && baseb_ramp[ib] <= lmax)
        {
        cg_wave_start=
              (ib-((baseb_ramp[ib]+dot_pts)>>1)+baseband_size)&baseband_mask;
        fit_dot();
        t2=cg_wave_fit;
        cg_wave_start=
             (ib-((baseb_ramp[ib]+dash_pts)>>1)+baseband_size)&baseband_mask;
        fit_dash();
        PRT07"\nib=%d dash:%f  dot:%f  [%f]",
                                        ib,cg_wave_fit, t2, cg_wave_midpoint);
        if(cg_wave_fit >DASH_DETECT_LIMIT && cg_wave_fit-t2 > 0.05 )
          {
          PRT07"\nstore dash %f ", cg_wave_midpoint);
          insert_item(CW_DASH);
          }
        }  
      ib=(ib-baseb_ramp[ib]+baseband_size)&baseband_mask;
      }
second_dashfind_x:;    
    }  
  cw_ptr++;
  }
check_cw(2010,1);
first_detect(1);
if(old_no_of_dashes != no_of_cwdat)
  {
  improve_cwspeed();
  old_no_of_dashes=no_of_cwdat;
  }
// At this point we have fitted dashes and maybe a few dots and
// spaces.
store_pattern();

if(dmp != NULL && PR08 != 0)show_cw();
PRT08"\n***   SET cw_detect_flag=2   ***");
cw_detect_flag=2;
baseb_pe=baseb_pc;
baseb_pd=baseb_pc;
}

void second_refine_carrier(void)
{
int sizhalf, old_no_of_dashes;
sizhalf=baseband_size>>1;
// When we arrive here the keying speed and the waveforms are well known.
// We have detected no_of_cwdat waveforms, most of them dashes, but
// maybe also some dots and spaces.
// First look for recent dashes.
old_no_of_dashes=no_of_cwdat;
get_recent_dashes();
// Fit dashes and dots in short gaps and next to
// dashes in the new region.
first_detect(old_no_of_dashes-1);
if(old_no_of_dashes != no_of_cwdat)
  {
  improve_cwspeed();
  old_no_of_dashes=no_of_cwdat;
  }
// Try to fit more dots and dashes in the whole region from 0 to no_of_cwdat.
second_detect();
store_pattern();
if(dmp != NULL && PR08 != 0)show_cw();
baseb_pe=baseb_pc;
baseb_pd=baseb_pc;
}

