
#include <vga.h>
#include <unistd.h>
#include "conf.h"
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "foldcorr.h"
#include "screendef.h"
#include "caldef.h"
#include "seldef.h"

#define FRESH_RECALC 8


void fix2_dspnames(char *s,int i)
{
s[i]='c';  
s[i+1]='o';
s[i+2]='r';
s[i+3]='r';
s[i+4]=0;
s[0]='d';
s[1]='s';
s[2]='p';
}


int fix1_dspnames(char *s)
{
int i;
i=0;
while(rxpar_filenames[rx_mode][i] != 0)
  {
  s[i]=rxpar_filenames[rx_mode][i];
  i++;
  }
s[i]='_';
i++;  
return i;
}



void make_iqcorr_filename(char *s)
{
int i;
i=fix1_dspnames(s);
s[i]='i';
s[i+1]='q';
i+=2;
fix2_dspnames(s,i);
}  


void make_filfunc_filename(char *s)
{
int i;
i=fix1_dspnames(s);
fix2_dspnames(s,i);
}  

void update_fft1_slowsum(void)
{
int i,ia,pa,pb;
// Now that we have a new power spectrum in fft1_sumsq, update the
// average of the spectra in fft1_slowsum by adding it's power and 
// subtracting the power of the old one that should no longer 
// contribute to the sum.  
// This way of calculating an average may cause errors after a long
// time since bits may be lost occasionally due to rounding errors.
// Calculate a few points from scratch each time to eliminate this
// problem. 
pa=fft1_sumsq_pws;
pb=(pa-wg_fft_avg2num*fft1_size+fft1_sumsq_bufsize)&fft1_sumsq_mask;
if(fft1_sumsq_recalc == fft1_last_point) fft1_sumsq_recalc=fft1_first_point;
ia=fft1_sumsq_recalc;
fft1_sumsq_recalc+=wg.xpoints/FRESH_RECALC;
if(fft1_sumsq_recalc>fft1_last_point)fft1_sumsq_recalc=fft1_last_point;
new_fft1_averages(ia,fft1_sumsq_recalc);
for(i=wg.first_xpoint; i < ia; i++)
  {
  fft1_slowsum[i]+=fft1_sumsq[pa+i]-fft1_sumsq[pb+i];
  if(fft1_slowsum[i]<0)fft1_slowsum[i]=0;
  }
for(i=fft1_sumsq_recalc+1; i <= fft1_last_point; i++)
  {
  fft1_slowsum[i]+=fft1_sumsq[pa+i]-fft1_sumsq[pb+i];
  if(fft1_slowsum[i]<0.0000001)fft1_slowsum[i]=0.0000001;
  }
fft1_sumsq_pws=(fft1_sumsq_pws+fft1_size)&fft1_sumsq_mask; 
}

void fft1_waterfall(void)
{
int i,j;
while(fft1_sumsq_pwg != fft1_sumsq_pa && wg_waterf_ymove_ptr == 0)
  {
  j=fft1_sumsq_pwg+wg.first_xpoint; 
  for(i=wg_first_point; i <= wg_last_point; i++)
    {
    wg_waterf_sum[i]+=fft1_sumsq[j];
    j++;
    }
  fft1_sumsq_pwg=(fft1_sumsq_pwg+fft1_size)&fft1_sumsq_mask; 
  wg_waterf_sum_counter+=wg.fft_avg1num;
  if(wg_waterf_sum_counter >= wg.waterfall_avgnum)
    {
    update_wg_waterf();
    }
  }
}

void make_fft1(int debughelp)
{
read_rawdat(debughelp);
if(debughelp == 1 || debughelp == 2)return;  
while( ( newdat_flag & ND_TIMF1) != 0)
  {
  if( network_flag != 2 || network_modeno != 2)fft1_b(debughelp);
  fft1_c();
  if(debughelp != 0)return;  
  }
}

void read_rawdat(int debughelp)
{
int i, j, k, m, ix;
short int *isho;
int *x1, *x2;
char *ch;
// read a block of data from A/D, network or disk.
ad_block_counter++;
if( (disksave_flag&6) == 0)
  {
  isho=(void*)(&timf1_char[timf1p_pa]);
  timf1p_pa=(timf1p_pa+ad_read_bytes)&timf1_bytemask;
  if(network_flag == 2)
    {
    if(network_modeno == 1)
      {
      read(network_fd, &i, sizeof(int));
      if(i != 0)
        {
        read(network_fd,&fg.passband_center,sizeof(double));
        read(network_fd,&fg.passband_direction,sizeof(int));
        fft1_direction=fg.passband_direction;
        }
      read(network_fd, isho, ad_read_bytes);
      }
    else
      {  
      if(ioctl(network_fd, FIONREAD, &i)==-1)end_program(9999);
      if(i < fft1_blockbytes+16)
        {
        end_program(238863);
        return;
        }
      read(network_fd, &i, sizeof(int));
      if(i != 0)
        {
        read(network_fd,&fg.passband_center,sizeof(double));
        read(network_fd,&fg.passband_direction,sizeof(int));
        fft1_direction=fg.passband_direction;
        }
      read(network_fd, &fft1_float[fft1_pa], fft1_blockbytes);
      newdat_flag&=-1-ND_TIMF1;
      fft1_pa=(fft1_pa+fft1_block)&fft1_mask;  
      fft1_na=fft1_pa/fft1_block;
      if( ((fft1_px-fft1_pa+fft1_block)&fft1_mask) < 2*fft1_block)
        {
        fullbuf_flag |= ND_FFT1;
        }
      if(fft1_nm != fft1n_mask)fft1_nm++;
      return;
      }
    }
  else
    {  
    if(ui.ad_device_no < 256)
      {
      read(audio_in, isho, ad_read_bytes);
      }
    else
      {
      read(audio_in, isho, ad_read_bytes>>1);
      read(audio_in2, fft1_tmp, ad_read_bytes>>1);
      m=ad_read_fragments;
      if( (ui.input_mode&DWORD_INPUT) == 0)
        {
        for(i=0; i<m; i++)
          {

          }  
        }
      else
        {
        x1=(void*)isho;
        x2=(void*)fft1_tmp;
        for(i=ad_read_fragments-1; i>=0; i--)
          {
          x1[4*i  ]=x1[2*i  ];
          x1[4*i+1]=x1[2*i+1];
          x1[4*i+2]=x2[2*i  ];
          x1[4*i+3]=x2[2*i+1];
          }
        }    
      }    
    }
  if(network_flag == 1)
    {
    if(network_modeno == 1)
      {
      i=0;
      if(fg.passband_center != old_passband_center)i=-1;
      write(network_sockfd, &i, sizeof(int));
      if(i != 0)
        {
        write(network_sockfd,&fg.passband_center,sizeof(double));
        write(network_sockfd,&fg.passband_direction,sizeof(int));
        old_passband_center=fg.passband_center;
        }
      write(network_sockfd, isho, ad_read_bytes);
      }
    }  
  if(disksave_flag == 1)
    {
    if( (ui.input_mode&DWORD_INPUT) == 0)
      {
      fwrite(isho,1,ad_read_bytes,save_file);
      }
    else
      {  
      compress_rawdat();
      fwrite(fft1_tmp,1,save_rw_bytes,save_file);
      }
    }
  }
else
  {  
  diskread_block_counter++;
  newdat_flag&=-1-ND_HWARE;
  if( (ui.input_mode&DWORD_INPUT) == 0)
    {
    isho=(void*)(&timf1_char[timf1p_pa]);
    timf1p_pa=(timf1p_pa+ad_read_bytes)&timf1_bytemask;
    if( (ui.input_mode&BYTE_INPUT) != 0)
      {
      ch=(void*)isho;
      j=ad_read_bytes>>1;
      k=j;
      i=fread(isho,1,j,save_file);
      while(j > 0)
        {
        j--;
        isho[j]=(ch[j]+128)<<8;
        } 
      if(i != k)
        {
        i*=2;
        goto end_savfile;
        }
      }
    else
      {  
      i=fread(isho,1,ad_read_bytes,save_file);
      if(i != ad_read_bytes)goto end_savfile;
      }
    }
  else
    {  
    i=fread(fft1_tmp,1,save_rw_bytes,save_file);
    expand_rawdat();
    isho=(void*)(&timf1_char[timf1p_pa]);
    timf1p_pa=(timf1p_pa+ad_read_bytes)&timf1_bytemask;
    if(i != save_rw_bytes)
      {
end_savfile:;        
      if(disksave_flag == 2)diskread_block_counter=0;
      disksave_flag=4;
      k=(timf1p_pa-ad_read_bytes+i+timf1_bytes)&timf1_bytemask;
      while(k != timf1p_pa)
        {
        timf1_char[k]=0;
        k=(k+1)&timf1_bytemask;
        }
      }
    }
  }
if(ampinfo_flag != 0)
  {
  k=ui.ad_channels;
  m=ad_read_fragments;
  if( (ui.input_mode&DWORD_INPUT) == 0)
    {
    for(i=0; i<m; i+=k)
      {
      for(j=0; j<k; j++)
        {
        ix=isho[k*i+j];
        ix=abs(ix);        
        if(ix > ad_maxamp[j])ad_maxamp[j]=ix;
        }
      }  
    }
  else
    {
    for(i=0; i<m; i+=k)
      {
      for(j=0; j<k; j++)
        {
        ix=isho[1+((k*i+j)<<1)];
        ix=abs(ix);        
        if(ix > ad_maxamp[j])ad_maxamp[j]=ix;
// ********************************************************        
/*
// This silly thing will introduce third order intermodulation.
// It is enabled when 'A' is pressed and one can easily see
// the effects of various non-linearities by inserting suitable 
// functions here.
{float t1;
t1=isho[1+((k*i+j)<<1)];
t1/=0x7fff;
t1=t1+.06*t1*t1*t1;
t1*=0x7fff;
isho[1+((k*i+j)<<1)]=t1;
}
*/
// ********************************************************
        }
      }  
    }
  }
if(debughelp == 1)return;  
if(fft_cntrl[FFT1_CURMODE].approx_iq != 0)
  {
  while( ((timf1p_px-timf1p_pa+timf1_bytes)&timf1_bytemask) >= ad_read_bytes)
    {
    real_to_complex_input();
    }
  if(((ctimf1p_pa-ctimf1p_px+ctimf1_bytes)&ctimf1_bytemask)>=ctimf1_blockbytes)
    {  
    newdat_flag |= ND_TIMF1;
    }
  if(((ctimf1p_px-ctimf1p_pa+ctimf1_bytes)&ctimf1_bytemask)<ctimf1_blockbytes)
    {
    fullbuf_flag |= ND_TIMF1;
    }
  }
else
  {
  if( ((timf1p_pa-timf1p_px+timf1_bytes)&timf1_bytemask) >= timf1_blockbytes)
    {  
    newdat_flag |= ND_TIMF1;
    }
  if( ((timf1p_px-timf1p_pa+timf1_bytes)&timf1_bytemask) < ad_bufmargin)
    {
    fullbuf_flag |= ND_TIMF1;
    }
  }
}

void fft1_b(int debughelp)
{
int i, k, m, ia,ib,ic,id;
float t1,t2,t3,t4;
int pc, p0;
// We have enough new data for a new transform because this routine
// will only be called if newdat_flag says it is OK.
// ***********************************************************************
// In case we use fft version numbers 0 or 1 together with real data
// we have to convert the real data to complex data of half the sampling
// speed. For that purpose we use assembly routines.
if(fft_cntrl[FFT1_CURMODE].approx_iq != 0)
  {
  m=ctimf1_mask;
  p0=(ctimf1p_px/sizeof(int)-fft1_interleave_points*twice_rxchan+
                                                           ctimf1_bytes)&m;
  if(debughelp == 3)
    {
    ic=p0;
    k=fft1_pa+fft1_block;
    for(ia=fft1_pa; ia<k; ia++)
      {
      fft1_float[ia ]= ctimf1[ic];
      ic=(ic+1)&m;
      }
    fft1_pa=(fft1_pa+fft1_block)&fft1_mask;  
    fft1_na=fft1_pa/fft1_block;
    ctimf1p_px=(ctimf1p_px+ctimf1_blockbytes)&ctimf1_bytemask;
    return;
    }  
  if(sw_onechan)
    {
    if(fft_cntrl[FFT1_CURMODE].window == 1)
      {
      fft1_approx_dif_one();
      }
    else
      {
      fft1_approx_dit_one();
      }  
// The real to complex conversion used if fft1_approx_flag != 0 is not
// accurate enough due to the limited steepness of the iir filters used.
// We correct for the mirror frequency here by combining the signal
// and it's mirror properly.
    pc=fft1_pa/2;
    ib=pc+1;
    ic=pc+fft1_size-1;
    for(ia=1; ia < fft1_size/2; ia++)
      {
      t1=   fft1_float[2*ib  ] * fft1_foldcorr[2*ia  ] 
          - fft1_float[2*ib+1] * fft1_foldcorr[2*ia+1];
      t2=   fft1_float[2*ib  ] * fft1_foldcorr[2*ia+1]
          + fft1_float[2*ib+1] * fft1_foldcorr[2*ia  ];
      fft1_float[2*ib  ] -=   fft1_float[2*ic  ] * fft1_foldcorr[2*ia  ] 
                            + fft1_float[2*ic+1] * fft1_foldcorr[2*ia+1];
      fft1_float[2*ib+1] -=   fft1_float[2*ic  ] * fft1_foldcorr[2*ia+1] 
                            - fft1_float[2*ic+1] * fft1_foldcorr[2*ia  ];
      fft1_float[2*ic  ]-=t1;
      fft1_float[2*ic+1]+=t2;
      ib++;
      ic--;
      }
    }
  else 
    {
    if(fft_cntrl[FFT1_CURMODE].window == 1)
      {
      fft1_approx_dif_two();
      }
    else
      {
      fft1_approx_dit_two();
      }  
// The real to complex conversion used if fft1_approx_flag != 0 is not
// accurate enough due to the limited steepness of the iir filters used.
// We correct for the mirror frequency here by combining the signal
// and it's mirror properly.
    pc=fft1_pa/4;
    ib=pc+1;
    ic=pc+fft1_size-1;
    for(ia=1; ia < fft1_size/2; ia++)
      {
      t1=   fft1_float[4*ib  ] * fft1_foldcorr[2*ia  ] 
          - fft1_float[4*ib+1] * fft1_foldcorr[2*ia+1];
      t2=   fft1_float[4*ib  ] * fft1_foldcorr[2*ia+1]
          + fft1_float[4*ib+1] * fft1_foldcorr[2*ia  ];
      fft1_float[4*ib  ] -=   fft1_float[4*ic  ] * fft1_foldcorr[2*ia  ] 
                            + fft1_float[4*ic+1] * fft1_foldcorr[2*ia+1];
      fft1_float[4*ib+1] -=   fft1_float[4*ic  ] * fft1_foldcorr[2*ia+1] 
                            - fft1_float[4*ic+1] * fft1_foldcorr[2*ia  ];
      fft1_float[4*ic  ]-=t1;
      fft1_float[4*ic+1]+=t2;
      t1=   fft1_float[4*ib+2] * fft1_foldcorr[2*ia  ] 
          - fft1_float[4*ib+3] * fft1_foldcorr[2*ia+1];
      t2=   fft1_float[4*ib+2] * fft1_foldcorr[2*ia+1]
          + fft1_float[4*ib+3] * fft1_foldcorr[2*ia  ];
      fft1_float[4*ib+2] -=   fft1_float[4*ic+2] * fft1_foldcorr[2*ia  ] 
                            + fft1_float[4*ic+3] * fft1_foldcorr[2*ia+1];
      fft1_float[4*ib+3] -=   fft1_float[4*ic+2] * fft1_foldcorr[2*ia+1] 
                            - fft1_float[4*ic+3] * fft1_foldcorr[2*ia  ];

      fft1_float[4*ic+2]-=t1;
      fft1_float[4*ic+3]+=t2;
      ib++;
      ic--;
      }
    }
  ctimf1p_px=(ctimf1p_px+ctimf1_blockbytes)&ctimf1_bytemask;
  if( ((ctimf1p_pa-ctimf1p_px+ctimf1_bytes)&ctimf1_bytemask) < 
                                                        ctimf1_blockbytes)
    {
    newdat_flag&=-1-ND_TIMF1;
    }
  if(((ctimf1p_px-ctimf1p_pa+ctimf1_bytes)&ctimf1_bytemask)>=ctimf1_blockbytes)
    {
    fullbuf_flag&=-1-ND_TIMF1;
    }

  }
else 
  {
// *******************************************************
// *******************************************************  
// Do not use approximate real to complex conversion.
// Indata is already complex or we use real to complex fft algorithm
// **************************************************************
  if(  (ui.input_mode&IQ_DATA) == 0)
    {
    if(ui.rx_channels==1)
      {
      fft1_reherm_dit_one();
      }
    else  
      {
      fft1_reherm_dit_two();
      }
    }
  else 
    {
    if(ui.rx_channels==1)
      {
      fft1_complex_one();
// In direct conversion mode it is not possible to get perfect amplitude
// and phase relations between the two channels in the analog circuitry.
// As a result the signal has a mirror image that can be expected in the
// -40dB region for 1% analog filter components.
// The image is removed by the below section that orthogonalises the
// signal and it's mirror using data obtained in a hardware calibration
// process.
      pc=fft1_pa/2;
      m=fft1_first_sym_point;
      if(m==0)m=1;
      ib=pc+m;
      ic=pc+fft1_size-m;
      id=fft1_size-m;
      k=fft1_size/2;
      if(fft1_direction > 0)
        {
        for(ia=m; ia < k; ia++)
          {
          t1=   fft1_float[2*ib  ] * fft1_foldcorr[2*ia  ] 
              - fft1_float[2*ib+1] * fft1_foldcorr[2*ia+1];
          t2=   fft1_float[2*ib  ] * fft1_foldcorr[2*ia+1]
              + fft1_float[2*ib+1] * fft1_foldcorr[2*ia  ];
          fft1_float[2*ib  ] -=   fft1_float[2*ic  ] * fft1_foldcorr[2*id  ] 
                                + fft1_float[2*ic+1] * fft1_foldcorr[2*id+1];
          fft1_float[2*ib+1] -=   fft1_float[2*ic  ] * fft1_foldcorr[2*id+1] 
                                - fft1_float[2*ic+1] * fft1_foldcorr[2*id  ];
          fft1_float[2*ic  ]-=t1;
          fft1_float[2*ic+1]+=t2;
          ib++;
          id--;
          ic--;
          }
        }
      else        
        {
        for(ia=m; ia < k; ia++)
          {
          t1= fft1_float[2*ic  ] -
              fft1_float[2*ib  ] * fft1_foldcorr[2*ia  ] +
              fft1_float[2*ib+1] * fft1_foldcorr[2*ia+1];
          t2= fft1_float[2*ic+1] +
              fft1_float[2*ib  ] * fft1_foldcorr[2*ia+1] +
              fft1_float[2*ib+1] * fft1_foldcorr[2*ia  ];
          t3= fft1_float[2*ib  ] -
              fft1_float[2*ic  ] * fft1_foldcorr[2*id  ] - 
              fft1_float[2*ic+1] * fft1_foldcorr[2*id+1];
          t4= fft1_float[2*ib+1] -
              fft1_float[2*ic  ] * fft1_foldcorr[2*id+1] +
              fft1_float[2*ic+1] * fft1_foldcorr[2*id  ];
          fft1_float[2*ib+1]=t1;
          fft1_float[2*ib  ]=t2;
          fft1_float[2*ic+1]=t3;
          fft1_float[2*ic  ]=t4;
          ib++;
          id--;
          ic--;
          }
        }
      }
    else
      {
      fft1_complex_two();
// In direct conversion mode it is not possible to get perfect amplitude
// and phase relations between the two channels in the analog circuitry.
// As a result the signal has a mirror image that can be expected in the
// -40dB region for 1% analog filter components.
// The image is removed by the below section that orthogonalises the
// signal and it's mirror using data obtained in a hardware calibration
// process.
      pc=fft1_pa/4;
      m=fft1_first_sym_point;
      if(m==0)m=1;
      ib=pc+m;
      ic=pc+fft1_size-m;
      id=fft1_size-m;
      k=fft1_size/2;
      if(fft1_direction > 0)
        {
        for(ia=m; ia < k; ia++)
          {
          t1=   fft1_float[4*ib  ] * fft1_foldcorr[4*ia  ] 
              - fft1_float[4*ib+1] * fft1_foldcorr[4*ia+1];
          t2=   fft1_float[4*ib  ] * fft1_foldcorr[4*ia+1]
              + fft1_float[4*ib+1] * fft1_foldcorr[4*ia  ];
          fft1_float[4*ib  ] -=   fft1_float[4*ic  ] * fft1_foldcorr[4*id  ] 
                                + fft1_float[4*ic+1] * fft1_foldcorr[4*id+1];
          fft1_float[4*ib+1] -=   fft1_float[4*ic  ] * fft1_foldcorr[4*id+1] 
                                - fft1_float[4*ic+1] * fft1_foldcorr[4*id  ];
          fft1_float[4*ic  ]-=t1;
          fft1_float[4*ic+1]+=t2;
          t1=   fft1_float[4*ib+2] * fft1_foldcorr[4*ia+2] 
              - fft1_float[4*ib+3] * fft1_foldcorr[4*ia+3];
          t2=   fft1_float[4*ib+2] * fft1_foldcorr[4*ia+3]
              + fft1_float[4*ib+3] * fft1_foldcorr[4*ia+2];
          fft1_float[4*ib+2] -=   fft1_float[4*ic+2] * fft1_foldcorr[4*id+2] 
                                + fft1_float[4*ic+3] * fft1_foldcorr[4*id+3];
          fft1_float[4*ib+3] -=   fft1_float[4*ic+2] * fft1_foldcorr[4*id+3] 
                                - fft1_float[4*ic+3] * fft1_foldcorr[4*id+2];
          fft1_float[4*ic+2]-=t1;
          fft1_float[4*ic+3]+=t2;
          ib++;
          id--;
          ic--;
          }
        }
      else
        {
        for(ia=m; ia < k; ia++)
          {
          t1= fft1_float[4*ic  ] -
              fft1_float[4*ib  ] * fft1_foldcorr[4*ia  ] +
              fft1_float[4*ib+1] * fft1_foldcorr[4*ia+1];
          t2= fft1_float[4*ic+1] +
              fft1_float[4*ib  ] * fft1_foldcorr[4*ia+1] +
              fft1_float[4*ib+1] * fft1_foldcorr[4*ia  ];
          t3= fft1_float[4*ib  ] -
              fft1_float[4*ic  ] * fft1_foldcorr[4*id  ] - 
              fft1_float[4*ic+1] * fft1_foldcorr[4*id+1];
          t4= fft1_float[4*ib+1] -
              fft1_float[4*ic  ] * fft1_foldcorr[4*id+1] +
              fft1_float[4*ic+1] * fft1_foldcorr[4*id  ];
          fft1_float[4*ib+1]=t1;
          fft1_float[4*ib  ]=t2;
          fft1_float[4*ic+1]=t3;
          fft1_float[4*ic  ]=t4;
          t1= fft1_float[4*ic+2] -
              fft1_float[4*ib+2] * fft1_foldcorr[4*ia+2] +
              fft1_float[4*ib+3] * fft1_foldcorr[4*ia+3];
          t2= fft1_float[4*ic+3] +
              fft1_float[4*ib+2] * fft1_foldcorr[4*ia+3] +
              fft1_float[4*ib+3] * fft1_foldcorr[4*ia+2];
          t3= fft1_float[4*ib+2] -
              fft1_float[4*ic+2] * fft1_foldcorr[4*id+2] - 
              fft1_float[4*ic+3] * fft1_foldcorr[4*id+3];
          t4= fft1_float[4*ib+3] -
              fft1_float[4*ic+2] * fft1_foldcorr[4*id+3] +
              fft1_float[4*ic+3] * fft1_foldcorr[4*id+2];
          fft1_float[4*ib+3]=t1;
          fft1_float[4*ib+2]=t2;
          fft1_float[4*ic+3]=t3;
          fft1_float[4*ic+2]=t4;
          ib++;
          id--;
          ic--;
          }
        }
      }
    }
  timf1p_px=(timf1p_px+timf1_blockbytes)&timf1_bytemask;
  if( ((timf1p_pa-timf1p_px+timf1_bytes)&timf1_bytemask) < timf1_blockbytes)
    {
    newdat_flag&=-1-ND_TIMF1;
    }
  if( ((timf1p_px-timf1p_pa+timf1_bytes)&timf1_bytemask) >= ad_bufmargin)
    {
    fullbuf_flag&=-1-ND_TIMF1;
    }
  }
if(network_flag == 1)
  {
  if(network_modeno == 2)
    {
    i=0;
    if(fg.passband_center != old_passband_center)i=-1;
    write(network_sockfd, &i, sizeof(int));
    if(i != 0)
      {
      write(network_sockfd,&fg.passband_center,sizeof(double));
      write(network_sockfd,&fg.passband_direction,sizeof(int));
      old_passband_center=fg.passband_center;
      }
    write(network_sockfd, &fft1_float[fft1_pa], fft1_block*sizeof(float));
    }
  }  
fft1_pa=(fft1_pa+fft1_block)&fft1_mask;  
fft1_na=fft1_pa/fft1_block;
if( ((fft1_px-fft1_pa+fft1_block)&fft1_mask) < 2*fft1_block)
  {
  fullbuf_flag |= ND_FFT1;
  }
if(fft1_nm != fft1n_mask)fft1_nm++;
}

void fft1_c(void)
{
int ia, ib, ic, pa, ix;
float *pwr;
TWOCHAN_POWER_FLOAT *pxy;
float t1,t2;
// The total filter chain of the hardware, including the IIR filter of
// the approximate real to complex conversion if used is normally not
// very flat, nor has it a good pulse response.
// Add one extra filter here so the total filter response becomes what
// the user has asked for.
// At the same time the data becomes normalised to an amplitude that
// is independent of the processes up to this point.
// Normalisation is for the noise floor to be around 0dB in the
// full dynamic range graph. 
// To save memory accesses, calculate fft1_sumsq at the same time.
// In case AFC is run from fft1 we are probably using a slow 
// computer and large fft1 sizes. Then summed powers are
// calculated elsewhere.
pa=fft1_nb*fft1_block;
ix=fft1_last_point;
ic=fft1_sumsq_pa+fft1_first_point;
if(fft1afc_flag <= 0)
  {
// We want fft1_sumsq to contain summed power spectra calculated from fft1
// over wg.fft_avg1num individual spectra.
  if(fft1_sumsq_counter == 0)
    {
    if(sw_onechan)
      {
      ib=pa/2+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
           fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                           fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib]=t1;
        fft1_sumsq[ic]=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
        ib++;
        ic++;
        }
      }  
    else
      {
      ib=pa/4+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
           fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                           fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib  ]=t1;
        t1=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];
        t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
           fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                           fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+2]=t2;
        fft1_sumsq[ic]=t1+t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
        ib++;
        ic++;
        }
      }    
    }
  else
    {
    if(sw_onechan)
      {
      ib=pa/2+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
           fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                           fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib]=t1;
        fft1_sumsq[ic]+=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
        ib++;
        ic++;
        }
      }  
    else
      {
      ib=pa/4+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
           fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                           fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib  ]=t1;
        t1=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];               
        t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
           fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                           fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+2]=t2;
        fft1_sumsq[ic]+=t1+t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
        ib++;
        ic++;
        }
      }    
    }
  }    
else
  {
// This code is executed to make the last step of fft1 in case
// fft2 is not selected and AFC is in use.
  if(no_of_spurs > 0)  
    {
    if(sw_onechan)
      {
      ib=pa/2+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
           fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                           fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib]=t1;
        ib++;
        }
      }  
    else
      {
      ib=pa/4+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
           fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                           fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib  ]=t1;
        t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
           fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                           fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+2]=t2;
        ib++;
        }
      }    
    fftx_na=fft1_nb;
    eliminate_spurs();
    if(fft1_sumsq_counter == 0)
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pwr[ia]=fft1_float[2*ib]*fft1_float[2*ib]+
                  fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]=pwr[ia];
          ib++;
          ic++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pxy[ia].x2=fft1_float[4*ib  ]*fft1_float[4*ib  ]+
                     fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=fft1_float[4*ib+2]*fft1_float[4*ib+2]+
                     fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-fft1_float[4*ib  ]*fft1_float[4*ib+3]+
                         fft1_float[4*ib+2]*fft1_float[4*ib+1];
          pxy[ia].re_xy= fft1_float[4*ib  ]*fft1_float[4*ib+2]+
                         fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    else
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pwr[ia]=fft1_float[2*ib]*fft1_float[2*ib]+
                  fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]+=pwr[ia];
          ic++;
          ib++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pxy[ia].x2=fft1_float[4*ib  ]*fft1_float[4*ib  ]+
                     fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=fft1_float[4*ib+2]*fft1_float[4*ib+2]+
                     fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-fft1_float[4*ib  ]*fft1_float[4*ib+3]+
                         fft1_float[4*ib+2]*fft1_float[4*ib+1];
          pxy[ia].re_xy= fft1_float[4*ib  ]*fft1_float[4*ib+2]+
                         fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]+=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    }  
  else
    {    
    if(fft1_sumsq_counter == 0)
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
             fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                             fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib]=t1;
          pwr[ia]=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]=pwr[ia];
          ib++;
          ic++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
             fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                             fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib  ]=t1;
          t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
             fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                             fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+2]=t2;
          pxy[ia].x2=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-t1*fft1_float[4*ib+3]+t2*fft1_float[4*ib+1];
          pxy[ia].re_xy=t1*t2+fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    else
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
             fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                             fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib]=t1;
          pwr[ia]=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]+=pwr[ia];
          ic++;
          ib++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
             fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                             fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib  ]=t1;
          t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
             fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                             fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+2]=t2;
          pxy[ia].x2=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-t1*fft1_float[4*ib+3]+t2*fft1_float[4*ib+1];
          pxy[ia].re_xy=t1*t2+fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]+=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    }
  }
fft1_sumsq_counter++;
if(fft1_sumsq_counter >= wg.fft_avg1num)
  {
  fft1_sumsq_counter=0;
// We have a new average power spectrum.
// In case the second fft is enabled we have to set up information
// for the selective limiter.
  if(genparm[SECOND_FFT_ENABLE] != 0)
    {
    fft1_update_liminfo();
    }
  fft1_sumsq_pa=(fft1_sumsq_pa+fft1_size)&fft1_sumsq_mask;   
  }
fft1_nb=(fft1_nb+1)&fft1n_mask;
fft1_pb=fft1_nb*fft1_block;
if(genparm[SECOND_FFT_ENABLE] == 0)ag_pa=(ag_pa+1)&ag_mask;  
newdat_flag|=ND_FFT1;
fullbuf_flag&=-1-ND_FFT1;
}








void set_fft1_endpoints(void)
{
// Set all pointers for a non-inverted spectrum.
wg_first_point=wg.first_xpoint;
wg_last_point=wg.first_xpoint+wg.xpoints-1;
fft1_first_point=0;
fft1_last_point=fft1_size-1;
fft1_first_inband=fft1_first_point;
fft1_last_inband=fft1_last_point;
if(network_flag == 0)
  { 
  if(genparm[SECOND_FFT_ENABLE] == 0)
    {
// In case second fft is not enabled, there is no reason to calculate
// the spectrum outside the range that we use on the display.
    fft1_first_point=wg_first_point;
    fft1_last_point=wg_last_point;
    }
  else
    {
    while(fft1_desired[fft1_first_point]==0 && 
                            fft1_first_point<fft1_size-1)fft1_first_point++;
    fft1_first_inband=fft1_first_point;
    while(fft1_desired[fft1_first_inband]<0.5 && 
                          fft1_first_inband<fft1_size-1) fft1_first_inband++;
    while(fft1_desired[fft1_last_point]==0 && 
                                      fft1_last_point > 0)fft1_last_point--;
    fft1_last_inband=fft1_last_point;
    while(fft1_desired[fft1_last_inband]<0.5 && 
                           fft1_last_inband > 0) fft1_last_inband--;
    if(fft1_last_point-fft1_first_point<fft1_size/16)end_program(1057);
    if(fft1_last_inband-fft1_first_inband<fft1_size/32)end_program(1057);
    }
  }  
fft1_sumsq_recalc=fft1_first_point;
fft1_first_sym_point=fft1_size-1-fft1_last_point;
if(fft1_first_sym_point > fft1_first_point) 
                                     fft1_first_sym_point=fft1_first_point;
fft1_last_sym_point=fft1_size-1-fft1_first_sym_point;
}

void make_filcorrstart(void)
{
fft1_filtercorr_start=150*fft1_size*pow((float)(fft1_size),-0.4);
if( (ui.input_mode&DWORD_INPUT) != 0)
  {
  fft1_filtercorr_start*=4096;
  if( fft_cntrl[FFT1_CURMODE].permute == 2)fft1_filtercorr_start*=16;
  if( (ui.input_mode&IQ_DATA) != 0)
    {
    fft1_filtercorr_start*=12;
    }
  }
fft1_filtercorr_start=genparm[FIRST_FFT_GAIN]/fft1_filtercorr_start;
}

void clear_fft1_filtercorr(void)
{
int i, j, mm;
settextcolor(8);
for(i=3; i<20; i++)xytext(40,i,"FILTERS NOT CALIBRATED!!");
fft1_filtercorr_flag=0;
make_filcorrstart();
settextcolor(7);
mm=twice_rxchan;
for(i=0; i<fft1_size; i++)
  {
  fft1_desired[i]=1;
  for(j=0; j<mm; j+=2)  
    {
    fft1_filtercorr[mm*i+j  ]=fft1_filtercorr_start;
    fft1_filtercorr[mm*i+j+1]=0;
    }
  }  
}

void expand_fft1_filtercorr(int cal_n, int cal_size)
{
int i, j, k, m, mm;
float t1,t2;
COSIN_TABLE *small_ffttab, *big_ffttab; 
short int *small_permute,*big_permute;
// FFT size is increased.
// Get the fourier transform with the old number of points.
// Increase the number of points and fill zeroes at high frequencies 
// in the transform.
// Then take the back transform to get function in fft1_size points.    
mm=twice_rxchan;
small_ffttab=chk_malloc(cal_size*sizeof(COSIN_TABLE )/2,1055);
small_permute=chk_malloc(cal_size*sizeof(short int),1055);
big_ffttab=chk_malloc(fft1_size*sizeof(COSIN_TABLE )/2,1055);
big_permute=chk_malloc(fft1_size*sizeof(short int),1055);
init_fft(0,fft1_n, fft1_size, big_ffttab, big_permute);
init_fft(0,cal_n, cal_size, small_ffttab, small_permute);
for(j=0; j<mm; j+=2)
  {
  for(i=0; i<cal_size; i++)
    {
    fft1_tmp[2*i  ]=fft1_filtercorr[mm*i+j  ];
    fft1_tmp[2*i+1]=fft1_filtercorr[mm*i+j+1];
    }
  fftback(cal_size, cal_n, fft1_tmp, small_ffttab, small_permute);
  for(i=cal_size/2; i<cal_size; i++)
    {
    k=i+fft1_size-cal_size;
    fft1_tmp[2*k  ]=fft1_tmp[2*i  ];
    fft1_tmp[2*k+1]=fft1_tmp[2*i+1];
    }
  for(i=cal_size/2; i<fft1_size-cal_size/2; i++)
    {
    fft1_tmp[2*i  ]=0;
    fft1_tmp[2*i+1]=0;
    }
  fftforward(fft1_size, fft1_n, fft1_tmp, big_ffttab, big_permute);
  m=fft1_size>>(fft1_n-cal_n-1);
  for(i=0; i<fft1_size; i++)
    {
    fft1_filtercorr[mm*i+j  ]=fft1_tmp[2*i]/m;
    fft1_filtercorr[mm*i+j+1]=fft1_tmp[2*i+1]/m;
    }
  }
m=fft1_size/cal_size;    
for(j=cal_size-1; j>0; j--)
  {
  t1=fft1_desired[j];
  t2=fft1_desired[j-1];
  for(i=0; i<m; i++)
    {
    fft1_desired[m*j-i]=t1+i*(t2-t1)/m;
    }
  }
fft1_desired[0]=0;
free(small_ffttab);
free(small_permute);
free(big_ffttab);
free(big_permute);
}


void init_fft1_filtercorr(void)
{
COSIN_TABLE *big_ffttab; 
short int *big_permute;
int rdbuf[10],chkbuf[10];
int i, j, k, m, mm;
int mask, ia, ib;
float t1,t2;
FILE *file;
char s[80];
double sum[4],isum[4];
fft1_filtercorr_direction=1;
fft1_filtercorr_flag=1;
mm=twice_rxchan;
make_filfunc_filename(s);
if(disksave_flag == 2 && (save_init_flag&1) == 1)
  {
  file=save_file;
  }
else
  {
  file = fopen(s, "rb");
  }
if (file == NULL)
  {
  clear_fft1_filtercorr();
  }
else
  {
  fread(rdbuf, sizeof(int),10,file);
  if( rdbuf[2] <0 ||
      rdbuf[2] >= MAX_RX_MODE ||
      (rdbuf[3]&IQ_DATA) != (ui.input_mode&IQ_DATA) ||
      rdbuf[5] != ui.input_speed ||
      rdbuf[6] != ui.rx_channels ||
      rdbuf[8] != 0 ||
      rdbuf[9] != 0 ) 
    {
    if(disksave_flag == 2 && (save_init_flag&1) == 1)end_program(1059);
    clear_fft1_filtercorr();
    }
  else
    {
    if(rdbuf[7] == 0)
      {
// The filtercorr function is saved in the frequency domain
// This format is used during the initialisation procedures and
// it may be kept for normal operation in case the number of points
// will not be reduced by saving in the time domain.  
      if(rdbuf[1] < fft1_size)
        {
        fread(fft1_filtercorr, mm*sizeof(float),rdbuf[1], file);
        fread(fft1_desired, sizeof(float),rdbuf[1], file);
        if(10 != fread(chkbuf, sizeof(int),10,file))goto exx;
        for(i=0; i<10; i++)
          {
          if(rdbuf[i]!=chkbuf[i])goto exx;
          }
        expand_fft1_filtercorr(rdbuf[0], rdbuf[1]);
        }
      else
        {
        m=1<<(rdbuf[0]-fft1_n);
        for(i=0; i<fft1_size; i++)
          {  
          fread(fft1_float, mm*sizeof(float),m, file);
          for(j=0; j<mm; j++)fft1_filtercorr[mm*i+j]=fft1_float[j];
          }  
        for(i=0; i<fft1_size; i++)
          {  
          fread(fft1_float, sizeof(float),m, file);
          fft1_desired[i]=fft1_float[0];
          }  
        if(10 != fread(chkbuf, sizeof(int),10,file))goto exx;
        for(i=0; i<10; i++)
          {
          if(rdbuf[i]!=chkbuf[i])goto exx;
          }
        }
      }
    else
      {
// The correction function was stored in the time domain in rdbuf[7] points
      mm=twice_rxchan;
      if( fft1_size < rdbuf[7])
        {
// We have to reduce the number of points.
        fread(fft1_filtercorr, mm*sizeof(float),fft1_size/2, file);
        for(m=0; m<rdbuf[7]-fft1_size; m++)
                                 fread(&fft1_filtercorr[mm*fft1_size/2], 
                                                    mm*sizeof(float),1, file);
        fread(&fft1_filtercorr[mm*fft1_size/2], 
                                          mm*sizeof(float),fft1_size/2, file);
// When limiting the pulse response in the time domain, we may
// introduce a discontinuity. It will occur between fft1_size/2 and
// fft1/size/2-1.
// Differentiate the pulse response starting at the discontinuity:
        mask=fft1_size-1;
        ia=fft1_size/2;
        ib=ia+1;
        for(i=1; i<fft1_size; i++)
          {
          for(j=0; j<mm; j++)
            {
            fft1_filtercorr[ia*mm+j] = fft1_filtercorr[ia*mm+j]
                                      -fft1_filtercorr[ib*mm+j];
            }
          ia=(ia+1)&mask;
          ib=(ib+1)&mask;
          }  
        for(j=0;j<mm; j++)
          {
          fft1_filtercorr[ia*mm+j]=0;
          sum[j]=0;
          }
// Get the DC component so we can remove it from the derivative
        for(i=0; i<fft1_size; i++)
          {
          for(j=0;j<mm; j++)
            {
            sum[j]+=fft1_filtercorr[i*mm+j];
            }
          }
        for(j=0;j<mm; j++)
          {
          sum[j]/=fft1_size;
          isum[j]=0;
          }
// Integrate the pulse response:
        for(i=0; i<fft1_size; i++)
          {
          for(j=0; j<mm; j++)
            {
            isum[j]+=fft1_filtercorr[ia*mm+j]-sum[j];
            fft1_filtercorr[ia*mm+j]=isum[j];
            }
          ia=(ia+mask)&mask;
          }  
        m=rdbuf[7]/fft1_size;
        i=0;
rrd:;
        for(j=0; j<m/2; j++)fread(&fft1_desired[i], sizeof(float),1, file);
        i++;
        if(i >= fft1_size)
          {
          for(j=m/2; j<m; j++)fread(chkbuf, sizeof(float),1, file);
          goto rrdx;
          }
        for(j=m/2; j<m; j++)fread(&fft1_desired[i], sizeof(float),1, file);
        goto rrd;
rrdx:;         
        }
      else
        {
        
        fread(fft1_filtercorr, mm*sizeof(float),rdbuf[7], file);
        fread(fft1_desired, sizeof(float),rdbuf[7], file);
        }
      if(10 != fread(chkbuf, sizeof(int),10,file))
        {
exx:;          
        if(disksave_flag==2)end_program(1059); else end_program(1052);
        }
      for(i=0; i<10; i++)
        {
        if(rdbuf[i]!=chkbuf[i])goto exx;
        }
      big_ffttab=chk_malloc(fft1_size*sizeof(COSIN_TABLE )/2,1055);
      big_permute=chk_malloc(fft1_size*sizeof(short int),1055);
      init_fft(0,fft1_n, fft1_size, big_ffttab, big_permute);
      if(fft1_size > rdbuf[7])
        {
// size is increased.
// We have the fourier transform with rdbuf[7] points.
// Increase the number of points and fill zeroes at high frequencies 
// in the transform.
        for(i=rdbuf[7]/2; i<rdbuf[7]; i++)
          {
          k=i+fft1_size-rdbuf[7];
          for(j=0; j<mm; j++)
            {
            fft1_filtercorr[mm*k+j]=fft1_filtercorr[mm*i+j];
            }
          } 
        for(i=rdbuf[7]/2; i<fft1_size-rdbuf[7]/2; i++)
          {
          for(j=0; j<mm; j++)
            {
            fft1_filtercorr[mm*i+j]=0;
            }
          } 
        m=fft1_size/rdbuf[7];    
        for(j=rdbuf[7]-1; j>0; j--)
          {
          t1=fft1_desired[j];
          t2=fft1_desired[j-1];
          for(i=0; i<m; i++)
            {
            fft1_desired[m*j-i]=t1+i*(t2-t1)/m;
            }
          }
        fft1_desired[0]=0;
        } 
// Take the back transform to get function in fft1_size points
// in the frequency domain.    
      for(j=0; j<mm; j+=2)
        {
        for(i=0; i<fft1_size; i++)
          {
          fft1_tmp[2*i  ]=fft1_filtercorr[mm*i+j  ];
          fft1_tmp[2*i+1]=fft1_filtercorr[mm*i+j+1];
          }
        fftback(fft1_size, fft1_n, fft1_tmp, big_ffttab, big_permute);
        for(i=0; i<fft1_size; i++)
          {
          if(fft1_desired[i] != 0)
            {
            fft1_filtercorr[mm*i+j  ]=fft1_tmp[2*i  ];
            fft1_filtercorr[mm*i+j+1]=fft1_tmp[2*i+1];
            }
          else 
            {
            fft1_filtercorr[mm*i+j  ]=0;
            fft1_filtercorr[mm*i+j+1]=0;
            }
          }
        }
      free(big_ffttab);
      free(big_permute);
      normalise_fft1_filtercorr(fft1_filtercorr);
      }
    if(disksave_flag != 2 || (save_init_flag&1) == 0)
      {
      fclose(file);
      }
    make_filcorrstart();    
    for(i=0; i<twice_rxchan*fft1_size; i++)
      {
      fft1_filtercorr[i]*=fft1_filtercorr_start;
      } 
    }
  }
}


void test_init(void)
{
int i;
open_audio_input();
get_buffers(0);
if(lir_status != LIR_OK)return;
wg.fft_avg1num=5;
wg_fft_avg2num=3;
fft1_sumsq_pws=-1;
if(fft1afc_flag == 0)fft1afc_flag=-1;
wg.first_xpoint=0;
wg.xpoints=fft1_size;
if(rx_mode != MODE_TUNE)
  {
  for(i=0; i<fft1_size; i++)
    {
    fft1_desired[i]=1;
    }
  }
set_fft1_endpoints();
fflush(NULL);
sync();
settextcolor(7);
return;
}

void check_fft1(void)
{
struct timeval tim1,tim2;
double fft1_time,idle_time;
char s[80];
float t1,t3;
int traces;
audio_buf_info ad_info;
//Now that the user made his decisions, find out what it means.
//Allocate buffers and pointers as if we will start normal operation.
t3=0;
test_init();
if(lir_status != LIR_OK) return;
vga_clear();
sprintf(s,"input DMA rate %d Hz. MODE %d",
               bytes_per_fragment*ui.input_speed/ad_read_bytes, ui.input_mode);
xytext(1,3,s);
if( (ui.input_mode&DWORD_INPUT) == 0)
  {
  xytext(40,3,"16bit");
  }
else
  {  
  xytext(40,3,"24bit");
  }
if(mmx_present)xytext(50,3,"MMX present"); else xytext(50,3,"no MMX");
if(simd_present)xytext(50,4,"SIMD present"); else xytext(50,4,"no SIMD");
sprintf(s,"First fft size %d.  Increment %d",fft1_size,fft1_new_points);
xytext(1,4,s);
t1=(float)(fft1_size)/fft1_new_points;
sprintf(s,"Sample use factor %3.3f",t1);
xytext(1,5,s);
sprintf(s,"First fft window is sin to power %d.  Bandwidth=%4.2fHz ",
                                   genparm[FIRST_FFT_SINPOW],fft1_bandwidth);
xytext(1,6,s);
sprintf(s,"First fft buffer %d kilobytes",fft1_bytes/1000);
xytext(1,7,s);
sprintf(s,"Timing for %s no %d: %s",genparm_text[FIRST_FFT_VERNR],
                    genparm[FIRST_FFT_VERNR], fft_cntrl[FFT1_CURMODE].text);
xytext(1,8,s);
traces=0;
xytext(1,16,"Accept settings ? (Y/N)");
settextcolor(15);
fft1_time=idle_time=0;
gettimeofday(&tim2,NULL);
make_fft1(0);
press:;
vga_inkey=vga_getkey();
clean_vga_inkey();
if(vga_inkey == 'Y' || vga_inkey == 10) goto exx;  
wait:;
if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(1076);
if(ad_info.bytes<ad_read_bytes)
  {
  goto wait;
  }
gettimeofday(&tim1,NULL);
idle_time+=0.000001*(tim1.tv_usec-tim2.tv_usec)+(tim1.tv_sec-tim2.tv_sec);
make_fft1(0);  
gettimeofday(&tim2,NULL);
fft1_time+=0.000001*(tim2.tv_usec-tim1.tv_usec)+(tim2.tv_sec-tim1.tv_sec);
if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(1090);
traces++;
if(traces%10 == 9 || ad_info.fragments >= overrun_limit)
  {
  sprintf(s,"FFT:%2.2f%%     N%d     Buffer:(%d/%d)  ",
                         100*fft1_time/(fft1_time+idle_time),
                           traces, ad_info.fragments, ad_info.fragstotal);
  xytext(1,13,s);
  if(ad_info.fragments >= overrun_limit)
    {
    xytext(1,14,"Speed far too slow. Try less demanding FFT!");
    settextcolor(7);
    xytext(1,15,"Press any key");
    await_keyboard();
    goto exx1;
    }
  }
if(vga_inkey != 'N')goto press;
exx1:;
lir_status=LIR_SPEEDERR;
exx:;
close_audio_output();
close_audio_input();
free_buffers();
}

void clear_iq_foldcorr(void)
{
int i;
for(i=0; i<twice_rxchan*fft1_size; i++)fft1_foldcorr[i]=0;
settextcolor(8);
for(i=3; i<20; i++)xytext(10,i,"I/Q PHASE NOT CALIBRATED!!");
fft1_calibrate_flag&=1;
settextcolor(7);
bal_updflag=1;
}

void init_foldcorr(void)
{
int rdbuf[10],chkbuf[10];
int ia, i, j, k;
FILE *file;
float t1,t2;
char s[80];
if(  (ui.input_mode&IQ_DATA) == 0)
  {
  if( FOLDCORR_START_SIZE == fft1_size/2)
    {
    for(i=0; i<fft1_size/2; i++)
      {
      fft1_foldcorr[2*i  ]=foldcorr_y1[i];
      fft1_foldcorr[2*i+1]=foldcorr_y2[i];
      }
    }
  else
    {
    if( FOLDCORR_START_SIZE > fft1_size/2)
      {
      k=2*FOLDCORR_START_SIZE/fft1_size;
      j=0;
      for(i=0; i<fft1_size/2; i++)
        {
        fft1_foldcorr[2*i  ]=foldcorr_y1[j];
        fft1_foldcorr[2*i+1]=foldcorr_y2[j];
        j+=k;
        }
      }
    else
      {
// We need to interpolate.
// The foldcorr data is not very accurate anyway so a linear interpolation
// will be enough for the time being.
      k=fft1_size/(2*FOLDCORR_START_SIZE);
      ia=0;
      for(i=1; i<FOLDCORR_START_SIZE; i++)
        {
        fft1_foldcorr[2*ia  ]=foldcorr_y1[i-1];
        fft1_foldcorr[2*ia+1]=foldcorr_y2[i-1];
        t1=(foldcorr_y1[i]-foldcorr_y1[i-1])/k;
        t2=(foldcorr_y2[i]-foldcorr_y2[i-1])/k;
        for(j=1; j<k; j++)
          {
          fft1_foldcorr[2*(ia+j)  ]=fft1_foldcorr[2*(ia+j-1)  ]+t1;          
          fft1_foldcorr[2*(ia+j)+1]=fft1_foldcorr[2*(ia+j-1)+1]+t2;
          }          
        ia+=k;
        }
      }
    }          
  }
else
  {
  if(disksave_flag == 2 && (save_init_flag&2) == 2)
    {
    file=save_file;
    }
  else
    {
    make_iqcorr_filename(s);
    file = fopen(s, "rb");
    }
  if (file == NULL)
    {
    clear_iq_foldcorr();
    }
  else
    {
    fread(rdbuf, sizeof(int),10,file);
    if( rdbuf[1] != (ui.input_mode&IQ_DATA) ||
        rdbuf[2] != ui.input_speed ||
        rdbuf[3] != ui.rx_channels ||
        rdbuf[4] != FOLDCORR_VERNR )
      {
      if(disksave_flag == 2 && (save_init_flag&2) == 2)end_program(1060);
      clear_iq_foldcorr();
      }
    else  
      {  
      bal_segments=rdbuf[0];
      contracted_iq_foldcorr=fft1_float;
// Note that the file is too large by a factor of 4.
// We better keep compatibility with old code..............
      fread(contracted_iq_foldcorr, twice_rxchan*sizeof(float),
                                                      4*bal_segments, file);  

      if(10 != fread(chkbuf, sizeof(int),10,file))end_program(1053);
      for(i=0; i<10; i++)
        {
        if(rdbuf[i]!=chkbuf[i])end_program(1053);
        }
      if(disksave_flag != 2 || (save_init_flag&2) == 0)fclose(file);
      cal_table=chk_malloc(fft1_size*sizeof(COSIN_TABLE )/2,1110);
      cal_permute=chk_malloc(fft1_size*sizeof(short int),1110);
      init_fft(0,fft1_n, fft1_size, cal_table, cal_permute);
      expand_foldcorr(fft1_foldcorr);
      free(cal_table);
      free(cal_permute);
      }
    }
  }
}


