
#define FFT1_CURMODE fft1_version[fft1mode][genparm[FIRST_FFT_VERNR]]
#define FFT1_BCKCURMODE fft1_back_version[ui.rx_channels-1][genparm[FIRST_BCKFFT_VERNR]]

// Buffer pointers for the fft1 buffer.
// They all point to the same memory location but we change
// the data format during processing so it is convenient to have 
// different pointers defined, one for each type.

#include <sys/time.h>

extern struct timeval ad_tim;
extern double ad_block_counter;
extern double diskread_block_counter;
extern double ad_block_check;

extern int interrupt_rate;
extern char *fft1_handle;
extern COSIN_TABLE *fft1tab;
extern COSIN_TABLE *fft1_backtab;
extern unsigned short int *fft1_permute;
extern float *fft1_window;
extern float *fft1_sumsq;
extern float *fft1_slowsum;
extern float *fft1_power;
extern float *fft1_powersum;
extern TWOCHAN_POWER_FLOAT *fft1_xypower;
extern TWOCHAN_POWER_FLOAT *fft1_xysum;
extern float *fft1_tmp;
extern char  *fft1_char;
extern short int *fft1_short_int;
extern int   *fft1_int;
extern float *fft1_float;
extern float *fft1_foldcorr;
extern short int *fft1_spectrum;
extern float *fft1_filtercorr;
extern float *buf0,*buf1,*buf2,*buf3,*buf4,*buf5,*buf6,*buf7;
extern float *fft1_desired;
extern int *ctimf1;
extern float *liminfo;
extern unsigned char *liminfo_wait; 
extern float *liminfo_group_min;
extern short int *fft1_split;
extern MMX_COSIN_TABLE *fft1_mmxcosin;
extern float *fft1_inverted_window;
extern short int *fft1_inverted_mmxwin;
extern short int *fft1_back_scramble;
extern short int *fft1_backbuffer;
extern short int *wg_waterf;
extern float *wg_waterf_yfac;
extern short int *txtest_ypeak;
extern short int *txtest_ypeak_decay;
extern short int *txtest_yavg;
extern float *txtest_power;
extern float *txtest_powersum;
extern short int *txtest_old_yavg;
extern short int *txtest_old_ypeak;
extern short int *txtest_old_ypeak_decay;
extern short int *fft1_old_spectrum;
extern float *txtest_peak_power;
extern float *txtest_peak_power_decay;
extern double wide_graph_time;


extern float fft1_bandwidth;
extern float fft1_hz_per_point;
extern float fft1_filtercorr_start;
extern int foldcorr_bytes;
void fft1_buffer_pointers(void);
void check_fft1(void);
void make_fft1(int debughelp);
void init_foldcorr(void);
void clear_iq_foldcorr(void);
void set_fft1_endpoints(void);
void normalise_fft1_filtercorr(float *xyzq);


extern int fft1_n;
extern int fft1_size;
extern int fft1_block;
extern int fft1_blockbytes;
extern int fft1_mask;  
extern int fft1_bytes;      
extern int fft1_bufmask;       
extern int fft1_pa;
extern int fft1_pb;
extern int fft1_px;
extern int fft1_na;
extern int fft1_nb;
extern int fft1_nc;
extern int fft1_nm;
extern int fft1_nx;
extern int fft1afc_flag;
extern int fft1_first_point;
extern int fft1_first_sym_point;
extern int fft1_first_sumsq_point;
extern int fft1_last_point;
extern int fft1_last_inband;
extern int fft1_first_inband;
extern int fft1_last_sym_point;
extern int fft1_last_sumsq_point;
extern int fft1back_lowgain_n;
extern int fft1_filtercorr_flag;
extern int fft1_calibrate_flag;
extern int fft1_lowlevel_points;
extern float fft1_lowlevel_fraction;
extern int ad_wts;
extern int max_fft1n;
extern int fft1n_mask;
extern float fft1_wtb;
extern float ad_wttim;
extern float fft1_wttim;  
extern float timf2_wtb;
extern float timf2_wttim;  
extern int ad_maxamp[];
extern int timf1_maxamp[];
extern int fft1_maxamp[];
extern float liminfo_amplitude_factor;
extern int fft1_sumsq_tot;
extern int fft1_direction;
extern int fft1_filtercorr_direction;
extern int wg_xpix1;

extern int fft1_sumsq_mask;
extern int fft1_sumsq_bufsize;
extern int fft1_interleave_points;
extern float fft1_interleave_ratio;
extern int fft1_new_points;
extern float fft1_blocktime;
extern float fft1_noise_floor;
extern int fft1_sumsq_counter;
extern int liminfo_groups;
extern int liminfo_group_points;



extern int ad_read_bytes;
extern int ad_read_fragments;
extern int bytes_per_fragment;
extern int ad_bufmargin;

extern int max_fft1_sumsq;
extern int fft1_sumsq_pa;
extern int fft1_sumsq_pws;
extern int fft1_sumsq_pwg;
extern int fft1_sumsq_recalc;
extern int fft1mode;

extern int ctimf1p_pa;
extern int ctimf1p_px;
extern int ctimf1_bytes;
extern int ctimf1_bytemask;
extern int ctimf1_mask;
extern int ctimf1_blockbytes;
extern int getiq_switch;

extern FILE *save_file;
extern int save_init_flag;
extern int save_rw_bytes;
extern int disksave_flag;
extern double diskread_timer;

extern int fft1_version[4][MAX_FFT1_VERNR];
extern int fft1_back_version[2][MAX_FFT1_BCKVERNR];
extern FFT_SETUP_INFO fft_cntrl[MAX_FFT_VERSIONS];

extern int timf1_bytes;
extern int timf1_bytemask;
extern int timf1_blockbytes;
extern char *timf1_char;
extern int *timf1_int;
extern short int *timf1_short_int;
extern float *timf1_float;
extern int timf1p_pa;
extern int timf1p_px;
extern float timf1_sampling_speed;





extern short int *timf2;
extern int timf2_pa;
extern int timf2_pn1;
extern int timf2_pn2;
extern int timf2p_fit;
extern int timf2_px;
extern int timf2_mask;
extern int timf2_totbytes;
extern int timf2_input_block;
extern int timf2_output_block;
extern int timf2_display_counter;
extern int timf2_display_interval;
extern int timf2_display_maxpoint;
extern int timf2_ovfl;
extern int timf2_fitted_pulses;
extern int timf2_cleared_points;
extern int timf2_blanker_points;
extern int timf2_ymin[16];
extern int timf2_ymax[16];
extern int timf2_y0[16];
extern unsigned int *timf2_pwr;
extern int timf2_hg_xmin;
extern int timf2_hg_xmax;
extern int timf2_hg_y[2];
extern int timf2_hg_yh;
extern int timf2_hg_x[2];
extern int timf2_hg_stux;
extern int timf2_hg_clex;
extern int timf2_hg_qex;
extern float timf2_hg_xfac;
extern float timf2_hg_xlog;
extern int overrun_limit;
extern int wg_last_point;
extern int wg_first_point;


extern short int *timf2pix;
extern unsigned int timf2_display_maxval;
extern unsigned int timf2_display_powermax;


extern int txtest_no_of_segs;
extern float txtest_pixinc;
extern int txtest_pntinc;
extern int txtest_first_xpix;
extern int txtest_spek_no;
extern int txtest_spek_p0;
extern int txtest_first_point;
extern int txtest_show_p0;
extern float txtest_yfac;



void simd1_16_win(void);
void simd1_16_nowin(void);
void simd1_32_win(void);
void simd1_32_nowin(void);
void real_to_complex_input(void);
void fft1_update_liminfo(void);
void compress_rawdat(void);
void expand_rawdat(void);
void fft1_approx_dif_two(void);
void fft1_approx_dif_one(void);
void fft1_approx_dit_one(void);
void fft1_approx_dit_two(void);
void fft1_reherm_dit_one(void);
void fft1_reherm_dit_two(void);
void fft1_complex_one(void);
void fft1_complex_two(void);
void update_fft1_slowsum(void);
void make_timf2(void);
void show_timf2(void);
void split_one(void);
void split_two(void);
void mmx_fft1back_two(void);
void mmx_fft1back_one(void);
void fft1back_one(void);
void fft1back_two(void);
void fft1back_fp_finish(void);
void fft1back_mmx_finish(void);
void test_rx(void);
void wcw_rx(void);
void fft1_mix1_fixed(void);
void fft1_mix1_afc(void);
void test_init(void);
void fft1_waterfall(void);
void read_rawdat(int debughelp);
void fft1_b(int debughelp);
void fft1_c(void);
void make_filfunc_filename(char *s);
void make_iqcorr_filename(char *s);
void check_fft1_timing(void);
