

#include "globdef.h"
#include "fft1def.h"

double ad_block_counter;
double diskread_block_counter;
double ad_block_check;

int interrupt_rate;
int fft1_n;             
int fft1_size;          
int fft1_block;
int fft1_blockbytes;
int fft1_interleave_points;
float fft1_interleave_ratio;
int fft1_new_points;
float fft1_blocktime;
double wide_graph_time;
int fft1_mask;  
int fft1_bytes;      
int fft1_bufmask;       
int fft1_pa;
int fft1_pb;
int fft1_px;
int fft1_na;
int fft1_nb;
int fft1_nc;
int fft1_nm;
int fft1_nx;
int fft1afc_flag;

int ad_wts;
float fft1_wtb;
float ad_wttim;
float fft1_wttim;  
float timf2_wtb;
float timf2_wttim;  

int fft1_sumsq_mask;
int fft1_sumsq_bufsize;
int fft1_sumsq_counter;
int fft1_sumsq_pa;
int fft1_sumsq_pws;
int fft1_sumsq_pwg;
int fft1mode;
int fft1_calibrate_flag;
int max_fft1_sumsq;
int input_counter;
int ad_read_bytes;
int ad_read_fragments;
int bytes_per_fragment;
int fft1_sumsq_recalc;
int ctimf1p_pa;
int ctimf1p_px;
int ctimf1_bytes;
int ctimf1_bytemask;
int ctimf1_mask;
int ctimf1_blockbytes;
int getiq_switch;
int fft1_first_point;
int fft1_first_sym_point;
int fft1_first_sumsq_point;
int fft1_last_point;
int fft1_last_inband;
int fft1_first_inband;
int fft1_last_sym_point;
int fft1_last_sumsq_point;
int fft1back_lowgain_n;
int fft1_filtercorr_flag;
int max_fft1n;
int fft1n_mask;
int fft1_sumsq_tot;
int fft1_direction;
int fft1_filtercorr_direction;
int foldcorr_bytes;
float fft1_bandwidth;
float fft1_hz_per_point;
float fft1_filtercorr_start;
int liminfo_groups;
int liminfo_group_points;
int fft1_lowlevel_points;
float fft1_lowlevel_fraction;
float liminfo_amplitude_factor;
float fft1_noise_floor;
int ad_bufmargin;
int wg_xpix1;

COSIN_TABLE *fft1tab;
COSIN_TABLE *fft1_backtab;
unsigned short int *fft1_permute;
float *fft1_window;
float *fft1_sumsq;
float *fft1_slowsum;
float *fft1_power;
float *fft1_powersum;
TWOCHAN_POWER_FLOAT *fft1_xypower;
TWOCHAN_POWER_FLOAT *fft1_xysum;
float *fft1_tmp;
float *fft1_foldcorr;
char *fft1_handle;
char  *fft1_char;
short int *fft1_short_int;
int   *fft1_int;
float *fft1_float;
short int *fft1_spectrum;
float *fft1_filtercorr;
float *buf0, *buf1,*buf2,*buf3,*buf4,*buf5,*buf6,*buf7;
float *fft1_desired;
int *ctimf1;
float *liminfo;
unsigned char *liminfo_wait; 
float *liminfo_group_min;
short int *fft1_split;
MMX_COSIN_TABLE *fft1_mmxcosin;
float *fft1_inverted_window;
short int *fft1_inverted_mmxwin;
short int *fft1_back_scramble;
short int *fft1_backbuffer;
char *timf1_char;
float *timf1_float;
int *timf1_int;
short int *timf1_short_int;
unsigned int *timf2_pwr;
short int *timf2pix;
float *wg_waterf_yfac;
short int *wg_waterf;
short int *txtest_ypeak;
short int *txtest_ypeak_decay;
short int *txtest_yavg;
float *txtest_power;
float *txtest_powersum;
short int *txtest_old_yavg;
short int *txtest_old_ypeak;
short int *fft1_old_spectrum;
short int *txtest_old_ypeak_decay;
float *txtest_peak_power;
float *txtest_peak_power_decay;
// Variables related to saving raw data on disk
int save_init_flag;
FILE *save_file;
int disksave_flag;
int save_rw_bytes;
double diskread_timer;

struct timeval ad_tim;
float timf1_sampling_speed;
int timf1_bytes;
int timf1_bytemask;
int timf1_blockbytes;
int timf1p_pa;
int timf1p_px;
short int *timf2;
int timf2_pa;
int timf2_pn1;
int timf2_pn2;
int timf2p_fit;
int timf2_px;
int timf2_mask;
int timf2_totbytes;
int timf2_input_block;
int timf2_output_block;
int timf2_display_counter;
int timf2_display_interval;
int timf2_display_maxpoint;
int timf2_ovfl;
int timf2_fitted_pulses;
int timf2_cleared_points;
int timf2_blanker_points;
int ad_maxamp[MAX_AD_CHANNELS];
int timf1_maxamp[2*MAX_RX_CHANNELS];
int fft1_maxamp[2*MAX_RX_CHANNELS];
int timf2_y0[16];
int timf2_ymax[16];
int timf2_ymin[16];
int timf2_hg_x[2];
int timf2_hg_y[2];
float timf2_hg_xfac;
float timf2_hg_xlog;
int timf2_hg_xmin;
int timf2_hg_xmax;
int timf2_hg_yh;
int timf2_hg_stux;
int timf2_hg_clex;
int timf2_hg_qex;
int overrun_limit;

unsigned int timf2_display_maxval;
unsigned int timf2_display_powermax;

int txtest_no_of_segs;
float txtest_pixinc;
int txtest_pntinc;
int txtest_first_xpix;
int txtest_spek_no;
int txtest_spek_p0;
int txtest_first_point;
int txtest_show_p0;
float txtest_yfac;

int wg_first_point;
int wg_last_point;

