


#include <vga.h>
#include <vgagl.h>
#include <unistd.h>
#include "conf.h"
#include "globdef.h"
#include "uidef.h"
#include "seldef.h"
#include "fft2def.h"
#include "fft1def.h"
#include "screendef.h"
#include "sigdef.h"

void fft2mmx_a2_nowin(void);
void fft2mmx_a2_win(void);
void fft2mmx_a1_nowin(void);
void fft2mmx_a1_win(void);
void fft2_mmx_b1hi(void);
void fft2_mmx_b2hi(void);
void fft2_mmx_b1med(void);
void fft2_mmx_b2med(void);
void fft2_mmx_b1low(void);
void fft2_mmx_b2low(void);
void fft2_mmx_c1(void);
void fft2_mmx_c2(void);


void show_bw(void)
{
char s[80];
vga_clear();
sprintf(s,"First fft size %d  (Bw=%fHz)",fft1_size,fft1_bandwidth);
xytext(1,1,s);
sprintf(s,"Second fft size %d (Bw=%fHz)",fft2_size,fft2_bandwidth);
xytext(1,2,s);
}

void check_fft2(void)
{
struct timeval tim1,tim2;
char s[80];
int i;
float t1;
double fft1_time,fft1_bcktime,fft2_time,idle_time;
audio_buf_info ad_info;
if(disksave_flag >= 2 || 
   genparm[SECOND_FFT_ENABLE] == 0 ||
   network_flag == 2)
  {
  show_bw();
  xytext(1,16,"Accept settings ? (Y/N)");
kbdinp:;
  await_keyboard();
  clean_vga_inkey();
  if(vga_inkey == 'Y' || vga_inkey == 'X' || vga_inkey == 10)return;
  if(vga_inkey == 'N')
    {
    lir_status=LIR_NEW_SETTINGS;
    return;
    }
  goto kbdinp;
  }
wg_waterf=chk_free(wg_waterf);
i=32*1024*sizeof(short int);  
wg_waterf=chk_malloc( i, 1036);
wg_waterf_y=0;
wg_waterf_y1=0;
wg_waterf_lines=-1;
test_init();
if(lir_status != LIR_OK) return;
show_bw();
sprintf(s,"Second fft window is sin to power %d",genparm[SECOND_FFT_SINPOW]);
xytext(1,3,s);
sprintf(s,"Timing for %s no %d: %s",genparm_text[FIRST_BCKFFT_VERNR],
                 genparm[FIRST_BCKFFT_VERNR], fft_cntrl[FFT1_BCKCURMODE].text);
xytext(1,6,s);
sprintf(s,"and for %s no %d: %s",genparm_text[SECOND_FFT_VERNR],
                 genparm[SECOND_FFT_VERNR], fft_cntrl[FFT2_CURMODE].text);
xytext(4,7,s);
xytext(1,16,"Accept settings ? (Y/N)");
fft1_time=fft1_bcktime=fft2_time=idle_time=0;
fflush(NULL);
sync();
gettimeofday(&tim2,NULL);
make_fft1(0);
chk2_loop:;
if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(7);
if(ad_info.fragments >= ad_info.fragstotal-1)
  {
  close_audio_input();
  overrun_count++;
  sprintf(s,"OVERRUN ERRORS %d",overrun_count);
  xytext(5,14,s);
  open_audio_input();
  }
if(ad_info.bytes>=ad_read_bytes)
  {
force_read:;  
  gettimeofday(&tim1,NULL);
  idle_time+=0.000001*(tim1.tv_usec-tim2.tv_usec)+(tim1.tv_sec-tim2.tv_sec);
  make_fft1(0);  
  gettimeofday(&tim2,NULL);
  fft1_time+=0.000001*(tim2.tv_usec-tim1.tv_usec)+(tim2.tv_sec-tim1.tv_sec);
  while(((fft1_pa-fft1_px+fft1_mask+1)&fft1_mask)>=fft1_block)
    {
    make_timf2();
    } 
  gettimeofday(&tim1,NULL);
  fft1_bcktime+=0.000001*(tim1.tv_usec-tim2.tv_usec)+(tim1.tv_sec-tim2.tv_sec);
more_fft2:;
  if( ((timf2_pa-fft2_size-timf2_px+timf2_mask)&timf2_mask) <timf2_mask/2)
    {
    if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(7);
    if(ad_info.bytes<2*ad_read_bytes)
      {
      wg_waterf_sum_counter=-1;
      if(make_fft2_status == FFT2_WATERFALL_LINE ||
         make_fft2_status == FFT2_COMPUTE_GRAPH)
                                           make_fft2_status=FFT2_TEST_FINISH;
      make_fft2();
      goto more_fft2;
      }
    }
  gettimeofday(&tim2,NULL);
  fft2_time+=0.000001*(tim2.tv_usec-tim1.tv_usec)+(tim2.tv_sec-tim1.tv_sec);
  }
t1=100/(fft1_time+fft1_bcktime+fft2_time+idle_time);
sprintf(s,
"fft1 %3.2f%%     fft1 back %3.2f%%     fft2 %3.2f%%     idle %3.2f%%",
                      fft1_time*t1,fft1_bcktime*t1,fft2_time*t1,idle_time*t1);
xytext(0,9,s);
vga_inkey=vga_getkey();
if(vga_inkey != 0)
  {
  clean_vga_inkey();
  if(vga_inkey == 0)goto force_read;
  if(vga_inkey == 'Y' || vga_inkey == 'X' || vga_inkey == 10) goto  exx;
  if(vga_inkey == 'N')
    {
    lir_status=LIR_NEW_SETTINGS;
    goto  exx;
    }
  }
idle:;
if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(7);
if(ad_info.bytes<ad_read_bytes)goto idle;
goto chk2_loop; 
exx:;
close_audio_output();
close_audio_input();
free_buffers();
}




void make_fft2(void)
{
int y, yval;
int ja, jb, jc, jd;
int i, ix, mm, iw, hgm1, hgm2;
float t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12;
float r1,r2,r3,r4,r5,r6,r7,r8,r9,r10,r11,r12;
float a1,a2,a3,a4;
float b1,b2,b3,b4;
float c1,c2,c3,c4;
float d1,d2,d3,d4;
float der;
int hg_xpix2;
int ia, ib, ic, id, itab;
int inc,j,k,n,n1,n2;
int m2, siz,siz_d4,siz_m4,siz_m2,siz_d2;
float u0,u1,u2,u3,u4,u5,u6,u7;
float w0,w1,w2,w3,w4,w5,w6,w7;
float x0,x1,x2,x3,x4,x5,x6,x7;
float y8,y9,y2,y3,y4,y5,y6,y7;
float ss1,ss2,cs1,cs2;
float *z,*fftxy, *fftab, *pwra, *pwrb, *pwrc;
TWOCHAN_POWER_FLOAT *ya, *yb;
int p0, mask;
short int *zxy;
// The second fft may be very large. To produce optimum sensitivity
// bandwidths below 1Hz may be desireable. 
// Every time this routine is called it will do just a fraction of
// the complete transform as indicated by make_fft2_status.
siz=fft2_size;
fftxy=&fft2_float[twice_rxchan*fft2_na*fft2_size];
z=(void*)(fftxy);
if(sw_onechan)
  {
  switch (make_fft2_status)
    {
    
    case FFT2_NOT_ACTIVE:
    mask=timf2_mask;
    if(FFT2_CURMODE == 15)
      {
      mask=timf2_mask;
      p0=timf2_px;
      if(genparm[SECOND_FFT_SINPOW] != 0)
        {
        for(i=0; i<siz; i++)
          {
          z[2*i  ]=fft2_window[i]*(timf2[p0  ]+timf2[p0+2]);
          z[2*i+1]=fft2_window[i]*(timf2[p0+1]+timf2[p0+3]);
          p0=(p0+4)&mask;            
          }
        }  
      else
        {
        for(i=0; i<siz; i++)
          {
          z[2*i  ]=(timf2[p0  ]+timf2[p0+2]);
          z[2*i+1]=(timf2[p0+1]+timf2[p0+3]);
          p0=(p0+4)&mask;            
          }
        }
      fftforward(siz, fft2_n, z, fft2_tab, fft2_permute);
      make_fft2_status=FFT2_ELIMINATE_SPURS;
      return;
      }
    fft2_chunk_counter=2;
    fft2_inc=siz/16;
    fft2_m1=32;
    fft2_m2=8;
    if(FFT2_CURMODE == 6)
      {
      make_fft2_status=FFT2_B;
      }
    else
      {  
// Use MMX routines
      if(genparm[SECOND_FFT_SINPOW] == 0)
        {
        fft2mmx_a1_nowin(); 
        }
      else
        {
        fft2mmx_a1_win(); 
        }
      make_fft2_status=FFT2_MMXB;
      return;
      }
    p0=timf2_px;
    if(genparm[SECOND_FFT_SINPOW] == 0)
      {
      for(j=0; j<siz; j+=4)
        {
        ia=(p0+4*(fft2_permute[j  ]&0xffff))&mask;
        ib=(p0+4*(fft2_permute[j+1]&0xffff))&mask;
        ic=(p0+4*(fft2_permute[j+2]&0xffff))&mask;
        id=(p0+4*(fft2_permute[j+3]&0xffff))&mask;

        t1=(float)(timf2[ia  ])+(float)(timf2[ib  ])+
           (float)(timf2[ia+2])+(float)(timf2[ib+2]);
        t2=-((float)(timf2[ia+1])+(float)(timf2[ib+1])+
           (float)(timf2[ia+3])+(float)(timf2[ib+3]));
  
        t3=(float)(timf2[ic  ])+(float)(timf2[id  ])+
           (float)(timf2[ic+2])+(float)(timf2[id+2]);
        t4=-((float)(timf2[ic+1])+(float)(timf2[id+1])+
           (float)(timf2[ic+3])+(float)(timf2[id+3]));
  
        t5=(float)(timf2[ia  ])-(float)(timf2[ib  ])+
           (float)(timf2[ia+2])-(float)(timf2[ib+2]);
        t7=-((float)(timf2[ia+1])-(float)(timf2[ib+1])+
           (float)(timf2[ia+3])-(float)(timf2[ib+3]));
  
        t10=(float)(timf2[ic  ])-(float)(timf2[id  ])+
            (float)(timf2[ic+2])-(float)(timf2[id+2]);
        t6= -((float)(timf2[ic+1])-(float)(timf2[id+1])+
            (float)(timf2[ic+3])-(float)(timf2[id+3]));
  
        z[2*j  ]=t1+t3;
        z[2*j+1]=t2+t4;
  
        z[2*j+4]=t1-t3;
        z[2*j+5]=t2-t4;
  
        t11=t5-t6;
        t8=t7-t10;
    
        t12=t5+t6;
        t9=t7+t10;
  
        z[2*j+2]=t12;
        z[2*j+3]=t8;
  
        z[2*j+6]=t11;
        z[2*j+7]=t9;
        }
      }
    else
      {
      for(j=0; j<siz; j+=4)
        {
        ja=fft2_permute[j  ]&0xffff;
        jb=fft2_permute[j+1]&0xffff;
        jc=fft2_permute[j+2]&0xffff;
        jd=fft2_permute[j+3]&0xffff;
        ia=(p0+4*ja)&mask;
        ib=(p0+4*jb)&mask;
        ic=(p0+4*jc)&mask;
        id=(p0+4*jd)&mask;
        a1=fft2_window[ja]*((float)(timf2[ia  ])+(float)(timf2[ia+2]));
        a2=fft2_window[ja]*((float)(timf2[ia+1])+(float)(timf2[ia+3]));

        b1=fft2_window[jb]*((float)(timf2[ib  ])+(float)(timf2[ib+2]));
        b2=fft2_window[jb]*((float)(timf2[ib+1])+(float)(timf2[ib+3]));

        c1=fft2_window[jc]*((float)(timf2[ic  ])+(float)(timf2[ic+2]));
        c2=fft2_window[jc]*((float)(timf2[ic+1])+(float)(timf2[ic+3]));

        d1=fft2_window[jd]*((float)(timf2[id  ])+(float)(timf2[id+2]));
        d2=fft2_window[jd]*((float)(timf2[id+1])+(float)(timf2[id+3]));

        t1=a1+b1;
        t2=-(a2+b2);
  
        t3=c1+d1;
        t4=-(c2+d2);
  
        t5=a1-b1;
        t7=-(a2-b2);
  
        t10=c1-d1;
        t6=-( c2-d2);
        z[2*j  ]=t1+t3;
        z[2*j+1]=t2+t4;
  
        z[2*j+4]=t1-t3;
        z[2*j+5]=t2-t4;
  
        t11=t5-t6;
        t8=t7-t10;
    
        t12=t5+t6;
        t9=t7+t10;

        z[2*j+2]=t12;
        z[2*j+3]=t8;
  
        z[2*j+6]=t11;
        z[2*j+7]=t9;
        }
      }
    return;

    case FFT2_MMXB:
    n1=fft2_chunk_counter;
    n2=n1+fft2_chunk_n;
    if(n2 >= fft2_n-2)
      {
      n2=fft2_n-2;
      make_fft2_status=FFT2_MMXC;
      }
    fft2_chunk_counter=n2;  
    for(n=n1; n<n2; n+=2)
      {
      if(n < fft2_att_limit)
        {
        fft2_mmx_b1hi();
        }
      else
        {  
        if(n == fft2_att_limit)
          {
          fft2_mmx_b1med();
          }
        else
          {  
          fft2_mmx_b1low();
          }
        }         
      }
    return;

    case FFT2_MMXC:
    fft2_mmx_c1();
    make_fft2_status=FFT2_ELIMINATE_SPURS_MMX;
    return;

    case FFT2_ELIMINATE_SPURS_MMX:
    if(no_of_spurs > 0)
      {
      fftx_na=fft2_na;
      eliminate_spurs();
      make_fft2_status=FFT2_PWRSUM_MMX;
      return;
      }
    goto one_fft2_pwrsum_mmx;

    case FFT2_PWRSUM_MMX:
one_fft2_pwrsum_mmx:;
// Make summed power spectrum.
    zxy=&fft2_short_int[twice_rxchan*fft2_na*fft2_size];
    pwra=&fft2_power_float[fft2_na*siz];
    if(ampinfo_flag != 0)
      {
      for(i=0; i<siz; i++)
        {
        k=zxy[2*i  ];
        k=abs(k);
        if(k > fft2_maxamp[0])fft2_maxamp[0]=k;
        k=zxy[2*i+1];
        k=abs(k);
        if(k > fft2_maxamp[0])fft2_maxamp[0]=k;
        }
      }
    if(wg_waterf_sum_counter == 0)
      {
      for(i=0; i<siz; i++)
        {
        pwra[i]=(float)(zxy[2*i  ])*(float)(zxy[2*i  ])+
                (float)(zxy[2*i+1])*(float)(zxy[2*i+1]);
        fft2_powersum_float[i]=pwra[i];
        }
      }
    else
      {
      for(i=0; i<siz; i++)
        {
        pwra[i]=(float)(zxy[2*i  ])*(float)(zxy[2*i  ])+
                (float)(zxy[2*i+1])*(float)(zxy[2*i+1]);
        fft2_powersum_float[i]+=pwra[i];
        }
      } 
    wg_waterf_sum_counter++;  
    if(wg_waterf_sum_counter < wg.waterfall_avgnum)
      {
      make_fft2_status=FFT2_COMPUTE_GRAPH;
      }
    else
      {
      make_fft2_status=FFT2_WATERFALL_LINE;
      }
    return;
    
    case FFT2_B:
    siz_d4=siz/4;
    siz_m2=siz*2;
    n1=fft2_chunk_counter;
    n2=n1+fft2_chunk_n;
    if(n2 >= fft2_n-2)
      {
      n2=fft2_n-2;
      make_fft2_status=FFT2_C;
      }
    fft2_chunk_counter=n2;  
    for(n=n1; n<n2; n+=2)
      {
      inc=fft2_inc;
      m2=fft2_m2;
      for(j=0; j<siz_m2; j+=fft2_m1)
        {
        itab=0;
        ia=j;
lp1:;    
        ib=ia+m2;
        ss1= fft2_tab[2*itab].sin; 
        cs1= fft2_tab[2*itab].cos;

        x0=z[ia  ];
        y8=z[ia+1];

        x1=z[ib  ];
        y9=z[ib+1];

        t1=cs1*x1+ss1*y9;      
        t2=cs1*y9-ss1*x1;      

        ic=ib+m2;
        id=ic+m2;

        x4=x0+t1;
        y4=y8+t2;

        x6=x0-t1;
        y6=y8-t2;

        x2=z[ic  ];
        y2=z[ic+1];

        x3=z[id  ];
        y3=z[id+1];

        t3=cs1*x3+ss1*y3;      
        t4=cs1*y3-ss1*x3;      

        x5=x2+t3;
        y5=y2+t4;

        x7=x2-t3;
        y7=y2-t4;

        ss2= fft2_tab[itab].sin; 
        cs2= fft2_tab[itab].cos;

        t5=cs2*x5+ss2*y5;
        t6=cs2*y5-ss2*x5;

        z[ia  ]=x4+t5;
        z[ia+1]=y4+t6;

        z[ic  ]=x4-t5;
        z[ic+1]=y4-t6;

        t8=cs2*x7+ss2*y7;
        t7=cs2*y7-ss2*x7;

        z[ib  ]=x6+t7;
        z[ib+1]=y6-t8;

        z[id  ]=x6-t7;
        z[id+1]=y6+t8;

        itab+=inc;
        ia+=2; 
        if(itab<siz_d4)goto lp1;
        }
      fft2_inc/=4;
      fft2_m1*=4;
      fft2_m2*=4;
      }
    return;

    case FFT2_C:
    if( (fft2_n&1)==1)
      {
      siz_d2=siz/2;
      ib=siz;
      ia=0;
      for(itab=0; itab<siz_d2; itab++)
        {
        ss1= fft2_tab[itab].sin; 
        cs1= fft2_tab[itab].cos;
        x0=z[ia  ];
        y8=z[ia+1];
        x1=z[ib  ];
        y9=z[ib+1];
        t1=cs1*x1+ss1*y9;
        t2=cs1*y9-ss1*x1;
        r1=cs1*u1+ss1*w1;
        r2=cs1*w1-ss1*u1;
        z[ib  ]=x0-t1;
        z[ib+1]=-(y8-t2);
        z[ia  ]=x0+t1;
        z[ia+1]=-(y8+t2);
        ia+=2;
        ib+=2;
        }
      }
    else
      {
      siz_d4=siz/4;
      m2=siz/2;
      itab=0;
      ia=0;
lp3:;    
      ib=ia+m2;
      ss1= fft2_tab[2*itab].sin; 
      cs1= fft2_tab[2*itab].cos;

      x0=z[ia  ];
      y8=z[ia+1];

      x1=z[ib  ];
      y9=z[ib+1];

      t1=cs1*x1+ss1*y9;      
      t2=cs1*y9-ss1*x1;      

      ic=ib+m2;
      id=ic+m2;

      x4=x0+t1;
      y4=y8+t2;

      x6=x0-t1;
      y6=y8-t2;

      x2=z[ic  ];
      y2=z[ic+1];

      x3=z[id  ];
      y3=z[id+1];

      t3=cs1*x3+ss1*y3;      
      t4=cs1*y3-ss1*x3;      

      x5=x2+t3;
      y5=y2+t4;

      x7=x2-t3;
      y7=y2-t4;

      ss2= fft2_tab[itab].sin; 
      cs2= fft2_tab[itab].cos;

      t5=cs2*x5+ss2*y5;
      t6=cs2*y5-ss2*x5;

      z[ia  ]=x4+t5;
      z[ia+1]=-(y4+t6);

      z[ic  ]=x4-t5;
      z[ic+1]=-(y4-t6);

      t8=cs2*x7+ss2*y7;
      t7=cs2*y7-ss2*x7;

      z[ib  ]=x6+t7;
      z[ib+1]=-(y6-t8);

      z[id  ]=x6-t7;
      z[id+1]=-(y6+t8);

      itab++;
      ia+=2; 
      if(itab<siz_d4)goto lp3;
      }
    make_fft2_status=FFT2_ELIMINATE_SPURS;
    return;

    case FFT2_ELIMINATE_SPURS:
    if(no_of_spurs > 0)
      {
      fftx_na=fft2_na;
      eliminate_spurs();
      make_fft2_status=FFT2_PWRSUM;
      return;
      }
    goto one_fft2_pwrsum;


    case FFT2_PWRSUM:
one_fft2_pwrsum:;    
// Make summed power spectrum.
    pwra=&fft2_power_float[fft2_na*siz];
    if(wg_waterf_sum_counter == 0)
      {
      for(i=0; i<siz; i++)
        {
        pwra[i]=z[2*i  ]*z[2*i  ]+z[2*i+1]*z[2*i+1];
        fft2_powersum_float[i]=pwra[i];
        }
      }
    else
      {
      for(i=0; i<siz; i++)
        {
        pwra[i]=z[2*i  ]*z[2*i  ]+z[2*i+1]*z[2*i+1];
        fft2_powersum_float[i]+=pwra[i];
        }
      } 
    wg_waterf_sum_counter++;  
    if(wg_waterf_sum_counter < wg.waterfall_avgnum)
      {
      make_fft2_status=FFT2_COMPUTE_GRAPH;
      }
    else
      {
      make_fft2_status=FFT2_WATERFALL_LINE;
      }
    return;
    

   
    case FFT2_WATERFALL_LINE:
    if(wg_waterf_sum_counter < wg.waterfall_avgnum)
      {
      make_fft2_status=FFT2_COMPUTE_GRAPH;
      return;
      }
    make_fft2_status=FFT2_LIMINFO;
// A new summed power spectrum has arrived.
// Convert it from linear power scale to log in units of 0.1dB.
// Expand or contract so we get the number of pixels that
// will fit on the screen.
// Store at the pos of our current line in waterfall
    iw=(wg_waterf_y-wg_waterf_y1)*wg_xpixels;
    a2=1;
    if(wg.xpoints_per_pixel >0)
      {
      a2=wg.xpoints_per_pixel;
      }
    else
      {
      a2=1./wg.pixels_per_xpoint;
      }
    a3=wg.first_xpoint+0.5*a2;
    if(hgwat_xpoints_per_pixel == 1 || hgwat_pixels_per_xpoint == 1)
      {
      i=hgwat_first_xpoint;
      for(ix=0; ix < wg_xpixels; ix++)
        {
        itab=a3;
        a3+=a2;
        y=100.*log10(fft2_powersum_float[i]*wg_waterf_yfac[itab]);
        if(y < -32767)y=-32767;
        if(y>32767)y=32767;
        wg_waterf[iw+ix]=y;
        i++;
        }
      }    
    else
      {
      if(hgwat_xpoints_per_pixel == 0)
        {
// There are more pixels than data points so we must interpolate.
        i=hgwat_first_xpoint;
        itab=a3;
        a3+=a2;
        y=100.*log10(fft2_powersum_float[i]*wg_waterf_yfac[itab]);
        yval=y;
        if(y < -32767)y=-32767;
        if(y>32767)y=32767;
        wg_waterf[iw]=y;
        i=hgwat_first_xpoint+1;
        for(ix=0; ix<wg_xpixels; ix+=hgwat_pixels_per_xpoint)
          {
          itab=a3;
          a3+=a2;
          r1=100.*log10(fft2_powersum_float[i]*wg_waterf_yfac[itab]);
          der=(r1-yval)/hgwat_pixels_per_xpoint;
          for(k=ix+1; k<=ix+hgwat_pixels_per_xpoint; k++)
            {
            yval=yval+der;
            y=yval;
            if(y < -32767)y=-32767;
            if(y>32767)y=32767;
            wg_waterf[iw+k]=y;
            }  
          yval=r1;
          i++;
          }      
        }
      else
        {
// There is more than one data point for each pixel.
// Make a region ia to ib for the points behind each pixel.
// find the largest value for each region.
        ia=hgwat_first_xpoint;
        ib=ia+hgwat_xpoints_per_pixel;
        yb=&fft2_xysum_float[siz];
        for(ix=0; ix<wg_xpixels; ix++)
          {
          r2=0;
          k=0;
          for(i=ia; i<ib; i++)
            {    
            r1=fft2_powersum_float[i];
            if(r1 > r2)r2=r1;
            }
          itab=a3;
          a3+=a2;
          a1=wg_waterf_yfac[itab];
          y=100.*log10(a1*r2);
          if(y < -32767)y=-32767;
          if(y>32767)y=32767;
          wg_waterf[iw+ix]=y;
          ia=ib;
          ib+=hgwat_xpoints_per_pixel;
          if(ib >= siz)ib=siz;
          }
        }  
      }
    if( wg_waterf_lines != -1) wg_waterf_line();
    return;

    case FFT2_LIMINFO:
    make_fft2_status=FFT2_COMPUTE_GRAPH;
    fft2_update_liminfo();
    return;


    case FFT2_COMPUTE_GRAPH:
// Place high resolution spectra on the screen in case a frequency is
// selected.
    if(mix1_selfreq[0]>0 && new_baseb_flag >= 0)
      {
      id=hg_last_point;
      pwra=&fft2_power_float[fft2_na*siz];
      if(hg.spek_avgnum == 1)
        {
        k=0;
        for(i=hg_first_point; i<id; i++)
          {
          hg_fft2_pwrsum[k]=pwra[i];
          k++;
          }
        }
      else
        {
        if(hg.spek_avgnum == 2)
          {
          pwrb=&fft2_power_float[((fft2_nb+1)&fft2n_mask)*siz];
          k=0;
          for(i=hg_first_point; i<id; i++)
            {
            hg_fft2_pwrsum[k]=pwra[i]+pwrb[i];
            k++;
            }
          }
        else
          {             
          pwrb=&fft2_power_float[fft2_nb*siz];
          k=0;
          ib=hg_recalc_pointer;
          ic=ib+hg_powersum_recalc;
          hg_recalc_pointer=ic;
          if(ic>=id)
            {
            ic=id;            
            hg_recalc_pointer=hg_first_point;
            }
// Make the sum the easy way for some points
          for(i=hg_first_point; i<ib; i++)
            {
            hg_fft2_pwrsum[k]+=pwra[i]-pwrb[i];
            k++;
            }
// For these points we want the correct sum in hg_fft2_pwrsum.
// This group will slide across our data and correct all points
          ja=k;
          jb=(fft2_nb+1)&fft2n_mask;  
          pwrc=&fft2_power_float[jb*siz];
          for(i=ib; i<ic; i++)
            {
            hg_fft2_pwrsum[k]=pwrc[i];
            k++;
            }
    
pwrsum_2:;
          k=ja; 
          jb=(jb+1)&fft2n_mask;  
          pwrc=&fft2_power_float[jb*siz];
          for(i=ib; i<ic; i++)
            {
            hg_fft2_pwrsum[k]+=pwrc[i];
            k++;
            }
          if(jb != fft2_na)goto pwrsum_2;
// We do the remaining points the easy way.
          for(i=ic; i<id; i++)
            {
            hg_fft2_pwrsum[k]+=pwra[i]-pwrb[i];
            k++;
            }
          }
        }
      hg_redraw_counter++;
      if(hg_redraw_counter >= hg.spek_avgnum/4)
        {
        hg_redraw_counter=0;
        make_fft2_status=FFT2_SHOW_SPECTRUM;
        hg_xpix1=hg_first_xpixel;
        return;
        }
      break;

      case FFT2_SHOW_SPECTRUM:
// Place the new curve on screen.
      hg_xpix2=hg_xpix1+WIDTH/NO_REDRAW_BLOCKS;
      if(hg_xpix2 >  hg_last_xpixel)hg_xpix2= hg_last_xpixel;
      i=hg_xpix1-hg_first_xpixel;
      if(  mouse_x+mouse_cursize >= hg_xpix1 &&
           mouse_x-mouse_cursize < hg_xpix2 &&
           mouse_y+mouse_cursize >= hg_ymax &&
           mouse_y-mouse_cursize <= hg_y0)hide_mouse();
      hgm1=hg_spectrum[hg_center];
      for(j=hg_xpix1; j<hg_xpix2; j++)
        {
        t1=hg_yfac_log*log10(hg_fft2_pwrsum[i  ]*hg_yfac_power);
        ia=t1;
        if(ia<0)ia=0;
        ia=hg_y0-ia;
        if(ia<hg_ymax)ia=hg_ymax;
        ja=hg_spectrum[j];
        hg_spectrum[j  ]=ia;
        if(ia != ja)
          {
          gl_setpixel(j,ja,hg_background[ja]);
          gl_setpixel(j,ia,15);
          }
        i++;
        }
      if(hgm1 != hg_spectrum[hg_center])     
        {
        gl_setpixel(hg_center,hgm1,8);
        }
      show_mouse();
      hg_xpix1=hg_xpix2;
      if(hg_xpix2 < hg_last_xpixel)return;
      break;
    
      default:
      break;
      }
    }
  }
else
  {
  switch (make_fft2_status)
    {
    case FFT2_NOT_ACTIVE:
    mask=timf2_mask;
    if(FFT2_CURMODE == 15)
      {
      ya=&fft2_xypower_float[fft2_na*siz];
      mask=timf2_mask;
      mm=twice_rxchan;
      for(j=0; j<mm; j+=2)
        {
        p0=timf2_px;
        if(genparm[SECOND_FFT_SINPOW] != 0)
          {
          for(i=0; i<siz; i++)
            {
            fftxy[2*i  ]=fft2_window[i]*(timf2[p0+j  ]+timf2[p0+j+4]);
            fftxy[2*i+1]=fft2_window[i]*(timf2[p0+j+1]+timf2[p0+j+5]);
            p0=(p0+8)&mask;            
            }
          }  
        else
          {
          for(i=0; i<siz; i++)
            {
            fftxy[2*i  ]=(timf2[p0+j  ]+timf2[p0+j+4]);
            fftxy[2*i+1]=(timf2[p0+j+1]+timf2[p0+j+5]);
            p0=(p0+8)&mask;            
            }
          }
        fftforward(siz, fft2_n, fftxy, fft2_tab, fft2_permute);
        fftxy=(void*)(ya);
        }
      fftxy=&fft2_float[twice_rxchan*fft2_na*siz];
      fftab=(void*)(ya);
      for(i=siz-1; i>=0; i--)
        {
        fftxy[4*i+3]=fftab[2*i+1];    
        fftxy[4*i+2]=fftab[2*i  ];    
        fftxy[4*i+1]=fftxy[2*i+1];    
        fftxy[4*i  ]=fftxy[2*i  ];    
        }
      make_fft2_status=FFT2_ELIMINATE_SPURS;
      return;
      }
    fft2_chunk_counter=2;
    fft2_inc=siz/16;
    fft2_m1=64;
    fft2_m2=16;
    if(FFT2_CURMODE == 16)
      {
      make_fft2_status=FFT2_B;
      }
    else  
      {
// Use MMX routines
      if(genparm[SECOND_FFT_SINPOW] == 0)
        {
        fft2mmx_a2_nowin(); 
        }
      else
        {
        fft2mmx_a2_win(); 
        }
      make_fft2_status=FFT2_MMXB;
      return;
      }
    p0=timf2_px;
    if(genparm[SECOND_FFT_SINPOW] == 0)
      {
      for(j=0; j<siz; j+=4)
        {
        ia=(p0+8*(fft2_permute[j  ]&0xffff))&mask;
        ib=(p0+8*(fft2_permute[j+1]&0xffff))&mask;
        ic=(p0+8*(fft2_permute[j+2]&0xffff))&mask;
        id=(p0+8*(fft2_permute[j+3]&0xffff))&mask;
  
        t1=(float)(timf2[ia  ])+(float)(timf2[ib  ])+
           (float)(timf2[ia+4])+(float)(timf2[ib+4]);
        t2=-((float)(timf2[ia+1])+(float)(timf2[ib+1])+
           (float)(timf2[ia+5])+(float)(timf2[ib+5]));
        r1=(float)(timf2[ia+2])+(float)(timf2[ib+2])+
           (float)(timf2[ia+6])+(float)(timf2[ib+6]);
        r2=-((float)(timf2[ia+3])+(float)(timf2[ib+3])+
           (float)(timf2[ia+7])+(float)(timf2[ib+7]));
  
        t3=(float)(timf2[ic  ])+(float)(timf2[id  ])+
           (float)(timf2[ic+4])+(float)(timf2[id+4]);
        t4=-((float)(timf2[ic+1])+(float)(timf2[id+1])+
           (float)(timf2[ic+5])+(float)(timf2[id+5]));
        r3=(float)(timf2[ic+2])+(float)(timf2[id+2])+
           (float)(timf2[ic+6])+(float)(timf2[id+6]);
        r4=-((float)(timf2[ic+3])+(float)(timf2[id+3])+
           (float)(timf2[ic+7])+(float)(timf2[id+7]));
  
        t5=(float)(timf2[ia  ])-(float)(timf2[ib  ])+
           (float)(timf2[ia+4])-(float)(timf2[ib+4]);
        t7=-((float)(timf2[ia+1])-(float)(timf2[ib+1])+
           (float)(timf2[ia+5])-(float)(timf2[ib+5]));
        r5=(float)(timf2[ia+2])-(float)(timf2[ib+2])+
           (float)(timf2[ia+6])-(float)(timf2[ib+6]);
        r7=-((float)(timf2[ia+3])-(float)(timf2[ib+3])+
            (float)(timf2[ia+7])-(float)(timf2[ib+7]));
  
        t10=(float)(timf2[ic  ])-(float)(timf2[id  ])+
            (float)(timf2[ic+4])-(float)(timf2[id+4]);
        t6= -((float)(timf2[ic+1])-(float)(timf2[id+1])+
            (float)(timf2[ic+5])-(float)(timf2[id+5]));
        r10=(float)(timf2[ic+2])-(float)(timf2[id+2])+
            (float)(timf2[ic+6])-(float)(timf2[id+6]);  
        r6= -((float)(timf2[ic+3])-(float)(timf2[id+3])+
            (float)(timf2[ic+7])-(float)(timf2[id+7]));
  
        fftxy[4*j  ]=t1+t3;
        fftxy[4*j+1]=(t2+t4);
        fftxy[4*j+2]=r1+r3;
        fftxy[4*j+3]=(r2+r4);
  
        fftxy[4*j+8]=t1-t3;
        fftxy[4*j+9]=(t2-t4);
        fftxy[4*j+10]=r1-r3;
        fftxy[4*j+11]=(r2-r4);
  
        t11=t5-t6;
        t8=t7-t10;
        r11=r5-r6;
        r8=r7-r10;
    
        t12=t5+t6;
        t9=t7+t10;
        r12=r5+r6;
        r9=r7+r10;
  
        fftxy[4*j+4]=t12;
        fftxy[4*j+5]=t8;
        fftxy[4*j+6]=r12;
        fftxy[4*j+7]=r8;
  
        fftxy[4*j+12]=t11;
        fftxy[4*j+13]=t9;
        fftxy[4*j+14]=r11;
        fftxy[4*j+15]=r9;
        }
      }
    else
      {
      for(j=0; j<siz; j+=4)
        {

        ja=fft2_permute[j  ]&0xffff;
        jb=fft2_permute[j+1]&0xffff;
        jc=fft2_permute[j+2]&0xffff;
        jd=fft2_permute[j+3]&0xffff;
        ia=(p0+8*ja)&mask;
        ib=(p0+8*jb)&mask;
        ic=(p0+8*jc)&mask;
        id=(p0+8*jd)&mask;
        a1=fft2_window[ja]*((float)(timf2[ia  ])+(float)(timf2[ia+4]));
        a2=fft2_window[ja]*((float)(timf2[ia+1])+(float)(timf2[ia+5]));
        a3=fft2_window[ja]*((float)(timf2[ia+2])+(float)(timf2[ia+6]));
        a4=fft2_window[ja]*((float)(timf2[ia+3])+(float)(timf2[ia+7]));

        b1=fft2_window[jb]*((float)(timf2[ib  ])+(float)(timf2[ib+4]));
        b2=fft2_window[jb]*((float)(timf2[ib+1])+(float)(timf2[ib+5]));
        b3=fft2_window[jb]*((float)(timf2[ib+2])+(float)(timf2[ib+6]));
        b4=fft2_window[jb]*((float)(timf2[ib+3])+(float)(timf2[ib+7]));

        c1=fft2_window[jc]*((float)(timf2[ic  ])+(float)(timf2[ic+4]));
        c2=fft2_window[jc]*((float)(timf2[ic+1])+(float)(timf2[ic+5]));
        c3=fft2_window[jc]*((float)(timf2[ic+2])+(float)(timf2[ic+6]));
        c4=fft2_window[jc]*((float)(timf2[ic+3])+(float)(timf2[ic+7]));

        d1=fft2_window[jd]*((float)(timf2[id  ])+(float)(timf2[id+4]));
        d2=fft2_window[jd]*((float)(timf2[id+1])+(float)(timf2[id+5]));
        d3=fft2_window[jd]*((float)(timf2[id+2])+(float)(timf2[id+6]));
        d4=fft2_window[jd]*((float)(timf2[id+3])+(float)(timf2[id+7]));

        t1=a1+b1;
        t2=-(a2+b2);
        r1=a3+b3;
        r2=-(a4+b4);
  
        t3=c1+d1;
        t4=-(c2+d2);
        r3=c3+d3;
        r4=-(c4+d4);
  
        t5=a1-b1;
        t7=-(a2-b2);
        r5=a3-b3;
        r7=-(a4-b4);
  
        t10=c1-d1;
        t6=-( c2-d2);
        r10=c3-d3;
        r6=-( c4-d4);

        fftxy[4*j  ]=t1+t3;
        fftxy[4*j+1]=t2+t4;
        fftxy[4*j+2]=r1+r3;
        fftxy[4*j+3]=r2+r4;
  
        fftxy[4*j+8]=t1-t3;
        fftxy[4*j+9]=t2-t4;
        fftxy[4*j+10]=r1-r3;
        fftxy[4*j+11]=r2-r4;
  
        t11=t5-t6;
        t8=t7-t10;
        r11=r5-r6;
        r8=r7-r10;
    
        t12=t5+t6;
        t9=t7+t10;
        r12=r5+r6;
        r9=r7+r10;

        fftxy[4*j+4]=t12;
        fftxy[4*j+5]=t8;
        fftxy[4*j+6]=r12;
        fftxy[4*j+7]=r8;
  
        fftxy[4*j+12]=t11;
        fftxy[4*j+13]=t9;
        fftxy[4*j+14]=r11;
        fftxy[4*j+15]=r9;
        }
      }
    return;

    case FFT2_MMXB:
    n1=fft2_chunk_counter;
    n2=n1+fft2_chunk_n;
    if(n2 >= fft2_n-2)
      {
      n2=fft2_n-2;
      make_fft2_status=FFT2_MMXC;
      }
    fft2_chunk_counter=n2;  
    for(n=n1; n<n2; n+=2)
      {
      if(n < fft2_att_limit)
        {
        fft2_mmx_b2hi();
        }
      else
        {
        if(n == fft2_att_limit)
          {
          fft2_mmx_b2med();
          }
        else
          {
          fft2_mmx_b2low();
          }
        }
      }
    return;

    case FFT2_MMXC:
    fft2_mmx_c2();
    make_fft2_status=FFT2_ELIMINATE_SPURS_MMX;
    return;

    case FFT2_ELIMINATE_SPURS_MMX:
    if(no_of_spurs > 0)
      {
      fftx_na=fft2_na;
      eliminate_spurs();
      make_fft2_status=FFT2_PWRSUM_MMX;
      return;
      }
    goto two_fft2_pwrsum_mmx;

    case FFT2_PWRSUM_MMX:
two_fft2_pwrsum_mmx:;    
// Make summed power spectrum.
    zxy=&fft2_short_int[twice_rxchan*fft2_na*fft2_size];
    ya=&fft2_xypower_float[fft2_na*siz];
    if(ampinfo_flag != 0)
      {
      for(i=0; i<siz; i++)
        {
        k=zxy[4*i  ];
        k=abs(k);
        if(k > fft2_maxamp[0])fft2_maxamp[0]=k;
        k=zxy[4*i+1];
        k=abs(k);
        if(k > fft2_maxamp[0])fft2_maxamp[0]=k;
        k=zxy[4*i+2];
        k=abs(k);
        if(k > fft2_maxamp[1])fft2_maxamp[1]=k;
        k=zxy[4*i+3];
        k=abs(k);
        if(k > fft2_maxamp[1])fft2_maxamp[1]=k;
        }
      }
// Make summed power spectrum and channel correlations.
    if(wg_waterf_sum_counter == 0)
      {
      for(i=0; i<siz; i++)
        {
        ya[i].x2=(float)(zxy[4*i  ])*(float)(zxy[4*i  ])+
                 (float)(zxy[4*i+1])*(float)(zxy[4*i+1]);
        fft2_xysum_float[i].x2   =ya[i].x2;
        ya[i].y2=(float)(zxy[4*i+2])*(float)(zxy[4*i+2])+
                 (float)(zxy[4*i+3])*(float)(zxy[4*i+3]);
        fft2_xysum_float[i].y2   =ya[i].y2;
        ya[i].im_xy=-(float)(zxy[4*i  ])*(float)(zxy[4*i+3])+
                    (float)(zxy[4*i+1])*(float)(zxy[4*i+2]);
        fft2_xysum_float[i].im_xy=ya[i].im_xy;
        ya[i].re_xy=(float)(zxy[4*i  ])*(float)(zxy[4*i+2])+
                    (float)(zxy[4*i+1])*(float)(zxy[4*i+3]);
        fft2_xysum_float[i].re_xy=ya[i].re_xy;
        }
      }
    else
      {
      for(i=0; i<siz; i++)
        {
        ya[i].x2=(float)(zxy[4*i  ])*(float)(zxy[4*i  ])+
                 (float)(zxy[4*i+1])*(float)(zxy[4*i+1]);
        fft2_xysum_float[i].x2   +=ya[i].x2;
        ya[i].y2=(float)(zxy[4*i+2])*(float)(zxy[4*i+2])+
                 (float)(zxy[4*i+3])*(float)(zxy[4*i+3]);
        fft2_xysum_float[i].y2   +=ya[i].y2;
        ya[i].im_xy=-(float)(zxy[4*i  ])*(float)(zxy[4*i+3])+
                    (float)(zxy[4*i+1])*(float)(zxy[4*i+2]);
        fft2_xysum_float[i].im_xy+=ya[i].im_xy;
        ya[i].re_xy=(float)(zxy[4*i  ])*(float)(zxy[4*i+2])+
                    (float)(zxy[4*i+1])*(float)(zxy[4*i+3]);
        fft2_xysum_float[i].re_xy+=ya[i].re_xy;
        }
      } 
    wg_waterf_sum_counter++;  
    if(wg_waterf_sum_counter < wg.waterfall_avgnum)
      {
      make_fft2_status=FFT2_COMPUTE_GRAPH;
      }
    else
      {
      make_fft2_status=FFT2_WATERFALL_LINE;
      }
    return;


    case FFT2_B:
    siz_d4=siz/4;
    siz_m4=siz*4;
    n1=fft2_chunk_counter;
    n2=n1+fft2_chunk_n;
    if(n2 >= fft2_n-2)
      {
      n2=fft2_n-2;
      make_fft2_status=FFT2_C;
      }
    fft2_chunk_counter=n2;  
    for(n=n1; n<n2; n+=2)
      {
      inc=fft2_inc;
      m2=fft2_m2;
      for(j=0; j<siz_m4; j+=fft2_m1)
        {
        itab=0;
        ia=j;
lp2:;    
        ib=ia+m2;
        ss1= fft2_tab[2*itab].sin; 
        cs1= fft2_tab[2*itab].cos;
        ss2= fft2_tab[itab].sin; 
        cs2= fft2_tab[itab].cos;

        x0=fftxy[ia  ];
        y8=fftxy[ia+1];
        u0=fftxy[ia+2];
        w0=fftxy[ia+3];

        x1=fftxy[ib  ];
        y9=fftxy[ib+1];
        u1=fftxy[ib+2];
        w1=fftxy[ib+3];

        t1=cs1*x1+ss1*y9;      
        t2=cs1*y9-ss1*x1;      
        r1=cs1*u1+ss1*w1;      
        r2=cs1*w1-ss1*u1;      
        ic=ib+m2;
        id=ic+m2;

        x4=x0+t1;
        y4=y8+t2;
        u4=u0+r1;
        w4=w0+r2;

        x6=x0-t1;
        y6=y8-t2;
        u6=u0-r1;
        w6=w0-r2;

        x2=fftxy[ic  ];
        y2=fftxy[ic+1];
        u2=fftxy[ic+2];
        w2=fftxy[ic+3];

        x3=fftxy[id  ];
        y3=fftxy[id+1];
        u3=fftxy[id+2];
        w3=fftxy[id+3];

        t3=cs1*x3+ss1*y3;      
        t4=cs1*y3-ss1*x3;      
        r3=cs1*u3+ss1*w3;      
        r4=cs1*w3-ss1*u3;      

        x5=x2+t3;
        y5=y2+t4;
        u5=u2+r3;
        w5=w2+r4;

        x7=x2-t3;
        y7=y2-t4;
        u7=u2-r3;
        w7=w2-r4;

        t5=cs2*x5+ss2*y5;
        t6=cs2*y5-ss2*x5;
        r5=cs2*u5+ss2*w5;
        r6=cs2*w5-ss2*u5;

        fftxy[ia  ]=x4+t5;
        fftxy[ia+1]=y4+t6;
        fftxy[ia+2]=u4+r5;
        fftxy[ia+3]=w4+r6;

        fftxy[ic  ]=x4-t5;
        fftxy[ic+1]=y4-t6;
        fftxy[ic+2]=u4-r5;
        fftxy[ic+3]=w4-r6;

        t8=cs2*x7+ss2*y7;
        t7=cs2*y7-ss2*x7;
        r8=cs2*u7+ss2*w7;
        r7=cs2*w7-ss2*u7;

        fftxy[ib  ]=x6+t7;
        fftxy[ib+1]=y6-t8;
        fftxy[ib+2]=u6+r7;
        fftxy[ib+3]=w6-r8;

        fftxy[id  ]=x6-t7;
        fftxy[id+1]=y6+t8;
        fftxy[id+2]=u6-r7;
        fftxy[id+3]=w6+r8;

        itab+=inc;
        ia+=4; 
        if(itab<siz_d4)goto lp2;
        }
      fft2_inc/=4;
      fft2_m1*=4;
      fft2_m2*=4;
      }
    return;

    case FFT2_C:
    if( (fft2_n&1)==1)
      {
      siz_d2=siz/2;
      ib=siz*2;
      ia=0;
      for(itab=0; itab<siz_d2; itab++)
        {
        ss1= fft2_tab[itab].sin; 
        cs1= fft2_tab[itab].cos;
        x0=fftxy[ia  ];
        y8=fftxy[ia+1];
        u0=fftxy[ia+2];
        w0=fftxy[ia+3];
        x1=fftxy[ib  ];
        y9=fftxy[ib+1];
        u1=fftxy[ib+2];
        w1=fftxy[ib+3];
        t1=cs1*x1+ss1*y9;
        t2=cs1*y9-ss1*x1;
        r1=cs1*u1+ss1*w1;
        r2=cs1*w1-ss1*u1;
        fftxy[ib  ]=x0-t1;
        fftxy[ib+1]=-(y8-t2);
        fftxy[ib+2]=u0-r1;
        fftxy[ib+3]=-(w0-r2);
        fftxy[ia  ]=x0+t1;
        fftxy[ia+1]=-(y8+t2);
        fftxy[ia+2]=u0+r1;
        fftxy[ia+3]=-(w0+r2);
        ia+=4;
        ib+=4;
        }
      }
    else
      {
      siz_d4=siz/4;
      siz_m4=siz*4;
      for(j=0; j<siz_m4; j+=fft2_m1)
        {
        itab=0;
        ia=j;
lp4:;    
        ib=ia+siz;
        ss1= fft2_tab[2*itab].sin; 
        cs1= fft2_tab[2*itab].cos;
        ss2= fft2_tab[itab].sin; 
        cs2= fft2_tab[itab].cos;

        x0=fftxy[ia  ];
        y8=fftxy[ia+1];
        u0=fftxy[ia+2];
        w0=fftxy[ia+3];

        x1=fftxy[ib  ];
        y9=fftxy[ib+1];
        u1=fftxy[ib+2];
        w1=fftxy[ib+3];

        t1=cs1*x1+ss1*y9;      
        t2=cs1*y9-ss1*x1;      
        r1=cs1*u1+ss1*w1;      
        r2=cs1*w1-ss1*u1;      
        ic=ib+siz;
        id=ic+siz;

        x4=x0+t1;
        y4=y8+t2;
        u4=u0+r1;
        w4=w0+r2;

        x6=x0-t1;
        y6=y8-t2;
        u6=u0-r1;
        w6=w0-r2;

        x2=fftxy[ic  ];
        y2=fftxy[ic+1];
        u2=fftxy[ic+2];
        w2=fftxy[ic+3];

        x3=fftxy[id  ];
        y3=fftxy[id+1];
        u3=fftxy[id+2];
        w3=fftxy[id+3];

        t3=cs1*x3+ss1*y3;      
        t4=cs1*y3-ss1*x3;      
        r3=cs1*u3+ss1*w3;      
        r4=cs1*w3-ss1*u3;      

        x5=x2+t3;
        y5=y2+t4;
        u5=u2+r3;
        w5=w2+r4;

        x7=x2-t3;
        y7=y2-t4;
        u7=u2-r3;
        w7=w2-r4;

        t5=cs2*x5+ss2*y5;
        t6=cs2*y5-ss2*x5;
        r5=cs2*u5+ss2*w5;
        r6=cs2*w5-ss2*u5;

        fftxy[ia  ]=x4+t5;
        fftxy[ia+1]=-(y4+t6);
        fftxy[ia+2]=u4+r5;
        fftxy[ia+3]=-(w4+r6);

        fftxy[ic  ]=x4-t5;
        fftxy[ic+1]=-(y4-t6);
        fftxy[ic+2]=u4-r5;
        fftxy[ic+3]=-(w4-r6);

        t8=cs2*x7+ss2*y7;
        t7=cs2*y7-ss2*x7;
        r8=cs2*u7+ss2*w7;
        r7=cs2*w7-ss2*u7;

        fftxy[ib  ]=x6+t7;
        fftxy[ib+1]=-(y6-t8);
        fftxy[ib+2]=u6+r7;
        fftxy[ib+3]=-(w6-r8);

        fftxy[id  ]=x6-t7;
        fftxy[id+1]=-(y6+t8);
        fftxy[id+2]=u6-r7;
        fftxy[id+3]=-(w6+r8);

        itab++;
        ia+=4; 
        if(itab<siz_d4)goto lp4;
        }
      }
    make_fft2_status=FFT2_ELIMINATE_SPURS;
    return;

    case FFT2_ELIMINATE_SPURS:
    if(no_of_spurs > 0)
      {
      fftx_na=fft2_na;
      eliminate_spurs();
      make_fft2_status=FFT2_PWRSUM;
      return;
      }
    goto two_fft2_pwrsum;


    case FFT2_PWRSUM:
two_fft2_pwrsum:;    
    ya=&fft2_xypower_float[fft2_na*siz];
// Make summed power spectrum and channel correlations.
    if(wg_waterf_sum_counter == 0)
      {
      for(i=0; i<siz; i++)
        {
        ya[i].x2=   fftxy[4*i  ]*fftxy[4*i  ]+fftxy[4*i+1]*fftxy[4*i+1];
        fft2_xysum_float[i].x2   =ya[i].x2;
        ya[i].y2=   fftxy[4*i+2]*fftxy[4*i+2]+fftxy[4*i+3]*fftxy[4*i+3];
        fft2_xysum_float[i].y2   =ya[i].y2;
        ya[i].im_xy=-fftxy[4*i  ]*fftxy[4*i+3]+fftxy[4*i+1]*fftxy[4*i+2];
        fft2_xysum_float[i].im_xy=ya[i].im_xy;
        ya[i].re_xy=fftxy[4*i  ]*fftxy[4*i+2]+fftxy[4*i+1]*fftxy[4*i+3];
        fft2_xysum_float[i].re_xy=ya[i].re_xy;
        }
      }
    else
      {
      for(i=0; i<siz; i++)
        {
        ya[i].x2=   fftxy[4*i  ]*fftxy[4*i  ]+fftxy[4*i+1]*fftxy[4*i+1];
        fft2_xysum_float[i].x2   +=ya[i].x2;
        ya[i].y2=   fftxy[4*i+2]*fftxy[4*i+2]+fftxy[4*i+3]*fftxy[4*i+3];
        fft2_xysum_float[i].y2   +=ya[i].y2;
        ya[i].im_xy=-fftxy[4*i  ]*fftxy[4*i+3]+fftxy[4*i+1]*fftxy[4*i+2];
        fft2_xysum_float[i].im_xy+=ya[i].im_xy;
        ya[i].re_xy=fftxy[4*i  ]*fftxy[4*i+2]+fftxy[4*i+1]*fftxy[4*i+3];
        fft2_xysum_float[i].re_xy+=ya[i].re_xy;
        }
      } 
    wg_waterf_sum_counter++;  
    if(wg_waterf_sum_counter < wg.waterfall_avgnum)
      {
      make_fft2_status=FFT2_COMPUTE_GRAPH;
      }
    else
      {
      make_fft2_status=FFT2_WATERFALL_LINE;
      }
    return;
    

   
    case FFT2_WATERFALL_LINE:
    make_fft2_status=FFT2_LIMINFO;
// A new summed power spectrum has arrived.
// Convert it from linear power scale to log in units of 0.1dB.
// Expand or contract so we get the number of pixels that
// will fit on the screen.
// Store at the pos of our current line in waterfall
    iw=(wg_waterf_y-wg_waterf_y1)*wg_xpixels;
    ya=fft2_xysum_float;
    a2=1;
    if(wg.xpoints_per_pixel >0)
      {
      a2=wg.xpoints_per_pixel;
      }
    else
      {
      a2=1./wg.pixels_per_xpoint;
      }
    a3=wg.first_xpoint+0.5*a2;
    if(hgwat_xpoints_per_pixel == 1 || hgwat_pixels_per_xpoint == 1)
      {
      i=hgwat_first_xpoint;
      for(ix=0; ix < wg_xpixels; ix++)
        {
        t1=ya[i].x2+ya[i].y2;
        itab=a3;
        a3+=a2;
        y=100.*log10((t1+2*(ya[i].re_xy*ya[i].re_xy+ya[i].im_xy*ya[i].im_xy-
                                ya[i].x2*ya[i].y2)/t1)*wg_waterf_yfac[itab]);
        if(y < -32767)y=-32767;
        if(y>32767)y=32767;
        wg_waterf[iw+ix]=y;
        i++;
        }
      }    
    else
      {
      if(hgwat_xpoints_per_pixel == 0)
        {
// There are more pixels than data points so we must interpolate.
        i=hgwat_first_xpoint;
        t1=ya[i].x2+ya[i].y2;
        itab=a3;
        a3+=a2;
        y=100.*log10((t1+2*(ya[i].re_xy*ya[i].re_xy+ya[i].im_xy*ya[i].im_xy-
                               ya[i].x2*ya[i].y2)/t1)*wg_waterf_yfac[itab]);
        yval=y;
        if(y < -32767)y=-32767;
        if(y>32767)y=32767;
        wg_waterf[iw]=y;
        i=hgwat_first_xpoint+1;
        for(ix=0; ix<wg_xpixels; ix+=hgwat_pixels_per_xpoint)
          {
          itab=a3;
          a3+=a2;
          t1=ya[i].x2+ya[i].y2;
          r1=100.*log10((t1+2*(ya[i].re_xy*ya[i].re_xy+ya[i].im_xy*ya[i].im_xy-
                                 ya[i].x2*ya[i].y2)/t1)*wg_waterf_yfac[itab]);
          der=(r1-yval)/hgwat_pixels_per_xpoint;
          for(k=ix+1; k<=ix+hgwat_pixels_per_xpoint; k++)
            {
            yval=yval+der;
            y=yval;
            if(y < -32767)y=-32767;
            if(y>32767)y=32767;
            wg_waterf[iw+k]=y;
            }  
          yval=r1;
          i++;
          }      
        }
      else
        {
// There is more than one data point for each pixel.
// Make a region ia to ib for the points behind each pixel.
// find the largest value for each region.
        ia=hgwat_first_xpoint;
        ib=ia+hgwat_xpoints_per_pixel;
        yb=&fft2_xysum_float[siz];
        for(ix=0; ix<wg_xpixels; ix++)
          {
          r2=0;
          k=0;
          for(i=ia; i<ib; i++)
            {    
            t1=ya[i  ].x2+ya[i  ].y2;
            r1=t1+2*(ya[i  ].re_xy*ya[i  ].re_xy+
                     ya[i  ].im_xy*ya[i  ].im_xy-
                     ya[i  ].x2*ya[i  ].y2)/t1;
            if(r1 > r2)r2=r1;
            }
          itab=a3;
          a3+=a2;
          a1=wg_waterf_yfac[itab];
          y=100.*log10(a1*r2);
          if(y < -32767)y=-32767;
          if(y>32767)y=32767;
          wg_waterf[iw+ix]=y;
          ia=ib;
          ib+=hgwat_xpoints_per_pixel;
          if(ib >= siz)ib=siz;
          }
        }  
      }
    if( wg_waterf_lines != -1) wg_waterf_line();
    return;

    case FFT2_LIMINFO:
    make_fft2_status=FFT2_COMPUTE_GRAPH;
    fft2_update_liminfo();
    return;

    case FFT2_COMPUTE_GRAPH:
// Place high resolution spectra on the screen in case a frequency is
// selected.
    if(mix1_selfreq[0]>0 && new_baseb_flag >=0)
      {
      if(fft_cntrl[FFT2_CURMODE].mmx == 0)
        { 
// Transform the polarisation and get power
        id=hg_last_point;
        pwra=&hg_fft2_pwr[2*fft2_na*hg_size];
        if(hg.spek_avgnum == 1)
          {
          k=0;
          for(i=hg_first_point; i<id; i++)
            {
            t1=fftxy[4*i  ];
            t2=fftxy[4*i+1];
            t3=fftxy[4*i+2];
            t4=fftxy[4*i+3];
            r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
            r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
            pwra[2*k  ]=r1*r1+r2*r2;
            hg_fft2_pwrsum[2*k  ]=pwra[2*k  ];
            r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
            r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
            pwra[2*k+1]=r1*r1+r2*r2;
            hg_fft2_pwrsum[2*k+1]=pwra[2*k+1];
            k++;
            }
          }
        else
          {
          if(hg.spek_avgnum == 2)
            {
            pwrb=&hg_fft2_pwr[2*((fft2_nb+1)&fft2n_mask)*hg_size];
            k=0;
            for(i=hg_first_point; i<id; i++)
              {
              t1=fftxy[4*i  ];
              t2=fftxy[4*i+1];
              t3=fftxy[4*i+2];
              t4=fftxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k  ]=pwra[2*k  ]+pwrb[2*k  ];
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k+1]=pwra[2*k+1]+pwrb[2*k+1];
              k++;
              }
            }
          else
            {             
            pwrb=&hg_fft2_pwr[2*fft2_nb*hg_size];
            k=0;
            ib=hg_recalc_pointer;
            ic=ib+hg_powersum_recalc;
            hg_recalc_pointer=ic;
            if(ic>=id)
              {
              ic=id;            
              hg_recalc_pointer=hg_first_point;
              }
// Make the sum the easy way for some points
            for(i=hg_first_point; i<ib; i++)
              {
              t1=fftxy[4*i  ];
              t2=fftxy[4*i+1];
              t3=fftxy[4*i+2];
              t4=fftxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k  ]+=pwra[2*k  ]-pwrb[2*k  ];
              if(hg_fft2_pwrsum[2*k  ]<1)hg_fft2_pwrsum[2*k  ]=1;
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k+1]+=pwra[2*k+1]-pwrb[2*k+1];
              if(hg_fft2_pwrsum[2*k+1]<1)hg_fft2_pwrsum[2*k+1]=1;
              k++;
              }
// For these points we want the correct sum in hg_fft2_pwrsum.
// This group will slide across our data and correct all points
            ja=k;
            for(i=ib; i<ic; i++)
              {
              t1=fftxy[4*i  ];
              t2=fftxy[4*i+1];
              t3=fftxy[4*i+2];
              t4=fftxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              k++;
              }
            jb=(fft2_nb+1)&fft2n_mask;  
            pwrc=&hg_fft2_pwr[2*jb*hg_size];
            for(i=ja; i<k; i++)
              {
              hg_fft2_pwrsum[2*i  ]=pwrc[2*i  ];
              hg_fft2_pwrsum[2*i+1]=pwrc[2*i+1];
              } 
corrsum_2:;
            jb=(jb+1)&fft2n_mask;  
            pwrc=&hg_fft2_pwr[2*jb*hg_size];
            for(i=ja; i<k; i++)
              {
              hg_fft2_pwrsum[2*i  ]+=pwrc[2*i  ];
              hg_fft2_pwrsum[2*i+1]+=pwrc[2*i+1];
              }              
            if(jb != fft2_na)goto corrsum_2;
// We do the remaining points the easy way.
            for(i=ic; i<id; i++)
              {
              t1=fftxy[4*i  ];
              t2=fftxy[4*i+1];
              t3=fftxy[4*i+2];
              t4=fftxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k  ]+=pwra[2*k  ]-pwrb[2*k  ];
              if(hg_fft2_pwrsum[2*k  ]<1)hg_fft2_pwrsum[2*k  ]=1;
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k+1]+=pwra[2*k+1]-pwrb[2*k+1];
              if(hg_fft2_pwrsum[2*k+1]<1)hg_fft2_pwrsum[2*k+1]=1;
              k++;
              }
            }
          }
        }
      else
        { 
        zxy=&fft2_short_int[twice_rxchan*fft2_na*fft2_size];
// Transform the polarisation and get power
        id=hg_last_point;
        pwra=&hg_fft2_pwr[2*fft2_na*hg_size];
        if(hg.spek_avgnum == 1)
          {
          k=0;
          for(i=hg_first_point; i<id; i++)
            {
            t1=zxy[4*i  ];
            t2=zxy[4*i+1];
            t3=zxy[4*i+2];
            t4=zxy[4*i+3];
            r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
            r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
            pwra[2*k  ]=r1*r1+r2*r2;
            hg_fft2_pwrsum[2*k  ]=pwra[2*k  ];
            r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
            r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
            pwra[2*k+1]=r1*r1+r2*r2;
            hg_fft2_pwrsum[2*k+1]=pwra[2*k+1];
            k++;
            }
          }
        else
          {
          if(hg.spek_avgnum == 2)
            {
            pwrb=&hg_fft2_pwr[2*((fft2_nb+1)&fft2n_mask)*hg_size];
            k=0;
            for(i=hg_first_point; i<id; i++)
              {
              t1=zxy[4*i  ];
              t2=zxy[4*i+1];
              t3=zxy[4*i+2];
              t4=zxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k  ]=pwra[2*k  ]+pwrb[2*k  ];
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k+1]=pwra[2*k+1]+pwrb[2*k+1];
              k++;
              }
            }
          else
            {             
            pwrb=&hg_fft2_pwr[2*fft2_nb*hg_size];
            k=0;
            ib=hg_recalc_pointer;
            ic=ib+hg_powersum_recalc;
            hg_recalc_pointer=ic;
            if(ic>=id)
              {
              ic=id;            
              hg_recalc_pointer=hg_first_point;
              }
// Make the sum the easy way for some points
            for(i=hg_first_point; i<ib; i++)
              {
              t1=zxy[4*i  ];
              t2=zxy[4*i+1];
              t3=zxy[4*i+2];
              t4=zxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k  ]+=pwra[2*k  ]-pwrb[2*k  ];
              if(hg_fft2_pwrsum[2*k  ]<1)hg_fft2_pwrsum[2*k  ]=1;
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k+1]+=pwra[2*k+1]-pwrb[2*k+1];
              if(hg_fft2_pwrsum[2*k+1]<1)hg_fft2_pwrsum[2*k+1]=1;
              k++;
              }
// For these points we want the correct sum in hg_fft2_pwrsum.
// This group will slide across our data and correct all points
            ja=k;
            for(i=ib; i<ic; i++)
              {
              t1=zxy[4*i  ];
              t2=zxy[4*i+1];
              t3=zxy[4*i+2];
              t4=zxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              k++;
              }
            jb=(fft2_nb+1)&fft2n_mask;  
            pwrc=&hg_fft2_pwr[2*jb*hg_size];
            for(i=ja; i<k; i++)
              {
              hg_fft2_pwrsum[2*i  ]=pwrc[2*i  ];
              hg_fft2_pwrsum[2*i+1]=pwrc[2*i+1];
              } 
corrsum_2b:;
            jb=(jb+1)&fft2n_mask;  
            pwrc=&hg_fft2_pwr[2*jb*hg_size];
            for(i=ja; i<k; i++)
              {
              hg_fft2_pwrsum[2*i  ]+=pwrc[2*i  ];
              hg_fft2_pwrsum[2*i+1]+=pwrc[2*i+1];
              }              
            if(jb != fft2_na)goto corrsum_2b;
// We do the remaining points the easy way.
            for(i=ic; i<id; i++)
              {
              t1=zxy[4*i  ];
              t2=zxy[4*i+1];
              t3=zxy[4*i+2];
              t4=zxy[4*i+3];
              r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
              r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
              pwra[2*k  ]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k  ]+=pwra[2*k  ]-pwrb[2*k  ];
              if(hg_fft2_pwrsum[2*k  ]<1)hg_fft2_pwrsum[2*k  ]=1;
              r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
              r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
              pwra[2*k+1]=r1*r1+r2*r2;
              hg_fft2_pwrsum[2*k+1]+=pwra[2*k+1]-pwrb[2*k+1];
              if(hg_fft2_pwrsum[2*k+1]<1)hg_fft2_pwrsum[2*k+1]=1;
              k++;
              }
            }
          }
        }
      }
    hg_redraw_counter++;
    if(hg_redraw_counter >= hg.spek_avgnum/4)
      {
      hg_redraw_counter=0;
      make_fft2_status=FFT2_SHOW_SPECTRUM;
      hg_xpix1=hg_first_xpixel;
      return;
    }
    break;

    case FFT2_SHOW_SPECTRUM:
// Place the new curves on screen.
    hg_xpix2=hg_xpix1+WIDTH/(2*NO_REDRAW_BLOCKS);
    if(hg_xpix2 >  hg_last_xpixel)hg_xpix2= hg_last_xpixel;
    i=hg_xpix1-hg_first_xpixel;
    if(  mouse_x+mouse_cursize >= hg_xpix1 &&
         mouse_x-mouse_cursize < hg_xpix2 &&
         mouse_y+mouse_cursize >= hg_ymax &&
         mouse_y-mouse_cursize <= hg_y0)hide_mouse();
    hgm1=hg_spectrum[2*hg_center];
    hgm2=hg_spectrum[2*hg_center+1];
    for(j=hg_xpix1; j<hg_xpix2; j++)
      {
      t1=hg_yfac_log*log10(hg_fft2_pwrsum[2*i  ]*hg_yfac_power);
      t2=hg_yfac_log*log10(hg_fft2_pwrsum[2*i+1]*hg_yfac_power);  
      ia=t1;
      ib=t2;
      if(ia<0)ia=0;
      if(ib<0)ib=0;  
      ia=hg_y0-ia;
      ib=hg_y0-ib;
      if(ia<hg_ymax)ia=hg_ymax;
      if(ib<hg_ymax)ib=hg_ymax;
      ja=hg_spectrum[2*j];
      jb=hg_spectrum[2*j+1];
      hg_spectrum[2*j  ]=ia;
      hg_spectrum[2*j+1]=ib;
      if(ia == ja)
        {
        if(ib != jb)
          {
          gl_setpixel(j,jb,hg_background[jb]);
          if(ia == ib)
            {
            gl_setpixel(j,ib,15);
            }
          else
            {
            gl_setpixel(j,ib,13);
            }  
          if(ja==jb)gl_setpixel(j,ja,10);
          } 
        }
      else
        {
        if(ib == jb)
          {
          gl_setpixel(j,ja,hg_background[ja]);
          if(ia == ib)
            {
            gl_setpixel(j,ia,15);
            }
          else
            {
            gl_setpixel(j,ia,10);
            }  
          if(ja==jb)
            {
            gl_setpixel(j,jb,10);
            }
          else
            {
            gl_setpixel(j,ja,hg_background[ja]);
            }              
          }  
        if(ia == ib)
          {
          gl_setpixel(j,ja,hg_background[ja]);
          gl_setpixel(j,jb,hg_background[jb]);
          gl_setpixel(j,ia,15);
          }       
        else 
          {
          gl_setpixel(j,jb,hg_background[jb]);
          gl_setpixel(j,ib,13);
          gl_setpixel(j,ja,hg_background[ja]);
          gl_setpixel(j,ia,10);
          }
        }  
      i++;
      }
// Put the middle line back in case we moved a point
    if(hgm1!=hg_spectrum[2*hg_center] && hgm1!=hg_spectrum[2*hg_center+1])     
      {
      gl_setpixel(hg_center,hgm1,8);
      }
    if(hgm2!=hg_spectrum[2*hg_center] && hgm2!=hg_spectrum[2*hg_center+1])     
      {
      gl_setpixel(hg_center,hgm2,8);
      }
    show_mouse();  
    hg_xpix1=hg_xpix2;
    if(hg_xpix2 < hg_last_xpixel) return;
    break;
    
    default:
    break;
    }
  }
make_fft2_status=FFT2_NOT_ACTIVE;
timf2_px=(timf2_px+timf2_output_block)&timf2_mask;
if(genparm[AFC_ENABLE] != 0)
  {
  for(i=0; i<genparm[MIX1_NO_OF_CHANNELS]; i++)
    {
    mix1_eval_avgn[i*max_fft2n+fft2_na]=-1;
    mix1_eval_sigpwr[i*max_fft2n+fft2_na]=-1;
    }
  }
fft2_na=(fft2_na+1)&fft2n_mask;
fft2_nb=(fft2_nb+1)&fft2n_mask;
ag_pa=(ag_pa+1)&ag_mask;  
newdat_flag |= ND_FFT2;
if( ((fft2_nx-fft2_na+fft2n_mask)&fft2n_mask) ==0 )
  {
  fullbuf_flag|=ND_FFT2;
  }
if( ((timf2_pn2-timf2_px+timf2_totbytes)&timf2_mask) <
                                          4*ui.rx_channels*fft2_size )
  {
  newdat_flag &=-1-ND_TIMF2BLN;
  }
if( ((timf2_px-timf2_pa+timf2_mask)&timf2_mask) >
                   timf2_output_block+timf2_input_block )
  {
  fullbuf_flag &=-1-ND_TIMF2RAW;
  }
if(fft2_nm != fft2n_mask)fft2_nm++;
}


