
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "seldef.h"
#include "fft3def.h"
#include "screendef.h"
#include "sigdef.h"

char uninit_mem_end;


void show_baseband_spectrum(void)
{
int i,j,k,kk,color,pp,bg_xpix2;
int new_y1, new_y2,old_y1, old_y2;
float p1,p2,p3,p4,der1,der2;
// Show baseband graph on screen for selected frequency no 0
if(bg_xpix1 >= bg_last_xpixel)bg_xpix1=bg_first_xpixel;
i=bg.pixels_per_point;
if(i==0)i=1;
j=NO_REDRAW_BLOCKS;
if(!sw_onechan)j<<=1;
k=WIDTH/(j*i);
k*=i;
bg_xpix2=bg_xpix1+k;
if(bg_xpix2 >  bg_last_xpixel)bg_xpix2= bg_last_xpixel;
if(  mouse_x+mouse_cursize >= bg_xpix1 &&
     mouse_x-mouse_cursize < bg_xpix2 &&
     mouse_y+mouse_cursize >= bg_ymax &&
     mouse_y-mouse_cursize <= bg_y0)hide_mouse();
pp=bg.pixels_per_point;
i=(bg_xpix1-bg_first_xpixel)/pp;
if(sw_onechan)
  {  
  p2=bg.yfac_log*log10(fft3_slowsum[i]*bg.yfac_power);
  for(k=bg_xpix1; k<bg_xpix2; k+=pp)
    {
    p1=p2;
    p2=bg.yfac_log*log10(fft3_slowsum[i+1]*bg.yfac_power);
    der1=(p2-p1)/pp;
    for(j=0; j<pp; j++)
      {
      kk=k+j;
      new_y1=p1;
      p1+=der1;
      old_y1=fft3_spectrum[kk];

      new_y1=p1;
      if(new_y1 < 0)new_y1=0;
      new_y1=bg_y0-new_y1;
      if(new_y1 < bg_ymax)new_y1=bg_ymax;
      if( new_y1 != old_y1)
        {
        if(bg_filterfunc_y[kk] == old_y1 || bg_carrfilter_y[kk] == old_y1)
          {
          color=14;
          }
        else 
          {
          if( (kk == bfo_xpixel && old_y1 < bg_y2) ||
              (kk == bfo10_xpixel && old_y1 >= bg_y2 && old_y1 < bg_y1) ||
              (kk == bfo100_xpixel && old_y1 >= bg_y1) )
            {
            color=12;
            }
          else
            {    
            color=bg_background[old_y1];
            }
          }
        gl_setpixel(kk,old_y1,color);
        gl_setpixel(kk,new_y1,15);
        fft3_spectrum[kk]=new_y1;
        }
      }
    i++;
    }
  }
else
  {
  p3=bg.yfac_log*log10(fft3_slowsum[2*i]*bg.yfac_power);
  p4=bg.yfac_log*log10(fft3_slowsum[2*i+1]*bg.yfac_power);
  for(k=bg_xpix1; k<bg_xpix2; k+=pp)
    {
    p1=p3;
    p2=p4;
    p3=bg.yfac_log*log10(fft3_slowsum[2*i+2]*bg.yfac_power);
    p4=bg.yfac_log*log10(fft3_slowsum[2*i+3]*bg.yfac_power);
    der1=(p3-p1)/pp;
    der2=(p4-p2)/pp;
    for(j=0; j<pp; j++)
      {
      kk=k+j;
      new_y1=p1;
      new_y2=p2;
      p1+=der1;
      p2+=der2;
      if(new_y1 < 0)new_y1=0;
      new_y1=bg_y0-1-new_y1;
      if(new_y1 < bg_ymax)new_y1=bg_ymax;
      old_y1=fft3_spectrum[2*kk];
      old_y2=fft3_spectrum[2*kk+1];
      if(new_y2 < 0)new_y2=0;
      new_y2=bg_y0-new_y2;
      if(new_y2 < bg_ymax)new_y2=bg_ymax;
      if(new_y1 == new_y2)
        {
        if(bg_filterfunc_y[kk] == old_y2 || bg_carrfilter_y[kk] == old_y2)
          {
          color=14;
          }
        else 
          {  
          if( (kk == bfo_xpixel && old_y2 < bg_y2) ||
              (kk == bfo10_xpixel && old_y2 >= bg_y2 && old_y2 < bg_y1) ||
              (kk == bfo100_xpixel && old_y2 >= bg_y1) )
            {
            color=12;
            }
          else
            {    
            color=bg_background[old_y2];
            }
          }
        gl_setpixel(kk,old_y2,color);
        if(bg_filterfunc_y[kk] == old_y1 || bg_carrfilter_y[kk] == old_y1)
          {
          color=14;
          }
        else 
          {  
          if( (kk == bfo_xpixel && old_y1 < bg_y2) ||
              (kk == bfo10_xpixel && old_y1 >= bg_y2 && old_y1 < bg_y1) ||
              (kk == bfo100_xpixel && old_y1 >= bg_y1) )
            {
            color=12;
            }
          else
            {    
            color=bg_background[old_y1];
            }
          }
        gl_setpixel(kk,old_y1,color);
        gl_setpixel(kk,new_y2,15);
        fft3_spectrum[2*kk+1]=new_y2;
        fft3_spectrum[2*kk]=new_y1;
        }
      else
        {  
        if( new_y2 != old_y2)
          {
          if(bg_filterfunc_y[kk] == old_y2 || bg_carrfilter_y[kk] == old_y2)
            {
            color=14;
            }
          else 
            {  
            if( (kk == bfo_xpixel && old_y2 < bg_y2) ||
                (kk == bfo10_xpixel && old_y2 >= bg_y2 && old_y2 < bg_y1) ||
                (kk == bfo100_xpixel && old_y2 >= bg_y1) )
              {
              color=12;
              }
            else
              {    
              color=bg_background[old_y2];
              }
            }
          gl_setpixel(kk,old_y2,color);
          gl_setpixel(kk,new_y2,13);
          fft3_spectrum[2*kk+1]=new_y2;
          }
        if( new_y1 != old_y1)
          {
          if(bg_filterfunc_y[kk] == old_y1 || bg_carrfilter_y[kk] == old_y1)
            {
            color=14;
            }
          else 
            {  
            if( (kk == bfo_xpixel && old_y1 < bg_y2) ||
                (kk == bfo10_xpixel && old_y1 >= bg_y2 && old_y1 < bg_y1) ||
                (kk == bfo100_xpixel && old_y1 >= bg_y1) )
              {
              color=12;
              }
            else
              {    
              color=bg_background[old_y1];
              }
            }
          gl_setpixel(kk,old_y1,color);
          gl_setpixel(kk,new_y1,10);
          fft3_spectrum[2*kk]=new_y1;
          }
        }
      }
    i++;
    }
  }
show_mouse();
bg_xpix1=bg_xpix2;
}






void make_fft3_all(void)
{
int ja,jb;
int i,iw,j,k,m,p0,ss,poffs;
int mm, ia, ib, ic, jr, pa, pb, pc;
float t1,t2,t3,t4,x1,x2;
float r1,r2,r3,r4;
float *z;
mm=twice_rxchan;
for(ss=0; ss<genparm[MIX1_NO_OF_CHANNELS]; ss++)
  {
  poffs=ss*mm*timf3_size;        
  pc=fft3_pa+ss*mm*fft3_size;
  z=&fft3[fft3_pa+ss*mm*fft3_size];
  if(mix1_selfreq[ss] >= 0)
    {
// Frequency no ss is selected.
    if(sw_onechan)
      {  
      pa=timf3_px;
      pb=(pa+fft3_size)&timf3_mask;
      ib=fft3_size-2;
      for( ia=0; ia<fft3_size/2; ia++)
        {
        ib+=2;
        t1=timf3_float[poffs+pa  ]*fft3_win[2*ia];
        t2=timf3_float[poffs+pa+1]*fft3_win[2*ia];      
        t3=timf3_float[poffs+pb  ]*fft3_win[2*ia+1];
        t4=timf3_float[poffs+pb+1]*fft3_win[2*ia+1];   
        x1=t1-t3;
        fft3_tmp[2*ia  ]=t1+t3;
        x2=t4-t2;
        fft3_tmp[2*ia+1]=t2+t4;
        pa=(pa+2)&timf3_mask;
        pb=(pb+2)&timf3_mask;
        fft3_tmp[ib  ]=fft3_tab[ia].cos*x1+fft3_tab[ia].sin*x2;
        fft3_tmp[ib+1]=fft3_tab[ia].sin*x1-fft3_tab[ia].cos*x2;
        } 
      asmbulk_of_dif(fft3_size, fft3_n, fft3_tmp, fft3_tab);
      for(ia=0; ia < fft3_size; ia+=2)
        {
        ib=2*fft3_permute[ia];                               
        ic=2*fft3_permute[ia+1];                             
        z[ib  ]=fft3_tmp[2*ia  ]+fft3_tmp[2*ia+2];
        z[ic  ]=fft3_tmp[2*ia  ]-fft3_tmp[2*ia+2];
        z[ib+1]=fft3_tmp[2*ia+1]+fft3_tmp[2*ia+3];
        z[ic+1]=fft3_tmp[2*ia+1]-fft3_tmp[2*ia+3];
        }
      }
    else
      {  
      pa=timf3_px;
      pb=(pa+2*fft3_size)&timf3_mask;
      ib=fft3_size-2;
      for( ia=0; ia<fft3_size/2; ia++)
        {
        ib+=2;
        t1=timf3_float[poffs+pa  ]*fft3_win[2*ia];
        t2=timf3_float[poffs+pa+1]*fft3_win[2*ia];      
        t3=timf3_float[poffs+pb  ]*fft3_win[2*ia+1];
        t4=timf3_float[poffs+pb+1]*fft3_win[2*ia+1];   
        x1=t1-t3;
        fft3_tmp[4*ia  ]=t1+t3;
        x2=t4-t2;
        fft3_tmp[4*ia+1]=t2+t4;
        fft3_tmp[2*ib  ]=fft3_tab[ia].cos*x1+fft3_tab[ia].sin*x2;
        fft3_tmp[2*ib+1]=fft3_tab[ia].sin*x1-fft3_tab[ia].cos*x2;
        r1=timf3_float[poffs+pa+2]*fft3_win[2*ia];
        r2=timf3_float[poffs+pa+3]*fft3_win[2*ia];      
        r3=timf3_float[poffs+pb+2]*fft3_win[2*ia+1];
        r4=timf3_float[poffs+pb+3]*fft3_win[2*ia+1];   
        x1=r1-r3;
        fft3_tmp[4*ia+2]=r1+r3;
        x2=r4-r2;
        fft3_tmp[4*ia+3]=r2+r4;
        pa=(pa+4)&timf3_mask;
        pb=(pb+4)&timf3_mask;
        fft3_tmp[2*ib+2]=fft3_tab[ia].cos*x1+fft3_tab[ia].sin*x2;
        fft3_tmp[2*ib+3]=fft3_tab[ia].sin*x1-fft3_tab[ia].cos*x2;
        } 
      asmbulk_of_dual_dif(fft3_size, fft3_n, fft3_tmp, fft3_tab);
      for(ia=0; ia < fft3_size; ia+=2)
        {
        ib=4*fft3_permute[ia  ];                               
        ic=4*fft3_permute[ia+1];                             
        z[ib  ]=fft3_tmp[4*ia  ]+fft3_tmp[4*ia+4];
        z[ic  ]=fft3_tmp[4*ia  ]-fft3_tmp[4*ia+4];
        z[ib+1]=fft3_tmp[4*ia+1]+fft3_tmp[4*ia+5];
        z[ic+1]=fft3_tmp[4*ia+1]-fft3_tmp[4*ia+5];
        z[ib+2]=fft3_tmp[4*ia+2]+fft3_tmp[4*ia+6];
        z[ic+2]=fft3_tmp[4*ia+2]-fft3_tmp[4*ia+6];
        z[ib+3]=fft3_tmp[4*ia+3]+fft3_tmp[4*ia+7];
        z[ic+3]=fft3_tmp[4*ia+3]-fft3_tmp[4*ia+7];
        }
      }
    }
  }
// Now fft3_float contains transforms for all enabled channels.
// In case the main channel is enabled, calculate power spectra
// and rx channel correlations.
// Before computing powers, use the current polarisation parameters
// to transform polarisation.
if(mix1_selfreq[0] < 0)goto mix0_absent;
z=&fft3[fft3_pa];
pc=fft3_pa;
if(sw_onechan)
  {
  k=bg_show_pa;
  iw=0;
  i=bg_first_xpoint<<1;
  for(j=0; j<fft3_slowsum_recalc; j++)
    {
    fft3_slowsum[j]-=fft3_power[k];
    fft3_power[k]=(z[i]*z[i]+z[i+1]*z[i+1])*fft3_fqwin_inv[i>>1];
    i+=2;
    bg_waterf_sum[iw]+=fft3_power[k];
    iw++;
    fft3_slowsum[j]+=fft3_power[k];
    if(fft3_slowsum[j]<0)fft3_slowsum[j]=0;
    k++;
    }
  jr=fft3_slowsum_recalc+bg_xpoints/bg.fft_avgnum+1;
  if(jr > bg_xpoints)jr=bg_xpoints;
  for(j=fft3_slowsum_recalc; j<jr; j++)
    {
    fft3_power[k]=(z[i]*z[i]+z[i+1]*z[i+1])*fft3_fqwin_inv[i>>1];
    i+=2;
    bg_waterf_sum[iw]+=fft3_power[k];
    iw++;
    p0=k-bg_show_pa;
    fft3_slowsum[j]=fft3_power[p0];
    for(m=1; m<bg.fft_avgnum; m++)
      {
      p0+=bg_xpoints;
      fft3_slowsum[j]+=fft3_power[p0];
      }
    k++;
    }
  for(j=jr; j<bg_xpoints; j++)
    {
    fft3_slowsum[j]-=fft3_power[k];
    fft3_power[k]=(z[i]*z[i]+z[i+1]*z[i+1])*fft3_fqwin_inv[i>>1];
    i+=2;
    bg_waterf_sum[iw]+=fft3_power[k];
    iw++;
    fft3_slowsum[j]+=fft3_power[k];
    if(fft3_slowsum[j]<0)fft3_slowsum[j]=0;
    k++;
    }
  }
else
  {  
  k=bg_show_pa;
  iw=0;
  i=4*bg_first_xpoint;
  jb=2*fft3_slowsum_recalc;
  for(j=0; j<jb; j+=2)
    {
    fft3_slowsum[j  ]-=fft3_power[k  ];
    fft3_slowsum[j+1]-=fft3_power[k+1];
    t1=pg.c1*z[i  ]+pg.c2*z[i+2]+pg.c3*z[i+3];
    t2=pg.c1*z[i+1]+pg.c2*z[i+3]-pg.c3*z[i+2];
    t3=pg.c1*z[i+2]-pg.c2*z[i  ]+pg.c3*z[i+1];
    t4=pg.c1*z[i+3]-pg.c2*z[i+1]-pg.c3*z[i  ];
    fft3_power[k  ]=(t1*t1+t2*t2)*fft3_fqwin_inv[i>>2];
    fft3_power[k+1]=(t3*t3+t4*t4)*fft3_fqwin_inv[i>>2];
    i+=4;
    bg_waterf_sum[iw]+=fft3_power[k];
    if(bg_twopol !=0)bg_waterf_sum[iw]+=fft3_power[k+1];
    iw++;
    fft3_slowsum[j  ]+=fft3_power[k  ];
    fft3_slowsum[j+1]+=fft3_power[k+1];
    if(fft3_slowsum[j  ]<0.00001)fft3_slowsum[j  ]=0.00001;
    if(fft3_slowsum[j+1]<0.00001)fft3_slowsum[j+1]=0.00001;
    k+=2;
    }
  jr=fft3_slowsum_recalc+bg_xpoints/bg.fft_avgnum+1;
  if(jr > bg_xpoints)jr=bg_xpoints;
  ja=jb;
  jb=2*jr;
  for(j=ja; j<jb; j+=2)
    {
    t1=pg.c1*z[i  ]+pg.c2*z[i+2]+pg.c3*z[i+3];
    t2=pg.c1*z[i+1]+pg.c2*z[i+3]-pg.c3*z[i+2];
    t3=pg.c1*z[i+2]-pg.c2*z[i  ]+pg.c3*z[i+1];
    t4=pg.c1*z[i+3]-pg.c2*z[i+1]-pg.c3*z[i  ];
    fft3_power[k  ]=(t1*t1+t2*t2)*fft3_fqwin_inv[i>>2];
    fft3_power[k+1]=(t3*t3+t4*t4)*fft3_fqwin_inv[i>>2];
    i+=4;
    bg_waterf_sum[iw]+=fft3_power[k];
    if(bg_twopol !=0)bg_waterf_sum[iw]+=fft3_power[k+1];
    iw++;
    p0=k-bg_show_pa;
    fft3_slowsum[j  ]=fft3_power[p0  ];
    fft3_slowsum[j+1]=fft3_power[p0+1];
    for(m=1; m<bg.fft_avgnum; m++)
      {
      p0+=2*bg_xpoints;
      fft3_slowsum[j  ]+=fft3_power[p0  ];
      fft3_slowsum[j+1]+=fft3_power[p0+1];
      }
    k+=2;
    }
  ja=jb;
  jb=2*bg_xpoints;
  for(j=ja; j<jb; j+=2)
    {
    fft3_slowsum[j  ]-=fft3_power[k  ];
    fft3_slowsum[j+1]-=fft3_power[k+1];
    t1=pg.c1*z[i  ]+pg.c2*z[i+2]+pg.c3*z[i+3];
    t2=pg.c1*z[i+1]+pg.c2*z[i+3]-pg.c3*z[i+2];
    t3=pg.c1*z[i+2]-pg.c2*z[i  ]+pg.c3*z[i+1];
    t4=pg.c1*z[i+3]-pg.c2*z[i+1]-pg.c3*z[i  ];
    fft3_power[k  ]=(t1*t1+t2*t2)*fft3_fqwin_inv[i>>2];
    fft3_power[k+1]=(t3*t3+t4*t4)*fft3_fqwin_inv[i>>2];
    i+=4;
    bg_waterf_sum[iw]+=fft3_power[k];
    if(bg_twopol !=0)bg_waterf_sum[iw]+=fft3_power[k+1];
    iw++;
    fft3_slowsum[j  ]+=fft3_power[k  ];
    fft3_slowsum[j+1]+=fft3_power[k+1];
    if(fft3_slowsum[j  ]<0.00001)fft3_slowsum[j  ]=0.00001;
    if(fft3_slowsum[j+1]<0.00001)fft3_slowsum[j+1]=0.00001;
    k+=2;
    }
  }
if(jr != bg_xpoints)
  {
  fft3_slowsum_recalc=jr;
  }
else
  {  
  fft3_slowsum_recalc=0;
  }
// Interleave factor is 2 for sin square window  
timf3_px=(timf3_px+ui.rx_channels*fft3_size)&timf3_mask;
if(((timf3_pa-timf3_px+timf3_size)&timf3_mask) < twice_rxchan*fft3_size)
  {
  newdat_flag&=-1-ND_TIMF3;
  } 
if( ((timf3_px-timf3_pa+timf3_mask)&timf3_mask) >= timf3_block)
  {
  fullbuf_flag &=-1-ND_TIMF3;
  }
bg_show_pa+=ui.rx_channels*bg_xpoints;
if(bg_show_pa+ui.rx_channels*bg_xpoints >= fft3_show_size)bg_show_pa=0;
bg_redraw_counter++;
bg_waterf_sum_counter++;
if(bg_waterf_sum_counter >= bg.waterfall_avgnum)
  {
  update_bg_waterf();
  }
mix0_absent:;
fft3_pa=(fft3_pa+fft3_block)&fft3_mask;
if( ((fft3_pa-fft3_px-bg.afc2_delay*fft3_block/2+fft3_mask)&
                                                    fft3_mask) > fft3_block)
  {
  newdat_flag|=ND_FFT3;
  }
if( ((fft3_px-fft3_pa+fft3_mask)&fft3_mask) < fft3_block)
  {
  fullbuf_flag|=ND_FFT3;
  }
}


