#include <vga.h>
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "seldef.h"
#include "screendef.h"
#include "hwaredef.h"
#include "fft1def.h"


void fill_afc_graph(void);

void check_filtercorr_direction(void)
{
int i,j,k,mm;
float t1,t2;
if( fft1_filtercorr_direction*fft1_direction < 0 )
  {
  fft1_filtercorr_direction = fft1_direction;
  mm=2*ui.rx_channels;
  k=fft1_size;
  for(i=0; i<fft1_size/2; i++)
    {
    k--;
    for(j=0; j<mm; j+=2)
      {
      t1=fft1_filtercorr[mm*i+j];
      t2=fft1_filtercorr[mm*i+j+1];
      fft1_filtercorr[mm*i+j]=fft1_filtercorr[mm*k+j+1];
      fft1_filtercorr[mm*i+j+1]=fft1_filtercorr[mm*k+j];
      fft1_filtercorr[mm*k+j]=t2;
      fft1_filtercorr[mm*k+j+1]=t1;
      }
    t1=fft1_desired[i];
    fft1_desired[i]=fft1_desired[k];
    fft1_desired[k]=t1;
    }
  for(i=0; i<fft1_size; i++)fft1_slowsum[i]=0;
  for(i=0; i<fft1_sumsq_bufsize; i++)fft1_sumsq[i]=0;
  }  
}


void show_hardware_gain(void)
{
char s[80];
sprintf(s,"%3d dB",fg.gain);
ck_write(fg.xleft+2.5*text_width,fg.ybottom-text_height,s);
}

void show_center_frequency(void)
{
int i,k;
char s[512];
// Get the center frequency in ascii with too many decimals and
// too many leading blanks.
sprintf(s,"         %.12f",fg.passband_center+FREQ_MHZ_ROUNDCORR);
i=1;
while(s[i] != '.' && i< 20)i++;
k=i-FREQ_MHZ_DIGITS;
s[FREQ_MHZ_DECIMALS+i+1]=0;
errno=20278;
ck_write(fg.xleft+2.5*text_width,fg.ybottom-2*text_height-1,&s[k]);
make_wg_freq_scale();
if(hg_flag == 1)hires_fq_scale();
if(bg_flag == 1)baseband_fq_scale();
if(genparm[AFC_ENABLE] != 0 && afc_graph_filled != 0)fill_afc_graph();
}


void new_center_frequency(void)
{
if(hware_init_flag != 0)return;
fg.passband_center=numinput_float_data;
set_hardware_rx_frequency();
check_filtercorr_direction();
show_center_frequency();
make_modepar_file(GRAPHTYPE_FG);
}

void new_rx_gain_value(void)
{
if(hware_init_flag != 0)return;
fg.gain=numinput_int_data;
set_hardware_rx_gain(fg_old_band);
show_hardware_gain();
make_modepar_file(GRAPHTYPE_FG);
}

void help_on_freq_graph(void)
{
int msg_no;
int event_no;
// Set msg invalid in case we are not in any select area.
if(mouse_y <= fg_yborder)
  {
  msg_no=84;
  }
else
  {  
  msg_no=87;
  }
for(event_no=0; event_no<MAX_FGBUTT; event_no++)
  {
  if( fgbutt[event_no].x1 <= mouse_x && 
      fgbutt[event_no].x2 >= mouse_x &&      
      fgbutt[event_no].y1 <= mouse_y && 
      fgbutt[event_no].y2 >= mouse_y) 
    {
    switch (event_no)
      {
      case FG_TOP:
      case FG_BOTTOM:
      case FG_LEFT:
      case FG_RIGHT:
      msg_no=101;
      break;

      case FG_INCREASE_FQ: 
      msg_no=83;
      break;
  
      case FG_DECREASE_FQ:
      msg_no=82;
      break;

      case FG_INCREASE_GAIN: 
      msg_no=85;
      break;
  
      case FG_DECREASE_GAIN:
      msg_no=86;
      break;
      }
    }  
  }
help_message(msg_no);
}




void mouse_continue_freq_graph(void)
{
int i, j;
hide_mouse();
switch (mouse_active_flag-1)
  {
  case FG_TOP:
  case FG_BOTTOM:
  case FG_LEFT:
  case FG_RIGHT:
  fg_borders(0);
  if(fg_oldx==-10000)
    {
    fg_oldx=mouse_x;
    fg_oldy=mouse_y;
    }
  else
    {
    i=mouse_x-fg_oldx;
    j=mouse_y-fg_oldy;  
    fg_oldx=mouse_x;
    fg_oldy=mouse_y;
    fg.ytop+=j;
    fg.ybottom+=j;      
    fg.xleft+=i;
    fg.xright+=i;
    check_fg_borders();
    fg_yborder=(fg.ytop+fg.ybottom)>>1;
    fg_borders(15);
    }
  break;
    
  default:
  goto await_release;
  }
if(leftpressed == 2)goto finish;
show_mouse();
return;
await_release:;
if(leftpressed == 1)
  {
  show_mouse();
  return;
  }
if(network_flag != 2)
  {
  switch (mouse_active_flag-1)
    {
    case FG_INCREASE_FQ: 
    if(hware_init_flag == 0)
      {
      fg.passband_center+=fg.passband_increment;
      set_hardware_rx_frequency();
      check_filtercorr_direction();
      }
    break;
  
    case FG_DECREASE_FQ:
    if(hware_init_flag == 0)
      {
      fg.passband_center-=fg.passband_increment;
      set_hardware_rx_frequency();
      check_filtercorr_direction();
      }
    break;

    case FG_INCREASE_GAIN: 
    if(hware_init_flag == 0)
      {
      fg.gain+=fg.gain_increment;
      set_hardware_rx_gain(fg_old_band);
      }
    break;
  
    case FG_DECREASE_GAIN:
    if(hware_init_flag == 0)
      {
      fg.gain-=fg.gain_increment;
      set_hardware_rx_gain(fg_old_band);
      }
    break;

    default:
    end_program(872);
    break;
    }
  }  
finish:;
leftpressed=0;  
mouse_active_flag=0;
for(i=0; i<no_of_scro; i++)
  {
  if(scro[i].no == FREQ_GRAPH)
    {
    fg_borders(0);
errno=40133;
    ck_fillbox(fg_old_x1,fg_old_y1,fg_old_x2-fg_old_x1,fg_old_y2-fg_old_y1,0);
    make_freq_graph(i);
    fg_oldx=-10000;
    show_mouse();
    return;
    }
  }
end_program(878);  
}

void mouse_on_freq_graph(void)
{
int event_no;
// First find out is we are on a button or border line.
for(event_no=0; event_no<MAX_FGBUTT; event_no++)
  {
  if( fgbutt[event_no].x1 <= mouse_x && 
      fgbutt[event_no].x2 >= mouse_x &&      
      fgbutt[event_no].y1 <= mouse_y && 
      fgbutt[event_no].y2 >= mouse_y) 
    {
    fg_old_y1=fg.ytop;
    fg_old_y2=fg.ybottom;
    fg_old_x1=fg.xleft;
    fg_old_x2=fg.xright;
    mouse_active_flag=1+event_no;
    current_mouse_activity=mouse_continue_freq_graph;
    return;
    }
  }
// Not button or border.
// Prompt the user for a new center frequency from keyboard.
if(network_flag == 2)return;
mouse_active_flag=1;
numinput_xpix=fg.xleft+2.5*text_width;
hide_mouse();
if(mouse_y < fg_yborder)
  {
  numinput_ypix=fg.ybottom-2*text_height-1;
  numinput_chars=FREQ_MHZ_DIGITS+FREQ_MHZ_DECIMALS+1;
  erase_numinput_txt();
  numinput_flag=FIXED_FLOAT_PARM;
  par_from_keyboard_routine=new_center_frequency;
  }
else
  {
  numinput_ypix=fg.ybottom-text_height;
  numinput_chars=4;
  erase_numinput_txt();
  numinput_flag=FIXED_INT_PARM;
  par_from_keyboard_routine=new_rx_gain_value;
  }  
show_mouse();
}





void check_fg_borders(void)
{
current_graph_minh=fg_vsiz;
current_graph_minw=fg_hsiz;
check_graph_placement((void*)(&fg));
set_graph_minwidth((void*)(&fg));
}

void fg_borders(int color)
{
errno=12546;
ck_hline(fg.xleft,fg.ytop,fg.xright,color);
errno=12545;
ck_hline(fg.xleft,fg_yborder,fg.xright,color);
errno=12547;
ck_hline(fg.xleft,fg.ybottom,fg.xright,color);
errno=12548;
ck_line(fg.xleft,fg.ytop,fg.xleft,fg.ybottom,color);
errno=12549;
ck_line(fg.xright,fg.ytop,fg.xright,fg.ybottom,color);
}


void make_freq_graph(int m)
{
fg_flag=1;
fg_hsiz=(FREQ_MHZ_DECIMALS+FREQ_MHZ_DIGITS+6)*text_width;
fg_vsiz=2*text_height+5;
check_fg_borders();
fg_yborder=(fg.ytop+fg.ybottom)>>1;
scro[m].no=FREQ_GRAPH;
scro[m].x1=fg.xleft;
scro[m].x2=fg.xright;
scro[m].y1=fg.ytop;
scro[m].y2=fg.ybottom;
fgbutt[FG_LEFT].x1=fg.xleft;
fgbutt[FG_LEFT].x2=fg.xleft;
fgbutt[FG_LEFT].y1=fg.ytop;
fgbutt[FG_LEFT].y2=fg.ybottom;
fgbutt[FG_RIGHT].x1=fg.xright;
fgbutt[FG_RIGHT].x2=fg.xright;
fgbutt[FG_RIGHT].y1=fg.ytop;
fgbutt[FG_RIGHT].y2=fg.ybottom;
fgbutt[FG_TOP].x1=fg.xleft;
fgbutt[FG_TOP].x2=fg.xright;
fgbutt[FG_TOP].y1=fg.ytop;
fgbutt[FG_TOP].y2=fg.ytop;
fgbutt[FG_BOTTOM].x1=fg.xleft;
fgbutt[FG_BOTTOM].x2=fg.xright;
fgbutt[FG_BOTTOM].y1=fg.ybottom;
fgbutt[FG_BOTTOM].y2=fg.ybottom;
// Draw the border lines
fg_borders(7);
fg_oldx=-10000;
settextcolor(7);
make_button(fg.xleft+text_width,fg.ybottom-3*text_height/2-2,
                                         fgbutt,FG_DECREASE_FQ,25);
make_button(fg.xright-text_width,fg.ybottom-3*text_height/2-2,
                                     fgbutt,FG_INCREASE_FQ,24); 
make_button(fg.xleft+text_width,fg.ybottom-text_height/2-2,
                                         fgbutt,FG_DECREASE_GAIN,25);
make_button(fg.xright-text_width,fg.ybottom-text_height/2-2,
                                     fgbutt,FG_INCREASE_GAIN,24); 
show_center_frequency();
show_hardware_gain();
make_modepar_file(GRAPHTYPE_FG);
}

void read_freq_control_data(void)
{
if (read_modepar_file(GRAPHTYPE_FG) == 0)
  {
  fg.xleft=7*WIDTH/8;
  fg.xright=fg.xleft+text_width;
  fg.ybottom=3*HEIGHT/4;
  fg.ytop=fg.ybottom-text_height;
  fg.passband_center=0;
  fg.passband_direction=0;
  fg.gain=0;
  fg.gain_increment=0;
  }
}


void init_freq_control(void)
{
hware_init_flag=0;
clear_hware_data();
make_freq_graph(no_of_scro);
fg_old_band=-1;
set_hardware_rx_frequency();
check_filtercorr_direction();
no_of_scro++;
if(no_of_scro >= MAX_SCRO)end_program(89);
}
