#include <vga.h>
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "screendef.h"
#include "seldef.h"
#include "sigdef.h"

unsigned char show_scro_color;

void show_scro(int ix1,int iy1,int ix2,int iy2)
{
unsigned char cl;
cl=show_scro_color;
ck_hline(ix1,iy1,ix2,cl);
cl++;
if(cl > 15)cl=9;
ck_hline(ix1,iy2,ix2,cl);
cl++;
if(cl > 15)cl=9;
ck_line(ix1,iy1,ix1,iy2,cl);
cl++;
if(cl > 15)cl=9;
ck_line(ix2,iy1,ix2,iy2,cl);
}


void help_screen_objects(void)
{
int i,j;
char *screensave;
struct timeval tim1, tim2;
float t1;
errno=10799;    

show_scro_color=9;
screensave=chk_malloc(WIDTH*HEIGHT,1047);
gl_getbox(0,0,WIDTH,HEIGHT,screensave);
repeat:;
for(i=0; i<no_of_scro; i++)
  {
  switch (scro[i].no)
    {
    case WIDE_GRAPH:
errno=10804;    
    for(j=0; j<MAX_WGBUTT; j++)
      {
      show_scro(wgbutt[j].x1,wgbutt[j].y1,wgbutt[j].x2,wgbutt[j].y2);
      }
    break;
    
    case HIRES_GRAPH:
    for(j=0; j<MAX_HGBUTT; j++)
      {
errno=10800;    
      if(hgbutt[j].x1 > 0)
        { 
        show_scro(hgbutt[j].x1,hgbutt[j].y1,hgbutt[j].x2,hgbutt[j].y2);
        }
      }
// The control bars are separate from the buttons.
errno=10801;    
    show_scro(timf2_hg_xmin-2,timf2_hg_y[0],
                               timf2_hg_xmax+1,timf2_hg_y[0]+text_height-1);
errno=10802;    
    show_scro(hg_ston1_x2+2,hg_ston_y0,hg_first_xpixel,hg_stonbars_ytop);
errno=10803;    
    show_scro(hg.xleft+1,hg_ston_y0, hg_ston1_x2,hg_stonbars_ytop);
    break;
    
    case AFC_GRAPH:
    for(j=0; j<MAX_AGBUTT; j++)
      {
errno=10808;    
      show_scro(agbutt[j].x1,agbutt[j].y1,agbutt[j].x2,agbutt[j].y2);
      } 
// The control bars are separate from the buttons.
errno=10805;    
    show_scro(ag_ston_x1,ag_fpar_y0,ag_ston_x2,ag_fpar_ytop);
errno=10806;    
    show_scro(ag_lock_x1,ag_fpar_y0,ag_lock_x2,ag_fpar_ytop);
errno=10807;    
    show_scro(ag_search_x1,ag_fpar_y0,ag_search_x2,ag_fpar_ytop);
    break;
    
    case BASEBAND_GRAPH:
    for(j=0; j<MAX_BGBUTT; j++)
      {
errno=10809;    
      if(bgbutt[j].x2 < WIDTH)
        { 
        show_scro(bgbutt[j].x1,bgbutt[j].y1,bgbutt[j].x2,bgbutt[j].y2);
        }
// The volume control bar:
errno=10811;    
      }
    show_scro(bg_vol_x1,bg_y0,bg_vol_x2,bg_ymax);
    break;
    
    case POL_GRAPH:
    for(j=0; j<MAX_PGBUTT; j++)
      {
errno=10810;    
      show_scro(pgbutt[j].x1,pgbutt[j].y1,pgbutt[j].x2,pgbutt[j].y2);
      } 
    break;
    
    case COH_GRAPH:
    for(j=0; j<MAX_CGBUTT; j++)
      {
errno=210810;    
      show_scro(cgbutt[j].x1,cgbutt[j].y1,cgbutt[j].x2,cgbutt[j].y2);
      } 
    break;
    
    case EME_GRAPH:
    for(j=0; j<MAX_EGBUTT; j++)
      {
errno=210811;    
      show_scro(egbutt[j].x1,egbutt[j].y1,egbutt[j].x2,egbutt[j].y2);
      } 
    break;

    case FREQ_GRAPH:
    for(j=0; j<MAX_FGBUTT; j++)
      {
errno=210812;    
      show_scro(fgbutt[j].x1,fgbutt[j].y1,fgbutt[j].x2,fgbutt[j].y2);
      } 
    break;


    }
  }
show_scro_color++;
if(show_scro_color > 15)show_scro_color=9;
gettimeofday(&tim1,NULL);
wait:;
gettimeofday(&tim2,NULL);
t1=0.000001*(tim2.tv_usec-tim1.tv_usec)+(tim2.tv_sec-tim1.tv_sec);
if(t1<0.3)goto wait;
vga_inkey=vga_getkey(); 
clean_vga_inkey();
if(vga_inkey == 0)goto repeat;
gl_putbox(0,0,WIDTH,HEIGHT,screensave);
}

void help_message(int msg_no)
{
char s[512];
char msg[128];
char chr;
int i,j,k,line;
int adf,daf;
FILE *file;
char *screensave;
if(msg_no < 0)return;
daf=audio_out;
adf=audio_in;
close_audio_output();
close_audio_input();
settextcolor(15);
screensave=chk_malloc(WIDTH*HEIGHT,1047);
gl_getbox(0,0,WIDTH,HEIGHT,screensave);
vga_clear();
file=fopen("help.lir", "r");
line=0;
if(file == NULL)
  {
  xytext(0,0,"Could not find file help.lir. No info available.");
  line=1;
  }
else
  {
gtnum:;
  i=fread(&s,1,1,file);
  if(i==0)
    {
    sprintf(msg,"Could not find info no %d",msg_no);
    xytext(0,0,msg);
    line=1;
    goto finish;
    }
  if(s[0] != '[')goto gtnum;
  j=0;
  while(fread(&s[j],1,1,file)==1 && s[j] != ']')j++;
  s[j]=0;
  sscanf(s,"%d",&k);
  if(k != msg_no)goto gtnum;
  sprintf(s,"[%d]",msg_no);
  j=0;
  while(s[j]!=0)j++;
  j--;
gtrow:; 
  j++;   
  i=fread(&s[j],1,1,file);
  if( i==1 && s[j] != 10 && s[j] != '[' && j<255 )goto gtrow;
  chr=s[j];
  if(chr== '[')
    {
    s[j]=0;
    }
  else
    {  
    s[j+1]=0;
    }
  xytext(0,line,s);
  line++;
  if(chr != '[' && i==1)
    {
    j=-1;
    goto gtrow;
    }   
  }
finish:;       
xytext(0,line,"       PRESS ANY KEY!");
await_keyboard();
clean_vga_inkey();
gl_putbox(0,0,WIDTH,HEIGHT,screensave);
free(screensave);
settextcolor(7);
if(adf != -1)open_audio_input();
if(daf != -1)open_audio_output();
vga_inkey=0;
if(adf == -1 && daf == -1)return;
clear_ad_countertimer();
clear_sound_timers();
if(new_baseb_flag >= 0)new_baseb_flag=2;
ensure_valid_input();
}
