   
#define HG_DBSCALE_COLOR 4
#define HG_STON_RANGE 6.0


#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "screendef.h"
#include "blnkdef.h"
#include "seldef.h"
#include "graphcal.h"
#include "vernr.h"

char chan_color[2]={2,4};

void show_hg_buttons(void)
{
char s[80];
errno=31009;
sprintf(s,"%4d",hg.spek_avgnum);
show_button(&hgbutt[HG_FFT2_AVGNUM],s);
}




void make_bars(void)
{
update_bar(hg_ston1_x1,hg_ston1_x2,hg_ston_y0,hg_ston1_y,-1,0xb0,hg_stonbuf);
update_bar(hg_ston2_x1,hg_ston2_x2,hg_ston_y0,hg_ston2_y,-1,0xb2,hg_stonbuf);
}

void make_hg_yscale(void)
{
char s[80];
int i,k;
int ypixels, scale_y;
float db_scalestep, scale_value, yrange,db_ref;
  errno=40103;
ck_fillbox(hg.xleft+1,hg.ytop+1,hg.xright-hg.xleft-2,
                                        hg_y0-hg.ytop-2,0);
for(i=0; i<HEIGHT; i++)hg_background[i]=0;
hg_db_per_pixel=HG_GAIN/wg.waterfall_db_gain;
db_scalestep=1.3*hg_db_per_pixel*text_height;
adjust_scale(&db_scalestep);
ypixels=hg_y0-hg.ytop;
yrange=ypixels*hg_db_per_pixel;
// Make db_ref a dB value to put at the bottom of our graph.
// Select it for waterfall_db_zero to be at 20% of the y axis.
db_ref=(wg.waterfall_db_zero-0.2*yrange);
// Make db_ref a multiple of db_scalestep + 0.00001  
i=0.5+db_ref/db_scalestep;
db_ref=i*db_scalestep+0.00001;
scale_value=db_ref-db_scalestep;
scale_y=hg_y0+db_scalestep/hg_db_per_pixel;
while( scale_y-2.5*text_height > hg.ytop+db_scalestep/hg_db_per_pixel)
  {
  scale_y-=db_scalestep/hg_db_per_pixel;
  scale_value+=db_scalestep;
  if(scale_y+2*text_height-1 < hg.ybottom)
    {
    i=scale_value;
    if(i>=-9 && i<100 && scale_value-i < db_scalestep/2)
      {
      sprintf(s,"%2d",i);
errno=20108;
      ck_write(hg.xleft+2,scale_y-text_midpoint,s);
      }
    }
  if(scale_y+2+text_height < hg.ybottom)
    {
    i=scale_y;
    hg_background[i]=HG_DBSCALE_COLOR;    
errno=10419;
    ck_hline(hg_first_xpixel,i,hg_last_xpixel,HG_DBSCALE_COLOR);
    }
  } 
  
hg_yfac_power=(float)(fft1_new_points)/fft1_size;
hg_yfac_power=(HG_ZERO*hg_yfac_power)/fft1_size;
hg_yfac_power/=(fft2_size*hg.spek_avgnum*pow(10.,0.1*db_ref));
if(fft_cntrl[FFT2_CURMODE].mmx != 0)
  {
  hg_yfac_power*=1<<(2*genparm[SECOND_FFT_ATT_N]);
  }
hg_yfac_power*=1<<(2*genparm[FIRST_BCKFFT_ATT_N]);
hg_yfac_log=10./hg_db_per_pixel;
// Place a colour scale at the right hand side
for(i=hg_y0; i>hg_ymax+text_height; i--)
  {
  scale_value=db_ref+(hg_y0-i)*hg_db_per_pixel;
  k=wg_waterf_cfac*((scale_value-wg.waterfall_db_zero)*10);
  if(k<0)k=0;
  if(k>=MAX_COLOR_SCALE)k=MAX_COLOR_SCALE-1;
errno=10420;
  ck_hline(hg_last_xpixel+1,i,hg.xright-1,color_scale[k]);
  }
make_wg_yfac();
}

void new_hg_pol(void)
{
float *fftxy, *pwr;
int i, j, j_last;
int ib,k;
float t1,t2,t3,t4,r1,r2;
short int *zxy;
ib=hg_last_point;
k=2*hg_size;
for(i=0; i<k; i++) hg_fft2_pwrsum[i]=0;
j=fft2_nb;
j_last=(fft2_na+fft2n_mask)&fft2n_mask;
nwpol:;
pwr=&hg_fft2_pwr[2*j*hg_size];
k=0;
if(fft_cntrl[FFT2_CURMODE].mmx == 0)
  { 
  fftxy=&fft2_float[twice_rxchan*j*fft2_size];
  for(i=hg_first_point; i<ib; i++)
    {
    t1=fftxy[4*i  ];
    t2=fftxy[4*i+1];
    t3=fftxy[4*i+2];
    t4=fftxy[4*i+3];
    r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
    r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
    pwr[2*k  ]=r1*r1+r2*r2;
    hg_fft2_pwrsum[2*k  ]+=pwr[2*k  ];
    r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
    r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
    pwr[2*k+1]=r1*r1+r2*r2;
    hg_fft2_pwrsum[2*k+1]+=pwr[2*k+1];
    k++;
    }
  }
else
  {
  zxy=&fft2_short_int[twice_rxchan*j*fft2_size];
  for(i=hg_first_point; i<ib; i++)
    {
    t1=zxy[4*i  ];
    t2=zxy[4*i+1];
    t3=zxy[4*i+2];
    t4=zxy[4*i+3];
    r1=pg.c1*t1+pg.c2*t3+pg.c3*t4;
    r2=pg.c1*t2+pg.c2*t4-pg.c3*t3;
    pwr[2*k  ]=r1*r1+r2*r2;
    hg_fft2_pwrsum[2*k  ]+=pwr[2*k  ];
    r1=pg.c1*t3-pg.c2*t1+pg.c3*t2;
    r2=pg.c1*t4-pg.c2*t2-pg.c3*t1;
    pwr[2*k+1]=r1*r1+r2*r2;
    hg_fft2_pwrsum[2*k+1]+=pwr[2*k+1];
    k++;
    }
  }
if(j==j_last)return;
j=(j+1)&fft2n_mask;
goto nwpol;
}



void new_fft2_averages(void)
{
float *pwra;
TWOCHAN_POWER_FLOAT *y;
int i, j, k, ib;
if(mix1_selfreq[0] < 0)return;
// The number to average over may have changed, update fft2_nb
i=(fft2_na-hg.spek_avgnum+max_fft2n)&fft2n_mask;
if(i != fft2_nb)
  {
  fft2_nb=i;
  if(sw_onechan)
    {
    pwra=&fft2_power_float[fft2_nb*fft2_size];
    for(i=0; i<fft2_size; i++)
      {
      fft2_powersum_float[i]=pwra[i];
      }
    j=fft2_nb;
    if(j==fft2_na)goto ex1;
sum:;
    j=(j+1)&fft2n_mask;
    if(j==fft2_na)goto ex1;
    pwra=&fft2_power_float[j*fft2_size];
    for(i=0; i<fft2_size; i++)
      {
      fft2_powersum_float[i]+=pwra[i];
      }
    goto sum;
ex1:;
    }
  else
    {  
    y=&fft2_xypower_float[fft2_nb*fft2_size];
    for(i=0; i<fft2_size; i++)
      {
      fft2_xysum_float[i].x2   =y[i].x2;
      fft2_xysum_float[i].y2   =y[i].y2;
      fft2_xysum_float[i].im_xy=y[i].im_xy;
      fft2_xysum_float[i].re_xy=y[i].re_xy;
      }
    j=fft2_nb;
    if(j==fft2_na)goto ex2;
sumxy:;
    j=(j+1)&fft2n_mask;
    if(j==fft2_na)goto ex2;
    y=&fft2_xypower_float[j*fft2_size];
    for(i=0; i<fft2_size; i++)
      {
      fft2_xysum_float[i].x2   +=y[i].x2;
      fft2_xysum_float[i].y2   +=y[i].y2;
      fft2_xysum_float[i].im_xy+=y[i].im_xy;
      fft2_xysum_float[i].re_xy+=y[i].re_xy;
      }
    goto sumxy;
ex2:;
    }
  }
if(sw_onechan)
  {
  ib=hg_last_point;
  j=fft2_nb;  
  pwra=&fft2_power_float[j*fft2_size];
  k=0;
  for(i=hg_first_point; i<ib; i++)
    {
    hg_fft2_pwrsum[k]=pwra[i];
    k++;
    }
sum_2:;
  k=0; 
  pwra=&fft2_power_float[j*fft2_size];
  for(i=hg_first_point; i<ib; i++)
    {
    hg_fft2_pwrsum[k]+=pwra[i];
    k++;
    }
  j=(j+1)&fft2n_mask;  
  if(j == fft2_na)return;
  goto sum_2;
  }
else
  {  
  new_hg_pol();
  }
}



void help_on_hires_graph(void)
{
int msg_no;
int event_no;
// Set msg to select a frequency in case it is not button or border
msg_no=13;
// In case we are on one of the control bars, select the
// appropriate message.
if(mouse_y >= hg_ston_y0)
  {
  if(mouse_x >= timf2_hg_xmin && mouse_x <= timf2_hg_xmax)
    {
    msg_no=14;
    }
  else
    {
    msg_no=-1;
    }  
  }
else
  {

  if( mouse_x<hg_first_xpixel && mouse_y > hg_stonbars_ytop)
    {
    if(mouse_x <= hg_ston1_x2)
      {
      msg_no=15;
      }
    else
      {
      msg_no=16;
      }  
    }
  }
for(event_no=0; event_no<MAX_WGBUTT; event_no++)
  {
  if( hgbutt[event_no].x1 <= mouse_x && 
      hgbutt[event_no].x2 >= mouse_x &&      
      hgbutt[event_no].y1 <= mouse_y && 
      hgbutt[event_no].y2 >= mouse_y) 
    {
    switch (event_no)
      {
      case HG_TOP:
      case HG_BOTTOM:
      case HG_LEFT:
      case HG_RIGHT:
      msg_no=100;
      break;

      case HG_BLN_STUPID:
      msg_no=17;
      break;

      case HG_BLN_CLEVER:
      msg_no=18;
      break;  

      case HG_TIMF2_STATUS:
      if(sw_onechan)
        {
        msg_no=19;
        }
      else
        {
        msg_no=20;
        }  
      break;

      case HG_TIMF2_ST_INC:
      msg_no=73;
      break;

      case HG_TIMF2_ST_DEC:
      msg_no=74;
      break;

      case HG_TIMF2_WK_INC:
      msg_no=75;
      break;

      case HG_TIMF2_WK_DEC:
      msg_no=76;
      break;

      case HG_TIMF2_LINES:
      msg_no=77;
      break;
  
      case HG_TIMF2_HOLD:
      msg_no=78;
      break;

      case HG_FFT2_AVGNUM:
      msg_no=62;
      break;

      }
    }  
  }
help_message(msg_no);
}  



void change_fft2avgnum(void)
{
hg.spek_avgnum=numinput_int_data;
if(hg.spek_avgnum <1)hg.spek_avgnum=1;
if(hg.spek_avgnum>fft2n_mask)hg.spek_avgnum=fft2n_mask;
make_modepar_file(GRAPHTYPE_HG);
make_hg_yscale();
hires_fq_scale();
make_bars();
new_fft2_averages();
}



void mouse_continue_hires_graph(void)
{
int i, j;
hide_mouse();
switch (mouse_active_flag-1)
  {
  case HG_TOP:
  hg_borders(0);
  hg.ytop=mouse_y;
  j=hg.ybottom-2*text_height;
  if(hg.ytop > j)hg.ytop=j;      
  hg_borders(15);
  break;

  case HG_BOTTOM:
  hg_borders(0);
  hg.ybottom=mouse_y;
  if(hg.ybottom < hg_stonbars_ytop)hg.ybottom=hg_stonbars_ytop;      
  hg_borders(15);
  break;

  case HG_LEFT:
  hg_borders(0);
  hg.xleft=mouse_x;
  j=hg.xright-32-6*text_width;
  if(hg.xleft > j)hg.xleft=j;      
  hg_borders(15);
  break;

  case HG_RIGHT:
  hg_borders(0);
  hg.xright=mouse_x;
  j=hg.xleft+32+6*text_width;
  if(hg.xright < j)hg.xright=j;      
  hg_borders(15);
  break;

  default:
  goto await_release;
  }
if(leftpressed == 2)goto finish;
show_mouse();
return;
await_release:;
if(leftpressed == 1)
  {
  show_mouse();
  return;
  }
switch (mouse_active_flag-1)
  {
  case HG_BLN_STUPID:
  hg.stupid_bln_mode++;
  if(hg.stupid_bln_mode>2)hg.stupid_bln_mode=0;
  break;

  case HG_BLN_CLEVER:
  if(fft1_filtercorr_flag!=0)
    {
    hg.clever_bln_mode++;
    if(hg.clever_bln_mode>2)hg.clever_bln_mode=0;
    }
  break;  

  case HG_TIMF2_STATUS:
  hg.timf2_display^=1;
  timf2_display_counter=0;
  timf2_display_maxval=0;
  timf2_display_powermax=0;
  timf2_show_pointer=-1;
  break;

  case HG_TIMF2_ST_INC:
  hg.timf2_display_st_gain *=2;
  if(hg.timf2_display_st_gain > 256)hg.timf2_display_st_gain = 256;
  break;

  case HG_TIMF2_ST_DEC:
  hg.timf2_display_st_gain /=2;
  if(hg.timf2_display_st_gain < 0.00002)hg.timf2_display_st_gain = 1./32768;
  break;

  case HG_TIMF2_WK_INC:
  hg.timf2_display_wk_gain *=2;
  if(hg.timf2_display_wk_gain > 256)hg.timf2_display_wk_gain = 256;
  break;

  case HG_TIMF2_WK_DEC:
  hg.timf2_display_wk_gain /=2;
  if(hg.timf2_display_wk_gain < 0.00002)hg.timf2_display_wk_gain = 1./32768;
  break;

  case HG_TIMF2_LINES:
  hg.timf2_display_lines^=1;
  break;
  
  case HG_TIMF2_HOLD:
  hg.timf2_display_hold^=1;
  break;

  case HG_FFT2_AVGNUM:
  mouse_active_flag=1;
  numinput_xpix=hgbutt[HG_FFT2_AVGNUM].x1+text_width/2-1;
  numinput_ypix=hgbutt[HG_FFT2_AVGNUM].y1+2;
  numinput_chars=4;    
  erase_numinput_txt();
  numinput_flag=FIXED_INT_PARM;
  show_mouse();
  par_from_keyboard_routine=change_fft2avgnum;
  return;

  break;
  }      
finish:;
leftpressed=0;  
mouse_active_flag=0;
for(i=0; i<no_of_scro; i++)
  {
  if(scro[i].no == HIRES_GRAPH)
    {
    timf2_hg_x[0]=-1;
    timf2_hg_x[1]=-1;
    hg_borders(0);
  errno=40103;
    ck_fillbox(hg_old_x1,hg_old_y1,hg_old_x2-hg_old_x1,hg_old_y2-hg_old_y1,0);
    make_hires_graph(i);
    hires_fq_scale();
    new_fft2_averages();
    show_mouse();
    return;
    }
  }
end_program(854);  
}


void hg_control_finish(void)
{
if(hg.clever_bln_mode != 0)
  {
errno=10421;
  ck_line(timf2_hg_xmin+timf2_hg_clex,timf2_hg_y[0],
                timf2_hg_xmin+timf2_hg_clex,timf2_hg_y[0]+text_height-1,11);
  }
if(hg.stupid_bln_mode != 0)
  {
errno=10422;
  ck_line(timf2_hg_xmin+timf2_hg_stux,timf2_hg_y[0],
                timf2_hg_xmin+timf2_hg_stux,timf2_hg_y[0]+text_height-1,14);
  }
show_mouse();
if(leftpressed == 2)
  {
  leftpressed=0;  
  make_modepar_file(GRAPHTYPE_HG);
  mouse_active_flag=0;
  }
}

void clever_limit_control(void)
{
int chan;
char color;
if(mouse_x < timf2_hg_xmin || mouse_x > timf2_hg_xmax)
  {
  if(leftpressed == 2)leftpressed=0;  
  return;
  }
hide_mouse();
for(chan=0; chan<ui.rx_channels; chan++)
  {
  if(timf2_hg_clex <= timf2_hg_x[chan])color=chan_color[chan]; else color=8;
errno=10423;

        ck_line(timf2_hg_xmin+timf2_hg_clex,timf2_hg_y[chan],
                timf2_hg_xmin+timf2_hg_clex,timf2_hg_y[chan]+timf2_hg_yh-1,color);
  }

hg.clever_bln_limit=2*exp((mouse_x-timf2_hg_xmin)/timf2_hg_xfac)/timf2_hg_xlog;
if(hg.clever_bln_mode == 1)
  {
  hg.clever_bln_factor=hg.clever_bln_limit/timf2_noise_floor;
  if(hg.clever_bln_factor < 0.7)hg.clever_bln_factor=0.7;
  }
timf2_hg_clex=log(timf2_hg_xlog*(hg.clever_bln_limit>>1))*timf2_hg_xfac;
hg_control_finish();
}


void stupid_limit_control(void)
{
int chan;
char color;
if(mouse_x < timf2_hg_xmin || mouse_x > timf2_hg_xmax)
  {
  if(leftpressed == 2)leftpressed=0;  
  return;
  }
hide_mouse();
for(chan=0; chan<ui.rx_channels; chan++)
  {
  if(timf2_hg_stux <= timf2_hg_x[chan])color=chan_color[chan]; else color=8;
errno=10424;
        ck_line(timf2_hg_xmin+timf2_hg_stux,timf2_hg_y[chan],
                timf2_hg_xmin+timf2_hg_stux,timf2_hg_y[chan]+timf2_hg_yh-1,color);
  }
hg.stupid_bln_limit=2*exp((mouse_x-timf2_hg_xmin)/timf2_hg_xfac)/timf2_hg_xlog;
if(hg.stupid_bln_mode == 1)
  {
  hg.stupid_bln_factor=hg.stupid_bln_limit/timf2_noise_floor;
  if(hg.stupid_bln_factor < 0.7) hg.stupid_bln_factor=0.7;
  }
timf2_hg_stux=log(timf2_hg_xlog*(hg.stupid_bln_limit>>1))*timf2_hg_xfac;
hg_control_finish();
}


void make_blanker_ston1(void)
{
int k;
k=hg_ston_y0-hg_ston1_y;
if(k<2)
  {
  k=2;
  hg_ston1_y=hg_ston_y0+2;
  }
hg.blanker_ston_fft1=pow(10.,HG_STON_RANGE*k/hg_floatypix);
}

void make_blanker_ston2(void)
{
int k;
k=hg_ston_y0-hg_ston2_y;
if(k<2)
  {
  k=2;
  hg_ston2_y=hg_ston_y0+2;
  }
hg.blanker_ston_fft2=pow(10.,HG_STON_RANGE*k/hg_floatypix);
}



void mouse_on_hires_graph(void)
{
float t1;
int i, oldy, event_no;
// First find out if we are on a button or border line.
for(event_no=0; event_no<MAX_HGBUTT; event_no++)
  {
  if( hgbutt[event_no].x1 <= mouse_x && 
      hgbutt[event_no].x2 >= mouse_x &&      
      hgbutt[event_no].y1 <= mouse_y && 
      hgbutt[event_no].y2 >= mouse_y) 
    {
    hg_old_y1=hg.ytop;
    hg_old_y2=hg.ybottom;
    hg_old_x1=hg.xleft;
    hg_old_x2=hg.xright;
    mouse_active_flag=1+event_no;
    current_mouse_activity=mouse_continue_hires_graph;
    return;
    }
  }
// Not button or border.
// Check if mouse is on bars or in the spectrum
if(mouse_y >= hg_ston_y0)
  {
  if(mouse_x == timf2_hg_xmin+timf2_hg_clex && hg.clever_bln_mode!=0)
    {
    current_mouse_activity=clever_limit_control;
    mouse_active_flag=1;
    }
  if(mouse_x == timf2_hg_xmin+timf2_hg_stux && hg.stupid_bln_mode!=0)
    {
    current_mouse_activity=stupid_limit_control;
    mouse_active_flag=1;
    }
  }
else
  {
  if( mouse_x<hg_first_xpixel && mouse_y > hg_stonbars_ytop)
    {
    hide_mouse();
    if(mouse_x <= hg_ston1_x2)
      {
      oldy=hg_ston1_y;
      hg_ston1_y=mouse_y;    
      make_blanker_ston1();
      update_bar(hg_ston1_x1,hg_ston1_x2,hg_ston_y0,
                                              hg_ston1_y,oldy,0xb0,hg_stonbuf);
      }
    else
      {
      oldy=hg_ston2_y;
      hg_ston2_y=mouse_y;    
      make_blanker_ston2();
      update_bar(hg_ston2_x1,hg_ston2_x2,hg_ston_y0,
                                              hg_ston2_y,oldy,0xb2,hg_stonbuf);
      }  
    show_mouse();
    if(leftpressed==2)
      {
      leftpressed=0;
      make_modepar_file(GRAPHTYPE_HG);
      }
    }
  else
    {
    if(leftpressed==2)
      {
      leftpressed=0;
      hide_mouse();
      t1=hg_first_fq+(mouse_x-hg_first_xpixel)*hg_hz_per_pixel;
      remove_mix1_cursor(0);
      if(t1 <  mix1_lowest_fq)t1=mix1_lowest_fq;
      if(t1 > mix1_highest_fq)t1=mix1_highest_fq;
      for(i=1; i<genparm[MIX1_NO_OF_CHANNELS]; i++)
        {
        if( fabs(t1-mix1_selfreq[i]) < 3*wg_hz_per_pixel)
          {
          remove_mix1_cursor(i);
          mix1_selfreq[i]=-BIG;
          }
        }
      make_new_signal(0, t1);
      clear_da();
      baseband_fq_scale();
      show_mouse();
      }
    }
  }  
}

void hg_borders(int color)
{
errno=10425;
ck_hline(hg.xleft,hg.ytop,hg.xright,color);
errno=10426;
ck_hline(hg.xleft,hg.ybottom,hg.xright,color);
errno=10427;
ck_line(hg.xleft,hg.ytop,hg.xleft,hg.ybottom,color);
errno=10428;
ck_line(hg.xright,hg.ytop,hg.xright,hg.ybottom,color);
}

void show_blanker_info(int mousestat)
{
char s[80];
char color;
int i,xnew,xold,chan,qeflag,cleflag[2],stuflag[2];
int mouseflag;
mouseflag=0;
if(mousestat == 1)
  {
  if(mouse_y <= hg.ybottom+mouse_cursize &&
     mouse_y >= hg.ybottom-mouse_cursize-text_height)
    {
    if(mouse_x>=timf2_hg_xmin-mouse_cursize &&
       mouse_x <= hg.xright+mouse_cursize)
      {
      hide_mouse();
      mouseflag=1;
      }
    }
  }
qeflag=0;
for(chan=0; chan<ui.rx_channels; chan++)
  {
  cleflag[chan]=0;
  stuflag[chan]=0;
  xnew=log(timf2_hg_xlog*timf2_despiked_pwr[chan])*timf2_hg_xfac;

  if(xnew<0)xnew=0;
  xold=timf2_hg_x[chan];
  timf2_hg_x[chan]=xnew;
  if(xold != xnew)
    {
    if(xnew > xold)
      {
   errno=40104;
      ck_fillbox(timf2_hg_xmin+xold,timf2_hg_y[chan],
                               xnew-xold+1,timf2_hg_yh,chan_color[chan]);
      if(timf2_hg_qex >=xold && timf2_hg_qex <=xnew)qeflag=1; 
      if(timf2_hg_clex>=xold && timf2_hg_clex<=xnew)cleflag[chan]=1; 
      if(timf2_hg_stux>=xold && timf2_hg_stux<=xnew)stuflag[chan]=1; 
      }
    else
      {
   errno=40105;
      ck_fillbox(timf2_hg_xmin+xnew,timf2_hg_y[chan],
                                        xold-xnew+1,timf2_hg_yh,8);
      if(timf2_hg_qex >=xnew && timf2_hg_qex <=xold)qeflag=1; 
      if(timf2_hg_clex>=xnew && timf2_hg_clex<=xold)cleflag[chan]=1; 
      if(timf2_hg_stux>=xnew && timf2_hg_stux<=xold)stuflag[chan]=1; 
      }
    }
  }
errno=10429;

if(qeflag != 0)ck_line(timf2_hg_xmin+timf2_hg_qex,timf2_hg_y[0],
               timf2_hg_xmin+timf2_hg_qex,timf2_hg_y[0]+text_height-1,12);
if(hg.clever_bln_mode!=0)
  {
  sprintf(s,"%02d",clever_blanker_rate);
  if(s[0]=='0')s[0]=' ';
  settextcolor(11);
errno=20109;
  ck_write(hg.xright-2-2*text_width,hg_ymax,s);
  xold=timf2_hg_clex;
  xnew=log(timf2_hg_xlog*(hg.clever_bln_limit>>1))*timf2_hg_xfac;
  if(xnew<0)xnew=0;
  timf2_hg_clex=xnew;
  if(xold == xnew)
    {
    if(cleflag[0]+cleflag[1] == 0)goto clever_ok;
    }
  else  
    {
    for(chan=0; chan<ui.rx_channels; chan++)
      {
      if(cleflag[chan] == 0)
        {
        if(xold <= timf2_hg_x[chan])color=chan_color[chan]; else color=8;
errno=10430;
        ck_line(timf2_hg_xmin+xold,timf2_hg_y[chan],
                timf2_hg_xmin+xold,timf2_hg_y[chan]+timf2_hg_yh-1,color);
        }
      }  
    }
errno=10431;
  ck_line(timf2_hg_xmin+xnew,timf2_hg_y[0],
                timf2_hg_xmin+xnew,timf2_hg_y[0]+text_height-1,11);
clever_ok:;
  }
if(hg.stupid_bln_mode!=0)
  {  
  sprintf(s,"%02d",stupid_blanker_rate);
  if(s[0]=='0')s[0]=' ';
  settextcolor(14);
errno=20110;
  ck_write(hg.xleft+2,hg_ymax,s);
  xold=timf2_hg_stux;
  xnew=log(timf2_hg_xlog*(hg.stupid_bln_limit>>1))*timf2_hg_xfac;
  if(xnew<0)xnew=0;
  if(xnew==timf2_hg_clex)xnew++;
  timf2_hg_stux=xnew;
  if(xold == xnew)
    {
    if(stuflag[0]+stuflag[1] == 0)goto stupid_ok;
    }
  else  
    {
    for(chan=0; chan<ui.rx_channels; chan++)
      {
      if(stuflag[chan] == 0)
        {
        if(xold < timf2_hg_x[chan])color=chan_color[chan]; else color=8;
errno=10432;
        ck_line(timf2_hg_xmin+xold,timf2_hg_y[chan],
                timf2_hg_xmin+xold,timf2_hg_y[chan]+timf2_hg_yh-1,color);
        }
      }  
    }
errno=10433;
  ck_line(timf2_hg_xmin+xnew,timf2_hg_y[0],
                  timf2_hg_xmin+xnew,timf2_hg_y[0]+text_height-1,14);
stupid_ok:;
  }
settextcolor(7);  
if(timf2_ovfl != 0)
  {
  sprintf(s,"OVFL %d",timf2_ovfl);
  i=6;
  while(s[i] != 0)i++;
errno=20111;
  ck_write(timf2_hg_xmax-text_width*i,hg.ybottom-text_height,s);
  }
if( mouseflag == 1)show_mouse();
}        


void hires_fq_scale(void)
{
char s[80];
int i,j,k;
int xm,xa,xb,ya,yb;
float t1, fq_scalestep, fq_x;
double fq_value, fq_offset; 
if(mix1_selfreq[0] < 0)return;
// Make a frequency scale on top of the high resolution spectrum.
// We will show mix1_selfreq[0] in this graph (if it exists)
hg_first_fq=mix1_selfreq[0]-hg_hz_per_pixel*hg_size/2;
hg_first_point=hg_first_fq/hg_hz_per_pixel;
if(hg_first_point<0)hg_first_point=0;
hg_last_point=hg_first_point+hg_size;
if(hg_last_point > fft2_size)hg_last_point=fft2_size;
hg_first_point=hg_last_point-hg_size;
if(hg_first_point<0)end_program(9998888);
hg_recalc_pointer=hg_first_point;
hg_first_fq=hg_first_point*hg_hz_per_pixel;
// Express frequencies in Hz and do not place numbers closer than
// 6 ascii characters.
#define CHARS 6 
fq_scalestep=CHARS*hg_hz_per_pixel*text_width;
j=adjust_scale(&fq_scalestep);
fq_offset=frequency_scale_offset;
// Get the decimal fraction and convert it to Hz  
fq_offset=(fq_offset-(int)(fq_offset))*100000;  
i=0.5+(hg_first_fq+fq_offset)/fq_scalestep;
fq_value=i*fq_scalestep;
fq_x=hg_first_xpixel+(fq_value-hg_first_fq-fq_offset)/hg_hz_per_pixel;
   errno=40106;
xm=hg.xleft+5*text_width;
ck_fillbox(xm, hg.ytop+1, hg.xright-xm-1, text_height+3, 0);
ya=hg.ytop+text_height;
yb=hg.ytop+text_height+3;
xb=fq_x-fq_scalestep/hg_hz_per_pixel;
while( fq_x < hg.xright)
  {
  if(fq_value >=100000)fq_value-=100000;
  i=fq_value+0.5;
  sprintf(s,"%d",i);
  k=0;
  while(s[k]!=0)k++;
errno=20112;
  if(fq_x-k*text_width/2 > xm && fq_x+k*text_width/2 < hg.xright )
    {
    ck_write(fq_x-k*text_width/2, hg.ytop+text_midpoint,s);
    if(j <= 2 )
      {
      xa=(fq_x+xb)/2;
errno=10434;
      if(xa > xm)ck_line(xa,ya,xa,yb,14);
      }
    else
      {  
      t1=0.2*(fq_x-xb)+0.5;
      xa=t1;
errno=10435;
      if( xb+xa > xm)ck_line(xb+xa,ya,xb+xa,yb,15);
errno=10436;
      if( fq_x-xa > xm)ck_line(fq_x-xa,ya,fq_x-xa,yb,15);
      t1=0.4*(fq_x-xb)+0.5;
      xa=t1;
errno=10437;
      if( xb+xa > xm)ck_line(xb+xa,ya,xb+xa,yb,15);
errno=10438;
      if( fq_x-xa > xm)ck_line(fq_x-xa,ya,fq_x-xa,yb,15);
      }
errno=10439;
    ck_line(fq_x,ya,fq_x,yb,15);
errno=10440;
    ck_line(fq_x+1,ya,fq_x+1,yb,15);
errno=10441;
    ck_line(fq_x-1,ya,fq_x-1,yb,15);
    }
  xb=fq_x;  
  fq_x+=fq_scalestep/hg_hz_per_pixel;
  fq_value+=fq_scalestep;
  }
hg_center=0.5+hg_first_xpixel+(mix1_selfreq[0]-hg_first_fq)/hg_hz_per_pixel;
for(i=hg_cury1; i<hg_cury2; i++)
  {      
errno=10442;
  if(hg_curx >= 0)ck_setpixel(hg_curx,i,hg_background[i]);
errno=10443;
  ck_setpixel(hg_center,i,8);
  }
hg_curx=hg_center;
if(afc_curx == hg_center)afc_curx=-1;
show_hg_buttons();
}

void make_hires_graph(int m)
{
char s[80],chr;
int i,pixwid,x,y,xt,yt;
float t1,t2;
current_graph_minh=7*text_height/2;
current_graph_minw=25*text_width;
check_graph_placement((void*)(&hg));
hg_first_xpixel=hg.xleft+2*text_width+2;
hg_last_xpixel=hg.xright-text_width-3;
hg_size=hg_last_xpixel-hg_first_xpixel;
if(hg_size > fft2_size)
  {
  hg_size=fft2_size;
  hg_first_xpixel=hg_last_xpixel-hg_size;
  hg.xleft=hg_first_xpixel-2*text_width-2;
  }
scro[m].no=HIRES_GRAPH;
scro[m].x1=hg.xleft;
scro[m].x2=hg.xright;
scro[m].y1=hg.ytop;
scro[m].y2=hg.ybottom;
hgbutt[HG_LEFT].x1=hg.xleft;
hgbutt[HG_LEFT].x2=hg.xleft;
hgbutt[HG_LEFT].y1=hg.ytop;
hgbutt[HG_LEFT].y2=hg.ybottom;
hgbutt[HG_RIGHT].x1=hg.xright;
hgbutt[HG_RIGHT].x2=hg.xright;
hgbutt[HG_RIGHT].y1=hg.ytop;
hgbutt[HG_RIGHT].y2=hg.ybottom;
hgbutt[HG_TOP].x1=hg.xleft;
hgbutt[HG_TOP].x2=hg.xright;
hgbutt[HG_TOP].y1=hg.ytop;
hgbutt[HG_TOP].y2=hg.ytop;
hgbutt[HG_BOTTOM].x1=hg.xleft;
hgbutt[HG_BOTTOM].x2=hg.xright;
hgbutt[HG_BOTTOM].y1=hg.ybottom;
hgbutt[HG_BOTTOM].y2=hg.ybottom;
// Draw the border lines
hg_borders(7);
hg_ymax=hg.ytop+1.5*text_height;
hg_stonbars_ytop=hg_ymax+text_height+1;
settextcolor(7);
x=hg.xleft+text_width;
y=hg.ybottom-text_height/2-2;
settextcolor(14);
make_button(x,y,hgbutt,HG_BLN_STUPID,modes_man_auto[hg.stupid_bln_mode]);
x+=2*text_width;
settextcolor(11);
make_button(x,y,hgbutt,HG_BLN_CLEVER,modes_man_auto[hg.clever_bln_mode]);
settextcolor(7);
hg_hz_per_pixel=timf1_sampling_speed/fft2_size;
// Allocate memory for the high resolution graph.
pixwid=(hg_first_xpixel+hg.xleft)/2;
hg_ston1_x1=hg.xleft+1;
hg_ston1_x2=pixwid-1;
hg_ston2_x1=pixwid+1;
hg_ston2_x2=hg_first_xpixel-1;
hg_ston_y0=hg.ybottom-3*text_height/2-1;
if(hires_handle != NULL)
  {
  memcheck(2,hiresmem,(int*)&hires_handle);
  hires_handle=chk_free(hires_handle);
  }
init_memalloc(hiresmem, MAX_HIRES_ARRAYS);
mem(1,&hg_spectrum,ui.rx_channels*WIDTH*sizeof(short int),0);
mem(2,&hg_background,HEIGHT*sizeof(char),0);
if(ui.rx_channels == 2)
  {
  mem(3,&hg_fft2_pwr,max_fft2n*2*hg_size*sizeof(float),0);
  }
mem(4,&hg_fft2_pwrsum,2*hg_size*sizeof(float),0);
mem(5,&hg_stonbuf,pixwid*(hg.ybottom-hg.ytop)*sizeof(char),0);
hires_totmem=memalloc((int*)(&hires_handle),"hires");
if(hires_totmem == 0)end_program(1066);
// ********************************************************
// ********************************************************
// Write out the y scale for logarithmic spectrum graph.
// The zero level is the level set by wg.waterfall_db_zero and the number
// of dB per pixel is set by wg.waterfall_db_gain
// This way the wide graph will reflect the colour scale of the
// waterfall graph.
hg_y0=hg.ybottom-3*text_height/2;
hg_redraw_counter=0;
if(hg.timf2_display == 1)
  {
  yt=y-3*text_height/2;
  hg_y0-=3*text_height/2;
  make_button(hg.xright-text_width,yt, hgbutt,HG_TIMF2_WK_INC,'+');
  make_button(hg.xright-3*text_width,yt, hgbutt,HG_TIMF2_WK_DEC,'-');
  xt=hg.xleft+7*text_width/2;
  chr='L';
  if(  (hg.timf2_display_lines&1) != 0)chr='P';
  make_button(xt,yt, hgbutt,HG_TIMF2_LINES,chr);
  xt+=2*text_width;
  chr='C';
  if(  (hg.timf2_display_hold&1) != 0)chr='H';
  make_button(xt,yt, hgbutt,HG_TIMF2_HOLD,chr);
  xt+=2*text_width;
  make_button(xt,yt, hgbutt,HG_TIMF2_ST_DEC,'-');
  xt+=2*text_width;
  make_button(xt,yt, hgbutt,HG_TIMF2_ST_INC,'+');
  xt+=3*text_width/2;
  sprintf(s,"%f",hg.timf2_display_st_gain);
  s[8]=0;
  i=7;
  while(s[i-1]!='.' && s[i]=='0')
    {
    s[i]=0;
    i--;
    }
errno=20113;
  ck_write(xt,y-2*text_height,s);
  xt+=i*text_width+3*text_width/2;
  sprintf(s,"%f",hg.timf2_display_wk_gain);
  s[8]=0;
  i=7;
  while(s[i-1]!='.' && s[i]=='0')
    {
    s[i]=0;
    i--;
    }
  xt=hg.xright-11*text_width/2-i*text_width;
errno=20114;
  ck_write(xt,y-2*text_height,s);
   errno=40107;
  ck_fillbox(0,timf2_ymin[4*ui.rx_channels],WIDTH/2,
                         timf2_ymax[0]-timf2_ymin[4*ui.rx_channels],0);
  }
else
  {
  hgbutt[HG_TIMF2_WK_INC].x1=-1;
  hgbutt[HG_TIMF2_WK_INC].x2=-1;
  hgbutt[HG_TIMF2_WK_INC].y1=-1;
  hgbutt[HG_TIMF2_WK_INC].y2=-1;
  hgbutt[HG_TIMF2_LINES].x1=-1;
  hgbutt[HG_TIMF2_LINES].x2=-1;
  hgbutt[HG_TIMF2_LINES].y1=-1;
  hgbutt[HG_TIMF2_LINES].y2=-1;
  hgbutt[HG_TIMF2_HOLD].x1=-1;
  hgbutt[HG_TIMF2_HOLD].x2=-1;
  hgbutt[HG_TIMF2_HOLD].y1=-1;
  hgbutt[HG_TIMF2_HOLD].y2=-1;
  hgbutt[HG_TIMF2_WK_DEC].x1=-1;
  hgbutt[HG_TIMF2_WK_DEC].x2=-1;
  hgbutt[HG_TIMF2_WK_DEC].y1=-1;
  hgbutt[HG_TIMF2_WK_DEC].y2=-1;
  hgbutt[HG_TIMF2_ST_INC].x1=-1;
  hgbutt[HG_TIMF2_ST_INC].x2=-1;
  hgbutt[HG_TIMF2_ST_INC].y1=-1;
  hgbutt[HG_TIMF2_ST_INC].y2=-1;
  hgbutt[HG_TIMF2_ST_DEC].x1=-1;
  hgbutt[HG_TIMF2_ST_DEC].x2=-1;
  hgbutt[HG_TIMF2_ST_DEC].y1=-1;
  hgbutt[HG_TIMF2_ST_DEC].y2=-1;
  }  
for(i=0; i<WIDTH*ui.rx_channels; i++) hg_spectrum[i]=hg_y0;
make_hg_yscale();
errno=10444;
ck_hline(hg_first_xpixel,hg_y0,hg_last_xpixel,15);
// hg_fft2_powersum, which may be the sum of many power values
// may become inaccurate because it is calculated each time
// by adding the difference between a new and a old value.
// This will make the noise floor inaccurate when a very strong
// signal disappears.
// Make sure to acctually sum all power values now and then so
// errors disappear within a reasonable time, twice the time
// covered by all the data or 2 seconds, whichever is longest.
t2=fft2_new_points/timf1_sampling_speed;
t1=hg.spek_avgnum*t2;
if(t1<2)t1=2;
hg_powersum_recalc=hg_size*t2/t1;
// Make a box in which timf2 levels will be drawn.
timf2_hg_xmin=x+3*text_width/2;
make_button(hg.xright-text_width,y,hgbutt,HG_TIMF2_STATUS,'o');
hgbutt[HG_FFT2_AVGNUM].x1=2+hg.xleft;
hgbutt[HG_FFT2_AVGNUM].x2=2+hg.xleft+4.5*text_width;
hgbutt[HG_FFT2_AVGNUM].y1=2+hg.ytop;
hgbutt[HG_FFT2_AVGNUM].y2=2+hg.ytop+text_height;
show_hg_buttons();
timf2_hg_xmax=hg.xright-2*text_width-2;
timf2_hg_y[1]=y;
timf2_hg_y[0]=y-text_height/2;
timf2_hg_x[0]=0;
if(sw_onechan)
  {
  timf2_hg_yh=text_height;
  }
else
  {
  timf2_hg_yh=text_height/2;
  timf2_hg_x[1]=0;
  }
   errno=40108;
ck_fillbox(timf2_hg_xmin,timf2_hg_y[0],
                                timf2_hg_xmax-timf2_hg_xmin+1,text_height,8);
// timf2 is 16 bit, level is 0 to 32767 (+ or -)
// Make a logarithmic scale that uses all pixels for the power level. 
t1=1;
t2=2*32767.*32767.;
for(i=0; i<4; i++)
  {
  timf2_hg_xfac=log(t2/t1)/(timf2_hg_xmax-timf2_hg_xmin+0.5);
  t1=exp(timf2_hg_xfac);
  }
timf2_hg_xfac=1/timf2_hg_xfac;
timf2_hg_xlog=1/t1;
timf2_hg_stux=-1;
timf2_hg_clex=-1;
// Set the quantisation error limit to some reasonable value (20dB = 100)
t1=100;
timf2_hg_qex=log(timf2_hg_xlog*t1)*timf2_hg_xfac;
errno=10445;
ck_line(timf2_hg_xmin+timf2_hg_qex,timf2_hg_y[0],
                     timf2_hg_xmin+timf2_hg_qex,timf2_hg_y[0]+text_height,12);
show_blanker_info(0);
make_modepar_file(GRAPHTYPE_HG);
hg_flag=1;
fft2_nb=(fft2_na-hg.spek_avgnum+max_fft2n)&fft2n_mask;
hg_curx=-1;
afc_curx=-1;
hg_cury2=hg.ybottom-3*text_height/2;
hg_cury1=hg_stonbars_ytop;
hg_cury0=(hg_cury1+4*hg_cury2)/5;
// Get the number of pixels we have vertically for control bars.
hg_floatypix=hg_ston_y0-hg.ytop-2*text_height;
hg_ston1_y=hg_ston_y0-hg_floatypix*log10(hg.blanker_ston_fft1)/HG_STON_RANGE;
hg_ston2_y=hg_ston_y0-hg_floatypix*log10(hg.blanker_ston_fft2)/HG_STON_RANGE;
make_blanker_ston1();
make_blanker_ston2();
make_bars();
}


void init_hires_graph(void)
{
int i;
if (read_modepar_file(GRAPHTYPE_HG) == 0)
  {
hg_default:;  
// Make the default window for the high resolution graph.
  i=WIDTH/4;
  if(i<256)i=256;
  if(i>WIDTH/2)i=WIDTH/2;
  hg.xleft=(WIDTH-i)/2;
  hg.xright=hg.xleft+i+1;
  hg.ytop=wg.ybottom+1;
  hg.ybottom=hg.ytop+HEIGHT/6;
  if(hg.ybottom>HEIGHT-text_height-1)
    {
    hg.ybottom=HEIGHT-text_height-1;
    hg.ytop=hg.ybottom-6*text_height;
    }
  hg.stupid_bln_mode=1;
  hg.clever_bln_mode=1;
  hg.stupid_bln_factor=5;
  hg.clever_bln_factor=10;
  hg.stupid_bln_limit=timf2_noise_floor*hg.stupid_bln_factor;
  hg.clever_bln_limit=timf2_noise_floor*hg.clever_bln_factor;
  hg.blanker_ston_fft1=30;
  hg.blanker_ston_fft2=30;
  hg.timf2_display=0;
  hg.timf2_display_lines=1;
  hg.timf2_display_hold=0;
  hg.timf2_display_wk_gain=1;
  hg.timf2_display_st_gain=1;
  hg.check = HG_VERNR;
  }
if(hg.check != HG_VERNR)goto hg_default;  
if(hg.xleft < 0 || hg.xright > WIDTH-1)goto hg_default;
if(hg.xright-hg.xleft<4*text_width)goto hg_default;
if(hg.ytop < 0 || hg.ybottom > HEIGHT-1)goto hg_default;
if(hg.ybottom-hg.ytop < text_height)goto hg_default;
if(fft1_filtercorr_flag==0)hg.clever_bln_mode=0;
if(hg.stupid_bln_mode <0 || hg.stupid_bln_mode >2)goto hg_default;
if(hg.clever_bln_mode <0 || hg.clever_bln_mode >2)goto hg_default;
if(hg.stupid_bln_factor<0.7 || hg.stupid_bln_factor> 1000)goto hg_default;
if(hg.clever_bln_factor<0.7 || hg.clever_bln_factor> 1000)goto hg_default;
if(hg.spek_avgnum<1)hg.spek_avgnum=1;
if(hg.spek_avgnum>fft2n_mask)hg.spek_avgnum=fft2n_mask;
if(hg.blanker_ston_fft1<1.5)hg.blanker_ston_fft1=20;
if(hg.blanker_ston_fft2<5)hg.blanker_ston_fft2=30;
make_hires_graph(no_of_scro);
no_of_scro++;
if(no_of_scro >= MAX_SCRO)end_program(89);
}

