//background color for signal graphs 
#define BCL 176


#define LOG_ZERO -0.8
#define LINFAC 0.000025

#include <vga.h>
#include <vgagl.h>
#include <unistd.h>
#include "conf.h"
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "screendef.h"

#define OUTTEST_SIZE 16

#define LAST_LINE 11


void test_rx(void)
{
struct timeval tim1;
struct timeval tim2;
int i, j, mode, x, p0, p_increment, points, px, p_max;
int max_y, yzer, traces;
int ch1_y[WIDTH], ch2_y[WIDTH]; 
int debughelp,maxmin_counter;
int ad_maxval1,ad_minval1,ad_maxval2,ad_minval2;
int graph_update_interval,graph_update_counter;
float t1, t2, db_scale, graph_total, math_total, idle_total;
float ya,yb;
double scale;
int pixmode;
int mh,ml,gh,gl,dh,dl;
float mf,gf,df;
char s[80];
audio_buf_info ad_info;
ad_maxval1=ad_minval1=ad_maxval2=ad_minval2=0;
maxmin_counter=0;
settextcolor(14);
xytext(10,0,"TEST OF BASIC INPUT ROUTINES (fft1)");
test_init();
if(lir_status != LIR_OK)return;
read(audio_in, fft1_char, ad_read_bytes);
if( (ui.input_mode&IQ_DATA) == 0)
  {
  xytext(3,1,"1:  Raw input channel 1 (oscilloscope)");
  if(genparm[FIRST_FFT_VERNR] <2)
    {
    xytext(3,3,"3:  I/Q channel 1 (oscilloscope)");
    xytext(3,5,"5:  I/Q channel 1 (fft input)");
    }
  xytext(3,7,"7:  channel 1 spectrum");
  if( ui.rx_channels == 2)
    {
    xytext(3,2,"2:  Raw input channel 2");
    if(genparm[FIRST_FFT_VERNR] <2)
      {
      xytext(3,4,"4:  I/Q channel 2 (oscilloscope)");
      xytext(3,6,"6:  I/Q channel 2 (fft input)");
      }
    xytext(3,8,"8:  channel 1 spectrum");
    }
  }
else
  {
  xytext(3,1,"1:  Rx0 Raw input I/Q  (AD0+AD1 oscilloscope)");
  xytext(3,5,"7:  Rx0 Spectrum");
  if( ui.rx_channels == 2)
    {
    xytext(3,2,"2:  Rx1 Raw input I/Q  (AD2+AD3 oscilloscope)");
    xytext(3,6,"8:  Rx1 Spectrum");
    }
  }
mode=1;
scale=1;
// Use lines 1 to LAST_LINE+2 for text messages.
i=(LAST_LINE+2)*text_height;
i+=text_height/2;
j=HEIGHT-i;
if(j < 4*text_height)end_program(1046);
j/=2;
yzer=HEIGHT-j-1;
max_y=j;
for(j=yzer-max_y; j<HEIGHT; j++)
  {
  for(i=0; i<WIDTH; i++)
    {
errno=10555;
    ck_setpixel(i,j,BCL);
    }
  }  
for(i=0; i<WIDTH; i++)
  {
  ch1_y[i]=yzer;
  ch2_y[i]=yzer;
  }
modewr:;
timf1p_pa=timf1p_px=0;
ctimf1p_pa=ctimf1p_px=0;
fft1_pa=fft1_px=0;
db_scale=-20*log10(scale);
for(i=0; i<WIDTH; i++)
  {
errno=10556;
  ck_setpixel(i,ch2_y[i],BCL);
  }
for(i=0; i<WIDTH; i++)
  {
errno=10557;
  ck_setpixel(i,ch1_y[i],BCL);
  }
graph_update_counter=0;
restart:;
x=0; 
graph_total=0;
math_total=0;
idle_total=0;
traces=0;
debughelp=(mode+1)/2;
if(debughelp < 3)
  {    
  graph_update_interval=1;
  }
else
  {  
  graph_update_interval=5;
  }
if( overrun_flag < 10)
  {
  for(j=text_height*(LAST_LINE+5); j<text_height*(LAST_LINE+7); j++)
    {
    for(i=0; i<WIDTH/2; i++)
      {
errno=10558;
      ck_setpixel(i,j,BCL);
      }
    }  
  }
  
  
pixmode=(mode-1)*2;
if( ui.rx_channels == 2)pixmode++;
pixmode*=2;
if( (ui.input_mode&IQ_DATA) != 0)pixmode++;
pixmode*=2;
if( (ui.input_mode&DWORD_INPUT) == 0)pixmode++;
//pixmode bit0  0=>32bit        1=>16bit.
//pixmode bit1  0=>normal       1=>IQ data
//pixmode bit2  0=>one          1=>two rx channels
//pixmode bit3-n    (mode-1) processing modes
settextcolor(15);
sprintf(s,"mode=%d pixmode=%d dbhlp=%d scale=%3.3fdB(%f) ",
                                  mode,pixmode,debughelp,db_scale,scale);
xytext(1,LAST_LINE-1,s);
xytext(1,LAST_LINE-2,
     "X Menu   Q Quit   0-9 Change mode   +- Change scale   P Pause");
settextcolor(7);
if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(6);
while(ad_info.bytes > ad_read_bytes)
  {
  read(audio_in, fft1_char, ad_read_bytes);
  if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(6);
  }
gettimeofday(&tim2,NULL);
press:;
vga_inkey=vga_getkey();
if(vga_inkey != 0)
  {
  clean_vga_inkey();
  if(vga_inkey == 'X')
    {
    close_all_except_vga();
    return;
    }
  if(vga_inkey == 'P')
    {
    await_keyboard();
    goto modewr;
    }
  if(vga_inkey == '+')
    {
    if(scale < BIG)scale*=2;
    goto modewr;
    }
  if(vga_inkey == '-')
    {
    if(scale > 1/BIG)scale/=2;
    goto modewr;
    }
  if(vga_inkey == 'Q')end_program(0);
  if( vga_inkey == '1' || vga_inkey == '7')
    {
new_mode:;
    mode=vga_inkey-'0';
    goto modewr;
    }    
  if( (ui.input_mode&TWO_CHANNELS) != 0)
    {
    if( vga_inkey == '2' || vga_inkey == '8')goto new_mode;
    }
  if( (ui.input_mode&IQ_DATA) == 0)
    {
    if(genparm[FIRST_FFT_VERNR] <2)
      {
      if( vga_inkey == '3' ||  vga_inkey == '5' ) goto new_mode;
      }
    if( (ui.input_mode&TWO_CHANNELS) != 0)
      {
      if(genparm[FIRST_FFT_VERNR] <2)
        {
        if( vga_inkey == '4' ||  vga_inkey == '6' )goto new_mode;
        }
      }
    }
  }  
if( (newdat_flag&ND_HWARE) == 0)
  {
  if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(7);
  if(ad_info.bytes<ad_read_bytes)goto press;
  }
gettimeofday(&tim1,NULL);
idle_total+=0.000001*(tim1.tv_usec-tim2.tv_usec)+(tim1.tv_sec-tim2.tv_sec);
make_fft1(debughelp);  
gettimeofday(&tim2,NULL);
math_total+=0.000001*(tim2.tv_usec-tim1.tv_usec)+(tim2.tv_sec-tim1.tv_sec);
switch (debughelp)
  {
  case 1:  
// In this case the timf1 consumer is here.
  p0=timf1p_px;
  points=(timf1p_pa-timf1p_px+timf1_bytes)&timf1_bytemask;
  timf1p_px=timf1p_pa;
  p_increment=bytes_per_fragment;
  points/=p_increment; 
  p_max=timf1_bytes;
  if(  (ui.input_mode&DWORD_INPUT) == 0)
    {
    p_increment/=sizeof(short int);
    p_max/=sizeof(short int);
    p0/=sizeof(short int);
    }
  else
    {
    p_increment/=sizeof(int);
    p_max/=sizeof(int);
    p0/=sizeof(int);
    }
  maxmin_counter+=points;  
  if(maxmin_counter > ui.input_speed/4)
    {
    if(  (ui.input_mode&DWORD_INPUT) != 0)
      {
      ad_maxval1/=256;
      ad_minval1/=256;
      ad_maxval2/=256;
      ad_minval2/=256;
      }
    sprintf(s,"AD max = %06d   ",ad_maxval1);
    xytext(1,LAST_LINE,s); 
    sprintf(s,"AD min = %06d   ",ad_minval1);
    xytext(41,LAST_LINE,s);
    if(  (ui.input_mode&IQ_DATA) != 0)
      {
      sprintf(s,"%06d   ",ad_maxval2);
      xytext(22,LAST_LINE,s); 
      sprintf(s,"%06d   ",ad_minval2);
      xytext(62,LAST_LINE,s);
      }
    ad_maxval1=ad_minval1=ad_maxval2=ad_minval2=0;
    maxmin_counter=0;
    }
  break;
   
  case 2:
// In this case the ctimf1 consumer is here.
  p0=ctimf1p_px/sizeof(int);
  points=(ctimf1p_pa-ctimf1p_px+ctimf1_bytes)&ctimf1_bytemask;
  ctimf1p_px=ctimf1p_pa;
  p_increment=2*bytes_per_fragment;
  points/=p_increment; 
  p_increment/=sizeof(int);
  if(  (ui.input_mode&DWORD_INPUT) == 0)p_increment*=2;
  p_max=ctimf1_bytes/sizeof(int);
  break;


  default:
  p0=fft1_px;
  if(fft1_px==fft1_pa)
    {
    points=0;
    }
  else
    {
    points=fft1_size;
    }
  fft1_px=fft1_pa;
  p_increment=2*ui.rx_channels;
  p_max=fft1_bytes;
  x=0;
  break;
  }
if(points>0)graph_update_counter++;
if(debughelp < 3 || graph_update_counter >= graph_update_interval)
  {
  graph_update_counter=0;
  sprintf(s,"N=%d inc=%d ",points,p_increment);
  xytext(60,LAST_LINE-1,s);
  for( px=0; px<points; px++)
    {
    switch (pixmode)
      {
      case 0:   // One channel 32 bit. Oscilloscope raw data 
      case 4:   // Two channels 32 bit. Oscilloscope raw data ch0
      if(ad_maxval1<timf1_int[p0])ad_maxval1=timf1_int[p0];
      if(ad_minval1>timf1_int[p0])ad_minval1=timf1_int[p0];
      ya=scale*LINFAC*timf1_int[p0]/65536;
      yb=BIG;
      break;

      case 1:   // One channel 16 bit. Oscilloscope raw data 
      case 5:   // Two channels 16 bit. Oscilloscope raw data ch0
      if(ad_maxval1<timf1_short_int[p0])ad_maxval1=timf1_short_int[p0];
      if(ad_minval1>timf1_short_int[p0])ad_minval1=timf1_short_int[p0];
      ya=scale*LINFAC*timf1_short_int[p0];
      yb=BIG;
      break;
  
      case 2:   // One channel IQ 32 bit. Oscilloscope raw data.   
      case 6:   // Two channels IQ 32 bit. Oscilloscope raw data ch0.
      if(ad_maxval1<timf1_int[p0  ])ad_maxval1=timf1_int[p0  ];
      if(ad_minval1>timf1_int[p0  ])ad_minval1=timf1_int[p0  ];
      if(ad_maxval2<timf1_int[p0+1])ad_maxval2=timf1_int[p0+1];
      if(ad_minval2>timf1_int[p0+1])ad_minval2=timf1_int[p0+1];
      ya=scale*LINFAC*timf1_int[p0  ]/65536;
      yb=scale*LINFAC*timf1_int[p0+1]/65536;
      break;

      case 3:   // One channel IQ 16 bit. Oscilloscope raw data.   
      case 7:   // Two channels IQ 16 bit. Oscilloscope raw data ch0.
      if(ad_maxval1<timf1_short_int[p0  ])ad_maxval1=timf1_short_int[p0  ];
      if(ad_minval1>timf1_short_int[p0  ])ad_minval1=timf1_short_int[p0  ];
      if(ad_maxval2<timf1_short_int[p0+1])ad_maxval2=timf1_short_int[p0+1];
      if(ad_minval2>timf1_short_int[p0+1])ad_minval2=timf1_short_int[p0+1];
      ya=scale*LINFAC*timf1_short_int[p0  ];
      yb=scale*LINFAC*timf1_short_int[p0+1];
      break;

      case 12:  // Two channels 32 bit. Oscilloscope raw data ch1
      if(ad_maxval1<timf1_int[p0+1])ad_maxval1=timf1_int[p0+1];
      if(ad_minval1>timf1_int[p0+1])ad_minval1=timf1_int[p0+1];
      ya=scale*LINFAC*timf1_int[p0+1]/65536;
      yb=BIG;
      break;

      case 13:  // Two channels 16 bit. Oscilloscope raw data ch1
      if(ad_maxval1<timf1_short_int[p0+1])ad_maxval1=timf1_short_int[p0+1];
      if(ad_minval1>timf1_short_int[p0+1])ad_minval1=timf1_short_int[p0+1];
      ya=scale*LINFAC*timf1_short_int[p0+1];
      yb=BIG;
      break;

      case 14:   // Two channels IQ 32 bit. Oscilloscope raw data ch1
      if(ad_maxval1<timf1_int[p0+2])ad_maxval1=timf1_int[p0+2];
      if(ad_minval1>timf1_int[p0+2])ad_minval1=timf1_int[p0+2];
      if(ad_maxval2<timf1_int[p0+3])ad_maxval2=timf1_int[p0+3];
      if(ad_minval2>timf1_int[p0+3])ad_minval2=timf1_int[p0+3];
      ya=scale*LINFAC*timf1_int[p0+2]/65536;
      yb=scale*LINFAC*timf1_int[p0+3]/65536;
      break;

      case 15:   // Two channels IQ 16 bit. Oscilloscope raw data ch0.
      if(ad_maxval1<timf1_short_int[p0+2])ad_maxval1=timf1_short_int[p0+2];
      if(ad_minval1>timf1_short_int[p0+2])ad_minval1=timf1_short_int[p0+2];
      if(ad_maxval2<timf1_short_int[p0+3])ad_maxval2=timf1_short_int[p0+3];
      if(ad_minval2>timf1_short_int[p0+3])ad_minval2=timf1_short_int[p0+3];
      ya=scale*LINFAC*timf1_short_int[p0+2];
      yb=scale*LINFAC*timf1_short_int[p0+3];
      break;

      case 16:  // One channel 32 bit.  Oscilloscope IQ data 
      case 20:  // Two channels 32 bit. Oscilloscope IQ data ch0
      ya=scale*LINFAC*ctimf1[p0  ]/8192;
      yb=scale*LINFAC*ctimf1[p0+1]/8192;
      break;

      case 17:  // One channel 16 bit.  Oscilloscope IQ data 
      case 21:  // Two channels 16 bit. Oscilloscope IQ data ch0
      ya=scale*LINFAC*ctimf1[p0  ]/2;
      yb=scale*LINFAC*ctimf1[p0+1]/2;
      break;

      case 28:  // Two channels 32 bit. Oscilloscope IQ data ch1
      ya=scale*LINFAC*ctimf1[p0+2]/8192;
      yb=scale*LINFAC*ctimf1[p0+3]/8192;
      break;

      case 29:  // Two channels 16 bit. Oscilloscope IQ data ch1
      ya=scale*LINFAC*ctimf1[p0+2]/2;
      yb=scale*LINFAC*ctimf1[p0+3]/2;
      break;

      case 32:  // One channel 32 bit.  One fft input frame       
      case 36:  // Two channels 32 bit. One fft input frame ch0
      ya=scale*LINFAC*fft1_float[p0  ]/8192;
      yb=scale*LINFAC*fft1_float[p0+1]/8192;
      break;

      case 33:  // One channel 16 bit.  One fft input frame ch0 
      case 37:  // Two channels 16 bit.   One fft input frame ch0 
      ya=scale*LINFAC*fft1_float[p0  ]/2;
      yb=scale*LINFAC*fft1_float[p0+1]/2;
      break;

      case 44:  // IQ data stereo  One fft input frame ch1 
      ya=scale*LINFAC*fft1_float[p0+2]/8192;
      yb=scale*LINFAC*fft1_float[p0+3]/8192;
      break;

      case 45:  // Two channels 16 bit.  One fft input frame ch1 
      ya=scale*LINFAC*fft1_float[p0+2]/2;
      yb=scale*LINFAC*fft1_float[p0+3]/2;
      break;

      case 48:  // One channel 32bit. FFT out
      case 49:  // One channel 16bit. FFT out
      case 50:  // One channel 32bit stereo IQ in. FFT out
      case 51:  // One channel 16bit stereo IQ in. FFT out
      case 52:  // Two channels 32bit. FFT out ch0 
      case 53:  // Two channels 16bit. FFT out ch0 
      case 54:  // Two channels 32bit IQ. FFT out ch0
      case 55:  // Two channels 16bit IQ. FFT out ch0
      t1=fft1_float[p0  ];
      t2=fft1_float[p0+1];
      ya=0.05*log((t1*t1+t2*t2)*scale*scale)+LOG_ZERO;
      yb=BIG;
      break;

      case 60:  // Two channels 32bit. FFT out ch1 
      case 61:  // Two channels 16bit. FFT out ch1 
      case 62:  // Two channels 32bit IQ. FFT out ch1
      case 63:  // Two channels 16bit IQ. FFT out ch1
      t1=fft1_float[p0+2];
      t2=fft1_float[p0+3];
      ya=0.05*log((t1*t1+t2*t2)*scale*scale)+LOG_ZERO;
      yb=BIG;
      break;

      default:
      ya=0;
      yb=0;
      break;
      }
    if(ya < -1)ya=-1;
    if(ya > 1)ya=1; 
errno=10559;
    ck_setpixel(x,ch1_y[x],BCL);
    ch1_y[x]=yzer-ya*max_y;    
    if(yb > BIG*0.9999999 )
      {
errno=10560;
      ck_setpixel(x,ch1_y[x],15);
      }
    else
      {
      if(yb < -1)yb=-1;
      if(yb > 1)yb=1; 
errno=10561;
      ck_setpixel(x,ch2_y[x],BCL);
      ch2_y[x]=yzer-yb*max_y;    
      if(ch1_y[x] == ch2_y[x]) 
        {
errno=10562;
        ck_setpixel(x,ch1_y[x],15);
        }
      else
        {  
errno=10563;
        ck_setpixel(x,ch1_y[x],14);
errno=10564;
        ck_setpixel(x,ch2_y[x],12);
        }
      }
    p0+=p_increment;
    if(p0 >= p_max)p0-=p_max;
    x++;
    if(x>=WIDTH)
      {
      x=0;
      if(debughelp>=3)goto spkx;
      }
    }
spkx:;
  gettimeofday(&tim1,NULL);
  graph_total+=0.000001*(tim1.tv_usec-tim2.tv_usec)+(tim1.tv_sec-tim2.tv_sec);
  tim2.tv_usec=tim1.tv_usec;
  tim2.tv_sec=tim1.tv_sec;
  }
traces++;
if(traces%10 == 9 || ad_info.fragments >= overrun_limit)
  {
  t1=math_total+graph_total+idle_total;
  mf=10000*math_total/t1;
  gf=10000*graph_total/t1;
  df=10000*idle_total/t1;
  mh=mf/100;
  gh=gf/100;
  dh=df/100;
  ml=mf-100*mh;
  gl=gf-100*gh;
  dl=df-100*dh;
  if(debughelp >= 3)
    {
    if( graph_update_interval > 1 && gh < 8) graph_update_interval--;
    if( graph_update_interval <10 && gh > 12) graph_update_interval*=2;
    }
  sprintf(s,"Math:%4d.%02d%%   Graph:%4d.%02d%%   Idle:%4d.%02d%%   N%d   ",
                                        mh,ml,gh,gl,dh,dl,traces);
  xytext(1,13,s);
  if(ioctl(audio_in, SNDCTL_DSP_GETISPACE, &ad_info) == -1)end_program(7);
  if(ad_info.fragments >= overrun_limit)
    {
    settextcolor(15);
    xytext(10,LAST_LINE+6," OVERRUN ERROR ");
    overrun_flag++;
    goto restart;
    }
  else
    {
    if(overrun_flag != 0 && overrun_flag < 10)
      {
      settextcolor(7);  
      xytext(10,LAST_LINE+6," W A R N I N G ");
      }
    }
  }
goto press; 
}
