

// Note that these definitions give the order by which data is 
// stored into the graphtype arrays in screenvar.c
#define GRAPHTYPE_AG 0
#define GRAPHTYPE_WG 1
#define GRAPHTYPE_BG 2
#define GRAPHTYPE_HG 3
#define GRAPHTYPE_PG 4
#define GRAPHTYPE_CG 5
#define GRAPHTYPE_EG 6
#define GRAPHTYPE_FG 7
#define MAX_GRAPHTYPES 8
extern char *graphtype_names[MAX_GRAPHTYPES];
extern char *graphtype_parptr[MAX_GRAPHTYPES];
extern char **graphtype_partexts_int[MAX_GRAPHTYPES];
extern char **graphtype_partexts_float[MAX_GRAPHTYPES];
extern int graphtype_max_intpar[MAX_GRAPHTYPES];
extern int graphtype_max_floatpar[MAX_GRAPHTYPES];




extern int numinput_flag;
extern int numinput_xdiff;
extern int numinput_ydiff;
extern int numinput_xpix;
extern int numinput_ypix;
extern int numinput_curpos;
extern int numinput_int_data;
extern int numinput_chars;
extern float moon_az;
extern float moon_el;

extern float numinput_float_data;

extern char numinput_txt[MAX_TEXTPAR_CHARS+1];
extern int wg_waterf_sum_counter;
extern float *wg_waterf_sum;
extern int wg_waterf_ymove_ptr;
extern int wg_waterf_ymove_start;
extern int wg_waterf_yinc;
extern int wg_waterf_y1;
extern int wg_waterf_y2;
extern int wg_waterf_y;
extern float wg_waterf_cfac;
extern float wg_waterf_czer;
extern int wg_waterf_block;
extern int wg_waterf_lines;

extern short int *bg_waterf;
extern int bg_waterf_sum_counter;
extern float *bg_waterf_sum;
extern int bg_waterf_ymove_ptr;
extern int bg_waterf_ymove_start;
extern int bg_waterf_yinc;
extern int bg_waterf_y1;
extern int bg_waterf_y2;
extern int bg_waterf_y;
extern float bg_waterf_cfac;
extern float bg_waterf_czer;
extern int bg_waterf_block;
extern int bg_waterf_lines;
extern float bg_waterf_yfac;



extern char *wg_background;
extern int wg_first_xpixel;
extern int wg_last_xpixel;
extern int wg_xpixels;
extern float wg_db_per_pixel;
extern float wg_yfac_power;
extern float wg_yfac_log;
extern float wg_hz_per_pixel;
extern float wg_first_frequency;
extern int wg_timestamp_counter;
extern double frequency_scale_offset;

extern char *bg_background;
extern int bg_flatpoints;
extern int bg_curvpoints;
extern int bg_first_xpixel;
extern int bg_last_xpixel;
extern int bg_first_xpoint;
extern int bg_xpoints;
extern int bg_xpixels;
extern int bg_xpix1;
extern float bg_first_frequency;
extern int bg_oscill_on;
extern int cg_oscill_on;
extern float bg_oscill_gain;
extern int bg_timestamp_counter;
extern int bg_ymax;
extern int bg_y0;
extern int bg_redraw_counter;
extern int bg_y1;
extern int bg_y2;
extern int bg_yborder_max;
extern int bg_yborder_min;
extern float bg_hz_per_pixel;
extern int bg_vol_x1;
extern int bg_vol_x2;

extern int *hires_handle;
extern char *hg_background;
extern char *hg_stonbuf;
extern short int *hg_spectrum;
extern int hg_size;
extern int hg_first_point;
extern int hg_last_point;
extern int hg_first_xpixel;
extern int hg_last_xpixel;
extern int hg_xpix1;
extern int hg_first_fq;
extern int hg_curx;
extern int hg_center;
extern int hg_cury0;
extern int hg_cury1;
extern int hg_cury2;
extern int hg_stonbars_ytop;
extern int hg_y0;
extern int hg_redraw_counter;
extern int hg_ymax;
extern float hg_db_per_pixel;
extern float hg_hz_per_pixel;
extern float hg_yfac_log;
extern float hg_yfac_power;
extern int hg_powersum_recalc;
extern int hg_recalc_pointer;
extern int hg_ston1_y;
extern int hg_ston2_y;
extern int hg_ston_y0;
extern int hg_ston1_x1;
extern int hg_ston1_x2;
extern int hg_ston2_x1;
extern int hg_ston2_x2;


extern int pg_old_y1;
extern int pg_old_y2;
extern int pg_old_x1;
extern int pg_old_x2;

extern int pg_x0;
extern int pg_y0;
extern int pg_oldx;
extern int pg_oldy;
extern float pg_pol_angle;
extern float pg_b;


extern AG_PARMS ag;
extern WG_PARMS wg;
extern HG_PARMS hg;
extern BG_PARMS bg;
extern PG_PARMS pg;
extern PG_PARMS dpg;
extern CG_PARMS cg;
extern EG_PARMS eg;
extern FG_PARMS fg;


extern char *mousepar_filenames[];

extern BUTTONS wgbutt[MAX_WGBUTT];
extern BUTTONS hgbutt[MAX_HGBUTT];
extern BUTTONS bgbutt[MAX_BGBUTT];
extern BUTTONS agbutt[MAX_AGBUTT];
extern BUTTONS pgbutt[MAX_PGBUTT];
extern BUTTONS cgbutt[MAX_CGBUTT];
extern BUTTONS egbutt[MAX_EGBUTT];
extern BUTTONS fgbutt[MAX_FGBUTT];
extern int no_of_scro;
extern int button_color;
extern SCREEN_OBJECT scro[];
extern int wg_flag;
extern int hg_flag;
extern int ag_flag;
extern int bg_flag;
extern int pg_flag;
extern int cg_flag;
extern int eg_flag;
extern int fg_flag;
extern int wg_fft_avg2num;
extern int wg_old_y1;
extern int wg_old_y2;
extern int wg_old_x1;
extern int wg_old_x2;
extern int hg_old_x1;
extern int hg_old_x2;
extern int hg_old_y1;
extern int hg_old_y2;
extern int ag_old_y1;
extern int ag_old_y2;
extern int ag_old_x1;
extern int ag_old_x2;
extern int bg_old_x1;
extern int bg_old_x2;
extern int bg_old_y1;
extern int bg_old_y2;

extern int cg_old_y1;
extern int cg_old_y2;
extern int cg_old_x1;
extern int cg_old_x2;
extern int cg_x0;
extern int cg_y0;
extern int cg_y1;
extern int cg_chirpx;
extern int cg_chirpy;

extern int cg_oldx;
extern int cg_oldy;


extern int eg_hsiz;
extern int eg_vsiz;
extern int eg_old_y1;
extern int eg_old_y2;
extern int eg_old_x1;
extern int eg_old_x2;
extern int eg_oldx;
extern int eg_oldy;
extern int eme_active_flag;

extern int fg_hsiz;
extern int fg_vsiz;
extern int fg_old_y1;
extern int fg_old_y2;
extern int fg_old_x1;
extern int fg_old_x2;
extern int fg_oldx;
extern int fg_oldy;
extern int fg_yborder;
extern int fg_old_band;

extern int afc_curx;
extern int fftx_totmem;
extern int baseband_totmem;
extern int afc_totmem;
extern int hires_totmem;
extern int fft3_totmem;



extern ROUTINE current_mouse_activity;
extern int mouse_active_flag;
extern char svga_palette[];
extern int color_scale[];
void make_button(int x, int y, BUTTONS *butt, int m, char chr);
void wg_error(char *txt, int line);
void new_fft1_averages(int ia, int ib);
void update_fft1_averages(void);
void mouse_on_wide_graph(void);
void mouse_on_hires_graph(void);
void mouse_on_afc_graph(void);
void mouse_on_baseband_graph(void);
void mouse_on_pol_graph(void);
void mouse_on_coh_graph(void);
void mouse_on_eme_graph(void);
void mouse_on_freq_graph(void);
void help_on_wide_graph(void);
void help_on_hires_graph(void);
void help_on_afc_graph(void);
void help_on_baseband_graph(void);
void help_on_pol_graph(void);
void help_on_coherent_graph(void);
void help_on_eme_graph(void);
void help_on_freq_graph(void);
void update_wg_spectrum(void);
void init_wide_graph(void);
void init_hires_graph(void);
void init_afc_graph(void);
void init_pol_graph(void);
void init_baseband_graph(void);
void init_coherent_graph(void);
void check_graph_placement(WG_PARMS *a);
void set_graph_minwidth(WG_PARMS *a);
void decrease_wg_pixels_per_points(void);
void decrease_hg_pixels_per_points(void);
void decrease_bg_pixels_per_points(void);
void increase_wg_pixels_per_points(void);
void wg_borders(int color);
void hg_borders(int color);
void bg_borders(int color);
void ag_borders(int color);
void pg_borders(int color);
void fg_borders(int color);
void make_wide_graph(int m);
void make_hires_graph(int m);
void make_afc_graph(int m);
void make_pol_graph(int m);
void make_baseband_graph(int m);
void make_freq_graph(int m);
void move_wg_waterfall(void);
void move_bg_waterfall(void);
void get_numinput_chars(void);
void show_pol(void);
void make_eme_graph(int m);
void eg_borders(int color);
void check_eg_borders(void);
void check_fg_borders(void);

