
#include "globdef.h"
#include "screendef.h"

int *hires_handle;
float *wg_waterf_sum;
int wg_waterf_sum_counter;
int wg_waterf_ymove_ptr;
int wg_waterf_ymove_start;
int wg_waterf_yinc;
int wg_waterf_y1;
int wg_waterf_y2;
int wg_waterf_y;
float wg_waterf_cfac;
float wg_waterf_czer;
int wg_waterf_block;
int wg_waterf_lines;


short int *bg_waterf;
int bg_waterf_sum_counter;
float *bg_waterf_sum;
int bg_waterf_ymove_ptr;
int bg_waterf_ymove_start;
int bg_waterf_yinc;
int bg_waterf_y1;
int bg_waterf_y2;
int bg_waterf_y;
float bg_waterf_cfac;
float bg_waterf_czer;
int bg_waterf_block;
int bg_waterf_lines;
float bg_waterf_yfac;



char *wg_background;
char *bg_background;
char *hg_background;
char *hg_stonbuf;
short int *hg_spectrum;
int mouse_active_flag;
int numinput_flag;
int numinput_xdiff;
int numinput_ydiff;
int numinput_xpix;
int numinput_ypix;
int numinput_curpos;
int numinput_int_data;
int numinput_chars;
float numinput_float_data;
float moon_az;
float moon_el;


char numinput_txt[MAX_TEXTPAR_CHARS+1];

ROUTINE current_mouse_activity;

int wg_first_xpixel;
int wg_last_xpixel;
float wg_yfac_power;
float wg_yfac_log;
float wg_hz_per_pixel;
float wg_first_frequency;
double frequency_scale_offset;
int wg_xpixels;
float wg_db_per_pixel;
int wg_timestamp_counter;

int bg_flatpoints;
int bg_curvpoints;
int bg_first_xpixel;
int bg_last_xpixel;
int bg_first_xpoint;
int bg_xpoints;
int bg_xpixels;
int bg_xpix1;
int bg_timestamp_counter;
int bg_ymax;
int bg_y2;
int bg_y1;
int bg_y0;
int bg_redraw_counter;
int bg_yborder_max;
int bg_yborder_min;
int bg_vol_x1;
int bg_vol_x2;
float bg_hz_per_pixel;
float bg_first_frequency;
int bg_oscill_on;
int cg_oscill_on;
float bg_oscill_gain;

int hg_size;
int hg_first_point;
int hg_last_point;
int hg_first_xpixel;
int hg_last_xpixel;
int hg_xpix1;
int hg_first_fq;
int hg_curx;
int hg_center;
int hg_cury0;
int hg_cury1;
int hg_cury2;
int hg_stonbars_ytop;
int hg_y0;
int hg_redraw_counter;
int hg_ymax;
float hg_db_per_pixel;
float hg_hz_per_pixel;
float hg_yfac_log;
float hg_yfac_power;
int hg_powersum_recalc;
int hg_recalc_pointer;
int hg_ston1_y;
int hg_ston2_y;
int hg_ston_y0;
int hg_ston1_x1;
int hg_ston1_x2;
int hg_ston2_x1;
int hg_ston2_x2;
int afc_curx;


int pg_old_y1;
int pg_old_y2;
int pg_old_x1;
int pg_old_x2;
int pg_x0;
int pg_y0;
int pg_oldx;
int pg_oldy;
float pg_pol_angle;
float pg_b;

int cg_old_y1;
int cg_old_y2;
int cg_old_x1;
int cg_old_x2;
int cg_x0;
int cg_y0;
int cg_y1;
int cg_chirpx;
int cg_chirpy;
int cg_oldx;
int cg_oldy;

int eg_hsiz;
int eg_vsiz;
int eg_old_y1;
int eg_old_y2;
int eg_old_x1;
int eg_old_x2;
int eg_oldx;
int eg_oldy;
int eme_active_flag;

int fg_hsiz;
int fg_vsiz;
int fg_old_y1;
int fg_old_y2;
int fg_old_x1;
int fg_old_x2;
int fg_oldx;
int fg_oldy;
int fg_yborder;
int fg_old_band;

int fftx_totmem;
int baseband_totmem;
int afc_totmem;
int hires_totmem;
int fft3_totmem;




AG_PARMS ag;
WG_PARMS wg;
HG_PARMS hg;
BG_PARMS bg;
PG_PARMS pg;
PG_PARMS dpg;
CG_PARMS cg;
EG_PARMS eg;
FG_PARMS fg;


char *graphtype_names[MAX_GRAPHTYPES]={"ag",
                                       "wg",
                                       "bg",
                                       "hg",
                                       "pg",
                                       "cg",
                                       "eg",
                                       "fg"};
                                       
char *graphtype_parptr[MAX_GRAPHTYPES]={(void*)(&ag),
                                       (void*)(&wg),
                                       (void*)(&bg),
                                       (void*)(&hg),
 //Use dpg for read/write to keep defaults while moving window.
                                       (void*)(&dpg),
                                       (void*)(&cg),
                                       (void*)(&eg),
                                       (void*)(&fg)};
                                       
int graphtype_max_intpar[MAX_GRAPHTYPES]={MAX_AG_INTPAR,
                                          MAX_WG_INTPAR,
                                          MAX_BG_INTPAR,
                                          MAX_HG_INTPAR,
                                          MAX_PG_INTPAR,
                                          MAX_CG_INTPAR,
                                          MAX_EG_INTPAR,
                                          MAX_FG_INTPAR};

char **graphtype_partexts_int[MAX_GRAPHTYPES]={ag_intpar_text,
                                               wg_intpar_text,
                                               bg_intpar_text,
                                               hg_intpar_text,
                                               pg_intpar_text,
                                               cg_intpar_text,
                                               eg_intpar_text,
                                               fg_intpar_text,};

// Store number of float with reversed sign if the
// float variables are double precision.
int graphtype_max_floatpar[MAX_GRAPHTYPES]={MAX_AG_FLOATPAR,
                                          MAX_WG_FLOATPAR,
                                          MAX_BG_FLOATPAR,
                                          MAX_HG_FLOATPAR,
                                          MAX_PG_FLOATPAR,
                                          MAX_CG_FLOATPAR,
                                          MAX_EG_FLOATPAR,
                                          -MAX_FG_FLOATPAR};

char **graphtype_partexts_float[MAX_GRAPHTYPES]={ag_floatpar_text,
                                               wg_floatpar_text,
                                               bg_floatpar_text,
                                               hg_floatpar_text,
                                               pg_floatpar_text,
                                               cg_floatpar_text,
                                               eg_floatpar_text,
                                               fg_floatpar_text,};
                                          

char *mousepar_filenames[]= {"par_wcw_mp",
                             "par_cw_mp",
                             "par_hsms_mp",
                             "par_ssb_mp",
                             "par_fm_mp",
                             "par_am_mp",
                             "par_qrss_mp",
                             "par_txtest_mp",
                             "par_tune_mp",
                             "par_test_mp"};



BUTTONS wgbutt[MAX_WGBUTT];
BUTTONS hgbutt[MAX_HGBUTT];
BUTTONS bgbutt[MAX_BGBUTT];
BUTTONS agbutt[MAX_AGBUTT];
BUTTONS pgbutt[MAX_PGBUTT];
BUTTONS cgbutt[MAX_CGBUTT];
BUTTONS egbutt[MAX_EGBUTT];
BUTTONS fgbutt[MAX_FGBUTT];
int button_color;
int no_of_scro;
SCREEN_OBJECT scro[MAX_SCRO];
int wg_flag;
int hg_flag;
int ag_flag;
int bg_flag;
int pg_flag;
int cg_flag;
int eg_flag;
int fg_flag;

int wg_fft_avg2num;
int wg_old_y1;
int wg_old_y2;
int wg_old_x1;
int wg_old_x2;
int hg_old_x1;
int hg_old_x2;
int hg_old_y1;
int hg_old_y2;
int ag_old_y1;
int ag_old_y2;
int ag_old_x1;
int ag_old_x2;
int bg_old_x1;
int bg_old_x2;
int bg_old_y1;
int bg_old_y2;


