

#include <sys/io.h>
#include <vga.h>
#include <vgagl.h>
#include <unistd.h>

#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft3def.h"
#include "conf.h"
#include "sigdef.h"
#include "screendef.h"
#include "seldef.h"
#include "hwaredef.h"
#include "caldef.h"

void wait(void)
{
update_recent_time();
hware_time=recent_time; 
while(recent_time-hware_time < 0.002) update_recent_time();
}


void parport_sendwait(char byte)
{    
outb(byte,HWARE_CONTROL);
wait();
}

void store_xtal_data(int unit, int bitdat)
{
char chk;
outb(unit,HWARE_PORT);
wait();
chk=inb(HWARE_STATUS)&HWARE_ACKNOWLEDGE;
if(bitdat ==0 )
  {
  if( chk == 0) hware_error_flag++;
  }
else  
  {
  if( chk != 0) hware_error_flag++;
  }
}


void send_bit(int bitdat)
{
char odat;
// Set clock low and make data the first bit of current output.
if( bitdat == 0)
  {
  odat=HWARE_DATA+HWARE_CLOCK;
  }
else
  {
  odat=HWARE_CLOCK;
  }
parport_sendwait(odat);    
// Set clock high to clock in new data bit.
odat^=HWARE_CLOCK;
outb(odat,HWARE_CONTROL);
wait();
}



void tune(void)
{
int ia, ib;
char s[80];
audio_buf_info ad_info;
int j, k, m, n;
int i, bits, current_bit, unit, ptr;
int tune_n, tune_size, ptr_inc, ptr_ovl;
int mm, nn, tune_bytes;
int yshow[64]; 
float pwr[256][2];
float t1,t2,yzer,deslim;
// Make sure the compiler is happy...
yzer=0;
tune_n=0;
tune_size=0;
ptr_inc=0;
ptr_ovl=0;
// Set some memory to zero.
for(j=0; j<2; j++)
  {
  for(i=0; i<256; i++)
    {
    pwr[i][j]=0;
    }
  }  
for(i=0; i<64; i++)yshow[i]=HEIGHT/2;
enter_tune:;
vga_clear();
if(     (ui.input_mode&IQ_DATA) == 0 ||
                (ui.rx_channels == 1) ||
    (ui.input_mode&DWORD_INPUT) == 0 ||
                 ui.input_speed != 96000)
  {
  settextcolor(14);
  xytext(10,10,"Incorrect soundcard settings");
  xytext(5,12,"Set ""Two Rx channels I/Q data"", 96 kHz and 32 bit.");
skip:;
  settextcolor(7);
  xytext(13,14,"Press any key");
  await_keyboard();
  lir_status=LIR_TUNEERR;
  return;
  } 
if(genparm[FIRST_FFT_BANDWIDTH] < 100.)
  {
  xytext(5,5,"Set fft1 bandwidth to 100 Hz or above");
  xytext(5,7,"Press any key");
  await_keyboard();
  lir_status=LIR_TUNEERR;
  return;
  }  
xytext(5,5,"Select unit");
xytext(8,7,"A=RX10700");
xytext(8,8,"B=RX70");
xytext(8,9,"C=RX144");
xytext(8,10,"X=Exit");
await_keyboard();
clean_vga_inkey();
switch (vga_inkey)
  {
  case 'A':
  sprintf(s,"10700");
  unit=RX10700;
  bits=4;
  yzer=3700;
  tune_n=3;
  tune_size=8;
  ptr_ovl=((25000*tune_size+48000)/96000);
  ptr_inc=tune_size+3*ptr_ovl;
  break;

  case 'B':
  sprintf(s,"70");
  unit=RX70;
  bits=5;
  yzer=4200;
  tune_n=2;
  tune_size=4;
  ptr_ovl=((25000*tune_size+48000)/96000);
  ptr_inc=tune_size;
// Set the RX10700 to 10.700 
  hware_error_flag=0;
  outb(0,HWARE_PORT);
  send_bit(0);
  store_xtal_data(RX10700,0);
  outb(0,HWARE_PORT);
  send_bit(0);
  store_xtal_data(RX10700,0);
  outb(0,HWARE_PORT);
  send_bit(1);  
  store_xtal_data(RX10700,1);
  outb(0,HWARE_PORT);
  send_bit(0);
  store_xtal_data(RX10700,0);
  outb(0,HWARE_PORT);
  if(hware_error_flag != 0)
    {
    settextcolor(12);
    xytext(10,12,"No response from RX10700");
    settextcolor(7);
    xytext(15,15,"Press any key");
    await_keyboard();
    goto enter_tune;  
    }
  break;

  case 'C':
  sprintf(s,"144");
  unit=RX144;
  bits=4;
  break;

  case 'X':
  return;

  default:
  goto enter_tune; 
  }
// Write the number of the current unit to the data port
bal_updflag=0;
genparm[AFC_ENABLE]=0;
genparm[SECOND_FFT_ENABLE]=0;
get_buffers(0);
if(lir_status != LIR_OK)return;
open_audio_input(); 
vga_clear();
if(fft1_desired[0] > .99 || bal_updflag == 1)
  {
  settextcolor(14);
  xytext(3,10,"Calibrate the RX2500 (Read the file: CALIBRATE)");
  close_all_except_vga();
  goto skip;
  }
// Make sure the tables fit the fft routine we use.
for(i=0; i<fft1_size; i++)
  {
  t1=1/fft1_desired[i];
  fft1_desired[i]=t1*t1/1000;
  }
deslim=100./1000;  
xytext(1,0,"Connect pulse generator to RX");
xytext(30,0,s);
read(audio_in, fft1_char, ad_read_bytes);
// Move zeroes to the hardware latch for all crystals but
// the first one.
for(i=1; i<bits; i++)send_bit(0);
current_bit=bits-2;
ptr=0;
// Move 1 into the first latch to enable the first crystal.
nn=fft1_size/tune_size;
// *********************************************************
// Collect data during 1/8 second.
tune_bytes=96000/8;
if(tune_bytes < fft1_size+fft1_interleave_points)
  {
  tune_bytes = fft1_size+fft1_interleave_points;
  }
tune_bytes*=bytes_per_fragment;
tune_bytes/=ad_read_bytes;
tune_bytes++;
tune_bytes*=ad_read_bytes;
if(tune_bytes > timf1_bytes)tune_bytes = timf1_bytes;
tune_loop:;
outb(0,HWARE_PORT);
current_bit++;
ptr+=ptr_inc;
if(current_bit == bits) current_bit=0;
if(current_bit == bits-1)
  {
  ptr=0;
  switch (unit)
    {
    case RX10700:
    for(i=0; i<ptr_inc; i++)
      {
      for(j=0;j<2; j++)
        {
        for(m=1; m<4; m++)
          {
          pwr[i+m*ptr_ovl][j]+=pwr[i+m*ptr_inc][j];
          }
        }
      }    
    i=0;
    j=ptr_inc-1;
    m=1;
nrm:;
    for(k=0; k<ptr_ovl; k++)
      {
      pwr[i][0]/=m;
      pwr[j][0]/=m;
      pwr[i][1]/=m;
      pwr[j][1]/=m;
      i++;
      j--;
      if(i>j)goto nrm_x;
      }
    m++;
    goto nrm;
nrm_x:;    
    for(i=0; i<ptr_inc; i++)
      {
      gl_fillbox(12*i+30,yshow[i],8,8,0);
      k=1000*log10(pwr[i][0])-yzer;
      k=HEIGHT-k;
      if(k<30)k=30;
      if(k>HEIGHT-9)k=HEIGHT-9;
      yshow[i]=k; 
      gl_fillbox(12*i+30,yshow[i],8,8,10);
      gl_fillbox(12*i+60+12*ptr_inc,yshow[i+ptr_inc],8,8,0);
      k=1000*log10(pwr[i][1])-yzer;
      k=HEIGHT-k;
      if(k<30)k=30;
      if(k>HEIGHT-9)k=HEIGHT-9;
      yshow[i+ptr_inc]=k; 
      gl_fillbox(12*i+60+12*ptr_inc,yshow[i+ptr_inc],8,8,13);
      }
    gl_hline(0,HEIGHT/2,24*ptr_inc+120,7); 
    gl_hline(0,HEIGHT/2-100,24*ptr_inc+120,7); 
    gl_hline(0,HEIGHT/2+100,24*ptr_inc+120,7); 
    for(j=0; j<2; j++)
      {
      for(i=0; i<4*ptr_inc; i++)
        {
        pwr[i][j]=0;
        }
      }  
    i=1;
    break;
    
    case RX70:
    for(i=0; i<5*ptr_inc; i++)
      {
      gl_fillbox(12*i+30,yshow[i],8,8,0);
      k=1000*log10(pwr[i][0])-yzer;
      k=HEIGHT-k;
      if(k<30)k=30;
      if(k>HEIGHT-9)k=HEIGHT-9;
      yshow[i]=k; 
      gl_fillbox(12*i+30,yshow[i],8,8,10);
      gl_fillbox(12*i+60+5*12*ptr_inc,yshow[i+5*ptr_inc],8,8,0);
      k=1000*log10(pwr[i][1])-yzer;
      k=HEIGHT-k;
      if(k<30)k=30;
      if(k>HEIGHT-9)k=HEIGHT-9;
      yshow[i+5*ptr_inc]=k; 
      gl_fillbox(12*i+60+5*12*ptr_inc,yshow[i+5*ptr_inc],8,8,13);
      }
    gl_hline(0,HEIGHT/2,5*24*ptr_inc+120,7); 
    gl_hline(0,HEIGHT/2-100,5*24*ptr_inc+120,7); 
    gl_hline(0,HEIGHT/2+100,5*24*ptr_inc+120,7); 
/*
    for(i=0; i<5*ptr_inc; i++)
      {
      sprintf(s,"%d  %9d   %9d    ",i%14,(int)(pwr[i][0]),(int)(pwr[i][1]));
      xytext(1,i+3,s);
      }
*/
    for(j=0; j<2; j++)
      {
      for(i=0; i<5*ptr_inc; i++)
        {
        pwr[i][j]=0;
        }
      }  
    i=1;
    break;

    case RX144:
    break;
    }
  }
else
  {
  i=0;
  }  
send_bit(i);
store_xtal_data(unit,i);
// Make sure to clear our input so the data actually
// comes from the currently selected frequency.
clrbuf:;
if(ioctl(audio_in,SNDCTL_DSP_GETISPACE,&ad_info)==-1)end_program(1079);
if(ad_info.bytes>ad_read_bytes)
  {
  read(audio_in, fft1_char, ad_read_bytes);
  goto clrbuf;
  }
i=ad_info.bytes/bytes_per_fragment;
i*=bytes_per_fragment;
if(i != 0)read(audio_in, timf1_int, i);
// Read one more block of data to make sure any switch
// transcients have died out. Make the time 30 milliseconds.
i=1+0.03*96000*sizeof(int)/bytes_per_fragment;
i*=bytes_per_fragment;
read(audio_in, timf1_int, i);
// Now read the data that we will process!
mm=0;
while(mm < (int)(tune_bytes/sizeof(int)))
  {
  read(audio_in, &timf1_char[mm], ad_read_bytes);
  mm+=ad_read_bytes;
  }
timf1p_px=fft1_interleave_points*4*sizeof(int);
while(timf1p_px+timf1_blockbytes <= mm)
  {
  fft1_pa=0;
  fft1_complex_two();
  timf1p_px=(timf1p_px+timf1_blockbytes)&timf1_bytemask;
  k=fft1_size/2;
  ib=fft1_size-1;
  for(ia=1; ia < k; ia++)
    {
    t1=   fft1_float[4*ia  ] * fft1_foldcorr[4*ia  ] 
        - fft1_float[4*ia+1] * fft1_foldcorr[4*ia+1];
    t2=   fft1_float[4*ia  ] * fft1_foldcorr[4*ia+1]
        + fft1_float[4*ia+1] * fft1_foldcorr[4*ia  ];
    fft1_float[4*ia  ] -=   fft1_float[4*ib  ] * fft1_foldcorr[4*ib  ] 
                          + fft1_float[4*ib+1] * fft1_foldcorr[4*ib+1];
    fft1_float[4*ia+1] -=   fft1_float[4*ib  ] * fft1_foldcorr[4*ib+1] 
                          - fft1_float[4*ib+1] * fft1_foldcorr[4*ib  ];
    fft1_float[4*ib  ]-=t1;
    fft1_float[4*ib+1]+=t2;
    t1=   fft1_float[4*ia+2] * fft1_foldcorr[4*ia+2] 
        - fft1_float[4*ia+3] * fft1_foldcorr[4*ia+3];
    t2=   fft1_float[4*ia+2] * fft1_foldcorr[4*ia+3]
        + fft1_float[4*ia+3] * fft1_foldcorr[4*ia+2];
    fft1_float[4*ia+2] -=   fft1_float[4*ib+2] * fft1_foldcorr[4*ib+2] 
                          + fft1_float[4*ib+3] * fft1_foldcorr[4*ib+3];
    fft1_float[4*ia+3] -=   fft1_float[4*ib+2] * fft1_foldcorr[4*ib+3] 
                          - fft1_float[4*ib+3] * fft1_foldcorr[4*ib+2];
    fft1_float[4*ib+2]-=t1;
    fft1_float[4*ib+3]+=t2;
    ib--;
    }
  for(k=0; k<tune_size; k++)
    {
    for(m=0; m<nn; m++)
      {
      n=k*nn+m; 
      if(fft1_desired[n] < deslim)
        { 
        t1=fft1_float[4*n  ]*fft1_filtercorr[4*n  ]-
           fft1_float[4*n+1]*fft1_filtercorr[4*n+1];
        t2=fft1_float[4*n+1]*fft1_filtercorr[4*n  ]+
           fft1_float[4*n  ]*fft1_filtercorr[4*n+1];
        pwr[ptr+k][0]+=(t1*t1+t2*t2)*fft1_desired[n];
        t1=fft1_float[4*n+2]*fft1_filtercorr[4*n+2]-
           fft1_float[4*n+3]*fft1_filtercorr[4*n+3];
        t2=fft1_float[4*n+3]*fft1_filtercorr[4*n+2]+
           fft1_float[4*n+2]*fft1_filtercorr[4*n+3];
        pwr[ptr+k][1]+=(t1*t1+t2*t2)*fft1_desired[n];
        }
      }
    }  
  }
  
vga_inkey=vga_getkey();
if(vga_inkey != 0)
  {
  clean_vga_inkey();
  switch (vga_inkey)
    {
    case '+':
    yzer-=100;
    break;

    case '-':
    yzer+=100;
    break;

    case 'X':
    goto tune_end;
    }
  }
if(ptr != 0)goto tune_loop;    
sprintf(s,"%f dB  ",yzer/100);
xytext(1,1,s);
if(hware_error_flag != 0)
  {
  settextcolor(12);
  sprintf(s,"No response");
  }
else
  {
  for(i=0; i<15; i++)s[i]=' ';
  s[i]=0;  
  }
hware_error_flag=0;
xytext(20,1,s);
settextcolor(7);
goto tune_loop;
tune_end:;
outb(0,HWARE_PORT);
free_buffers();
close_audio_input(); 
return;
}
