#include <arpa/inet.h>

#define MAX_FLOWCNT 31
 

extern int mouse_flag;
extern int graphics_flag;
extern int audio_flag;
extern FILE *dmp;
extern FILE *wav_file;

extern int mmx_present;
extern int simd_present;
extern ROUTINE par_from_keyboard_routine;

extern float baseband_bw_hz;
extern int baseband_bw_fftxpts;
extern int fft2_to_fft1_ratio;

extern USERINT_PARM ui;
extern int vga_inkey;
extern char *vga_font;
extern int text_width;
extern int text_height;
extern int text_midpoint;
extern char userint_filename[];
extern int mouse_hide_flag;
extern int mouse_x;
extern int mouse_y;
extern int mouse_cursize;
extern char *behind_mouse;
extern int leftpressed;
extern int rightpressed;
extern int audio_in;
extern int audio_in2;
extern int audio_out;
extern int mixer;
extern int adout_block;
extern char *da_wrbuf;
extern float total_wttim;
extern int da_output_bytes;
extern int da_output_channels;
extern int timinfo_flag;
extern int ampinfo_flag;
extern float measured_da_speed;
extern float measured_ad_speed;
extern int newdat_flag;
extern int fullbuf_flag;
extern double workload_start_time;
extern double info_time;
extern double bg_maxamp_time;
extern double workload_max_latency;
extern double latest_idle_time;
extern double idle_start;
extern double workload_idle;
extern float workload_total;
extern float workload_percentage;
extern double sound_start_time;
extern double recent_time;
extern double diskread_time;
extern double eme_time;
extern int dasync_counter;
extern int flowinfo_flag;
extern float dasync_sum;
extern float dasync_avg1;
extern float dasync_avg2;
extern float dasync_avg3;
extern double dasync_time;
extern double dasync_avgtime;
extern double daspeed_time;
extern double da_start_time;
extern double disksync_time;
extern int overrun_count;
extern int overrun_flag;
extern int dasync_errors;
extern int da_start_bytes;
extern char savefile_parname[];
extern int memalloc_no;
extern int memalloc_max;
extern MEM_INF *memalloc_mem;
extern DXDATA *dx;
extern int timf3_oscilloscope_limit;


extern int rx_mode;
extern int use_bfo;
extern int rx_channels;
extern int twice_rxchan;
extern int mailbox[];
extern char *rxpar_filenames[MAX_RX_MODE];
extern char *rxmodes[MAX_RX_MODE];
extern int genparm[MAX_GENPARM+2];
extern int genparm_min[MAX_GENPARM];
extern int genparm_max[MAX_GENPARM];
extern int genparm_default[MAX_RX_MODE][MAX_GENPARM];
extern char *genparm_text[MAX_GENPARM+2];
extern char modes_man_auto[3];
extern MEM_INF fft1mem[MAX_FFT1_ARRAYS];
extern MEM_INF fft3mem[MAX_FFT3_ARRAYS];
extern MEM_INF basebmem[MAX_BASEB_ARRAYS];
extern MEM_INF hiresmem[MAX_HIRES_ARRAYS];
extern MEM_INF afcmem[MAX_AFC_ARRAYS];
extern double flowcnt[MAX_FLOWCNT];
extern double flowtime;


extern int cwlong_no_of_traces[CWLONG_MAXBUF];
extern int current_graph_minh;
extern int current_graph_minw;
extern int calibrate_flag;
extern int network_flag;
extern struct sockaddr_in network_address;
extern int network_sockfd;
extern int network_modeno;
extern int network_fd;
extern double old_passband_center;

extern int wav_write_flag;
extern int wav_read_flag;
extern int wavfile_bytes;
extern int swmmx_fft2;
extern int swmmx_fft1;
extern int sw_onechan;
extern int eme_flag;
extern int idle_flag;
extern char *press_any_key;
extern int lir_status;
extern int audio_dump_flag;
extern int allow_parport;



void save_screen_image(void);
void clean_vga_inkey(void);
void *chk_malloc(int size, int errcod);
void *chk_free(void *p);
void set_vgamode(void);
void await_keyboard(void);
void end_program(int errcod);
void settextcolor(int color);
void xytext(int x, int y, char *txt);
void init_font(void);
void set_mouse(void);
void clearscreen(void);
void clear_lines(int i, int j);
void show_mouse(void);
void hide_mouse(void);
void dsp_mouse(void);
void open_mouse(void);
void close_mouse(void);
void open_audio_input(void);
void open_audio_output(void);
void close_audio_input(void);
void close_audio_output(void);
void clear_real2iq(void);
void set_analog_io(void);
void free_buffers(void);
void make_sincos(int mo, int sz, COSIN_TABLE *tab);
void make_permute(int mo, int nz, int sz, unsigned short int *perm);
void make_bigpermute(int mo, int nz, int sz, unsigned int *perm);
void make_window(int i, int size, int n_sin, float *fft1_window);
void init_fft(int i,int n, int size, 
                          COSIN_TABLE *tab, unsigned short int *permute);
void init_mmxfft(int size, MMX_COSIN_TABLE *tab);
void make_mmxwindow(int mo, int size, int n, short int *x);
void fftback(int sz, int n, float *x, 
                          COSIN_TABLE *sc, unsigned short int *pm);
void dual_fftback(int sz, int n, float *x, 
                          COSIN_TABLE *sc, unsigned short int *pm);
void fftforward(int sz, int n, float *x, 
                          COSIN_TABLE *sc, unsigned short int *pm);
void dual_fftforward(int sz, int n, float *x, 
                          COSIN_TABLE *sc, unsigned short int *pm);
void fft_iqshift(int size, float *x);
void fft_real_to_hermitian( float *z, int size, int n, COSIN_TABLE *tab);
void asmbulk_of_dual_dif(int size, int n, float *x, COSIN_TABLE *sincos);
void asmbulk_of_dif(int size, int n, float *x, COSIN_TABLE *sincos);
void bulk_of_dif(int size, int n, float *x, COSIN_TABLE *sincos);
void bulk_of_dual_dif(int size, int n, float *x, COSIN_TABLE *sincos);
void bulk_of_dit(int size, int n, float *x, COSIN_TABLE *sincos);
void bulk_of_dual_dit(int size, int n, float *x, COSIN_TABLE *sincos);
void simdbulk_of_dual_dit(int size, int n, float *x, COSIN_TABLE *sincos);
int check_mmx(void);
void get_buffers(int sizes_only);
int adjust_scale(float *step);
int llsq(void);
int llsq1(void);
int make_power_of_two(int *i);
void close_all_except_vga(void);
void close_all(void);
int vga_get_filename(int  x, int y, char *name);
int vga_get_integer(int  x, int y, int len, int min, int max);
void xz(char *s);
void qq(char *s);
void qq1(char *s);
void qq2(char *s);
void tt0(void);
void tt(char *s);
float tt1(void);


void disksave_start_stop(void);
void wavsave_start_stop(void);

void remove_mix1_cursor(int i);
void make_new_signal(int ss, float fq);
void make_wg_file(void);
void make_wg_yfac(void);
void make_hg_file(void);
void baseband_fq_scale(void);
void hires_fq_scale(void);
void make_hg_yscale(void);
void new_fft2_averages(void);
void wide_graph_add_signal(void);
void make_fft3_all(void);
void show_baseband_spectrum(void);
void fft3_mix2(void);
void init_blanker(void);
void new_hg_pol(void);
void timf3_oscilloscope(void);
void update_wg_waterf(void);
void wg_waterf_line(void);
void update_bg_waterf(void);
void bg_waterf_line(void);
void clear_fft1_filtercorr(void);
void init_fft1_filtercorr(void);
void calibrate_fft1(void);
void set_general_parms(char *mode);
void make_audio_output(void);
void clear_da(void);
void change_fft3_avgnum(void);
void clear_ad_countertimer(void);
void make_ad_wttim(void);
void make_fft2_wttim(void);
void make_audio_signal(void);
void clear_ad_countertimer(void);
void make_da_wttim(void);
void make_fft2_wttim(void);
void make_timing_info(void);
void show_amp_info(void);
void amp_info_texts(void);
void show_timing_info(void);
void timing_info_texts(void);
void update_bar(int x1, int x2, int yzer, 
                         int newy, int oldy, char color, char *buf);
void parabolic_fit(float *amp, float *pos, float yy1, float yy2, float yy3);
void set_daout_parms(void);
void parfile_end(FILE *file);
void clear_sound_timers(void);
void ck_setpixel(int x, int y, int c);
void ck_write(int x, int y, char *s);
void ck_hline(int xx1, int y, int xx2, int c);
void ck_line(int xx1, int yy1, int xx2,int yy2, int c);
void ck_fillbox(int x, int y,int w, int h, int c);
void help_message(int msg_no);
void help_screen_objects(void);
void select_pol_default(void);
void init_spur_elimination(void);
void cancel_spur_elimination(void);
void eliminate_spurs(void);
void init_spur_spectra(void);
float average_curvature(float *z, int siz);
float average_slope(float *z, int siz);
void spur_phase_parameters(void);
void complex_lowpass(float *zin, float *zout, int nn, int siz);
void remove_phasejumps(float *z, int siz);
int spur_phase_lock(int nx);
int make_spur_freq(void);
void make_spur_pol(void);
void spurspek_norm(void);
void spur_relock(void);
void refine_pll_parameters(void);
int verify_spur_pll(void);
void shift_spur_table(int j);
void coherent(void);
void clear_coherent(void);
void clear_cg_traces(void);
void init_memalloc(MEM_INF *mem, int max);
void mem(int num, void *pointer, int size, int scratch_size);
int memalloc( int *handle, char *s);
void memcheck(int n, MEM_INF *mm, int *handle);
void ncw_rx(void);
void clear_workload_timers(void);
void update_recent_time(void);
void clear_sound_timers(void);
void show_name_and_size(void);
void get_rx_mode(void);
int init_wavread(int m);
int init_diskread(int m);
void check_fft2(void);
void init_eme_database(void);
void read_eme_database(void);
void init_eme_graph(void);
void calculate_moon_data(void);
void init_freq_control(void);
void erase_numinput_txt(void);
void read_freq_control_data(void);
void make_wg_freq_scale(void);
void network_send_fft1info(void);
void network_receive_fft1info(void);
void network_send_adinfo(void);
void network_receive_adinfo(void);
void start_network_output(void);
void start_network_input(void);
void network_setup(int change);
void users_open_devices(void);
void expand_fft1_filtercorr(int cal_n, int cal_size);
void make_filcorrstart(void);    
void show_center_frequency(void);
void userdefined_u(void);
void userdefined_q(void);
void check_mouse_actions(void);
int check_keyboard_actions(void);
void audio_output_routines(void);
void ensure_valid_input(void);
int check_timing(int idle);
void modesub_idle(int idle);
int read_modepar_file(int type);
void make_modepar_file(int type);
void show_button(BUTTONS *butt, char *s);
void remove_carr_indicator(void);
void txtest(void);
void txtest_init(void);
void clear_hware_data(void);
void hware_interface_test(void);
void tune(void);
