#define WG_DBSCALE_COLOR 0x1
#define MIX1_MAINCUR_COLOR 0xb1
#define MIX1_SUBCUR_COLOR 0x1

#define YBO 8
#define YWF 4
#define MAX_FFT1_AVG1 6

#include <unistd.h>
#include <vgagl.h>
#include </usr/include/sys/ioctl.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "fft3def.h"
#include "screendef.h"
#include "seldef.h"
#include "graphcal.h"
#include "vernr.h"
#include "sigdef.h"
#include "conf.h"


void show_wg_buttons(void)
{
char s[80];
errno=30003;
sprintf(s,"%4d",wg.spek_avgnum);
show_button(&wgbutt[WG_FFT1_AVGNUM],s);
sprintf(s,"%4d",wg.waterfall_avgnum);
if(wgbutt[WG_WATERF_AVGNUM].y1 > wg.ytop+1.5*text_height)
                                    show_button(&wgbutt[WG_WATERF_AVGNUM],s);
sprintf(s,"%f",wg.waterfall_db_zero);
s[5]=0;
if(wgbutt[WG_WATERF_ZERO].y1 > wg.ytop+1.5*text_height)
                                      show_button(&wgbutt[WG_WATERF_ZERO],s);
sprintf(s,"%f",wg.waterfall_db_gain);
s[4]=0;
if(wgbutt[WG_WATERF_GAIN].y1 > wg.ytop+1.5*text_height)
                                       show_button(&wgbutt[WG_WATERF_GAIN],s);
}


void check_fft1_timing(void)
{
audio_buf_info ad_info;
if(disksave_flag == 2 || disksave_flag == 4 || network_flag == 2)return;
while( (fullbuf_flag&ND_TIMF1) != 0)
  {
  if( (fullbuf_flag & ND_FFT1) != 0)return;
  fft1_b(0);
  }
// Try to avoid overrun errors if we read from our own A/D converter.
if(ioctl(audio_in,SNDCTL_DSP_GETISPACE,&ad_info)==-1)end_program(88231);
if(ad_info.bytes < ad_read_bytes)return;
// Avoid an overrun situation by reading some data now! 
read_rawdat(0);
}

int make_dafrag(void);
void clear_da(void)
{
int i, n;
float raw_wttim,t1;
new_baseb_flag=3;
if( (ui.input_mode&NO_DUPLEX) != 0 && audio_out == -1)goto no_duplex;
if(ui.da_device_no != -1 || disksave_flag == 2)
  {
  if( audio_out == -1)end_program(88997);
  new_baseb_flag=2;
// Aborting the data already written to the output is not
// a simple thing. The OSS manual recommends a close and a reopen of 
// the output. As it turns out, this may cause problems with
// the analog input. After a close and reopen sequence the input
// is incorrect, not always, but often enough to be unacceptable.
// The problem can be solved by closing and reopening the input also
// but that will destroy the phase of the old information already in
// memory.
// The SNDCTL_DSP_RESET does not work always. The result of issuing
// this command blindly is stochastic. Sometimes the call takes very
// long time, sometimes the device is stopped, sometimes not.
// Make sure data is waiting and device running !!!!
  if( audio_in != audio_out)
    {
    gl_fillbox(0,6,3,3,12);
    if(ioctl(audio_out,SNDCTL_DSP_GETOSPACE, &da_info) == -1)end_program(1077);
    for(i=0; i<daout_block; i++)da_wrbuf[i]=0;
    if(da_info.fragstotal - da_info.fragments <= 4)
      {
      write(audio_out,da_wrbuf,daout_block);
      } 
    if(ui.da_stopstart != 0)
      {
      check_fft1_timing();
      if(ioctl(audio_out,SNDCTL_DSP_RESET,0)==-1)end_program(622);
// Now close and reopen is more or less safe.
      close_audio_output();
      check_fft1_timing();
      open_audio_output();
      gl_fillbox(0,6,3,3,14);
      check_fft1_timing();
      }
    }
  }
no_duplex:;
// We have to recalculate timf3 from old transforms.
// Find out how much time the data waiting before fft1 sums up to.
make_ad_wttim();
raw_wttim=ad_wttim;
// We need a total delay from input sample to output sample
// that can accomodate the most unfavourable situation while collecting
// enough data to make a new transform.
// Make da_wait_time the desired number of seconds from input sample
// to output sample.
// First a safety margin for processing delay and adjusting speed
// errors in case different soundboards are used for input and output.
da_wait_time=0.1*genparm[OUTPUT_DELAY_MARGIN];
if(disksave_flag != 2)
  {
// Maximum delay inside device driver
  da_wait_time+=1.0/interrupt_rate;
// Maximum raw data waiting that is not enough for a new fft1 transform
  da_wait_time+=fft1_size/timf1_sampling_speed;
  }
// Maximum data waiting in timf3 that is not enough for a new fft3 transform
// plus the number of 50% interleaved transforms we want to wait.
da_wait_time+=(0.5*bg.afc2_delay+1.5)*fft3_size/timf3_sampling_speed;
t1=da_wait_time-raw_wttim;
// If we run in RDWR mode, devices can not be stopped immediately.
// Therefore we do not try to flush the output buffer.
// There is no reason to calculate fresh data for the time it takes
// to empty the output buffer.
if(audio_out == audio_in)
  {
  make_da_wttim();
  t1-=da_wttim;
  if(t1<0)t1=0;
  }
// We use sin squared windows for fft3 so we need to recalculate 
// one extra half transform to get the first transform output right.
// make data for 0.5 seconds extra
t1+=0.5*(1+fft3_size/timf3_sampling_speed);
if(genparm[SECOND_FFT_ENABLE]!=0)
  {
// Add time for data waiting in timf2.
  make_fft2_wttim();
  raw_wttim+=timf2_wttim;
// Maximum data waiting in timf2 that is not enough for a new fft2 transform
  da_wait_time+=fft2_size/timf1_sampling_speed;
  hires_fq_scale();
  n=t1/fft2_blocktime; 
  if(fft2_blocktime > 0.25)n++;
  if(genparm[AFC_ENABLE] != 0)
    {
    n+=afct_delay_points;
    da_wait_time+=afct_delay_points*fft2_blocktime;
    }
  if(n > fft2_nm)n=fft2_nm;
  fft2_nx=(fft2_na-n+max_fft2n)&fft2n_mask;
  fft2_nc=fft2_nx;
  new_fft2_averages();
  if(n == 0)
    {
    newdat_flag&=-1-ND_FFT2;
    }
  else
    {  
    newdat_flag|=ND_FFT2;
    }
  }
else
  {
  n=t1/fft1_blocktime; 
  if(fft1_blocktime > 0.25)n++;
  if(genparm[AFC_ENABLE] != 0)
    {
    n+=afct_delay_points;
    da_wait_time+=afct_delay_points*fft1_blocktime;
    }
  if(n >= fft1n_mask)n=max_fft1n-1;
  fft1_nx=(fft1_na-n+max_fft1n)&fft1n_mask;
  fft1_nc=fft1_nx;
  fft1_px=fft1_nx*fft1_block;
  newdat_flag|=ND_FFT1;
  }  
newdat_flag&=ND_WG+ND_WGX+ND_BG+
             ND_HWARE+ND_TIMF1+ND_FFT1+ND_TIMF2RAW+ND_TIMF2BLN+ND_FFT2;
timf3_pa=0;
timf3_px=0;
timf3_ps=0;
fft3_pa=0;
fft3_px=0;
for(i=0;i<timf3_block;i++)timf3_float[i]=0;
baseb_pa=0;
clear_coherent();
baseb_wts=4;
baseb_fx=(baseb_pa-4+baseband_size)&baseband_mask;
daout_pa=0;
daout_px=0;
da_resample_ratio=genparm[DA_OUTPUT_SPEED]/baseband_sampling_speed;
new_da_resample_ratio=da_resample_ratio;
da_empty_flag = 0;
for(i=0; i<genparm[MIX1_NO_OF_CHANNELS]; i++)
  {
  mix1_status[i]=0;
  }  
old_afct_delay=afct_delay_points;
poleval_pointer=0;
check_fft1_timing();
}



void add_mix1_cursor(int num)
{
int xpos;
char color;
if(mix1_selfreq[num]<wg_first_frequency)end_program(1087);
xpos=0.5+wg_first_xpixel+
                    (mix1_selfreq[num]-wg_first_frequency)/wg_hz_per_pixel;
mix1_curx[num]=xpos;
if(num==0)
  {
  color=MIX1_MAINCUR_COLOR;
  }
else
  {
  color=MIX1_SUBCUR_COLOR;
  }
errno=10620;
ck_line(xpos,wg.ybottom-1,xpos,wg.yborder+1,color);
}

void remove_mix1_cursor(int num)
{
int i,xpos;
if(mix1_selfreq[num]<0)return;
xpos=mix1_curx[num];
for(i=wg.yborder+1; i<wg.ybottom; i++)
  {
errno=10621;
  ck_setpixel(xpos,i, wg_background[i]);
  }
fft1_spectrum[mix1_curx[num]]=-10;
mix1_curx[num]=-1;
}


float wg_check_mix1(int i0)
{
int i,k;
float t1;
t1=wg_first_frequency+(mouse_x-wg_first_xpixel)*wg_hz_per_pixel;

if(t1 <  mix1_lowest_fq)t1=mix1_lowest_fq;
if(t1 > mix1_highest_fq)t1=mix1_highest_fq;

k=0;
for(i=i0; i<genparm[MIX1_NO_OF_CHANNELS]; i++)
  {
  if( fabs(t1-mix1_selfreq[i]) < 3*wg_hz_per_pixel)
    {
    remove_mix1_cursor(i);
    k++;
    mix1_selfreq[i]=-BIG;
    }
  }
if(k>0 && i0==0)return -BIG;
return t1;
}





void make_new_signal(int i,float t1)
{
int k;
mix1_selfreq[i]=t1;
t1/=wg_hz_per_pixel;
if(wg.xpoints_per_pixel == 0)
  {
  t1/=wg.pixels_per_xpoint;
  }
else
  {
  t1*=wg.xpoints_per_pixel;
  }
if(genparm[SECOND_FFT_ENABLE] != 0)
  {  
  t1*=fft2_size/fft1_size;
  }
mix1_point[i]=t1+0.5;
k=mix1_point[i]%mix1_size;    
k=(k*mix1_new_points)%mix1_size;
mix1_phase_step[i]=k*2*PI_L/mix1_size;
mix1_phase[i]=0;
add_mix1_cursor(i);
}



void wide_graph_add_signal(void)
{
float t1;
int i;
// Add or remove a receive signal.
// mix1_selfreq[0] is the frequency we process and send to the loudspeaker.
// The other frequencies are translated from CW to ASCII and placed on
// the screen (hopefully, some time...).
// If we are within +/- 3 pixels from a frequency that is already selected
// we deselect it.  
hide_mouse();
t1=wg_check_mix1(0);
if(t1 <0)
  {
  new_baseb_flag=-1;
  goto addx; 
  } 
for(i=1; i<genparm[MIX1_NO_OF_CHANNELS]; i++)
  {
  if(mix1_selfreq[i]<0)
    {
    make_new_signal(i,t1);
    goto addx;
    }
  }  
addx:;
show_mouse();
rightpressed=0;  
}

void clear_around_wgbutt(int n)
{
errno=43100;
if(wgbutt[n].y1 <= wg.ytop+1.5*text_height)return;
ck_fillbox(wgbutt[n].x1-1,wgbutt[n].y1-1,
           wgbutt[n].x2-wgbutt[n].x1+3,wgbutt[n].y2-wgbutt[n].y1+3,0);
}


void move_wg_waterfall(void)
{
int ia; 
ia=wg_waterf_ymove_ptr-wg_waterf_yinc;
if(ia < wg_waterf_y1)
  {
  ia=wg_waterf_y1;
  wg_waterf_ymove_ptr=wg_waterf_yinc+wg_waterf_y1;
  }
if(  mouse_x+mouse_cursize >= wg.xleft &&
     mouse_x-mouse_cursize <= wg.xright &&
     mouse_y+mouse_cursize >= ia &&
     mouse_y-mouse_cursize <= wg_waterf_ymove_ptr+wg_waterf_yinc)hide_mouse();
gl_copybox(wg.xleft,ia,wg_xpixels+wg_first_xpixel-wg.xleft+1,wg_waterf_yinc,
           wg.xleft,wg_waterf_ymove_ptr);
if( mouse_active_flag != 1)
  {
  clear_around_wgbutt(WG_WATERF_AVGNUM);
  clear_around_wgbutt(WG_WATERF_ZERO);
  clear_around_wgbutt(WG_WATERF_GAIN);
  show_wg_buttons();
  }
if(ia != wg_waterf_y1)
  {
  wg_waterf_ymove_ptr=ia;
  }
else
  {
  errno=40100;
  ck_fillbox(wg.xleft+1,wg_waterf_y1,wg_last_xpixel-wg.xleft,
                                    wg_waterf_y2-wg_waterf_y1+1,0);
  wg_waterf_ymove_ptr=0;
  }
show_mouse();
}  


void make_wg_waterf_cfac(void)
{
wg_waterf_cfac=wg.waterfall_db_gain*0.1;
wg_waterf_czer=10*(wg.waterfall_db_zero+WATERFALL_SCALE_ZERO);
}

void redraw_wg_waterfall(void)
{
int color, i, ix, iw, iy,iymax;
make_wg_waterf_cfac();
iw=(wg_waterf_y-wg_waterf_y1)*wg_xpixels;
iy=wg_waterf_y;
iymax=wg_waterf_y+wg_waterf_lines-wg_waterf_yinc;
while(iy < iymax)
  {
  i=wg_first_xpixel;
  for(ix=0; ix<wg_xpixels; ix++)
    {
    color=wg_waterf_cfac*(wg_waterf[iw+ix]-wg_waterf_czer);
    if(color<0)color=0;
    if(color >= MAX_COLOR_SCALE)color=MAX_COLOR_SCALE-1;
    gl_setpixel(i,iy,color_scale[color]);
    i++;
    }
  iy++;
  iw+=wg_xpixels;
  }  
show_wg_buttons();
}

void update_wg_waterf(void)
{
int i,k,ix,iw;
float der,t1,y,yval;
// A new summed power spectrum has arrived.
// Convert it from linear power scale to log in units of 0.1dB.
// Expand or contract so we get the number of pixels that
// will fit on the screen.
// Store at the pos of our current line in waterfall
iw=(wg_waterf_y-wg_waterf_y1)*wg_xpixels;
if(wg.xpoints_per_pixel == 1 || wg.pixels_per_xpoint == 1)
  {
  i=wg.first_xpoint;
  for(ix=0; ix < wg_xpixels; ix++)
    {
    y=100*log10(wg_waterf_sum[i]*wg_waterf_yfac[i]);
    if(y < -32767)y=-32767;
    if(y>32767)y=32767;
    wg_waterf[iw+ix]=y;
    i++;
    }
  }    
else
  {
  if(wg.xpoints_per_pixel == 0)
    {
// There are more pixels than data points so we must interpolate.
    y=100*log10(wg_waterf_sum[wg.first_xpoint]*
                                           wg_waterf_yfac[wg.first_xpoint]);
    yval=y;
    if(y < -32767)y=-32767;
    if(y>32767)y=32767;
    wg_waterf[0]=y;
    i=wg.first_xpoint+1;
    for(ix=0; ix<wg_xpixels; ix+=wg.pixels_per_xpoint)
      {
      t1=100*log10(wg_waterf_sum[i]*wg_waterf_yfac[i]);
      der=(t1-yval)/wg.pixels_per_xpoint;
      for(k=ix+1; k<=ix+wg.pixels_per_xpoint; k++)
        {
        yval=yval+der;
        y=yval;
        if(y < -32767)y=32767;
        if(y>32767)y=32767;
        wg_waterf[iw+k]=y;
        }  
      yval=t1;
      i++;
      }      
    }
  else
    {
// There is more than one data point for each pixel.
// Slide a triangular filter across the spectrum to make it
// smoother before resampling.
    i=wg.first_xpoint;
    for(ix=0; ix<wg_xpixels; ix++)
      {
      t1=wg_waterf_sum[i]*wg.xpoints_per_pixel;
      for(k=1; k<wg.xpoints_per_pixel; k++)
        {
        t1+=(wg_waterf_sum[i+k]+wg_waterf_sum[i-k])*(wg.xpoints_per_pixel-k);
        }
      y=100*log10(t1*wg_waterf_yfac[i]);
      if(y < -32767)y=-32767;
      if(y>32767)y=32767;
      wg_waterf[iw+ix]=y;
      i+=wg.xpoints_per_pixel;
      }
    }  
  }
for(i=wg_first_point; i <= wg_last_point; i++)
  {
  wg_waterf_sum[i]=0;
  }
wg_waterf_line();
}


void wg_waterf_line(void)
{
struct timeval tim;
int ia, ib;
int i,ix,iw,color;
char s[80];
iw=(wg_waterf_y-wg_waterf_y1)*wg_xpixels;
// Toggle the mouse in case we would write on it's cursor.
if(   mouse_x+mouse_cursize >= wg_first_xpixel &&
      mouse_x-mouse_cursize <= wg_last_xpixel &&
      mouse_y+mouse_cursize >= wg_waterf_y &&
      mouse_y-mouse_cursize <= wg_waterf_y) hide_mouse();
// Write the current line of waterfall to the screen 
i=wg_first_xpixel;
for(ix=0; ix<wg_xpixels; ix++)
  {
  color=wg_waterf_cfac*(wg_waterf[iw+ix]-wg_waterf_czer);
  if(color<0)color=0;
  if(color >= MAX_COLOR_SCALE)color=MAX_COLOR_SCALE-1;
  gl_setpixel(i,wg_waterf_y,color_scale[color]);
  i++;
  }
wg_waterf_y--;
wg_timestamp_counter++;
if(wg_timestamp_counter>2*text_height)
  {
  hide_mouse();
  if(disksave_flag < 2)
    {
    gettimeofday(&tim,NULL);
    i=tim.tv_sec;
    }
  else
    {
    i=diskread_time+diskread_block_counter*ad_read_fragments/ui.input_speed;
    }
  i%=3600;
  sprintf(s,"%02d.%02d",i/60,i%60);
  errno=20101;
  ck_write(wg.xleft+2,wg_waterf_y+text_height/2,s);
  wg_timestamp_counter=0;
  }
if(wg_waterf_y < wg_waterf_y1)
  {
// Move the whole waterfall graph one block downwards.
// This may take some time.
// Set up loop variables but do not run the loop here.
// The main receive routine is responsible for executing the
// block move loop when there is time available.
  wg_waterf_ymove_ptr=wg_waterf_ymove_start;
  move_wg_waterfall(); 
// Save the data behind the waterfall graph in case we want to use it
// for drawing an image with another color scale.
  ia=wg_xpixels*wg_waterf_lines-1;
  ib=ia-wg_waterf_block;
  while(ib >= 0)
    {
    wg_waterf[ia]=wg_waterf[ib];
    ia--;
    ib--;
    }
  wg_waterf_y=wg_waterf_y2;
  }
wg_waterf_sum_counter=0;
show_mouse();
}

void check_wg_fft_avgnum(void)
{
// fft1 average power spectra are used to display the full dynamic
// range spectrum.
// In case fft2 is not enabled they are also used for the waterfall graph
// and for AFC (if enabled)
// Average power spectra are time consuming to calculate so several
// different ways are used depending on the needs.
// wg.fft_avg1num 1 to 5   fft1_sumsq=sum over avg1num spectra.
// wg.spek_avgnum = number of spectra for main spectrum
// wg.spek_avgnum=wg.fft_avg1num*wg_fft_avg2num;
// On entry here wg.fft_avg1num is determined by the user.
// change wg.spek_avgnum if necessary
// calculate the new avg2num
// In case neither AFC nor fft2 is enabled, make sure the averaging
// selected for the waterfall graph is a multiple of wg.fft_avg1num.
if(wg.fft_avg1num<1)wg.fft_avg1num=1;
if(wg.fft_avg1num>5)wg.fft_avg1num=5;
if(wg.spek_avgnum<wg.fft_avg1num)wg.spek_avgnum=wg.fft_avg1num;
wg_fft_avg2num=(wg.spek_avgnum+wg.fft_avg1num/2)/wg.fft_avg1num;
if(wg_fft_avg2num >= max_fft1_sumsq)wg_fft_avg2num=max_fft1_sumsq-1;
wg.spek_avgnum=wg.fft_avg1num*wg_fft_avg2num;
if( genparm[SECOND_FFT_ENABLE] == 0 )
  {
  if(wg.waterfall_avgnum<wg.fft_avg1num)wg.waterfall_avgnum=wg.fft_avg1num;
  wg.waterfall_avgnum=(wg.waterfall_avgnum+wg.fft_avg1num/2)/wg.fft_avg1num;
  wg.waterfall_avgnum*=wg.fft_avg1num;
  }
}

void wg_error(char *txt,int line)
{
int i;
i=0;
while(txt[i]!=0)i++;
settextcolor(15);
i=wg.xright/text_width-4-i;
if(i<=wg.xleft)i=wg.xleft+1;
xytext(i,wg.ybottom/text_height-2-line,txt);
settextcolor(7);
}


void decrease_wg_pixels_per_points(void)
{
if(wg_xpixels < 128)return;
if(wg.pixels_per_xpoint != 0)
  {
  wg.pixels_per_xpoint/=2;
  if(wg.pixels_per_xpoint > 0)
    {
    wg.xpoints=wg_xpixels/wg.pixels_per_xpoint;
    }
  else
    {
    wg.pixels_per_xpoint=0;
    wg.xpoints_per_pixel=2;
    wg.xpoints=wg_xpixels*2;
    }
  }
else
  {
  if(genparm[SECOND_FFT_ENABLE] == 0)
    {
    wg.xpoints_per_pixel++;
    wg.xpoints=wg_xpixels*wg.xpoints_per_pixel;
    }
  else
    {  
    wg.xpoints_per_pixel*=2;
    wg.xpoints=wg_xpixels*wg.xpoints_per_pixel;
    }
  }
}

void help_on_wide_graph(void)
{
int msg_no;
int event_no;
// Set msg to select a frequency in case it is not button or border
msg_no=2;
// First find out is we are on a button or border line.
for(event_no=0; event_no<MAX_WGBUTT; event_no++)
  {
  if( wgbutt[event_no].x1 <= mouse_x && 
      wgbutt[event_no].x2 >= mouse_x &&      
      wgbutt[event_no].y1 <= mouse_y && 
      wgbutt[event_no].y2 >= mouse_y) 
    {
    switch (event_no)
      {
      case WG_TOP:
      case WG_BORDER:
      case WG_BOTTOM:
      case WG_LEFT:
      case WG_RIGHT:
      msg_no=100;
      break;

      case WG_YSCALE_EXPAND:
      msg_no=3;
      break;
     
      case WG_YSCALE_CONTRACT:
      msg_no=4;
      break;
      
      case WG_YZERO_DECREASE:
      msg_no=5;
      break;
            
      case WG_YZERO_INCREASE:
      msg_no=6;
      break;

      case WG_FQMIN_DECREASE:
      msg_no=7;
      break;

      case WG_FQMIN_INCREASE:
      msg_no=8;
      break;

      case WG_FQMAX_DECREASE:
      msg_no=9;
      break;

      case WG_FQMAX_INCREASE:
      msg_no=10;
      break;

      case WG_AVG1NUM:
      if(genparm[SECOND_FFT_ENABLE]==0)
        {
        msg_no=11;
        }
      else
        {
        msg_no=12;
        }  
      break;

      case WG_FFT1_AVGNUM:
      if(genparm[SECOND_FFT_ENABLE] == 0)
        {
        msg_no=58;
        }
      else
        {
        msg_no=59;
        }
      break;

      case WG_WATERF_AVGNUM:
      if(genparm[SECOND_FFT_ENABLE] == 0)
        {
        msg_no=60;
        }
      else
        {
        msg_no=61;
        }
      break;

      case WG_WATERF_ZERO:
      if(genparm[SECOND_FFT_ENABLE] == 0)
        {
        msg_no=64;
        }
      else
        {
        msg_no=65;
        }
      break;

      case WG_WATERF_GAIN:
      if(genparm[SECOND_FFT_ENABLE] == 0)
        {
        msg_no=66;
        }
      else
        {
        msg_no=67;
        }
      break;


      }
    }
  }  
help_message(msg_no);
}

void change_fft1avgnum(void)
{
wg.spek_avgnum=numinput_int_data;
check_wg_fft_avgnum();
new_fft1_averages(wg_first_point,wg_last_point);
make_wg_yfac();
make_modepar_file(GRAPHTYPE_WG);
show_wg_buttons();
}

void change_waterfall_avgnum(void)
{
wg.waterfall_avgnum=numinput_int_data;
if(wg.waterfall_avgnum < 1)
  {
  wg.waterfall_avgnum=1;
  }  
if(genparm[SECOND_FFT_ENABLE] == 0) check_wg_fft_avgnum();
make_wg_yfac();
make_modepar_file(GRAPHTYPE_WG);
show_wg_buttons();
}

void change_wg_waterfall_zero(void)
{
wg.waterfall_db_zero=numinput_float_data;
make_modepar_file(GRAPHTYPE_WG);
redraw_wg_waterfall();
if(genparm[SECOND_FFT_ENABLE] != 0)
  {
  make_hg_yscale();
  hires_fq_scale();
  }
}

void change_wg_waterfall_gain(void)
{
wg.waterfall_db_gain=numinput_float_data;
if(wg.waterfall_db_gain <0.01)wg.waterfall_db_gain=0.01;
make_modepar_file(GRAPHTYPE_WG);
redraw_wg_waterfall();
if(genparm[SECOND_FFT_ENABLE] != 0)
  {
  make_hg_yscale();
  hires_fq_scale();
  }
}


void mouse_continue_wide_graph(void)
{
int i, j, old_xpoints, xpix;
hide_mouse();
switch (mouse_active_flag-1)
  {
  case WG_TOP:
  wg_borders(0);
  wg.ytop=mouse_y;
  j=wg.yborder-text_height-YBO;
  if(wg.ytop > j)wg.ytop=j;      
  wg_borders(15);
  break;

  case WG_BORDER:
  wg_borders(0);
  wg.yborder=mouse_y; 
  j=wg.ytop+text_height+YBO;
  if(wg.yborder < j)wg.yborder=j;      
  j=wg.ybottom-2*text_height;
  if(wg.yborder > j)wg.yborder=j;      
  wg_borders(15);
  break;

  case WG_BOTTOM:
  wg_borders(0);
  wg.ybottom=mouse_y;
  j=wg.yborder+2*text_height;
  if(wg.ybottom < j)wg.ybottom=j;      
  wg_borders(15);
  break;

  case WG_LEFT:
  wg_borders(0);
  wg.xleft=mouse_x;
  j=wg.xright-32-6*text_width;
  if(wg.xleft > j)wg.xleft=j;      
  wg_borders(15);
  break;

  case WG_RIGHT:
  wg_borders(0);
  wg.xright=mouse_x;
  j=wg.xleft+32+6*text_width;
  if(wg.xright < j)wg.xright=j;      
  wg_borders(15);
  break;

  default:
  goto await_release;
  }
if(leftpressed == 2)goto finish;
show_mouse();
return;
await_release:;
if(leftpressed == 1)
  {
  show_mouse();
  return;
  }
switch (mouse_active_flag-1)
  {
  case WG_YSCALE_EXPAND:
  wg.yrange/=1.5;
  break;
     
  case WG_YSCALE_CONTRACT:
  wg.yrange*=1.5;
  break;
      
  case WG_YZERO_DECREASE:
  wg.yzero/=1.5;
  break;
            
  case WG_YZERO_INCREASE:
  wg.yzero*=1.5;
  break;

  case WG_FQMIN_DECREASE:
  old_xpoints=wg.xpoints;
  decrease_wg_pixels_per_points();
  wg.first_xpoint-=wg.xpoints-old_xpoints;
  break;

  case WG_FQMIN_INCREASE:
  old_xpoints=wg.xpoints;
  increase_wg_pixels_per_points();
  wg.first_xpoint-=wg.xpoints-old_xpoints;
  break;

  case WG_FQMAX_DECREASE:
  old_xpoints=wg.xpoints;
  increase_wg_pixels_per_points();
  break;

  case WG_FQMAX_INCREASE:
  old_xpoints=wg.xpoints;
  decrease_wg_pixels_per_points();
  break;

  case WG_AVG1NUM:
  wg.fft_avg1num++;
  if(wg.fft_avg1num > 5)wg.fft_avg1num=1;
  check_wg_fft_avgnum();
  show_wg_buttons();
  break;

  case WG_FFT1_AVGNUM:
  mouse_active_flag=1;
  numinput_xpix=wgbutt[WG_FFT1_AVGNUM].x1+text_width/2-1;
  numinput_ypix=wgbutt[WG_FFT1_AVGNUM].y1+2;
  numinput_chars=4;    
  erase_numinput_txt();
  numinput_flag=FIXED_INT_PARM;
  show_mouse();
  par_from_keyboard_routine=change_fft1avgnum;
  return;

  case WG_WATERF_AVGNUM:
  mouse_active_flag=1;
  numinput_xpix=wgbutt[WG_WATERF_AVGNUM].x1+text_width/2-1;
  numinput_ypix=wgbutt[WG_WATERF_AVGNUM].y1+2;
  numinput_chars=4;    
  erase_numinput_txt();
  numinput_flag=FIXED_INT_PARM;
  show_mouse();
  par_from_keyboard_routine=change_waterfall_avgnum;
  return;

  case WG_WATERF_ZERO:
  mouse_active_flag=1;
  numinput_xpix=wgbutt[WG_WATERF_ZERO].x1+text_width/2-1;
  numinput_ypix=wgbutt[WG_WATERF_ZERO].y1+2;
  numinput_chars=5;    
  erase_numinput_txt();
  numinput_flag=FIXED_FLOAT_PARM;
  show_mouse();
  par_from_keyboard_routine=change_wg_waterfall_zero;
  return;

  case WG_WATERF_GAIN:
  mouse_active_flag=1;
  numinput_xpix=wgbutt[WG_WATERF_GAIN].x1+text_width/2-1;
  numinput_ypix=wgbutt[WG_WATERF_GAIN].y1+2;
  numinput_chars=4;    
  erase_numinput_txt();
  numinput_flag=FIXED_FLOAT_PARM;
  show_mouse();
  par_from_keyboard_routine=change_wg_waterfall_gain;
  return;
  }      
finish:;
leftpressed=0;  
mouse_active_flag=0;
for(i=0; i<no_of_scro; i++)
  {
  if(scro[i].no == WIDE_GRAPH)
    {
    if(rx_mode != MODE_TXTEST)
      {
      for(j=0; j<genparm[MIX1_NO_OF_CHANNELS]; j++)
        {
        if(mix1_selfreq[j] > 0)
          {
          xpix=mix1_curx[j];
errno=10622;
          ck_line(xpix,wg.yborder,xpix,wg.ybottom,0);
          }
        }
      }
    for(xpix=wg_first_xpixel; xpix<=wg_last_xpixel; xpix++)
      {
      j=fft1_spectrum[xpix];
      if(j<0)j=-i;
errno=10623;
      ck_setpixel(xpix,j,0);
      }
    wg_borders(0);
  errno=40101;
    ck_fillbox(wg_old_x1,wg_old_y1,wg_old_x2-wg_old_x1,wg_old_y2-wg_old_y1,0);
    make_wide_graph(i);
    show_mouse();
    return;
    }
  }
end_program(854);  
}


void wide_graph_selfreq(void)
{
float t1;
hide_mouse();
remove_mix1_cursor(0);
t1=wg_check_mix1(1);
make_new_signal(0, t1);
show_mouse();
if(genparm[SECOND_FFT_ENABLE] != 0)hires_fq_scale();
if(leftpressed != 2)return;
baseband_fq_scale();
clear_da();
leftpressed=0;  
mouse_active_flag=0;
}


void mouse_on_wide_graph(void)
{
int event_no;
// First find out is we are on a button or border line.
for(event_no=0; event_no<MAX_WGBUTT; event_no++)
  {
  if( wgbutt[event_no].x1 <= mouse_x && 
      wgbutt[event_no].x2 >= mouse_x &&      
      wgbutt[event_no].y1 <= mouse_y && 
      wgbutt[event_no].y2 >= mouse_y) 
    {
    wg_old_y1=wg.ytop;
    wg_old_y2=wg.ybottom;
    wg_old_x1=wg.xleft;
    wg_old_x2=wg.xright;
    mouse_active_flag=1+event_no;
    current_mouse_activity=mouse_continue_wide_graph;
    return;
    }
  }
if(rx_mode != MODE_TXTEST)
  {
// Not button or border.
// Select a frequency.
  mouse_active_flag=1;
  current_mouse_activity=wide_graph_selfreq;
  }
}


void make_wg_yfac(void)
{
float t1;
int i;
wg_yfac_power=1/(4*wg.spek_avgnum*wg.yzero*wg.yzero);
// If waterfall is generated from fft1 we set the zero point here.
t1=FFT1_WATERFALL_ZERO/wg.waterfall_avgnum;
if(wg.xpoints_per_pixel > 1)
  {
  wg_yfac_power/=wg.xpoints_per_pixel*wg.xpoints_per_pixel;
  t1/=pow((float)(wg.xpoints_per_pixel),1.8); 
  t1*=ui.rx_channels;      
  }
if(genparm[SECOND_FFT_ENABLE] != 0)
  {
// The constant here sets the zero point for the waterfall graph
// generated by fft2.
  t1=FFT2_WATERFALL_ZERO/(((float)(fft2_size)*fft1_size));
  t1/=sqrt((float)(wg.waterfall_avgnum));
  if(fft_cntrl[FFT2_CURMODE].mmx != 0)
    {
    t1*=2<<(2*(genparm[SECOND_FFT_ATT_N]));
    }
  t1*=1<<(2*genparm[FIRST_BCKFFT_ATT_N]);
  t1*=(1 + 1/(0.5+genparm[FIRST_FFT_SINPOW]));
  t1*=ui.rx_channels*ui.rx_channels;      
  }
// Straighten out the waterfall graph until the -10dB point is reached
for(i=0; i<fft1_size; i++)
  {
  if(fft1_desired[i] > 0.3162278)
    {
    wg_waterf_yfac[i]=t1/pow(fft1_desired[i],2.0);
    }
  else
    {
    wg_waterf_yfac[i]=t1*10;
    }
  }
wg_waterf_yfac[0]=t1;
wg_yfac_log=10/wg_db_per_pixel;
}


void new_fft1_averages(int ia, int ib)
{
int i,m,p0;
// Make fft1_slowsum from scratch over the specified interval
// We have power spectra in fft1_sumsq and we want to take
// the sum over the latest wg.fft_avg2num of them.
if(ia<0)end_program(233);
if(ib<ia)end_program(234);
if(ib>=fft1_size)end_program(235);
p0=(fft1_sumsq_pws-(wg_fft_avg2num-1)*fft1_size+fft1_sumsq_bufsize)
                                                          &fft1_sumsq_mask;
for(i=ia; i<=ib; i++)fft1_slowsum[i]=fft1_sumsq[p0+i]+0.0000001;
p0=(p0+fft1_size)&fft1_sumsq_mask;   
for(m=1; m<wg_fft_avg2num; m++)
  {
  for(i=ia; i<=ib; i++)fft1_slowsum[i]+=fft1_sumsq[p0+i];
  p0=(p0+fft1_size)&fft1_sumsq_mask;   
  }
}

void wg_borders(int color)
{
errno=10624;
ck_hline(wg.xleft,wg.ytop,wg.xright,color);
errno=10625;
ck_hline(wg.xleft,wg.yborder,wg.xright,color);
errno=10626;
ck_hline(wg.xleft,wg.ybottom,wg.xright,color);
errno=10627;
ck_line(wg.xleft,wg.ytop,wg.xleft,wg.ybottom,color);
errno=10628;
ck_line(wg.xright,wg.ytop,wg.xright,wg.ybottom,color);
}

void increase_wg_pixels_per_points(void)
{
if(wg.pixels_per_xpoint != 0)
  {
  wg.pixels_per_xpoint*=2;
  wg.xpoints=wg_xpixels/wg.pixels_per_xpoint;
  }
else
  {
  wg.xpoints_per_pixel--;
  wg.xpoints=wg_xpixels*wg.xpoints_per_pixel;
  if(wg.xpoints_per_pixel <= 1)
    {
    wg.xpoints_per_pixel=0;
    wg.pixels_per_xpoint=1;
    wg.xpoints=wg_xpixels;
    }  
  }
}

void update_wg(int xpix,int new_y, char spk_color )
{
int i, old_y, sw;
char bkg_color;
old_y=fft1_spectrum[xpix];
if(new_y < 0)new_y=0;
new_y=wg.ybottom-1-new_y;
if(new_y < wg.yborder+1)new_y=wg.yborder+1;
if(old_y < 0)
  {
  if(spk_color ==15)sw=1; else sw=0;
  old_y=-old_y;
  }
else  
  {
  if(spk_color ==15)sw=0; else sw=1;
  }
if(new_y!=old_y || sw!=0)
  {
  bkg_color=wg_background[old_y];
  if(xpix == mix1_curx[0])
    {
    bkg_color=MIX1_MAINCUR_COLOR;
    }
  else
    {
    for(i=1; i<genparm[MIX1_NO_OF_CHANNELS]; i++)
      {
      if(xpix == mix1_curx[i])
        {
        bkg_color=MIX1_SUBCUR_COLOR;
        }
      }  
    }
  gl_setpixel(xpix,old_y,bkg_color);
  gl_setpixel(xpix,new_y,spk_color);
  if(spk_color != 15)new_y=-new_y;
  fft1_spectrum[xpix]=new_y;
  }
}


void update_wg_spectrum(void)
{
int i,m,mm, new_y, xpix, wg_xpix2;
int k;
float yval,der,t1;
char cl;
// fft1_spectrum is the y-value currently on screen.
// behind_fft1_spectrum is the colour behind the current data point.
// Calculate updated values and move the corresponding bright 
// pixel in case the value has changed
if(wg_xpix1 >= wg_last_xpixel)wg_xpix1=wg_first_xpixel;
i=wg.pixels_per_xpoint;
if(i==0)i=1;
k=WIDTH/(NO_REDRAW_BLOCKS*i);
k*=i;
wg_xpix2=wg_xpix1+k;
if(wg_xpix2 >  wg_last_xpixel)wg_xpix2= wg_last_xpixel;
if(  mouse_x+mouse_cursize >= wg_xpix1 &&
     mouse_x-mouse_cursize < wg_xpix2 &&
     mouse_y+mouse_cursize > wg.yborder &&
     mouse_y-mouse_cursize < wg.ybottom)hide_mouse();
if(wg.xpoints_per_pixel == 1 || wg.pixels_per_xpoint == 1)
  {
  i=wg.first_xpoint+wg_xpix1-wg_first_xpixel;
  for(xpix=wg_xpix1; xpix<=wg_xpix2; xpix++)
    {
    if(liminfo[i]==0)
      {
      cl=15;
      }
    else
      {
      cl=12;
      }
    update_wg(xpix,(int)(wg_yfac_log*log10(fft1_slowsum[i]*wg_yfac_power)),cl);
    i++;
    }
  }    
else
  {
  if(wg.xpoints_per_pixel == 0)
    {
// There are more pixels than data points so we must interpolate.
    i=wg.first_xpoint+(wg_xpix1-wg_first_xpixel)/wg.pixels_per_xpoint;
    new_y=wg_yfac_log*log10(fft1_slowsum[i]*wg_yfac_power);
    yval=new_y;
    if(liminfo[i]==0)
      {
      cl=15;
      }
    else
      {
      cl=12;
      }
    i++;  
    update_wg(wg_xpix1,new_y,cl);
    for(xpix=wg_xpix1; 
        xpix<=wg_xpix2; xpix+=wg.pixels_per_xpoint)
      {
      t1=wg_yfac_log*log10(fft1_slowsum[i]*wg_yfac_power);
      der=(t1-yval)/wg.pixels_per_xpoint;
      m=xpix+wg.pixels_per_xpoint/2;  
      for(k=xpix+1; k<=m; k++)
        {
        yval=yval+der;
        new_y=yval;
        update_wg(k,new_y,cl);
        }  
      if(liminfo[i]==0)
        {
        cl=15;
        }
      else
        {
        cl=12;
        }
      mm=xpix+wg.pixels_per_xpoint;  
      for(k=m+1; k<=mm; k++)
        {
        yval=yval+der;
        new_y=yval;
        update_wg(k,new_y,cl);
        }  
      i++;
      yval=t1;
      }      
    }
  else
    {
// There is more than one data point for each pixel.
// Slide a triangular filter across the spectrum to make it
// smoother before resampling.
    i=wg.first_xpoint+(wg_xpix1-wg_first_xpixel)*wg.xpoints_per_pixel;
    for(xpix=wg_xpix1; xpix<=wg_xpix2; xpix++)
      {
      if(liminfo[i]==0)
        {
        cl=15;
        }
      else
        {
        cl=12;
        }
      t1=fft1_slowsum[i]*wg.xpoints_per_pixel;
      for(k=1; k<wg.xpoints_per_pixel; k++)
        {
        t1+=(fft1_slowsum[i+k]+fft1_slowsum[i-k])*(wg.xpoints_per_pixel-k);
        if(liminfo[i+k]!=0||liminfo[i-k]!=0)cl=12;
        }
      new_y=wg_yfac_log*log10(t1*wg_yfac_power);
      update_wg(xpix,new_y,cl);
      i+=wg.xpoints_per_pixel;
      }
    }  
  }
show_mouse();
wg_xpix1=wg_xpix2;
}

void make_wg_freq_scale(void)
{
char s[80];
int i, j, k;
int xa, xb, ya, yb;
float t1, fq_scalestep;
float fq_x;
double fq_value, fq_offset;
// Make a frequency scale on top of the waterfall graph.
// Express frequencies in Hz and do not place numbers closer than
// 7 ascii characters. 
fq_scalestep=7*wg_hz_per_pixel*text_width;
j=adjust_scale(&fq_scalestep);
// The frequency scale is showing the last five digits of
// the frequency in Hz  (tens of kHz)
// Get the frequency for the first bin of fft1 in tens of kHz.
if(fg.passband_center != 0)
  {
  fq_offset=fg.passband_center*10-timf1_sampling_speed/200000;
  }
else
  {
  fq_offset=0;
  }
frequency_scale_offset=fq_offset;
// Get the decimal fraction and convert it to Hz  
fq_offset=(fq_offset-(int)(fq_offset))*100000;  
i=0.5+(fq_offset+wg_first_frequency)/fq_scalestep;
fq_value=i*fq_scalestep;
fq_x=wg_first_xpixel+(fq_value-wg_first_frequency-fq_offset)/wg_hz_per_pixel;
xb=-1;
ya=wg.ytop+text_height;
yb=wg.ytop+text_height+3;
  errno=40102;
ck_fillbox(wg.xleft+4*text_width,wg.ytop+1,
            wg.xright-wg.xleft-8*text_width,text_height+3,0);
while( fq_x+6.5*text_width < wg.xright)
  {
  if(fq_value >=100000)fq_value-=100000;
  if(fq_x-5.5*text_width > wg.xleft)
    {
    i=fq_value+0.5;
    sprintf(s,"%d",i);
    k=0;
    while(s[k]!=0)k++;
  errno=20102;
    ck_write(fq_x-k*text_width/2, wg.ytop+text_midpoint,s);
    if(xb > 0)
      {
      if(j <= 2 )
        {
        xa=(fq_x+xb)/2;
errno=10633;
        ck_line(xa,ya,xa,yb,14);
        }
      else
        {  
        t1=0.2*(fq_x-xb)+0.5;
        xa=t1;
errno=10634;
        ck_line(xb+xa,ya,xb+xa,yb,15);
errno=10635;
        ck_line(fq_x-xa,ya,fq_x-xa,yb,15);
        t1=0.4*(fq_x-xb)+0.5;
        xa=t1;
errno=10636;
        ck_line(xb+xa,ya,xb+xa,yb,15);
errno=10637;
        ck_line(fq_x-xa,ya,fq_x-xa,yb,15);
        }
      }
    xb=fq_x;  
errno=10638;
    ck_line(fq_x,ya,fq_x,yb,15);
errno=10639;
    ck_line(fq_x+1,ya,fq_x+1,yb,15);
errno=10640;
    ck_line(fq_x-1,ya,fq_x-1,yb,15);
    }
  fq_x+=fq_scalestep/wg_hz_per_pixel;
  fq_value+=fq_scalestep;
  }    
errno=10641;
ck_hline(wg_first_xpixel,yb+1,wg_last_xpixel-2*text_width,7);
}


void make_wide_graph(int m)
{
char s[80];
int i, j, k;
int ypixels, old_xpix;
int hgwat_xpoints;
float t1, t2, db_scalestep;
float scale_value, scale_y;
// If there is another window open, make sure we stay away from it
current_graph_minh=YBO+3*text_height;
current_graph_minw=32+6*text_width;
check_graph_placement(&wg);
if(wg.ybottom-wg.ytop<3*text_height+YBO)
  {
  wg.yborder=(wg.ybottom+wg.ytop)/2;
  }
else
  { 
  if(wg.yborder < wg.ytop+text_height+YBO)wg.yborder=wg.ytop+text_height+YBO;
  if(wg.yborder > wg.ybottom-2*text_height)wg.yborder=wg.ybottom-2*text_height;
  }
wg_waterf_lines=wg.yborder-wg.ytop-text_height-YWF;
wg_waterf_y1=wg.ytop+text_height+YWF+1;
wg_waterf_y2=wg_waterf_y1+2+wg_waterf_lines/20;
if(wg_waterf_y2 > wg_waterf_y1+wg_waterf_lines-1)
                           wg_waterf_y2=wg_waterf_y1+wg_waterf_lines-1;
wg_waterf_y=wg_waterf_y2;
if(wg_waterf_y2 > wg.yborder-1)wg_waterf_y2=wg.yborder-1;
wg_waterf_ymove_start=2*wg_waterf_y1-2-wg_waterf_y2+wg_waterf_lines;
wg_waterf_yinc=wg_waterf_y2-wg_waterf_y1+1;
// Check if the desired spectrum fits within the frame and
// make changes as required if not.
wg_first_xpixel=wg.xleft+4*text_width;
wg_last_xpixel=wg.xright-2*text_width;
wg_xpixels = wg_last_xpixel-wg_first_xpixel+1;
old_xpix=wg_xpixels;
if(wg.pixels_per_xpoint != 0)
  {
  wg.xpoints=wg_xpixels/wg.pixels_per_xpoint;
  }
else
  {
  wg.xpoints=wg_xpixels*wg.xpoints_per_pixel;
  }
if(wg.xpoints < 4)
  {
  wg.xpoints=4;
  wg.pixels_per_xpoint=wg_xpixels/wg.xpoints;
  wg.xpoints_per_pixel=0;
  } 
if(wg.first_xpoint<0)wg.first_xpoint=0;
if(wg.xpoints>fft1_size)
  {
  wg.xpoints=fft1_size;
  if(wg.pixels_per_xpoint != 0)
    {
    wg_xpixels=wg.xpoints*wg.pixels_per_xpoint;
    }
  else
    {
    wg_xpixels=wg.xpoints/wg.xpoints_per_pixel;
    }
  }  
if(wg.first_xpoint+wg.xpoints>=fft1_size)wg.first_xpoint=fft1_size-wg.xpoints;
// Now that we know that fft1 fits in the window, set the number of
// pixels per data point.
if(genparm[SECOND_FFT_ENABLE] != 0)
  { 
  hgwat_xpoints=wg.xpoints*fft2_to_fft1_ratio;
  if(hgwat_xpoints > wg_xpixels)
    {
    hgwat_xpoints_per_pixel=hgwat_xpoints/wg_xpixels;
    hgwat_pixels_per_xpoint=0;
// Make sure that wg.xpoints_per_pixel is an integer number
    wg.xpoints_per_pixel=hgwat_xpoints_per_pixel/fft2_to_fft1_ratio;
    if(wg.xpoints_per_pixel > 0)
      {
      hgwat_xpoints_per_pixel=wg.xpoints_per_pixel*fft2_to_fft1_ratio;
      wg_xpixels=hgwat_xpoints/hgwat_xpoints_per_pixel;
      wg.xpoints=wg_xpixels*wg.xpoints_per_pixel;
      if(wg.xpoints_per_pixel == 1)
        {
        wg.pixels_per_xpoint=1;
        }
      else
        {  
        wg.pixels_per_xpoint=0;
        }
      wg_hz_per_pixel=fft1_hz_per_point*wg.xpoints_per_pixel;
      }
    else
      {
      wg.pixels_per_xpoint=fft2_to_fft1_ratio/hgwat_xpoints_per_pixel;
      wg_xpixels=wg.xpoints*wg.pixels_per_xpoint;
      while(wg_xpixels > old_xpix)
        {
        wg.xpoints--;
        wg_xpixels-=wg.pixels_per_xpoint;
        }
      wg.xpoints=wg_xpixels/wg.pixels_per_xpoint;
      wg_hz_per_pixel=fft1_hz_per_point/wg.pixels_per_xpoint;
      make_power_of_two(&wg.pixels_per_xpoint);
      hgwat_xpoints_per_pixel=fft2_to_fft1_ratio/wg.pixels_per_xpoint;
      }  
    }
  else
    {
    hgwat_xpoints_per_pixel=0;
    hgwat_pixels_per_xpoint=wg_xpixels/hgwat_xpoints;
    wg.pixels_per_xpoint=fft2_to_fft1_ratio*hgwat_pixels_per_xpoint;
    wg_xpixels=wg.xpoints*wg.pixels_per_xpoint;
    wg.xpoints=wg_xpixels/wg.pixels_per_xpoint;
    wg_hz_per_pixel=fft1_hz_per_point/wg.pixels_per_xpoint;
    wg.xpoints_per_pixel=0;
    }
  hgwat_first_xpoint=wg.first_xpoint*fft2_to_fft1_ratio;
  }
else
  {
  if(wg.pixels_per_xpoint != 0)
    {
    wg_xpixels=wg.xpoints*wg.pixels_per_xpoint;
    wg_hz_per_pixel=fft1_hz_per_point/wg.pixels_per_xpoint;
    }
  else
    {
    wg_xpixels=wg.xpoints/wg.xpoints_per_pixel;
    wg_hz_per_pixel=fft1_hz_per_point*wg.xpoints_per_pixel;
    }  
  }
wg_last_xpixel=wg_first_xpixel+wg_xpixels-1;
wg.xright=wg_last_xpixel+2*text_width;
wg_first_frequency=fft1_hz_per_point*wg.first_xpoint;
set_fft1_endpoints();
wg_xpix1=wg_first_xpixel;
mix1_lowest_fq=(fft1_first_point+1)*fft1_hz_per_point;
t2=wg.first_xpoint*fft1_hz_per_point;
if(mix1_lowest_fq<t2) mix1_lowest_fq=t2;
mix1_highest_fq=(fft1_last_point-1)*fft1_hz_per_point;
t2=wg_last_point*fft1_hz_per_point;
if(mix1_highest_fq > t2)mix1_highest_fq=t2;
if(wg.ybottom >= HEIGHT)wg.ybottom=HEIGHT-1;
scro[m].no=WIDE_GRAPH;
scro[m].x1=wg.xleft;
scro[m].x2=wg.xright;
scro[m].y1=wg.ytop;
scro[m].y2=wg.ybottom;
wgbutt[WG_LEFT].x1=wg.xleft;
wgbutt[WG_LEFT].x2=wg.xleft;
wgbutt[WG_LEFT].y1=wg.ytop;
wgbutt[WG_LEFT].y2=wg.ybottom;
wgbutt[WG_RIGHT].x1=wg.xright;
wgbutt[WG_RIGHT].x2=wg.xright;
wgbutt[WG_RIGHT].y1=wg.ytop;
wgbutt[WG_RIGHT].y2=wg.ybottom;
wgbutt[WG_TOP].x1=wg.xleft;
wgbutt[WG_TOP].x2=wg.xright;
wgbutt[WG_TOP].y1=wg.ytop;
wgbutt[WG_TOP].y2=wg.ytop;
wgbutt[WG_BORDER].x1=wg.xleft;
wgbutt[WG_BORDER].x2=wg.xright;
wgbutt[WG_BORDER].y1=wg.yborder;
wgbutt[WG_BORDER].y2=wg.yborder;
wgbutt[WG_BOTTOM].x1=wg.xleft;
wgbutt[WG_BOTTOM].x2=wg.xright;
wgbutt[WG_BOTTOM].y1=wg.ybottom;
wgbutt[WG_BOTTOM].y2=wg.ybottom;
// Draw the border lines
wg_borders(7);
settextcolor(7);
// Free the waterfall buffer in case there is already one allocated
// Then allocate the number of bytes we actually need for the current screen.
wg_waterf=chk_free(wg_waterf);
// ************************************
j=wg_xpixels*wg_waterf_lines*sizeof(short int);         //waterfall
wg_waterf=chk_malloc( j+HEIGHT*sizeof(char), 1036);
wg_background=(void*)(wg_waterf)+j;
j/=sizeof(short int);
for(i=0;i<j;i++)wg_waterf[i]=0x8000;
// Write out the y scale for logarithmic spectrum graph.
// We want a point with amplitude 1<<(fft1_n/2) to be placed at the
// zero point of the dB scale. 
for(i=0; i<HEIGHT; i++)wg_background[i]=0;
ypixels=wg.ybottom-wg.yborder-1;
wg_db_per_pixel=20*log10(wg.yrange)/ypixels;
db_scalestep=1.3*wg_db_per_pixel*text_height;
adjust_scale(&db_scalestep);
if(db_scalestep < 1)
  {
  db_scalestep=1;
  wg_db_per_pixel=0.5/text_height;
  wg.yrange=pow(10.,ypixels*wg_db_per_pixel/20);
  }
t1=20*log10( wg.yzero);
i=(t1+0.5*db_scalestep)/db_scalestep;
scale_value=i*db_scalestep;
scale_y=wg.ybottom+(t1-scale_value)/wg_db_per_pixel;
while( scale_y-text_height/2-2 > wg.yborder+1.5*text_height)
  {
  if(scale_y+text_height+2 < wg.ybottom)
    {
    i=scale_value*1.000001;
    sprintf(s,"%3d",i);
    errno=20103;
    ck_write(wg.xleft+text_width/2,scale_y-text_midpoint,s);
    }
  if(scale_y+2 < wg.ybottom)
    {
    i=scale_y;
    wg_background[i]=WG_DBSCALE_COLOR;    
errno=10631;
    ck_hline(wg_first_xpixel,i,wg_last_xpixel,WG_DBSCALE_COLOR);
    }
  scale_y-=db_scalestep/wg_db_per_pixel;
  scale_value+=db_scalestep;
  }
// Init fft1_spectrum as the base line and place it on the screen. 
for(i=wg_first_xpixel; i<=wg_last_xpixel; i++) fft1_spectrum[i]=wg.ybottom-1;
errno=10632;
ck_hline(wg_first_xpixel,wg.ybottom-1,wg_last_xpixel,15);
new_fft1_averages(fft1_first_point,fft1_last_point);
make_button(wg.xleft+text_width,wg.ybottom-text_height/2-2,
                                         wgbutt,WG_YSCALE_EXPAND,24);
make_button(wg.xleft+3*text_width,wg.ybottom-text_height/2-2,
                                         wgbutt,WG_YSCALE_CONTRACT,25);
i=(wg.ybottom+wg.yborder)/2;
make_button(wg.xright-text_width,i-text_height/2-2,
                                         wgbutt,WG_YZERO_DECREASE,24);
make_button(wg.xright-text_width,i+text_height/2+2,
                                         wgbutt,WG_YZERO_INCREASE,25);
make_button(wg.xleft+text_width,wg.ytop+text_height/2+3,
                                         wgbutt,WG_FQMIN_DECREASE,26);
make_button(wg.xleft+3*text_width,wg.ytop+text_height/2+3,
                                         wgbutt,WG_FQMIN_INCREASE,27);
make_button(wg.xright-3*text_width,wg.ytop+text_height/2+3,
                                         wgbutt,WG_FQMAX_DECREASE,26);
make_button(wg.xright-text_width,wg.ytop+text_height/2+3,
                                         wgbutt,WG_FQMAX_INCREASE,27); 
make_button(wg.xright-text_width,wg.ybottom-text_height/2-2,
                                     wgbutt,WG_AVG1NUM,wg.fft_avg1num+48); 
// ***********  fft1 averaging number button ******************
wgbutt[WG_FFT1_AVGNUM].x1=2+wg.xleft;
wgbutt[WG_FFT1_AVGNUM].x2=2+wg.xleft+4.5*text_width;
wgbutt[WG_FFT1_AVGNUM].y1=2+wg.yborder;
wgbutt[WG_FFT1_AVGNUM].y2=2+wg.yborder+text_height;
wgbutt[WG_WATERF_AVGNUM].x1=2+wg.xleft;
wgbutt[WG_WATERF_AVGNUM].x2=2+wg.xleft+4.5*text_width;
wgbutt[WG_WATERF_AVGNUM].y1=wg.yborder-text_height-2;
wgbutt[WG_WATERF_AVGNUM].y2=wg.yborder-2;
wgbutt[WG_WATERF_GAIN].x1=wg.xright-4.5*text_width-2;
wgbutt[WG_WATERF_GAIN].x2=wg.xright-2;
wgbutt[WG_WATERF_GAIN].y1=wg.yborder-2*text_height-4;
wgbutt[WG_WATERF_GAIN].y2=wg.yborder-text_height-4;
wgbutt[WG_WATERF_ZERO].x1=wg.xright-5.5*text_width-2;
wgbutt[WG_WATERF_ZERO].x2=wg.xright-2;
wgbutt[WG_WATERF_ZERO].y1=wg.yborder-text_height-2;
wgbutt[WG_WATERF_ZERO].y2=wg.yborder-2;
show_wg_buttons();
make_wg_freq_scale();
make_wg_yfac();
make_modepar_file(GRAPHTYPE_WG);
wg_flag=1;
wg_waterf_block=(wg_waterf_y2-wg_waterf_y1+1)*wg_xpixels;
make_wg_waterf_cfac();
// Check if there are selected frequencies that are still
// within the permitted range.
// Place their cursors on screen and remove other selected frequencies.
if(rx_mode != MODE_TXTEST)
  {
  for(i=0; i<genparm[MIX1_NO_OF_CHANNELS]; i++)
    {
    if( mix1_selfreq[i] > mix1_lowest_fq  && mix1_selfreq[i]<mix1_highest_fq)
      {
      add_mix1_cursor(i);
      if(genparm[AFC_ENABLE] != 0)
        {
        for(j=0; j<max_fftxn; j++)
          {
          k=i*max_fftxn+j;
          if(mix1_fq_mid[k]<mix1_lowest_fq)mix1_fq_mid[k]=mix1_lowest_fq;
          if(mix1_fq_mid[k]>mix1_highest_fq)mix1_fq_mid[k]=mix1_highest_fq;
          }
        }
      }
    else
      {
      mix1_selfreq[i]=-BIG;
      mix1_curx[i]=-1;
      }
    }
  }
wg_timestamp_counter=0;
if(mix1_selfreq[0] < 0)
  {
  new_baseb_flag=-1;
  }
else
  {

  }  
if(rx_mode == MODE_TXTEST)txtest_init();
}

void init_wide_graph()
{
int i;
float t1;
if (read_modepar_file(GRAPHTYPE_WG) == 0)
  {
wg_default:;  
// Make the default window for the wide graphs (spectrum and waterfall)
  wg.check=WG_VERNR;
  wg.xleft=0;
  if(fft1_size < 32)
    {
    lir_status=LIR_PARERR;
    return;
    }
  i=fft1_size+6*text_width-1;
  if(i > WIDTH-1)i=WIDTH-1;
  wg.xright=i;
  wg.ytop=0;
  wg.yborder=HEIGHT/4;
  wg.ybottom=HEIGHT/2;
// Decide what range in fft1 points we want to place on the x-axis 
// Default is to show approximately half the spectrum.
  wg_first_xpixel=wg.xleft+4*text_width;
  wg_last_xpixel=wg.xright-2*text_width;
  wg_xpixels=wg_last_xpixel-wg_first_xpixel+1;
  t1=(0.5*fft1_size)/wg_xpixels;
  if(t1 > 1)
    {
    wg.xpoints_per_pixel=t1+0.5;
    wg.xpoints=wg.xpoints_per_pixel*wg_xpixels;
    wg.pixels_per_xpoint=0;
    }
  else
    {
    wg.pixels_per_xpoint=1.01/t1;
    wg.xpoints=wg_xpixels/wg.pixels_per_xpoint;
    wg.xpoints_per_pixel=0;
    }
  wg.first_xpoint=(fft1_size-wg.xpoints)/3;
  if(wg.first_xpoint<0)end_program(314);
  wg.yrange=32768;
  wg.yzero=1;
  wg.waterfall_db_gain=.25;
  wg.waterfall_db_zero=20;
  wg.spek_avgnum=1+2/fft1_blocktime;  
  wg.fft_avg1num=wg.spek_avgnum/3;
  if(genparm[SECOND_FFT_ENABLE] == 0)
    {
    wg.waterfall_avgnum=2*wg.spek_avgnum;
    }
  else
    {
    wg.waterfall_avgnum=1+5/fft2_blocktime;;
    }  
  check_wg_fft_avgnum();
  }
if(wg.check != WG_VERNR)goto wg_default;
if(wg.first_xpoint < 0)goto wg_default;
if(wg.first_xpoint+wg.xpoints > fft1_size)goto wg_default;  
if(wg.xleft<0 || wg.xleft > wg.xright-32-6*text_width)goto wg_default;
if(wg.xright>=WIDTH)goto wg_default;
if(wg.ytop < 0 || wg.ytop >wg.ybottom-50)goto wg_default; 
if(wg.ybottom>=HEIGHT)goto wg_default;
if(wg.yborder < wg.ytop+text_height+YBO || 
                wg.yborder > wg.ybottom-2*text_height)goto wg_default;
if(genparm[SECOND_FFT_ENABLE] != 0 && wg.pixels_per_xpoint>2)
                                    make_power_of_two(&wg.pixels_per_xpoint);
check_wg_fft_avgnum();
make_wide_graph(no_of_scro);
no_of_scro++;
if(no_of_scro >= MAX_SCRO)end_program(89);
baseb_wts=0;
}
